local L = LibStub("AceLocale-3.0"):GetLocale("AOTH")

AddOnName, AOTH = ...;


local CLASS_RARE       = "Rare"      ;
local CLASS_RARE_ELITE = "Rare_Elite";
local CLASS_ELITE      = "Elite"     ;
local CLASS_STABLE_MASTER = "Stable Master";
local CLASS_BOSS       = "Boss"      ;
local CLASS_WORLD_BOSS = "World Boss";

local TENACITY   = "Tenacity";
local CUNNING    = "Cunning";
local FEROCITY   = "Ferocity";

AOTH.specSkills = {

    ["Tenacity"] = {264662, 264735},
    ["Cunning"] =  {264656, 53271 },
    ["Ferocity"] = {264663, 264667},

}

local NOT_EXOTIC = false;
local IS_EXOTIC  = true;

-- FAMILY SKILLS
local ACID_BITE          = 263863;
local ACID_SPIT          = 263446;
local AGILE_REFLEXES     = 160011;
local ANCIENT_HIDE       = 279399;
local ANKLE_CRACK        = 50433 ;
local BLOOD_BOLT         = 288962;
local BLOOD_OF_THE_RHINO = 280069;
local BLOOD_SCREECH      = 24423 ;
local BRISTLE            = 263869;
local BULWARK            = 279410;
local BURROW_ATTACK      = 93433 ;
local CALCIFIED_CARAPACE = 279254;
local CATLIKE_REFLEXES   = 263892;
local CHIJI_TRANQUILITY  = 264028;
local DEADLY_STING       = 160060;
local DEFENSE_MATRIX     = 263868;
local DRAGONS_GUILE      = 263887;
local DUNE_STRIDER       = 280151;
local DUST_CLOUD         = 50285 ;
local ETERNAL_GUARDIAN   = 267922;
local FEAST              = 159953;
local FEATHER_FLURRY     = 263916;
local FROST_BREATH       = 54644 ;
local FROSTSTORM_BREATH  = 92380 ;
local FURIOUS_BITE       = 263840;
local GNAW               = 263856;
local GORE               = 263861;
local GRIEVOUS_BITE      = 279362;
local GRUESOME_BITE      = 160018;
local GRUFF              = 263921;
local HARDEN_CARAPACE    = 90339 ;
local INFECTED_BITE      = 263853
local LOCKJAW            = 263423;
local MOLTEN_HIDE        = 159788;
local MONSTROUS_BITE     = 54680 ;
local NATURES_GRACE      = 264266;
local NETHER_SHOCK       = 264264;
local NIUZAO_FORTITUDE   = 264023;
local OBSIDIAN_SKIN      = 263867;
local PIN                = 50245 ;
local PLAY               = 90347 ;
local PRIMAL_AGILITY     = 160044;
local PROWL              = 24450 ;
local PETRIFYING_GAZE    = 263841;
local RAVAGE             = 263857;
local REST               = 94019 ;
local SAVAGE_REND        = 263854;
local SCALE_SHIELD       = 263865;
local SERENITY_DUST      = 264055;
local SERPENTS_SWIFTNES  = 263904;
local SHELL_SHIELD       = 26064 ;
local SHIMMERING_SHALE   = 279259;
local SILVERBACK         = 263939;
local SOLID_SHELL        = 160063;
local SOOTHING_WATER     = 264262;
local SPIRIT_MEND        = 90361 ;
local SPIRIT_SHOCK       = 264265;
local SPIRIT_WALK        = 90328 ;
local SPORE_CLOUD        = 264056;
local STONE_ARMOR        = 160049;
local SURFACE_TROT       = 126311;
local SWARM_OF_FLIES     = 279336;
local TALON_REND         = 263852;
local TENDON_RIP         = 160065;
local THICK_FUR          = 263934;
local THICK_HIDE         = 160057;
local TOXIC_STING        = 263858;
local TRICK              = 94022 ;
local UPDRAFT            = 160007;
local WARP_TIME          = 35346 ;
local WEB_SPRAY          = 160067;
local WINGED_AGILITY     = 264360;
local SONIC_BLAST        = 264263;

-- COMMON SKILLS

local BITE = 17253;
local SMACK = 49966;
local CLAW = 16827;

-- PET FAMILIES
local BASILISK_SKILLS      = {PETRIFYING_GAZE                            }; -- BITE
local BAT_SKILLS           = {SONIC_BLAST                                }; -- BITE
local BEAR_SKILLS          = {THICK_FUR        , REST                    }; -- CLAW
local BEETLE_SKILLS        = {HARDEN_CARAPACE                            }; -- BITE
local BIRDS_OF_PREY_SKILLS = {TALON_REND       , TRICK                   }; -- CLAW
local BLOOD_BEAST_SKILLS   = {BLOOD_BOLT                                 }; -- BITE
local BOAR_SKILLS          = {BRISTLE                                    }; -- BITE
local CARRION_BIRD_SKILLS  = {BLOOD_SCREECH                              }; -- BITE
local CAT_SKILLS           = {CATLIKE_REFLEXES , PROWL                   }; -- CLAW
local CHIMAERAS_SKILLS     = {FROST_BREATH     , FROSTSTORM_BREATH       }; -- BITE
local CLEFTHOOVE_SKILLS    = {THICK_HIDE       , BLOOD_OF_THE_RHINO      }; -- SMACK
local COREHOUND_SKILLS     = {OBSIDIAN_SKIN    , MOLTEN_HIDE             }; -- BITE
local CRAB_SKILLS          = {PIN                                        }; -- CLAW
local CRANE_SKILLS         = {CHIJI_TRANQUILITY, TRICK                   }; -- SMACK
local CROCOLISK_SKILLS     = {ANKLE_CRACK                                }; -- BITE
local DEVILSAUR_SKILLS     = {MONSTROUS_BITE   , FEAST                   }; -- BITE
local DIREHORN_SKILLS      = {GORE                                       }; -- BITE
local DOGS_SKILLS          = {LOCKJAW                                    }; -- BITE
local DRAGONHAWKS_SKILLS   = {DRAGONS_GUILE                              }; -- BITE
local FEATHERMANES_SKILLS  = {FEATHER_FLURRY   , UPDRAFT                 }; -- BITE
local FOX_SKILLS           = {AGILE_REFLEXES   , PLAY                    }; -- BITE
local GOAT_SKILLS          = {GRUFF                                      }; -- SMACK
local GORILLA_SKILLS       = {SILVERBACK                                 }; -- SMACK
local HYDRA_SKILLS         = {ACID_BITE                                  }; -- BITE
local HYENA_SKILLS         = {INFECTED_BITE                              }; -- BITE
local KROLUSK_SKILLS       = {BULWARK          , CALCIFIED_CARAPACE      }; -- BITE
local LIZARD_SKILLS        = {GRIEVOUS_BITE                              }; -- BITE
local MECHANICAL_SKILLS    = {DEFENSE_MATRIX                             }; -- BITE
local MONKEY_SKILLS        = {PRIMAL_AGILITY                             }; -- SMACK
local MOTH_SKILLS          = {SERENITY_DUST                              }; -- SMACK
local OXEN_SKILLS          = {NIUZAO_FORTITUDE                           }; -- SMACK
local PTERRORDAXE_SKILLS   = {ANCIENT_HIDE     , UPDRAFT                 }; -- BITE
local QUILLEN_SKILLS       = {STONE_ARMOR      , ETERNAL_GUARDIAN        }; -- BITE
local RAPTOR_SKILLS        = {SAVAGE_REND                                }; -- CLAW
local RAVAGER_SKILLS       = {RAVAGE                                     }; -- BITE
local RAY_SKILLS           = {NETHER_SHOCK                               }; -- BITE
local RIVERBEAST_SKILLS    = {GRUESOME_BITE                              }; -- BITE
local RODENT_SKILLS        = {GNAW             , REST                    }; -- CLAW
local SCALEHIDE_SKILLS     = {SCALE_SHIELD                               }; -- SMACK
local SCORPID_SKILLS       = {DEADLY_STING                               }; -- CLAW
local SERPENT_SKILLS       = {SERPENTS_SWIFTNES                          }; -- BITE
local SHALE_SPIDER_SKILLS  = {SOLID_SHELL      , SHIMMERING_SHALE        }; -- BITE
local SILITHID_SKILLS      = {TENDON_RIP       , DUNE_STRIDER            }; -- CLAW
local SPIDER_SKILLS        = {WEB_SPRAY                                  }; -- BITE
local SPIRIT_BEAST_SKILLS  = {SPIRIT_SHOCK     , SPIRIT_MEND, SPIRIT_WALK}; -- CLAW
local SPOREBATS_SKILLS     = {SPORE_CLOUD                                }; -- SMACK
local STAG_SKILLS          = {NATURES_GRACE                              }; -- SMACK
local TALLSTRIDER_SKILLS   = {DUST_CLOUD                                 }; -- CLAW
local TOAD_SKILLS          = {SWARM_OF_FLIES                             }; -- SMACK
local TURTLE_SKILLS        = {SHELL_SHIELD                               }; -- BITE
local WARP_STALKERS_SKILLS = {WARP_TIME                                  }; -- BITE
local WASP_SKILLS          = {TOXIC_STING                                }; -- SMACK
local WATER_STRIDER_SKILLS = {SOOTHING_WATER   , SURFACE_TROT            }; -- BITE
local WIND_SERPENTS_SKILLS = {WINGED_AGILITY                             }; -- BITE
local WOLF_SKILLS          = {FURIOUS_BITE                               }; -- BITE
local WORMS_SKILLS         = {ACID_SPIT        , BURROW_ATTACK           }; -- BITE


 AOTH.families = {
  {"Basilisk"    , CUNNING , NOT_EXOTIC},
  {"Bat"         , FEROCITY, NOT_EXOTIC},
  {"Bear"        , TENACITY, NOT_EXOTIC},
  {"Beetle"      , TENACITY, NOT_EXOTIC},
  {"Bird of Prey", CUNNING , NOT_EXOTIC},
  {"Blood Beast" , TENACITY, NOT_EXOTIC},
  {"Boar"        , CUNNING , NOT_EXOTIC},
  {"Carrion Bird", FEROCITY, NOT_EXOTIC},
  {"Cat"         , FEROCITY, NOT_EXOTIC},
  {"Chimaera"    , FEROCITY, IS_EXOTIC },
  {"Clefthoof"   , FEROCITY, IS_EXOTIC },
  {"Core Hound"  , FEROCITY, IS_EXOTIC },
  {"Crab"        , TENACITY, NOT_EXOTIC},
  {"Crane"       , TENACITY, NOT_EXOTIC},
  {"Crocolisk"   , FEROCITY, NOT_EXOTIC},
  {"Devilsaur"   , FEROCITY, IS_EXOTIC },
  {"Direhorn"    , TENACITY, NOT_EXOTIC},
  {"Dog"         , CUNNING , NOT_EXOTIC},
  {"Dragonhawk"  , TENACITY, NOT_EXOTIC},
  {"Feathermane" , TENACITY, NOT_EXOTIC},
  {"Fox"         , CUNNING , NOT_EXOTIC},
  {"Goat"        , CUNNING , NOT_EXOTIC},
  {"Gorilla"     , FEROCITY, NOT_EXOTIC},
  {"Hydra"       , TENACITY, NOT_EXOTIC},
  {"Hyena"       , CUNNING , NOT_EXOTIC},
  {"Krolusk"     , TENACITY, IS_EXOTIC },
  {"Lizard"      , TENACITY, NOT_EXOTIC},
  {"Mechanical"   , CUNNING , NOT_EXOTIC},
  {"Monkey"       , CUNNING , NOT_EXOTIC},
  {"Moth"         , CUNNING , NOT_EXOTIC},
  {"Oxen"         , TENACITY, NOT_EXOTIC},
  {"Pterrordax"   , CUNNING , IS_EXOTIC },
  {"Quilen"       , TENACITY, IS_EXOTIC },
  {"Raptor"       , CUNNING , NOT_EXOTIC},
  {"Ravager"      , FEROCITY, NOT_EXOTIC},
  {"Ray"          , FEROCITY, NOT_EXOTIC},
  {"Riverbeast"   , TENACITY, NOT_EXOTIC},
  {"Rodent"       , CUNNING , NOT_EXOTIC},
  {"Scalehide"    , FEROCITY, NOT_EXOTIC},
  {"Scorpid"      , FEROCITY, NOT_EXOTIC},
  {"Serpent"      , CUNNING , NOT_EXOTIC},
  {"Shale Spider" , CUNNING , IS_EXOTIC },
  {"Silithid"     , CUNNING , IS_EXOTIC },
  {"Spider"       , FEROCITY, NOT_EXOTIC},
  {"Spirit Beast" , TENACITY, IS_EXOTIC },
  {"Sporebat"     , CUNNING , NOT_EXOTIC},
  {"Stag"         , TENACITY, NOT_EXOTIC},
  {"Tallstrider"  , FEROCITY, NOT_EXOTIC},
  {"Toad"         , TENACITY, NOT_EXOTIC},
  {"Turtle"       , TENACITY, NOT_EXOTIC},
  {"Unclassified" , "nil"   , NOT_EXOTIC},
  {"Warp Stalker" , CUNNING , NOT_EXOTIC},
  {"Wasp"         , FEROCITY, NOT_EXOTIC},
  {"Water Strider", CUNNING , IS_EXOTIC },
  {"Wind Serpent" , FEROCITY, NOT_EXOTIC},
  {"Wolf"         , FEROCITY, NOT_EXOTIC},
  {"Worm"         , TENACITY, IS_EXOTIC },
}


AOTH.famSkills = {

    ["Basilisk"     ] = BASILISK_SKILLS,
    ["Bat"          ] = BAT_SKILLS,
    ["Bear"         ] = BEAR_SKILLS,
    ["Beetle"       ] = BEETLE_SKILLS,
    ["Bird of Prey" ] = BIRDS_OF_PREY_SKILLS,
    ["Blood Beast"  ] = BLOOD_BEAST_SKILLS,
    ["Boar"         ] = BOAR_SKILLS,
    ["Carrion Bird" ] = CARRION_BIRD_SKILLS,
    ["Cat"          ] = CAT_SKILLS,
    ["Chimaera"     ] = CHIMAERAS_SKILLS,
    ["Clefthoof"    ] = CLEFTHOOVE_SKILLS,
    ["Core Hound"   ] = COREHOUND_SKILLS,
    ["Crab"         ] = CRAB_SKILLS,
    ["Crane"        ] = CRANE_SKILLS,
    ["Crocolisk"    ] = CROCOLISK_SKILLS,
    ["Devilsaur"    ] = DEVILSAUR_SKILLS,
    ["Direhorn"     ] = DIREHORN_SKILLS,
    ["Dog"          ] = DOGS_SKILLS,
    ["Dragonhawk"   ] = DRAGONHAWKS_SKILLS,
    ["Feathermane"  ] = FEATHERMANES_SKILLS,
    ["Fox"          ] = FOX_SKILLS,
    ["Goat"         ] = GOAT_SKILLS,
    ["Gorilla"      ] = GORILLA_SKILLS,
    ["Hydra"        ] = HYDRA_SKILLS,
    ["Hyena"        ] = HYENA_SKILLS,
    ["Krolusk"      ] = KROLUSK_SKILLS,
    ["Lizard"       ] = LIZARD_SKILLS,
    ["Mechanical"   ] = MECHANICAL_SKILLS,
    ["Monkey"       ] = MONKEY_SKILLS,
    ["Moth"         ] = MOTH_SKILLS,
    ["Oxen"         ] = OXEN_SKILLS,
    ["Pterrordax"   ] = PTERRORDAXE_SKILLS,
    ["Quilen"       ] = QUILLEN_SKILLS,
    ["Raptor"       ] = RAPTOR_SKILLS,
    ["Ravager"      ] = RAVAGER_SKILLS,
    ["Ray"          ] = RAY_SKILLS,
    ["Riverbeast"   ] = RIVERBEAST_SKILLS,
    ["Rodent"       ] = RODENT_SKILLS,
    ["Scalehide"    ] = SCALEHIDE_SKILLS,
    ["Scorpid"      ] = SCORPID_SKILLS,
    ["Serpent"      ] = SERPENT_SKILLS,
    ["Shale Spider" ] = SHALE_SPIDER_SKILLS,
    ["Silithid"     ] = SILITHID_SKILLS,
    ["Spider"       ] = SPIDER_SKILLS,
    ["Spirit Beast" ] = SPIRIT_BEAST_SKILLS,
    ["Sporebat"     ] = SPOREBATS_SKILLS,
    ["Stag"         ] = STAG_SKILLS,
    ["Tallstrider"  ] = TALLSTRIDER_SKILLS,
    ["Toad"         ] = TOAD_SKILLS,
    ["Turtle"       ] = TURTLE_SKILLS,
    ["Warp Stalker" ] = WARP_STALKERS_SKILLS,
    ["Wasp"         ] = WASP_SKILLS,
    ["Water Strider"] = WATER_STRIDER_SKILLS,
    ["Wind Serpent" ] = WIND_SERPENTS_SKILLS,
    ["Wolf"         ] = WOLF_SKILLS,
    ["Worm"         ] = WORMS_SKILLS,
}



AOTH.zones = {
    {"Abyssal Depths"                       , 204  },
    {"Ahn'Qiraj: The Fallen Kingdom"        , 327  },
    {"Arathi Highlands"                     , 14   },
    {"Ashenvale"                            , 63   },
    {"Ashran"                               , 588  },
    {"Azshara"                              , 76   },
    {"Azsuna"                               , 630  },
    {"Badlands"                             , 15   },
    {"Blasted Lands"                        , 17   },
    {"Borean Tundra"                        , 114  },
    {"Burning Steppes"                      , 36   },
    {"Darkshore"                            , 62   },
    {"Deathknell"                           , 465  },
    {"Deepholm"                             , 207  },
    {"Desolace"                             , 66   },
    {"Drustvar"                             , 896  },
    {"Dun Morogh"                           , 27   },
    {"Durotar"                              , 1    },
    {"Duskwood"                             , 47   },
    {"Dustwallow Marsh"                     , 70   },
    {"Eastern Plaguelands"                  , 23   },
    {"Elwynn Forest"                        , 37   },
    {"Felwood"                              , 77   },
    {"Feralas"                              , 69   },
    {"Frostfire Ridge"                      , 525  },
    {"Gorgrond"                             , 543  },
    {"Grizzly Hills"                        , 116  },
    {"Highmountain"                         , 650  },
    {"Hillsbrad Foothills"                  , 25   },
    {"Loch Modan"                           , 48   },
    {"Mechagon"                             , 1462 },
    {"Molten Front"                         , 338  },
    {"Mount Hyjal"                          , 198  },
    {"Mulgore"                              , 7    },
    {"Nagrand"                              , 107  },
    {"Nazjatar"                             , 1355 },
    {"Nazmir"                               , 863  },
    {"Netherstorm"                          , 109  },
    {"New Tinkertown"                       , 30   },
    {"Northern Barrens"                     , 10   },
    {"Northern Stranglethorn"               , 50   },
    {"Redridge Mountains"                   , 49   },
    {"Searing Gorge"                        , 32   },
    {"Shadowmoon Valley"                    , 539  },
    {"Sholazar Basin"                       , 119  },
    {"Silithus"                             , 81   },
    {"Silverpine Forest"                    , 21   },
    {"Southern Barrens"                     , 199  },
    {"Spires of Arak"                       , 542  },
    {"Stonetalon Mountains"                 , 65   },
    {"Stormheim"                            , 634  },
    {"Stormsong Valley"                     , 942  },
    {"Stormwind City"                       , 84   },
    {"Suramar"                              , 680  },
    {"Swamp of Sorrows"                     , 51   },
    {"Talador"                              , 535  },
    {"Tanaan Jungle"                        , 534  },
    {"Tanaris"                              , 71   },
    {"The Cape of Stranglethorn"            , 210  },
    {"The Hinterlands"                      , 26   },
    {"The Storm Peaks"                      , 120  },
    {"Thousand Needles"                     , 64   },
    {"Thunder Totem"                        , 652  },
    {"Timeless Isle"                        , 554  },
    {"Tiragarde Sound"                      , 895  },
    {"Tirisfal Glades"                      , 18   },
    {"Twilight Highlands"                   , 241  },
    {"Uldum (Corrupted)"                    , 1527 },
    {"Uldum"                                , 249  },
    {"Un'Goro Crater"                       , 78   },
    {"Val'sharah"                           , 641  },
    {"Vale of Eternal Blossoms (corrupted)" , 1530 },
    {"Vale of Eternal Blossoms"             , 390  },
    {"Vision of Stormwind"                  , 1470 },
    {"Vol'dun"                              , 864  },
    {"Western Plaguelands"                  , 22   },
    {"Westfall"                             , 52   },
    {"Wetlands"                             , 56   },
    {"Winterspring"                         , 83   },
    {"Zangarmarsh"                          , 102  },
    {"Zul'Drak"                             , 121  },
    {"Zuldazar"                             , 862  },
}

--[[
TODO: add mech rares,add elites 
]]
AOTH.test = {
  { ["zone_name"] = "Westfall"                      , [ "zoneID" ] = 52   , [ "name" ] = "Vultros"                     ,["maxlevel"] =62    ,["minlevel"] =15    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 507   ,["id"] = 462    ,["coords"] = {{48.4  , 33    },{49,28},{49,28.6},{49,32.2},{49,33.4},{49,33.6},{49,35.2},{49.2,26.8},{49.4,26.4},{49.8,32.4},{50.2,28.2},{50.2,33},{50.4,28.8},{54.2,24.2},{54.2,25},{54.4,25.8},{54.6,24.6},{55.2,35},{55.4,23.6},{55.6,35.6},{56,34.4},{56.2,33.4},{56.4,20.8},{56.4,35.2},{56.6,35.4},{56.6,35.6},{56.8,34},{57.2,19.4},{57.4,19.8},{57.6,19.4},{57.8,20.6},{58,18},{58,20.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Mother Fang"                 ,["maxlevel"] =62    ,["minlevel"] =12    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 36505 ,["id"] = 471    ,["coords"] = {{61    , 47    },{61.4,48},{61.6,47.4},{61.8,47.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Duskwood"                      , [ "zoneID" ] = 47   , [ "name" ] = "Lupos"                       ,["maxlevel"] =62    ,["minlevel"] =22    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 10278 ,["id"] = 521    ,["coords"] = {{58.8  , 18.6  },{59,20},{59.8,21},{60,22},{60.2,18.8},{60.2,22.8},{60.4,20},{60.6,21.2},{60.8,19.6},{63.8,19.4},{64.4,21.8},{64.8,20.6},{65,20},{65.2,18.2},{65.2,22},{65.4,19.4},{65.6,17.8},{65.6,19.6},{66,21.6},{66.2,20.8},{66.4,19.4},{66.6,19},{69,24.2},{69,25.2},{69.2,25.6},{69.4,22.8},{69.6,22.6},{69.8,25},{70,24.4},{70.4,25.6},{70.6,25},{70.8,22.2},{70.8,23.8},{71,22.8},{71.6,23}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Duskwood"                      , [ "zoneID" ] = 47   , [ "name" ] = "Naraxis"                     ,["maxlevel"] =62    ,["minlevel"] =23    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 963   ,["id"] = 574    ,["coords"] = {{86.4  , 48    },{86.6,49}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Redridge Mountains"            , [ "zoneID" ] = 49   , [ "name" ] = "Chatter"                     ,["maxlevel"] =62    ,["minlevel"] =21    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 37620 ,["id"] = 616    ,["coords"] = {{36.4  , 33.8  },{36.8,36.2},{37.4,34.2},{37.4,35.2},{37.4,36.6},{37.8,34.4},{37.8,34.8},{38,33.4},{38.2,35.8},{38.6,36.6},{38.8,34.4},{39,36.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Wetlands"                      , [ "zoneID" ] = 56   , [ "name" ] = "Leech Widow"                 ,["maxlevel"] =62    ,["minlevel"] =24    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 283   ,["id"] = 1112   ,["coords"] = {{46.8  , 63.4  },{46.8,63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Dun Morogh"                    , [ "zoneID" ] = 27   , [ "name" ] = "Bjarn"                       ,["maxlevel"] =62    ,["minlevel"] =16    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70185 ,["id"] = 1130   ,["coords"] = {{66.2  , 59.8  },{66.4,58.8},{67.2,58},{67.4,58.6},{67.8,58.4},{67.8,58.8},{69.2,55.8},{69.6,56.4},{69.8,56.8},{69.8,58.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "New Tinkertown"                , [ "zoneID" ] = 30   , [ "name" ] = "Timber"                      ,["maxlevel"] =62    ,["minlevel"] =5     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 10278 ,["id"] = 1132   ,["coords"] = {{66    , 33.6  },{66,37.2},{66.8,37.8},{67.2,35.6},{67.4,34},{67.4,35.4},{67.6,35},{67.6,35.8},{67.8,33.8},{67.8,37.4},{69,34.4},{69.6,38},{70,34.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Wetlands"                      , [ "zoneID" ] = 56   , [ "name" ] = "Razormaw Matriarch"          ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 11316 ,["id"] = 1140   ,["coords"] = {{69.8  , 29.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "The Cape of Stranglethorn"     , [ "zoneID" ] = 210  , [ "name" ] = "Scale Belly"                 ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      }, ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 45945 ,["id"] = 1552   ,["coords"] = {{67.8  , 25.2  },{68,25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Darkshore"                     , [ "zoneID" ] = 62   , [ "name" ] = "Strider Clutchmother"        ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 12  , "Tallstrider"   }, ["familySkills" ] = TALLSTRIDER_SKILLS   ,["displayID"] = 38    ,["id"] = 2172   ,["coords"] = {{40.8  , 48.4  },{40.8,48.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Darkshore"                     , [ "zoneID" ] = 62   , [ "name" ] = "Shadowclaw"                  ,["maxlevel"] =62    ,["minlevel"] =27    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 37555 ,["id"] = 2175   ,["coords"] = {{41.2  , 36.4  },{41.2,36.6},{41.6,36}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Loch Modan"                    , [ "zoneID" ] = 48   , [ "name" ] = "Gosh-Haldir"                 ,["maxlevel"] =62    ,["minlevel"] =20    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     }, ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 32813 ,["id"] = 2476   ,["coords"] = {{52.8  , 57.8  },{53,55.8},{53,56.8},{53.2,55.4},{53.6,54.2},{53.8,55},{54,53.4},{54,56.4},{54,56.6},{54,58},{54.2,59},{54.6,56.4},{54.6,57},{55.2,54.2},{55.4,53},{55.4,55.2},{55.6,53.4},{55.6,54.8},{55.6,55.8},{56,53.6},{56.4,51.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Barnabus"                    ,["maxlevel"] =62    ,["minlevel"] =55    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 9372  ,["id"] = 2753   ,["coords"] = {{39.4  , 58.2  },{39.4,59.4},{39.4,60.2},{39.8,59},{40.4,60},{40.6,60.2},{40.8,58.8},{41.2,58.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Broken Tooth"                ,["maxlevel"] =62    ,["minlevel"] =47    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 21192 ,["id"] = 2850   ,["coords"] = {{22.4  , 60.8  },{22.6,60},{22.8,60.6},{23,61.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Zaricotl"                    ,["maxlevel"] =62    ,["minlevel"] =45    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 37577 ,["id"] = 2931   ,["coords"] = {{55    , 43.2  },{55.4,44.4},{55.4,44.6},{55.4,45.8},{55.8,42.6},{56.4,43.8},{56.4,44.8},{56.6,43.4},{56.6,44}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Mulgore"                       , [ "zoneID" ] = 7    , [ "name" ] = "Arra'chea"                   ,["maxlevel"] =62    ,["minlevel"] =6     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 156 , "Scalehide"     }, ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 10916 ,["id"] = 3058   ,["coords"] = {{48    , 68.6  },{48.2,68.2},{48.6,67.8},{48.6,69.6},{49,69},{50.4,66.6},{50.4,68.4},{51,69},{51.2,66},{51.4,65.2},{51.6,65.4},{51.8,68.4},{52.4,63.8},{53.2,62.2},{53.4,61.4},{53.6,62.2},{53.8,69},{54.6,68},{54.8,62.4},{54.8,70},{55,68.6},{56.2,63.2},{56.2,70},{56.8,63.4},{57,65.8},{57.2,66.8},{57.8,67.6},{57.8,69}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Mulgore"                       , [ "zoneID" ] = 7    , [ "name" ] = "Mazzranache"                 ,["maxlevel"] =62    ,["minlevel"] =15    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 12  , "Tallstrider"   }, ["familySkills" ] = TALLSTRIDER_SKILLS   ,["displayID"] = 1961  ,["id"] = 3068   ,["coords"] = {{42.4  , 45.4  },{42.8,46.2},{43.6,41},{44.4,47.4},{45,46.4},{45.2,47.6},{45.4,47.4},{45.6,47.2},{46.8,46.8},{47.2,40.6},{47.2,46.2},{47.6,46.4},{48.8,43.4},{49.6,43.6},{50,42.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Southern Barrens"              , [ "zoneID" ] = 199  , [ "name" ] = "Silithid Harvester"          ,["maxlevel"] =62    ,["minlevel"] =35    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        }, ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 37581 ,["id"] = 3253   ,["coords"] = {{41.2  , 67    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 10   , [ "name" ] = "Gesharahan"                  ,["maxlevel"] =62    ,["minlevel"] =21    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         }, ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 1397  ,["id"] = 3398   ,["coords"] = {{40    , 74.6  },{40.4,74.2},{40.6,74.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Stormwind City"                , [ "zoneID" ] = 84   , [ "name" ] = "Sewer Beast"                 ,["maxlevel"] =50    ,["minlevel"] =50    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     }, ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 2850  ,["id"] = 3581   ,["coords"] = {{48.4  , 61.8  },{52.2,64.2},{54,68.2},{54.2,64.8},{54.2,68.6},{54.4,70.8},{54.6,65.6},{54.8,67.4},{54.8,67.6},{54.8,69.4},{55,70.6},{55.6,65},{56,72.8},{56.2,74.2},{56.2,76.6},{56.6,64.6},{57,75},{57.2,76.2},{57.6,73.4},{57.8,77.6},{58,41.2},{58.4,79.2},{59,43},{59.4,45.2},{59.8,44.2},{60.4,45.4},{60.4,72.2},{61.2,47.2},{61.4,47.6},{61.8,48.8},{62,51},{62.2,49.8},{62.6,50.6},{62.8,51.8},{63.6,49},{64.4,60.4},{65,65.4},{65.6,50.8},{65.6,64.6},{66,61.2},{66.4,64.2},{66.6,58.4},{66.6,61},{66.8,58.6},{67,55},{67.2,52.6},{67.4,54.2},{67.4,62},{67.4,62.6},{67.6,62.8},{67.8,62.2},{67.8,64},{67.8,66},{68.2,53.2},{68.6,53.4},{68.8,50.4},{68.8,50.6},{68.8,64.2},{69,65.4},{69.4,51.6},{69.4,63.4},{69.6,49.2},{69.8,50},{70,50.8},{70.2,65.8},{70.6,68},{71,48.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Pridewing Patriarch"         ,["maxlevel"] =120   ,["minlevel"] =28    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   }, ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 35655 ,["id"] = 4015   ,["coords"] = {{55    , 45    },{55.2,44.4},{55.4,46.4},{55.6,44.4},{55.6,44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Krkk'kx"                     ,["maxlevel"] =62    ,["minlevel"] =45    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 37583 ,["id"] = 4132   ,["coords"] = {{69.8  , 85.6  },{70,85.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Darkmist Widow"              ,["maxlevel"] =62    ,["minlevel"] =37    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 17814 ,["id"] = 4380   ,["coords"] = {{33.4  , 22.8  },{33.6,22.4},{33.6,22.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Antilus the Soarer"          ,["maxlevel"] =62    ,["minlevel"] =42    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   }, ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 10889 ,["id"] = 5347   ,["coords"] = {{53.4  , 68.8  },{53.6,70.8},{53.8,67.6},{53.8,70.4},{54,66.4},{54,71.6},{54.4,65.2},{54.4,67},{54.4,68.8},{54.6,65},{54.6,68.4},{54.6,73.6},{54.8,69},{55,65.8},{55.2,66.6},{55.2,70.8},{55.2,71.6},{55.4,70.2},{55.6,69.4},{55.6,69.8},{55.8,72.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Arash-ethis"                 ,["maxlevel"] =62    ,["minlevel"] =38    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  }, ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 7569  ,["id"] = 5349   ,["coords"] = {{37.4  , 22    },{37.8,23.4},{38,24},{38.4,21.6},{38.8,24.2},{38.8,24.6},{39,20.4},{39.4,20.6},{39.8,20.2},{39.8,21},{40.2,24.6},{40.4,22.4},{40.8,24.6},{41,22.6},{41.4,24}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Qirot"                       ,["maxlevel"] =62    ,["minlevel"] =50    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 11142 ,["id"] = 5350   ,["coords"] = {{73.4  , 64    },{73.6,64},{76.4,61.2},{76.6,61.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Old Grizzlegut"              ,["maxlevel"] =62    ,["minlevel"] =37    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 706   ,["id"] = 5352   ,["coords"] = {{55.4  , 61.2  },{55.4,62},{55.8,59.8},{55.8,62.4},{56,57.6},{56,58.6},{56.2,60.8},{56.2,62.8},{56.6,62.6},{57,58.2},{57.2,62.2},{57.6,58.8},{57.6,62.6},{58,58},{58,62.4},{58.6,62.4},{58.8,59},{59,62.6},{59.2,61},{59.6,60.2},{60,59.4},{60,60.8},{60.8,60.4},{60.8,62},{61,62.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Snarler"                     ,["maxlevel"] =62    ,["minlevel"] =54    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 780   ,["id"] = 5356   ,["coords"] = {{75.2  , 36.4  },{75.4,36.8},{75.6,36.8},{76,38.6},{76.4,38.2},{76.6,38.8},{77.8,37.8},{78.6,38},{79.4,39.2},{81.2,38.6},{81.4,39.8},{82,39.4},{82.2,39.8},{83.4,38.8},{84,38.2},{84.6,38}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Mulgore"                       , [ "zoneID" ] = 7    , [ "name" ] = "The Rake"                    ,["maxlevel"] =62    ,["minlevel"] =13    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 1973  ,["id"] = 5807   ,["coords"] = {{49.6  , 22    },{49.8,25},{50,23.2},{50.4,26.2},{50.6,26.6},{50.8,21.6},{51,28.4},{51.2,21.4},{51.8,21.4},{52.6,20.4},{52.6,20.6},{53.4,19.4},{53.4,29.6},{53.8,19.2},{54.4,20.2},{54.4,20.8},{54.6,20.8},{55.4,24},{55.4,24.6},{55.6,24.4},{55.8,25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Durotar"                       , [ "zoneID" ] = 1    , [ "name" ] = "Death Flayer"                ,["maxlevel"] =62    ,["minlevel"] =16    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 2491  ,["id"] = 5823   ,["coords"] = {{34.4  , 44.6  },{34.8,43.4},{35,44.2},{35.4,45.2},{35.4,46},{35.6,45.6},{36.4,44.4},{36.4,44.6},{36.6,44.4},{37,44.6},{37.2,45.8},{37.2,47.6},{37.4,46.8},{37.8,47.8},{38,44.6},{38.2,44.2},{38.4,43.4},{38.4,46.8},{38.6,44},{38.6,44.6},{38.8,48.6},{39,46.4},{39.2,46.6},{39.6,45.2},{39.6,45.6},{39.8,44}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 10   , [ "name" ] = "Humar the Pridelord"         ,["maxlevel"] =62    ,["minlevel"] =21    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 4424  ,["id"] = 5828   ,["coords"] = {{67.2  , 64    },{67.4,64.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Southern Barrens"              , [ "zoneID" ] = 199  , [ "name" ] = "Snort the Heckler"           ,["maxlevel"] =62    ,["minlevel"] =34    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         }, ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 34324 ,["id"] = 5829   ,["coords"] = {{45.4  , 43.4  },{45.4,43.6},{45.6,43.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 10   , [ "name" ] = "Swiftmane"                   ,["maxlevel"] =62    ,["minlevel"] =20    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 151 , "Stag"          }, ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 6084  ,["id"] = 5831   ,["coords"] = {{63.2  , 63.4  },{64.8,60.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Southern Barrens"              , [ "zoneID" ] = 199  , [ "name" ] = "Thunderstomp"                ,["maxlevel"] =62    ,["minlevel"] =34    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 156 , "Scalehide"     }, ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 37778 ,["id"] = 5832   ,["coords"] = {{44.4  , 77.4  },{44.4,77.6},{44.4,80},{44.6,77.4},{44.6,80.2},{46.2,79},{46.4,78.2},{48.2,74.4},{48.2,74.6},{49.8,79.2},{49.8,80.2},{49.8,80.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Southern Barrens"              , [ "zoneID" ] = 199  , [ "name" ] = "Azzere the Skyblade"         ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  }, ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 2702  ,["id"] = 5834   ,["coords"] = {{42.2  , 53.4  },{42.2,54},{42.4,54.8},{42.8,53.6},{43,54.6},{43,56.2},{43.4,56.6},{43.6,57.4},{43.6,58.2},{43.8,54.8},{44,56},{44.2,59},{44.6,56.2},{45,58.8},{46,57.4},{46.2,55.2},{46.2,57.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 10   , [ "name" ] = "Takk the Leaper"             ,["maxlevel"] =62    ,["minlevel"] =24    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 1337  ,["id"] = 5842   ,["coords"] = {{63.4  , 36    },{63.4,36.6},{63.6,35.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 10   , [ "name" ] = "Dishu"                       ,["maxlevel"] =62    ,["minlevel"] =25    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 1043  ,["id"] = 5865   ,["coords"] = {{45.2  , 52.8  },{45.4,33},{48.8,51.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Sorrow Wing"                 ,["maxlevel"] =62    ,["minlevel"] =27    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   }, ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 11012 ,["id"] = 5928   ,["coords"] = {{50.2  , 41.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Ironeye the Invincible"      ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      }, ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 46055 ,["id"] = 5935   ,["coords"] = {{61.2  , 67    },{61.2,67.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Vile Sting"                  ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 10988 ,["id"] = 5937   ,["coords"] = {{5.4   , 42    },{5.6,42.6},{6,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Un'Goro Crater"                , [ "zoneID" ] = 78   , [ "name" ] = "Ravasaur Matriarch"          ,["maxlevel"] =62    ,["minlevel"] =45    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 11319 ,["id"] = 6581   ,["coords"] = {{60.8  , 72.8  },{66.4,67}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Un'Goro Crater"                , [ "zoneID" ] = 78   , [ "name" ] = "Clutchmother Zavas"          ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 11084 ,["id"] = 6582   ,["coords"] = {{76.8  , 52.4  },{78.6,47.8},{80.2,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Un'Goro Crater"                , [ "zoneID" ] = 78   , [ "name" ] = "Gruff"                       ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 156 , "Scalehide"     }, ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 37587 ,["id"] = 6583   ,["coords"] = {{31.8  , 78.2  },{32,78.6},{33,79.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Un'Goro Crater"                , [ "zoneID" ] = 78   , [ "name" ] = "King Mosh"                   ,["maxlevel"] =62    ,["minlevel"] =50    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 39  , "Devilsaur"     }, ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 5305  ,["id"] = 6584   ,["coords"] = {{29    , 36.4  },{29,36.8},{29.2,47.4},{29.4,42.4},{29.4,46},{29.6,45.8},{29.8,37},{30,35.6},{30,44.4},{30.2,45.4},{30.2,46.8},{30.8,31.8},{31.2,29.4},{31.4,30},{31.4,36.6},{32,30.4},{32,31},{32.6,30.4},{32.6,36.6},{32.8,31},{33.4,28.4},{33.4,29.4},{33.4,35.6},{33.8,37.2},{34.4,38},{35.2,35.8},{35.2,36.8},{35.2,37.6},{35.2,39},{35.4,35.2},{35.6,35.8},{36.2,37},{36.4,30.6},{36.4,35.4},{36.8,32.2},{36.8,34.8},{37,31.4},{37,33.8},{37.4,30.2},{37.6,31}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Un'Goro Crater"                , [ "zoneID" ] = 78   , [ "name" ] = "Uhk'loc"                     ,["maxlevel"] =62    ,["minlevel"] =50    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 9   , "Gorilla"       }, ["familySkills" ] = GORILLA_SKILLS       ,["displayID"] = 8129  ,["id"] = 6585   ,["coords"] = {{62.8  , 18.4  },{63,18.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Azshara"                       , [ "zoneID" ] = 76   , [ "name" ] = "Antilos"                     ,["maxlevel"] =62    ,["minlevel"] =31    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   }, ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 3212  ,["id"] = 6648   ,["coords"] = {{44.4  , 26.4  },{44.4,26.6},{44.4,27.6},{44.6,26.4},{44.8,27.2},{44.8,28}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Soriid the Devourer"         ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 14521 ,["id"] = 8204   ,["coords"] = {{53.4  , 67.8  },{53.4,70.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Haarka the Ravenous"         ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15439 ,["id"] = 8205   ,["coords"] = {{58.2  , 23.4  },{60.2,27.8},{60.6,21.6},{60.8,25.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Emberwing"                   ,["maxlevel"] =62    ,["minlevel"] =44    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 34048 ,["id"] = 8207   ,["coords"] = {{44.4  , 40.4  },{44.4,40.6},{44.6,40.4},{44.6,40.6},{48.2,45.4},{48.2,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Tanaris "                      , [ "zoneID" ] = 71   , [ "name" ] = "Murderous Blisterpaw"        ,["maxlevel"] ="???" ,["minlevel"] ="???" , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         }, ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 1534  ,["id"] = 8208   ,["coords"] = {{47.4  , 25.2  },{47.6,25.8},{47.8,30},{48,27},{48.6,31.6},{49,31.4},{49.6,31.8},{50,32.6},{51.2,32.6},{51.6,32},{52.4,32.8},{53.4,32.2},{53.4,32.8},{54,32.4},{54.4,32.6},{55,33.4},{55,33.8},{55.4,36.6},{56.4,36.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "The Hinterlands"               , [ "zoneID" ] = 26   , [ "name" ] = "Old Cliff Jumper"            ,["maxlevel"] =62    ,["minlevel"] =36    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 11414 ,["id"] = 8211   ,["coords"] = {{13.2  , 53.8  },{13.6,53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "The Hinterlands"               , [ "zoneID" ] = 26   , [ "name" ] = "Ironback"                    ,["maxlevel"] =62    ,["minlevel"] =32    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        }, ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 37770 ,["id"] = 8213   ,["coords"] = {{79.4  , 56.6  },{80.2,56.4},{80.2,58.2},{80.4,57},{80.6,56.2},{81,55.4},{81,57.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Rekk'tilac"                  ,["maxlevel"] =62    ,["minlevel"] =56    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 37685 ,["id"] = 8277   ,["coords"] = {{29.2  , 67.8  },{30.2,68.6},{30.4,70.2},{30.4,71},{30.4,71.8},{30.6,69.8},{30.6,71.2},{30.6,72.2},{31.2,69.4},{31.6,72},{31.8,73.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Blasted Lands"                 , [ "zoneID" ] = 17   , [ "name" ] = "Spiteflayer"                 ,["maxlevel"] =62    ,["minlevel"] =61    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 37536 ,["id"] = 8299   ,["coords"] = {{59.4  , 35.4  },{59.4,36.6},{59.4,38.2},{59.6,36.8},{59.6,38.2},{59.8,35.2},{60,34.2},{60,38.8},{60.4,33.2},{60.6,33.2},{60.8,40},{61.4,40.6},{61.6,32.6},{61.8,32.4},{62,36.6},{62,40.2},{62.4,41},{63.2,40.2},{63.4,33},{63.4,33.6},{63.6,33},{63.6,40.6},{64,33.6},{64,39.4},{64,39.6},{64.4,38},{64.6,33.6},{64.6,36},{64.6,37.2},{64.6,39.4},{64.8,35.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Blasted Lands"                 , [ "zoneID" ] = 17   , [ "name" ] = "Ravage"                      ,["maxlevel"] =62    ,["minlevel"] =53    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         }, ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 34324 ,["id"] = 8300   ,["coords"] = {{49    , 34.4  },{49,35.4},{49.4,36.2},{49.6,34.4},{49.6,35.6},{49.8,35}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Blasted Lands"                 , [ "zoneID" ] = 17   , [ "name" ] = "Clack the Reaver"            ,["maxlevel"] =62    ,["minlevel"] =52    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 15433 ,["id"] = 8301   ,["coords"] = {{47.2  , 13.8  },{47.2,14.6},{47.6,14.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Blasted Lands"                 , [ "zoneID" ] = 17   , [ "name" ] = "Deatheye"                    ,["maxlevel"] =62    ,["minlevel"] =50    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      }, ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 46053 ,["id"] = 8302   ,["coords"] = {{51.2  , 27.2  },{51.6,25.6},{52.2,27.8},{52.4,27.4},{52.4,29},{52.6,27.8},{53.2,26.8},{53.4,26.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Blasted Lands"                 , [ "zoneID" ] = 17   , [ "name" ] = "Grunter"                     ,["maxlevel"] =62    ,["minlevel"] =53    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 24741 ,["id"] = 8303   ,["coords"] = {{54.4  , 39.4  },{54.4,39.8},{54.8,39},{55.2,38.4},{55.4,40.2},{55.6,39.4},{55.6,40}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Azshara"                       , [ "zoneID" ] = 76   , [ "name" ] = "The Evalcharr"               ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      }, ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 37569 ,["id"] = 8660   ,["coords"] = {{13.8  , 50.6  },{14.4,50.4},{14.4,57.4},{14.4,57.6},{14.6,57.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Deathmaw"                    ,["maxlevel"] =62    ,["minlevel"] =59    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 37671 ,["id"] = 10077  ,["coords"] = {{62.8  , 31.4  },{63.2,32.2},{63.4,32.6},{67.4,54.6},{68.4,55.2},{70,56.2},{70.2,56.8},{70.6,31.2},{70.8,29.8},{72.2,59},{73,51.6},{73.6,51.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Rak'shiri"                   ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 10054 ,["id"] = 10200  ,["coords"] = {{46.8  , 19.4  },{47,19.6},{47.4,18.2},{47.8,18.8},{48.4,17.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Bayne"                       ,["maxlevel"] =62    ,["minlevel"] =6     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 52  , "Dog"           }, ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 37773 ,["id"] = 10356  ,["coords"] = {{45.4  , 48.8  },{45.8,48.4},{45.8,48.6},{46,49.6},{46.6,50.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Ressan the Needler"          ,["maxlevel"] =62    ,["minlevel"] =8     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 24  , "Bat"           }, ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 16053 ,["id"] = 10357  ,["coords"] = {{52.2  , 56.4  },{53.2,56.4},{53.4,57.4},{53.4,57.8},{53.6,57.4},{53.6,58},{53.6,58.6},{54.2,56.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Sri'skulk"                   ,["maxlevel"] =62    ,["minlevel"] =12    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 22185 ,["id"] = 10359  ,["coords"] = {{84.4  , 49.2  },{84.4,49.6},{84.6,49.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Ashenvale"                     , [ "zoneID" ] = 63   , [ "name" ] = "Mist Howler"                 ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 165   ,["id"] = 10644  ,["coords"] = {{25.2  , 26.8  },{26.2,15.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Sian-Rotam"                  ,["maxlevel"] =62    ,["minlevel"] =52    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 10114 ,["id"] = 10741  ,["coords"] = {{45.8  , 17.4  },{45.8,17.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Ashenvale"                     , [ "zoneID" ] = 63   , [ "name" ] = "Ursol'lok"                   ,["maxlevel"] =62    ,["minlevel"] =28    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70188 ,["id"] = 12037  ,["coords"] = {{89.4  , 46.4  },{89.4,46.6},{89.4,47.6},{89.6,46.4},{89.6,46.6},{92.8,45.4},{92.8,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Gorefang"                    ,["maxlevel"] =62    ,["minlevel"] =15    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 11413 ,["id"] = 12431  ,["coords"] = {{56    , 23    },{56.2,25.2},{56.4,24.4},{56.6,24},{56.8,23.2},{57.2,16},{57.4,15.4},{57.4,17.4},{57.8,16.2},{57.8,16.8},{58,15.2},{58.6,15},{58.6,16},{60,9},{60.2,9.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Krethis the Shadowspinner"   ,["maxlevel"] =62    ,["minlevel"] =21    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 22185 ,["id"] = 12433  ,["coords"] = {{34.6  , 15.6  },{34.6,17.6},{35.2,15.2},{35.4,14.2},{35.4,16.8},{35.6,17.4},{35.6,18.2},{36.2,15.2},{36.2,15.6},{36.4,14},{36.6,16},{36.6,17},{36.8,14.4},{37,14.6},{37.4,17.6},{37.6,17.4},{37.8,16.2},{38.4,14.2},{38.4,14.8},{38.6,14.2},{38.6,14.6},{38.6,16}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Araga"                       ,["maxlevel"] =62    ,["minlevel"] =31    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 37735 ,["id"] = 14222  ,["coords"] = {{44.2  , 54    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Cranky Benj"                 ,["maxlevel"] =62    ,["minlevel"] =32    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        }, ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 21240 ,["id"] = 14223  ,["coords"] = {{56.6  , 61.6  },{57.2,61.2},{57.4,60},{58,59},{58,60.8},{58.4,59.6},{59.2,58.6},{59.4,58.4},{59.8,58.4},{60.2,57},{60.4,55.2},{60.4,56.4},{60.6,47.4},{60.6,55.2},{60.6,56.4},{60.8,50.8},{60.8,52},{60.8,52.8},{60.8,54},{61,47.8},{61.2,45.4},{61.4,41.6},{61.4,43},{61.4,44.4},{61.6,42},{61.6,43},{61.6,43.6},{61.6,48},{62.2,40.4},{62.8,39.2},{63,39.8},{63,40.8},{64,38.6},{64.6,37.2},{65.4,36},{65.8,36.4},{67.2,34.8},{68.4,30.6},{68.6,32.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Desolace"                      , [ "zoneID" ] = 66   , [ "name" ] = "Hissperak"                   ,["maxlevel"] =62    ,["minlevel"] =39    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      }, ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 45445 ,["id"] = 14227  ,["coords"] = {{41.8  , 47.2  },{42.4,45.8},{42.6,46.6},{43,42.6},{43,61.2},{43,61.8},{43.4,41.8},{43.8,61},{46.2,53},{46.4,54},{51.4,47.6},{51.4,48.8},{51.6,48.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Desolace"                      , [ "zoneID" ] = 66   , [ "name" ] = "Giggler"                     ,["maxlevel"] =62    ,["minlevel"] =32    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         }, ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 2714  ,["id"] = 14228  ,["coords"] = {{57.4  , 8.4   },{57.4,10},{58,9},{58.6,18.4},{59,17.2},{60,25.4},{60.2,24},{60.8,24.6},{61,24.2},{61,25.6},{63,34.2},{63,34.8},{63.8,19.6},{64.2,19.4},{64.2,33.6},{66,24.2},{66.2,25},{66.4,25.8},{66.6,25.2},{66.6,26.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Dart"                        ,["maxlevel"] =62    ,["minlevel"] =50    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 788   ,["id"] = 14232  ,["coords"] = {{46.8  , 17.4  },{47,18.2},{47.2,18.6},{47.4,15},{47.4,16.2},{47.4,20},{47.8,19.2},{48.2,14.2},{48.4,15.2},{48.4,15.8},{48.4,16.6},{49,17.2},{49,18},{49,18.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Ripscale"                    ,["maxlevel"] =62    ,["minlevel"] =47    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     }, ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 37748 ,["id"] = 14233  ,["coords"] = {{37.6  , 49.2  },{37.6,50.6},{37.8,50.4},{41.8,55.2},{42.2,55.8},{42.6,54.6},{43.6,50.8},{43.8,50},{47.4,54.4},{47.4,54.6},{47.4,55.6},{47.6,54.4},{47.6,54.6},{47.6,55.8},{49,57.6},{49.2,57.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Hayoc"                       ,["maxlevel"] =62    ,["minlevel"] =46    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  }, ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 2703  ,["id"] = 14234  ,["coords"] = {{47.4  , 61.4  },{47.4,61.6},{47.6,61.4},{47.6,61.6},{47.8,63.2},{48.4,59.8},{48.6,60.4},{48.6,60.8},{48.6,61.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Oozeworm"                    ,["maxlevel"] =62    ,["minlevel"] =46    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 42  , "Worm"          }, ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 12336 ,["id"] = 14237  ,["coords"] = {{36.4  , 62.4  },{37,62.4},{37,62.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Loch Modan"                    , [ "zoneID" ] = 48   , [ "name" ] = "Shanda the Spinner"          ,["maxlevel"] =62    ,["minlevel"] =22    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 34437 ,["id"] = 14266  ,["coords"] = {{61.4  , 73.4  },{61.4,73.6},{61.6,74.4},{61.6,74.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Loch Modan"                    , [ "zoneID" ] = 48   , [ "name" ] = "Lord Condar"                 ,["maxlevel"] =62    ,["minlevel"] =22    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 25868 ,["id"] = 14268  ,["coords"] = {{66.2  , 71.2  },{66.2,73.2},{67.4,76},{68.8,75},{69,73.8},{70.8,73.4},{70.8,74.4},{70.8,75},{70.8,75.6},{71,72.2},{72,71},{72.2,72.4},{72.2,72.6},{73,71},{73,72.2},{73.2,72.6},{73.6,71.2},{73.8,71.6},{74.2,65.8},{74.2,68.6},{74.4,70},{74.6,68.8},{74.8,66.2},{74.8,67.2},{74.8,67.6},{74.8,73.6},{75,71.2},{75.4,73},{75.8,63},{75.8,73},{76,73.8},{76.2,62},{77,74},{77.2,73.4},{77.6,74},{77.8,64.6},{78,67.6},{78,70.2},{78,73},{78,76},{78.2,64.4},{78.2,68.8},{78.2,71.2},{78.2,71.8},{78.2,74.6},{78.4,67},{78.6,64.4},{78.6,64.6},{78.6,68.8},{78.6,70.2},{78.6,71.2},{78.8,67.6},{78.8,72.4},{79,63},{79,67},{79.2,66}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Creepthess"                  ,["maxlevel"] =62    ,["minlevel"] =22    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 37738 ,["id"] = 14279  ,["coords"] = {{43.4  , 75.2  },{43.6,74.8},{43.8,74.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Big Samras"                  ,["maxlevel"] =62    ,["minlevel"] =43    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70189 ,["id"] = 14280  ,["coords"] = {{63.4  , 52.6  },{63.6,52.4},{63.6,52.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Death Howl"                  ,["maxlevel"] =62    ,["minlevel"] =42    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 36341 ,["id"] = 14339  ,["coords"] = {{48.2  , 74.4  },{48.2,74.8},{48.4,73.4},{48.6,75},{53.4,85.6},{53.8,84.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Olm the Wise"                ,["maxlevel"] =62    ,["minlevel"] =58    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 37568 ,["id"] = 14343  ,["coords"] = {{54.4  , 26.4  },{54.4,26.8},{54.6,27.2},{54.8,23.2},{55.2,24},{56.2,23.6},{56.4,23.4},{56.6,23.2},{56.6,23.6},{57,18.4},{57.4,19.4},{57.4,19.6},{57.8,19.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Mongress"                    ,["maxlevel"] =62    ,["minlevel"] =44    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70186 ,["id"] = 14344  ,["coords"] = {{43.4  , 75.8  },{43.6,75.6},{46.8,82}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Teldrassil"                    , [ "zoneID" ] = 57   , [ "name" ] = "Duskstalker"                 ,["maxlevel"] =62    ,["minlevel"] =12    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 37558 ,["id"] = 14430  ,["coords"] = {{52.2  , 67.4  },{52.2,67.6},{54,66.6},{54.2,66.2},{57,66.4},{57.4,66.6},{57.6,66.4},{57.6,66.8},{59.4,64.4},{59.4,65.6},{59.6,65.2},{59.6,65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Gretheer"                    ,["maxlevel"] =62    ,["minlevel"] =44    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 1104  ,["id"] = 14472  ,["coords"] = {{35.6  , 38    }, {35.8, 39.6}, {36, 38.8}, {36.4, 42}, {36.6, 38}, {36.6, 39.4}, {36.6, 39.8}, {44.4, 51}, {44.6, 49}, {45.2, 50.2}, {45.2, 51.4}, {45.2, 51.6}, {45.6, 50.4}, {51.6, 56.2}, {52.2, 55.2}, {53, 54.6}, {53, 55.8}, {64, 57.6}, {64.4, 58.6}, {64.6, 58}, {64.6, 58.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Lapress"                     ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 37593 ,["id"] = 14473  ,["coords"] = {{55.4  , 71    }, {56, 74.4}, {57.2, 75}, {57.6, 76}, {58.6, 66.8}, {60.8, 68.8}, {61.6, 66}, {63, 73.4}, {63, 74.4}, {63.6, 82}, {65.6, 75.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Zora"                        ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 37548 ,["id"] = 14474  ,["coords"] = {{27    , 62    }, {32, 55.8}, {33.8, 53.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Rex Ashil"                   ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 37579 ,["id"] = 14475  ,["coords"] = {{51    , 23    }, {51.4, 26.6}, {51.6, 26.6}, {51.8, 23.8}, {51.8, 25.6}, {52, 24.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Krellack"                    ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 6068  ,["id"] = 14476  ,["coords"] = {{62.4  , 18.4  }, {62.4, 18.6}, {62.8, 18.8}, {64.4, 39}, {64.4, 39.8}, {64.6, 39.8}, {64.8, 39.4}, {67.2, 29.2}, {67.4, 29.8}, {67.8, 29.4}, {69.2, 36.8}, {69.8, 37.4}, {69.8, 37.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Grubthor"                    ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 42  , "Worm"          }, ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 14523 ,["id"] = 14477  ,["coords"] = {{34    , 73.2  }, {34.4, 71}, {34.6, 72.4}, {34.6, 72.8}, {35.2, 71}, {41, 65.8}, {41.2, 64.4}, {41.2, 64.8}, {48.8, 71.4}, {48.8, 72}, {49.2, 72.6}, {49.4, 63.8}, {49.6, 71}, {49.6, 72.4}, {50, 62.8}, {50.2, 61.4}, {50.2, 63.8}, {50.8, 62.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "The Cape of Stranglethorn"     , [ "zoneID" ] = 210  , [ "name" ] = "Kurmokk"                     ,["maxlevel"] =62    ,["minlevel"] =35    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 9   , "Gorilla"       }, ["familySkills" ] = GORILLA_SKILLS       ,["displayID"] = 3188  ,["id"] = 14491  ,["coords"] = {{48    , 58    },{48.2,57.4},{49.4,56.6},{49.6,56.4},{50.6,55.6},{50.8,55},{51,54.4},{51.4,53.4},{51.8,53.8},{52.2,53.2},{52.8,53.2},{53.6,53.2},{54.4,52.2},{54.8,51.8},{55.4,51.2},{55.6,51.2},{56.2,50.2},{56.2,52.8},{57.2,49.2},{58,47.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Goretooth"                   ,["maxlevel"] =82    ,["minlevel"] =82    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     }, ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 20763 ,["id"] = 17144  ,["coords"] = {{41.4  , 41.4  },{44,47},{44.8,40.4},{58.2,27.8},{74.6,76},{75.8,75.6},{76,79.6},{76,80.8},{76.2,78}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Desolace"                      , [ "zoneID" ] = 66   , [ "name" ] = "Crusty"                      ,["maxlevel"] =62    ,["minlevel"] =39    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 27692 ,["id"] = 18241  ,["coords"] = {{34.4  , 21.6  },{34.4,23.4},{34.4,24},{34.6,20.8},{34.6,22.4},{34.6,23.2},{34.6,24.4},{35,20},{35.2,25.4},{35.8,24},{36,20.4},{36,25.2},{36.2,22.4},{36.4,23.4},{37,19.8},{37.2,20.8},{37.6,20.2},{38,20.8},{38.4,19},{39,18.2},{39.6,18},{41.2,18.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Zangarmarsh"                   , [ "zoneID" ] = 102  , [ "name" ] = "Marticar"                    ,["maxlevel"] =82    ,["minlevel"] =70    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 126 , "Water Strider" }, ["familySkills" ] = WATER_STRIDER_SKILLS ,["displayID"] = 45045 ,["id"] = 18680  ,["coords"] = {{9.8   , 52.2  },{10.8,47.2},{10.8,55.2},{11,50.4},{11.2,46.4},{13.4,45.4},{14,44.6},{14.6,44.6},{14.8,44.4},{15,40.4},{15,43.4},{16,38.2},{16.8,36.2},{17.6,34.6},{37.8,38.4},{38.8,33.8},{40.4,33.6},{41.4,33.2},{42.2,33.6},{42.6,34.4},{43,34.6},{43.6,34.8},{44.6,34.2},{47,32},{47.4,30.6},{47.8,30},{50,30.8},{52.4,32.4},{52.8,33},{54,33},{54.8,33.8},{70.2,39.8},{70.4,37.4},{73.6,36.2},{73.8,46.6},{75.8,48.4},{77,51.4},{78.8,53.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Netherstorm"                   , [ "zoneID" ] = 109  , [ "name" ] = "Nuramoc"                     ,["maxlevel"] =82    ,["minlevel"] =82    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      }, ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 19913 ,["id"] = 20932  ,["coords"] = {{23.2  , 78.8  },{24.8,80.2},{26.8,81.4},{33,32},{34.2,20.8},{34.4,25},{34.4,27.6},{35,26},{35.2,19.6},{35.4,24.8},{35.6,24.4},{35.6,78},{38.4,78.4},{39.4,77.8},{40.4,77.2},{44.2,71.8},{54.2,59.8},{57.2,60.2},{63.6,58.8},{65.6,58.2},{67.6,60.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Borean Tundra"                 , [ "zoneID" ] = 114  , [ "name" ] = "Icehorn"                     ,["maxlevel"] =82    ,["minlevel"] =70    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     }, ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 26286 ,["id"] = 32361  ,["coords"] = {{80.4  , 46    },{80.6,46.2},{81.2,31.6},{81.4,31.4},{81.6,32},{84.6,46.8},{85.4,34.4},{85.6,34.4},{85.8,34.6},{88.2,39.6},{88.4,39.4},{88.6,39.8},{91.4,32.4},{91.4,32.6},{91.6,32.4},{91.6,32.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Zul'Drak"                      , [ "zoneID" ] = 121  , [ "name" ] = "Terror Spinner"              ,["maxlevel"] =82    ,["minlevel"] =72    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 27683 ,["id"] = 32475  ,["coords"] = {{52.6  , 32    },{53.2,31.4},{61.2,36.4},{61.2,36.6},{71.4,23.2},{71.4,23.8},{71.4,28.4},{71.4,29},{71.6,23.4},{71.6,24.2},{71.6,28.8},{71.8,24.6},{72,28.4},{74,66},{74.4,66.6},{74.6,66.4},{75.2,66.6},{77.2,42.2},{77.2,42.8},{77.8,42.8},{81.4,34.4},{81.4,34.6},{81.6,34.4},{82,35}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Sholazar Basin"                , [ "zoneID" ] = 119  , [ "name" ] = "Aotona"                      ,["maxlevel"] =82    ,["minlevel"] =72    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 27975 ,["id"] = 32481  ,["coords"] = {{54.8  , 51.8  }, {57.0, 65.0}, {52.6, 72.2}, {44.4, 69.8}, {41.6, 68}, {40.6, 58.6}, {43.2, 52.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Sholazar Basin"                , [ "zoneID" ] = 119  , [ "name" ] = "King Krush"                  ,["maxlevel"] =82    ,["minlevel"] =73    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 39  , "Devilsaur"     }, ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 28052 ,["id"] = 32485  ,["coords"] = {{48.6  , 41.8  }, {58.0, 82.6}, {33.2, 32.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Sholazar Basin"                , [ "zoneID" ] = 119  , [ "name" ] = "Loque'nahak"                 ,["maxlevel"] =82    ,["minlevel"] =73    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 28010 ,["id"] = 32517  ,["coords"] = {{58.80 , 22.01 }, {36.00, 30.00}, {31.00, 66.00}, {21.8, 70.6}, {51.2, 81.4}, {67.00, 78.8}, {71.4, 71.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }, },
  { ["zone_name"] = "Zul'Drak"                      , [ "zoneID" ] = 121  , [ "name" ] = "Gondria"                     ,["maxlevel"] =82    ,["minlevel"] =67    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 28871 ,["id"] = 33776  ,["coords"] = {{61    , 63.4  },{61.4,61.6},{61.6,62.6},{63.2,42.8},{63.6,43.2},{67.4,77.6},{67.6,77.8},{67.8,77.4},{69.4,48.4},{69.6,48.2},{77.2,70},{77.6,70}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "The Storm Peaks"               , [ "zoneID" ] = 120  , [ "name" ] = "Skoll"                       ,["maxlevel"] =82    ,["minlevel"] =82    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 29673 ,["id"] = 35189  ,["coords"] = {{27.8  , 50.4  },{27.8,50.8},{30.2,64.4},{30.2,64.6},{46.2,64.4},{46.2,64.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Grizzly Hills"                 , [ "zoneID" ] = 116  , [ "name" ] = "Arcturis"                    ,["maxlevel"] =82    ,["minlevel"] =73    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 31094 ,["id"] = 38453  ,["coords"] = {{31    , 55.8  },{31.2,55.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Scorpitar"                   ,["maxlevel"] =62    ,["minlevel"] =53    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 31351 ,["id"] = 39183  ,["coords"] = {{49.4  , 58.4  },{49.4,58.8},{49.6,58.4},{49.6,58.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Slaverjaw"                   ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         }, ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 31352 ,["id"] = 39185  ,["coords"] = {{40    , 67.8  },{40.2,67.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Hellgazer"                   ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      }, ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 45946 ,["id"] = 39186  ,["coords"] = {{40.8  , 41.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Loch Modan"                    , [ "zoneID" ] = 48   , [ "name" ] = "Ashtail"                     ,["maxlevel"] =62    ,["minlevel"] =25    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 50  , "Fox"           }, ["familySkills" ] = FOX_SKILLS           ,["displayID"] = 30239 ,["id"] = 45380  ,["coords"] = {{66.6  , 40    },{67.6,42.8},{68.4,37.8},{68.8,36},{68.8,38.2},{69.6,42},{70,37.4},{70,37.6},{70.4,35.6},{70.6,36.2},{70.8,36.8},{71,42.8},{72.2,37},{72.4,36.2},{72.4,42.2},{72.8,42.2},{73,35.4},{73,36},{73,43.4},{73.2,36.6},{73.2,44.6},{73.6,42.8},{73.6,44},{73.8,36.4},{74,34},{74.2,44.8},{74.6,43.8},{75.2,42.6},{76.2,42.8},{76.2,43.8},{76.4,38.4},{76.4,42.4},{76.6,35},{77,36.8},{77,39},{77.6,41.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Loch Modan"                    , [ "zoneID" ] = 48   , [ "name" ] = "Nix"                         ,["maxlevel"] =62    ,["minlevel"] =22    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 18723 ,["id"] = 45402  ,["coords"] = {{50.4  , 37.8  },{50.8,36},{50.8,37.4},{51.2,37.8},{51.2,40.6},{51.8,41},{52.2,36},{52.2,40.4},{52.2,41.6},{52.4,34.8},{52.6,41.2},{53,33.8},{53.2,35},{53.2,42.2},{53.8,35.2},{53.8,41},{53.8,43.2},{54.6,41},{55.4,34.6},{55.4,35.8},{55.4,40.2},{55.4,42},{55.6,35.4},{55.8,39},{55.8,41.8},{55.8,42.6},{56,37},{56.8,38.2},{56.8,41.6},{57,36.8},{57.2,34.2},{57.4,34.8},{57.4,35.8},{57.4,38.6},{57.4,40},{57.4,42.6},{57.6,36},{57.6,38},{57.6,42.6},{57.8,40.2},{57.8,40.6},{57.8,42.2},{58.2,36.6},{58.4,38.6},{58.8,39.8},{58.8,41.6},{59,39},{59.4,40.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Ainamiss the Hive Queen"     ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 37549 ,["id"] = 47386  ,["coords"] = {{32.4  , 48.6  },{33,48.8},{33.8,46},{34,45.4},{35,44.6},{35.4,44.4},{36.4,42.4},{36.4,42.6},{36.6,42.4},{36.6,42.6},{36.8,43.8},{36.8,46.6},{36.8,47.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Harakiss the Infestor"       ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15657 ,["id"] = 47387  ,["coords"] = {{50.4  , 72.4  },{50.4,72.8},{50.6,72.2},{50.6,72.6},{52.4,65.4},{52.4,65.8},{52.6,65.4},{52.6,65.6},{52.8,70.6},{53,70.4},{55.6,64.4},{55.8,64.6},{56.2,68.8},{56.4,68.4},{56.6,68.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Deepholm"                      , [ "zoneID" ] = 207  , [ "name" ] = "Jadefang"                    ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 55  , "Shale Spider"  }, ["familySkills" ] = SHALE_SPIDER_SKILLS  ,["displayID"] = 36636 ,["id"] = 49822  ,["coords"] = {{61.2  , 22.4  },{61.2,22.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Abyssal Depths"                , [ "zoneID" ] = 204  , [ "name" ] = "Ghostcrawler"                ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] = L["Ghostcrawler_info"      ] , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 37396 ,["id"] = 50051  ,["coords"] = {{12.8  , 82.6  },{15,77.4},{15,87.4},{19,77.4},{20,58},{20.4,68.4},{22,65},{24.2,71.8},{24.4,80.4},{26,81.4},{28.2,82.2},{31.2,78},{31.4,80.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Mount Hyjal"                   , [ "zoneID" ] = 198  , [ "name" ] = "Terrorpene"                  ,["maxlevel"] =92    ,["minlevel"] =91    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        }, ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 37282 ,["id"] = 50058  ,["coords"] = {{52.2  , 83.2  },{53.8,82},{54.2,80},{55.6,76.2},{56,75.4},{56.8,75.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Twilight Highlands"            , [ "zoneID" ] = 241  , [ "name" ] = "Karoma"                      ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 36726 ,["id"] = 50138  ,["coords"] = {{49.2  , 74.2  },{49.4,75},{49.8,75.4},{53.8,53.2},{54,54},{54.2,76.2},{54.6,75},{54.6,75.6},{58.2,63.6},{58.4,63.4},{58.6,63.2},{58.8,64},{59.2,43.4},{59.4,44},{59.6,43.4},{59.6,44},{65.4,60.2},{65.4,60.6},{65.6,60.2},{65.6,60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 249  , [ "name" ] = "Madexx"                      ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 36728 ,["id"] = 50154  ,["coords"] = {{44.4  , 10.4  },{44.4,11},{44.4,21.8},{44.4,22.6},{44.6,10.8},{44.8,10},{44.8,22.2},{47.4,18.2},{47.6,18.6},{48.2,18.4},{50,23.8},{50.2,19.6},{50.4,21},{50.6,20.6},{50.8,20.2},{50.8,23.8},{53.4,18.6},{53.4,19.6},{53.6,19.6},{53.8,19.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Twilight Highlands"            , [ "zoneID" ] = 241  , [ "name" ] = "Sambas"                      ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 37352 ,["id"] = 50159  ,["coords"] = {{38.2  , 53    },{42.6,38.6},{68.8,25.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Deathknell"                    , [ "zoneID" ] = 465  , [ "name" ] = "Fangor"                      ,["maxlevel"] =62    ,["minlevel"] =5     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 24  , "Bat"           }, ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 46665 ,["id"] = 50328  ,["coords"] = {{60.8  , 77.8  },{61.4,76.8},{61.6,79.6},{62.8,80.6},{64,80},{65,81.4},{65.2,79.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Kree"                        ,["maxlevel"] =62    ,["minlevel"] =23    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 24  , "Bat"           }, ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 34130 ,["id"] = 50330  ,["coords"] = {{60.2  , 6.8   },{60.4,6},{60.6,6.6},{60.6,7.8},{60.8,6.4},{61.6,6.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Alitus"                      ,["maxlevel"] =62    ,["minlevel"] =27    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 26255 ,["id"] = 50335  ,["coords"] = {{46    , 66.2  },{46.4,66.8},{46.8,66.8},{47,66.2},{47.4,68.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Cackle"                      ,["maxlevel"] =62    ,["minlevel"] =40    , ["info"] = L["Cackle_info"            ] , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 46227 ,["id"] = 50337  ,["coords"] = {{21    , 87.6  },{21.4,86.6},{21.6,88.6},{21.8,86.2},{22.2,87},{22.2,87.8},{22.6,86.8},{22.6,87.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Heronis"                     ,["maxlevel"] =62    ,["minlevel"] =40    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 33004 ,["id"] = 50342  ,["coords"] = {{39.4  , 28.6  },{40,28.2},{40.2,28.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Quall"                       ,["maxlevel"] =62    ,["minlevel"] =24    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 46988 ,["id"] = 50343  ,["coords"] = {{59.6  , 64    },{60,63.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Alit"                        ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 21133 ,["id"] = 50345  ,["coords"] = {{31    , 71.8  },{31.8,71.4},{31.8,72.2},{32,73},{32.6,72.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Ronak"                       ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      }, ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 17093 ,["id"] = 50346  ,["coords"] = {{59.4  , 42.6  },{59.6,42.4},{59.8,42.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Norissis"                    ,["maxlevel"] =62    ,["minlevel"] =60    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      }, ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 17092 ,["id"] = 50348  ,["coords"] = {{59.4  , 23.8  },{59.6,24}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Manas"                       ,["maxlevel"] =62    ,["minlevel"] =53    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 30  , "Dragonhawk"    }, ["familySkills" ] = DRAGONHAWKS_SKILLS   ,["displayID"] = 45200 ,["id"] = 50353  ,["coords"] = {{64    , 80    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Sunwing"                     ,["maxlevel"] =62    ,["minlevel"] =46    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 30  , "Dragonhawk"    }, ["familySkills" ] = DRAGONHAWKS_SKILLS   ,["displayID"] = 45201 ,["id"] = 50357  ,["coords"] = {{8.4   , 54.6  },{9,54.4},{9,54.6},{9.4,52.4},{9.4,53.4},{9.6,55},{9.8,54.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Ornat"                       ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 34  , "Ray"           }, ["familySkills" ] = RAY_SKILLS           ,["displayID"] = 20596 ,["id"] = 50361  ,["coords"] = {{50.4  , 60.2  },{50.4,60.6},{50.6,59.4},{50.6,60.4},{50.6,60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Blackbog the Fang"           ,["maxlevel"] =62    ,["minlevel"] =56    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 34  , "Ray"           }, ["familySkills" ] = RAY_SKILLS           ,["displayID"] = 20596 ,["id"] = 50362  ,["coords"] = {{34.8  , 59.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Karapax"                     ,["maxlevel"] =62    ,["minlevel"] =55    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       }, ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20067 ,["id"] = 50370  ,["coords"] = {{57    , 14.4  }, {57, 14.6}, {57.6, 14.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Spinecrawl"                  ,["maxlevel"] =62    ,["minlevel"] =56    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       }, ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20297 ,["id"] = 50724  ,["coords"] = {{60.4  , 22    },{60.6,22.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Azelisk"                     ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       }, ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20309 ,["id"] = 50725  ,["coords"] = {{71.8  , 23    },{72.8,22.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Kalixx"                      ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       }, ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 46250 ,["id"] = 50726  ,["coords"] = {{32    , 35.2  },{32,35.6},{32.4,34.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Strix the Barbed"            ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       }, ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20834 ,["id"] = 50727  ,["coords"] = {{93.4  , 80.6  },{94.4,81.6},{94.6,81.4},{94.6,81.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Deathstrike"                 ,["maxlevel"] =62    ,["minlevel"] =46    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       }, ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20308 ,["id"] = 50728  ,["coords"] = {{69.4  , 53.6  },{70,53.6},{70.2,53.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Venomspine"                  ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       }, ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20297 ,["id"] = 50730  ,["coords"] = {{5.2   , 38.6  },{5.4,38.4},{5.6,38.6},{5.8,38.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }, },
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Needlefang"                  ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       }, ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 17062 ,["id"] = 50731  ,["coords"] = {{50.4  , 72.4  },{50.6,72.2},{50.8,72.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Blinkeye the Rattler"        ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       }, ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 4435  ,["id"] = 50735  ,["coords"] = {{51.4  , 16.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Acroniss"                    ,["maxlevel"] =62    ,["minlevel"] =55    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       }, ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 46985 ,["id"] = 50737  ,["coords"] = {{73.6  , 16    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Shimmerscale"                ,["maxlevel"] =62    ,["minlevel"] =50    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       }, ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 25009 ,["id"] = 50738  ,["coords"] = {{55.4  , 54.6  },{55.6,54},{55.6,54.6},{55.8,52.6},{56.6,54.6},{56.8,54.2},{57.2,52},{57.4,52.8},{57.6,54},{57.8,52.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Kaxx"                        ,["maxlevel"] =62    ,["minlevel"] =48    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 1561  ,["id"] = 50741  ,["coords"] = {{37.4  , 56    },{37.6,56}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Qem"                         ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 46982 ,["id"] = 50742  ,["coords"] = {{43.8  , 17.6  }, {44, 17.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Manax"                       ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 46983 ,["id"] = 50743  ,["coords"] = {{67.2  , 66.4  }, {67.2, 66.6}, {67.8, 66.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Qu'rik"                      ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 46981 ,["id"] = 50744  ,["coords"] = {{54.4  , 26.4  }, {54.6, 26.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Losaj"                       ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15658 ,["id"] = 50745  ,["coords"] = {{42.2  , 55.8  }, {42.2, 57}, {42.6, 56.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Bornix the Burrower"         ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15656 ,["id"] = 50746  ,["coords"] = {{62.6  , 89.4  }, {63.6, 88.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Ahn'Qiraj: The Fallen Kingdom" , [ "zoneID" ] = 327  , [ "name" ] = "Tix"                         ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] = L["NO FURTHER INFO YET..."]  , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15334 ,["id"] = 50747  ,["coords"] = {{60.4  , 6.2   },{60.8,6.4},{60.8,6.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Nyaj"                        ,["maxlevel"] =62    ,["minlevel"] =48    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 41  , "Silithid"      }, ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 481   ,["id"] = 50748  ,["coords"] = {{44    , 40.4  },{44,40.6},{44.6,40.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Tarantis"                    ,["maxlevel"] =62    ,["minlevel"] =9     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 2537  ,["id"] = 50752  ,["coords"] = {{65.2  , 64.6  },{65.4,64.2},{65.8,65},{66.4,63},{66.4,63.6},{66.6,63.2},{67.2,63.8},{67.6,63.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Iriss the Widow"             ,["maxlevel"] =62    ,["minlevel"] =26    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 42742 ,["id"] = 50759  ,["coords"] = {{54.4  , 74.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Shadowstalker"               ,["maxlevel"] =62    ,["minlevel"] =6     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 67596 ,["id"] = 50763  ,["coords"] = {{38    , 52    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Paraliss"                    ,["maxlevel"] =62    ,["minlevel"] =37    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 46518 ,["id"] = 50764  ,["coords"] = {{38    , 74.4  },{38.4,74.8},{38.8,74.8},{39,74.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Miasmiss"                    ,["maxlevel"] =62    ,["minlevel"] =22    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 27683 ,["id"] = 50765  ,["coords"] = {{37    , 68.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Zorn"                        ,["maxlevel"] =62    ,["minlevel"] =39    , ["info"] = L["Zorn_info"              ] , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 46232 ,["id"] = 50770  ,["coords"] = {{21.6  , 15.4  },{22,14}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Likk the Hunter"             ,["maxlevel"] =62    ,["minlevel"] =42    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 46518 ,["id"] = 50775  ,["coords"] = {{11.6  , 70.2  },{12.2,71.6},{12.4,71.4},{12.8,72.2},{13,71.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Needle"                      ,["maxlevel"] =62    ,["minlevel"] =47    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 18041 ,["id"] = 50777  ,["coords"] = {{51    , 34.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Ironweb"                     ,["maxlevel"] =62    ,["minlevel"] =50    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 42742 ,["id"] = 50778  ,["coords"] = {{51.2  , 70.2  },{51.2,70.8},{51.4,69.4},{51.6,69.6},{51.8,69.2},{52.2,68.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Sporeggon"                   ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 33  , "Sporebat"      }, ["familySkills" ] = SPOREBATS_SKILLS     ,["displayID"] = 18029 ,["id"] = 50779  ,["coords"] = {{39.4  , 55.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Anith"                       ,["maxlevel"] =62    ,["minlevel"] =44    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  }, ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 47124 ,["id"] = 50784  ,["coords"] = {{32.2  , 31    },{32.6,30.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Skyshadow"                   ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  }, ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 46995 ,["id"] = 50785  ,["coords"] = {{93.8  , 57.4  },{94,58.2},{94.2,58.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Sparkwing"                   ,["maxlevel"] =62    ,["minlevel"] =31    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  }, ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 46990 ,["id"] = 50786  ,["coords"] = {{58.8  , 86.4  },{59,86.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Quetzl"                      ,["maxlevel"] =62    ,["minlevel"] =52    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  }, ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 46996 ,["id"] = 50788  ,["coords"] = {{66.8  , 83.4  },{66.8,83.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Ionis"                       ,["maxlevel"] =62    ,["minlevel"] =56    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  }, ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 47120 ,["id"] = 50790  ,["coords"] = {{39    , 34    },{39.2,33.2},{39.4,34.6},{39.8,33},{39.8,35.2},{40,34.4},{40.4,35.6},{40.6,35.2},{40.8,35.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Chiaa"                       ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  }, ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 46278 ,["id"] = 50792  ,["coords"] = {{35.2  , 26.2  },{35.4,26.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Yukiko"                      ,["maxlevel"] =62    ,["minlevel"] =57    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  }, ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 47126 ,["id"] = 50797  ,["coords"] = {{69.2  , 66.4  },{69.4,67.4},{69.4,67.8},{69.8,67.4},{69.8,67.6},{70,65.8},{70.4,64.8},{70.6,66.2},{70.8,65}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Bonechewer"                  ,["maxlevel"] =62    ,["minlevel"] =9     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 37992 ,["id"] = 50803  ,["coords"] = {{31.2  , 46.4  },{31.8,46.4},{32.2,47.2},{32.6,46.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Ripwing"                     ,["maxlevel"] =62    ,["minlevel"] =33    , ["info"] = L["Ripwing_info"           ] , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 10827 ,["id"] = 50804  ,["coords"] = {{35.4  , 61.8  },{35.4,62.8},{35.6,61.6},{36,63.4},{36.2,63.8},{36.4,61.2},{36.6,61},{36.6,61.6},{36.8,62.6},{37.2,63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Catal"                       ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 46277 ,["id"] = 50807  ,["coords"] = {{63.6  , 54.2  },{64,52},{64,54.8},{64.4,53},{64.6,53.4},{64.6,54.8},{65,53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Heress"                      ,["maxlevel"] =62    ,["minlevel"] =41    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 46740 ,["id"] = 50809  ,["coords"] = {{34.8  , 52.4  },{34.8,53.8},{35.2,53.2},{35.8,52.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Favored of Isiset"           ,["maxlevel"] =62    ,["minlevel"] =51    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 20347 ,["id"] = 50810  ,["coords"] = {{73.2  , 53    },{74.2,52},{74.4,51.4},{75,53.2},{75.4,51.8},{75.4,53.6},{75.6,52.2},{75.6,53.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Arae"                        ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 46229 ,["id"] = 50812  ,["coords"] = {{49.4  , 65.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Fene-mal"                    ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 46516 ,["id"] = 50813  ,["coords"] = {{49.6  , 43.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Corpsefeeder"                ,["maxlevel"] =62    ,["minlevel"] =29    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 23481 ,["id"] = 50814  ,["coords"] = {{49.2  , 68.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Skarr"                       ,["maxlevel"] =122   ,["minlevel"] =122   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 19607 ,["id"] = 50815  ,["coords"] = {{33    , 52.2  },{33.2,52.6},{33.6,52.2},{33.6,52.6},{36.8,34.8},{37.4,35.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "The Dark Prowler"            ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 26618 ,["id"] = 50818  ,["coords"] = {{33    , 55    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Iceclaw"                     ,["maxlevel"] =62    ,["minlevel"] =54    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 9951  ,["id"] = 50819  ,["coords"] = {{52    , 18.4  },{52,18.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Feras"                       ,["maxlevel"] =62    ,["minlevel"] =38    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 46987 ,["id"] = 50825  ,["coords"] = {{76    , 91.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Duskcoat"                    ,["maxlevel"] =62    ,["minlevel"] =42    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 38913 ,["id"] = 50833  ,["coords"] = {{39.4  , 31.6  },{39.6,31.8},{39.8,31.4},{40.6,31}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Kash"                        ,["maxlevel"] =62    ,["minlevel"] =55    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 46575 ,["id"] = 50837  ,["coords"] = {{78.2  , 27.2  },{78.2,29.6},{79,27.6},{79,28.8},{79.4,26.8},{79.4,29.8},{79.4,30.8},{79.6,27.4},{79.6,28.2},{79.6,28.6},{80.2,29.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Tabbs"                       ,["maxlevel"] =62    ,["minlevel"] =48    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 46251 ,["id"] = 50838  ,["coords"] = {{58.2  , 60.4  },{58.4,60.6},{58.6,60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Chromehound"                 ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 45  , "Core Hound"    }, ["familySkills" ] = COREHOUND_SKILLS     ,["displayID"] = 29539 ,["id"] = 50839  ,["coords"] = {{35.6  , 60.8  },{36,49.6},{37.2,66},{37.6,66.6},{38.2,44.6},{38.8,42.6},{40.4,40.2},{40.6,40.2},{40.8,73.2},{41.6,73.2},{42.4,74.8},{43,76},{43.2,76.6},{43.6,36},{44.2,36.6},{44.4,76.6},{44.6,37.6},{44.6,75},{45,36},{45.4,76.4},{46.4,35},{46.4,78.8},{46.8,77.6},{47.4,36},{48,78.6},{48.8,35},{50,35.2},{50.6,78.6},{51,35.6},{54.4,35.8},{54.6,76.2},{55.2,35.6},{56.2,76},{57,36.4},{57.2,36.8},{57.8,38},{58,38.6},{59.6,41.4},{61,43.4},{62,44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Magmagan"                    ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 45  , "Core Hound"    }, ["familySkills" ] = COREHOUND_SKILLS     ,["displayID"] = 12168 ,["id"] = 50842  ,["coords"] = {{28.4  , 33    },{28.8,32.4},{28.8,33},{29,33.6},{29,34.8},{29.2,31.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Jaxx the Rabid"              ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         }, ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 79025 ,["id"] = 50855  ,["coords"] = {{47    , 24.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Snark"                       ,["maxlevel"] =62    ,["minlevel"] =49    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         }, ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 31352 ,["id"] = 50856  ,["coords"] = {{37.8  , 84    },{39.2,84},{39.4,84.6},{39.6,84.4},{39.6,84.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Dustwing"                    ,["maxlevel"] =62    ,["minlevel"] =22    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 37  , "Moth"          }, ["familySkills" ] = MOTH_SKILLS          ,["displayID"] = 46551 ,["id"] = 50858  ,["coords"] = {{27.8  , 83.6  },{28.4,83.4},{28.6,83.4},{28.6,83.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Thicket"                     ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 37  , "Moth"          }, ["familySkills" ] = MOTH_SKILLS          ,["displayID"] = 46831 ,["id"] = 50864  ,["coords"] = {{59.4  , 6.8   },{59.6,6.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }, },
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Saurix"                      ,["maxlevel"] =62    ,["minlevel"] =27    , ["info"] = L["Saurix_info"            ] , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 21825 ,["id"] = 50865  ,["coords"] = {{41.8  , 34.4  },{41.8,35.6},{42,34.6},{42.8,36.2},{43.2,34.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Tenok"                       ,["maxlevel"] =62    ,["minlevel"] =31    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 19733 ,["id"] = 50874  ,["coords"] = {{44.4  , 49.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Nychus"                      ,["maxlevel"] =62    ,["minlevel"] =59    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 46287 ,["id"] = 50875  ,["coords"] = {{34    , 70.4  },{34.4,71.2},{34.6,70.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Avis"                        ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 1746  ,["id"] = 50876  ,["coords"] = {{70.6  , 18.6  },{71.2,17.8},{71.4,16.8},{71.6,19.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Chupacabros"                 ,["maxlevel"] =62    ,["minlevel"] =61    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 19743 ,["id"] = 50882  ,["coords"] = {{27    , 61    },{27.4,61.6},{27.4,63},{27.6,61},{27.6,62},{27.6,62.8},{27.8,63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Dustflight the Cowardly"     ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 12  , "Tallstrider"   }, ["familySkills" ] = TALLSTRIDER_SKILLS   ,["displayID"] = 21268 ,["id"] = 50884  ,["coords"] = {{44.8  , 55.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Seawing"                     ,["maxlevel"] =62    ,["minlevel"] =48    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 12  , "Tallstrider"   }, ["familySkills" ] = TALLSTRIDER_SKILLS   ,["displayID"] = 21268 ,["id"] = 50886  ,["coords"] = {{80.2  , 16.2  },{81.8,17},{82.4,17.6},{85,24.2},{85.4,22.2},{85.6,21.8},{85.8,23.2},{85.8,25},{86,23.8},{87.2,24.6},{87.6,30.4},{88,26.6},{88.4,31},{88.6,27.6},{88.8,29.8},{88.8,31.2},{88.8,33},{89,28.8},{89,33.6},{89.2,31.6},{89.4,27.2},{89.4,35.8},{90,35.2},{90.4,36.8},{90.4,38.8},{90.6,39.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Boros"                       ,["maxlevel"] =62    ,["minlevel"] =40    , ["info"] = L["Boros_info"             ] , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 46235 ,["id"] = 50891  ,["coords"] = {{47.4  , 33.8  },{48,34.4},{48.2,36.6},{48.4,35.2},{48.4,35.6},{48.6,34.4},{48.6,35},{48.6,35.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Cyn"                         ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 25857 ,["id"] = 50892  ,["coords"] = {{55.2  , 40.4  },{55.2,40.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Volux"                       ,["maxlevel"] =62    ,["minlevel"] =33    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 46998 ,["id"] = 50895  ,["coords"] = {{39.8  , 46    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Ffexk the Dunestalker"       ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 46980 ,["id"] = 50897  ,["coords"] = {{32.2  , 53    }, {32.8, 53.8}, {33, 53.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Teromak"                     ,["maxlevel"] =62    ,["minlevel"] =42    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 46235 ,["id"] = 50901  ,["coords"] = {{41.8  , 43.4  },{42,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Orlix the Swamplord"         ,["maxlevel"] =62    ,["minlevel"] =58    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 37856 ,["id"] = 50903  ,["coords"] = {{16    , 36    },{16.8,35.2},{16.8,35.6},{17.2,38.6},{17.4,37.2},{17.4,38.4},{17.6,37.6},{17.6,39.2},{17.8,36.2},{17.8,37.2},{18.6,35.4},{18.6,38.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Cida"                        ,["maxlevel"] =62    ,["minlevel"] =49    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 46830 ,["id"] = 50905  ,["coords"] = {{45    , 31.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Mutilax"                     ,["maxlevel"] =62    ,["minlevel"] =47    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 37857 ,["id"] = 50906  ,["coords"] = {{52.2  , 27.2  },{52.4,26.4},{52.4,28.2},{52.6,27.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Nighthowl"                   ,["maxlevel"] =9     ,["minlevel"] =9     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 46667 ,["id"] = 50908  ,["coords"] = {{42.4  , 28.4  },{42.4,28.8},{42.6,28.6},{42.8,28.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Snort"                       ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 46520 ,["id"] = 50915  ,["coords"] = {{57.4  , 80    },{57.6,79.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Lamepaw the Whimperer"       ,["maxlevel"] =62    ,["minlevel"] =11    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 46543 ,["id"] = 50916  ,["coords"] = {{51.4  , 62.4  },{51.4,63.4},{51.4,63.6},{52,62.2},{52,63.6},{52.2,62.8},{52.6,63.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Warg"                        ,["maxlevel"] =62    ,["minlevel"] =45    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 35394 ,["id"] = 50922  ,["coords"] = {{56    , 62.6  },{56.4,61.6},{56.6,63.6},{57,61.8},{57,63.4},{57.2,60.6},{58,61.8},{58.2,61.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Grovepaw"                    ,["maxlevel"] =62    ,["minlevel"] =45    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 9569  ,["id"] = 50925  ,["coords"] = {{38.2  , 72.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Grizzled Ben"                ,["maxlevel"] =62    ,["minlevel"] =10    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70199 ,["id"] = 50926  ,["coords"] = {{27.4  , 67.4  },{27.4,67.8},{27.4,69.2},{27.6,67},{28.6,66.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Little Bjorn"                ,["maxlevel"] =62    ,["minlevel"] =22    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 46552 ,["id"] = 50929  ,["coords"] = {{34.6  , 78.8  },{35,78.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Hibernus the Sleeper"        ,["maxlevel"] =62    ,["minlevel"] =6     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70192 ,["id"] = 50930  ,["coords"] = {{46.8  , 69.2  },{47.4,70.2},{47.6,70.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Mange"                       ,["maxlevel"] =62    ,["minlevel"] =52    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70191 ,["id"] = 50931  ,["coords"] = {{65.6  , 56.6  },{66,55.4},{66.2,55.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Hamhide"                     ,["maxlevel"] =62    ,["minlevel"] =44    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 6122  ,["id"] = 50937  ,["coords"] = {{43    , 34.4  },{43.2,35.6},{43.6,35.2},{43.6,36}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Swee"                        ,["maxlevel"] =62    ,["minlevel"] =32    , ["info"] = L["Swee_info"              ] , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 20814 ,["id"] = 50940  ,["coords"] = {{55.6  , 57.6  },{56.2,56.8},{56.4,56.4},{56.6,56.2},{56.6,56.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Snoot the Rooter"            ,["maxlevel"] =62    ,["minlevel"] =9     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 1208  ,["id"] = 50942  ,["coords"] = {{67.8  , 82.2  },{69.2,77},{69.2,78.2},{69.2,79.4},{69.4,79.6},{69.6,78.8},{69.6,79.6},{69.8,77.4},{69.8,78},{70.6,79.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Scruff"                      ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 4714  ,["id"] = 50945  ,["coords"] = {{29.4  , 43.4  },{29.4,44},{29.4,44.6},{29.6,44.4},{29.6,44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Hogzilla"                    ,["maxlevel"] =62    ,["minlevel"] =42    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 2450  ,["id"] = 50946  ,["coords"] = {{21.2  , 78.8  },{22.2,77.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Varah"                       ,["maxlevel"] =62    ,["minlevel"] =56    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 46532 ,["id"] = 50947  ,["coords"] = {{11.6  , 28    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Crystalback"                 ,["maxlevel"] =62    ,["minlevel"] =47    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 46566 ,["id"] = 50948  ,["coords"] = {{64.4  , 46.2  },{65,45.6},{65.2,45},{65.4,46.6},{65.8,47.6},{66,45.2},{66,46.2},{66,47.2},{66.4,44.4},{66.8,43.8},{66.8,46.6},{67,45.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Finn's Gambit"               ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 4714  ,["id"] = 50949  ,["coords"] = {{64    , 46.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Barnacle Jim"                ,["maxlevel"] =62    ,["minlevel"] =48    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 46994 ,["id"] = 50952  ,["coords"] = {{41    , 36.2  },{41,36.8},{41.6,36.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Carcinak"                    ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 46558 ,["id"] = 50955  ,["coords"] = {{46.6  , 76.6  },{46.8,76}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Hugeclaw"                    ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 46285 ,["id"] = 50957  ,["coords"] = {{53.8  , 43.4  },{54,43.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Karkin"                      ,["maxlevel"] =122   ,["minlevel"] =122   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 88834 ,["id"] = 50959  ,["coords"] = {{33    , 52.2  },{33.4,53},{33.6,52.2},{36.8,34.8},{37.6,35.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Wetlands"                      , [ "zoneID" ] = 56   , [ "name" ] = "Chops"                       ,["maxlevel"] =61    ,["minlevel"] =59    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     }, ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 46230 ,["id"] = 50964  ,["coords"] = {{57.2  , 9     },{57.4,8.4},{57.8,7.2},{57.8,8.4},{58,8.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Craw the Ravager"            ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     }, ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 32807 ,["id"] = 50967  ,["coords"] = {{51.8  , 87.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Goldenback"                  ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 9   , "Gorilla"       }, ["familySkills" ] = GORILLA_SKILLS       ,["displayID"] = 5245  ,["id"] = 50986  ,["coords"] = {{82.2  , 79.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Gal'dorak"                   ,["maxlevel"] =62    ,["minlevel"] =43    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     }, ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 26267 ,["id"] = 50993  ,["coords"] = {{35.4  , 48.4  },{35.4,49},{35.6,48.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Bruiser"                     ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     }, ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 28648 ,["id"] = 50995  ,["coords"] = {{65.4  , 41.6  },{65.8,42.8},{66,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Bornak the Gorer"            ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     }, ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 26295 ,["id"] = 50997  ,["coords"] = {{59.2  , 16.4  },{59.4,17},{59.6,17.4},{59.8,17.6},{62.2,24.4},{62.4,24.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Blackshell the Impenetrable" ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 46248 ,["id"] = 51000  ,["coords"] = {{70.2  , 29.6  },{71.8,28},{72.2,27.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Venomclaw"                   ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 15423 ,["id"] = 51001  ,["coords"] = {{81.4  , 95.8  },{81.8,96}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Scorpoxx"                    ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 15336 ,["id"] = 51002  ,["coords"] = {{17.8  , 38.4  },{18.4,38.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Toxx"                        ,["maxlevel"] =62    ,["minlevel"] =53    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 46984 ,["id"] = 51004  ,["coords"] = {{42.4  , 17.2  }, {42.4, 18.2}, {42.6, 17.4}, {42.8, 16.2}, {42.8, 18.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Serkett"                     ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 46252 ,["id"] = 51007  ,["coords"] = {{26.4  , 38.4  },{26.4,38.6},{26.6,38.6},{26.8,38},{27.6,38}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "The Barbed Horror"           ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 20912 ,["id"] = 51008  ,["coords"] = {{71.2  , 94.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Snips"                       ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 46248 ,["id"] = 51010  ,["coords"] = {{35    , 52    },{36.2,53}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Terrapis"                    ,["maxlevel"] =62    ,["minlevel"] =9     , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        }, ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 7837  ,["id"] = 51014  ,["coords"] = {{50.6  , 87.2  },{51.2,88},{51.6,87.8},{53.4,87.8},{53.8,86.8},{53.8,87.8},{55.2,86.6},{55.8,85.8},{56.2,85.4},{57,85.2},{58.4,83.8},{58.8,83},{59.2,83.8},{59.6,83},{60.4,82.2},{60.8,82.4},{62,82.4},{62.6,82.4},{63.4,83.4},{63.6,83.2},{63.6,83.6},{66,84.4},{66.4,84.6},{66.8,85},{67.4,84.4},{68,85.4},{68.6,84.6},{70.2,85.4},{71,85.4},{72,84.4},{72.2,85.4},{73,85.2},{73.2,85.8},{74,84.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Gezan"                       ,["maxlevel"] =62    ,["minlevel"] =59    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  }, ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 20142 ,["id"] = 51017  ,["coords"] = {{52.4  , 31.4  },{52.4,31.6},{52.6,31.4},{52.6,31.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Zormus"                      ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  }, ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 19996 ,["id"] = 51018  ,["coords"] = {{51.4  , 34.2  },{51.6,34.6},{51.8,34.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Vorticus"                    ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  }, ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 20910 ,["id"] = 51021  ,["coords"] = {{21.8  , 37.4  },{23.2,37.2},{23.2,37.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Chordix"                     ,["maxlevel"] =62    ,["minlevel"] =31    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 42  , "Worm"          }, ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 37540 ,["id"] = 51022  ,["coords"] = {{56.2  , 54.4  },{56.2,54.6},{56.8,54.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Dilennaa"                    ,["maxlevel"] =62    ,["minlevel"] =42    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 42  , "Worm"          }, ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 12335 ,["id"] = 51025  ,["coords"] = {{42.2  , 47.4  },{42.2,48.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Gnath"                       ,["maxlevel"] =62    ,["minlevel"] =21    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 42  , "Worm"          }, ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 46569 ,["id"] = 51026  ,["coords"] = {{49.2  , 29.4  },{49.6,29.6},{50,29.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Spirocula"                   ,["maxlevel"] =62    ,["minlevel"] =44    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 42  , "Worm"          }, ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 46534 ,["id"] = 51027  ,["coords"] = {{74.2  , 58.4  },{74.2,58.8},{74.6,58.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "The Deep Tunneler"           ,["maxlevel"] =62    ,["minlevel"] =53    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 42  , "Worm"          }, ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 37551 ,["id"] = 51028  ,["coords"] = {{50.6  , 72.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Parasitus"                   ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 42  , "Worm"          }, ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 23998 ,["id"] = 51029  ,["coords"] = {{61.6  , 72.4  },{62,73.4},{62,73.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Tracker"                     ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 52  , "Dog"           }, ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 46741 ,["id"] = 51031  ,["coords"] = {{62.2  , 47.6  },{62.4,47.4},{62.6,47.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Lost Gilnean Wardog"         ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 52  , "Dog"           }, ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 33998 ,["id"] = 51037  ,["coords"] = {{57.2  , 42.4  },{57.6,41.6},{58.4,41},{59,41},{59,42},{60,40.8},{60,41.6},{60.2,40.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Snuffles"                    ,["maxlevel"] =61    ,["minlevel"] =27    , ["info"] = L["Snuffles_info"          ] , ["class"] = CLASS_RARE       , ["family"] = { 52  , "Dog"           }, ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 30222 ,["id"] = 51040  ,["coords"] = {{25.2  , 27.6  },{25.4,27.2},{26,27.2},{26.2,27.6},{26.8,27.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Bleakheart"                  ,["maxlevel"] =62    ,["minlevel"] =46    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 52  , "Dog"           }, ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 46517 ,["id"] = 51042  ,["coords"] = {{71.8  , 45.4  },{71.8,45.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Plague"                      ,["maxlevel"] =15    ,["minlevel"] =12    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 52  , "Dog"           }, ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 46668 ,["id"] = 51044  ,["coords"] = {{57.8  , 33    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Arcanus"                     ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 52  , "Dog"           }, ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 24906 ,["id"] = 51045  ,["coords"] = {{48    , 59.4  },{48,59.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Fidonis"                     ,["maxlevel"] =62    ,["minlevel"] =49    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 52  , "Dog"           }, ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 46517 ,["id"] = 51046  ,["coords"] = {{38.4  , 52.8  },{38.6,52.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Rexxus"                      ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 52  , "Dog"           }, ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 35356 ,["id"] = 51048  ,["coords"] = {{39.4  , 50.6  },{39.8,53},{40.2,50.2},{40.4,49.4},{40.4,50.6},{40.6,49.2},{41,49.6},{41.4,50.6},{42,49.8},{42.8,47.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Gib the Banana-Hoarder"      ,["maxlevel"] =62    ,["minlevel"] =52    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 51  , "Monkey"        }, ["familySkills" ] = MONKEY_SKILLS        ,["displayID"] = 46574 ,["id"] = 51052  ,["coords"] = {{16.4  , 47.2  },{16.6,47.2},{16.6,47.6},{17.6,47.2},{17.8,48}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Quirix"                      ,["maxlevel"] =62    ,["minlevel"] =47    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        }, ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 37580 ,["id"] = 51053  ,["coords"] = {{23.6  , 78.4  },{23.8,78.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Weevil"                      ,["maxlevel"] =62    ,["minlevel"] =27    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        }, ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 34898 ,["id"] = 51057  ,["coords"] = {{45.4  , 52.4  },{45.4,52.8},{45.6,52.4},{45.6,53.2},{45.6,53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Aphis"                       ,["maxlevel"] =62    ,["minlevel"] =50    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        }, ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 34900 ,["id"] = 51058  ,["coords"] = {{62.4  , 35.2  },{62.4,35.6},{62.6,35.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Roth-Salam"                  ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        }, ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 15339 ,["id"] = 51061  ,["coords"] = {{50.2  , 84.4  },{50.2,84.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Khep-Re"                     ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        }, ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 46225 ,["id"] = 51062  ,["coords"] = {{74.6  , 73.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Phalanax"                    ,["maxlevel"] =62    ,["minlevel"] =36    , ["info"] = L["Phalanax_info"          ] , ["class"] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        }, ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 46226 ,["id"] = 51063  ,["coords"] = {{47.8  , 82.2  },{48.6,81.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Crystalfang"                 ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 55  , "Shale Spider"  }, ["familySkills" ] = SHALE_SPIDER_SKILLS  ,["displayID"] = 33863 ,["id"] = 51066  ,["coords"] = {{33.2  , 19.6  },{33.4,18.8},{33.6,19.2},{34,20}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Glint"                       ,["maxlevel"] =62    ,["minlevel"] =33    , ["info"] = L["Glint_info"             ] , ["class"] = CLASS_RARE       , ["family"] = { 55  , "Shale Spider"  }, ["familySkills" ] = SHALE_SPIDER_SKILLS  ,["displayID"] = 36634 ,["id"] = 51067  ,["coords"] = {{29.4  , 59.6  },{29.6,59.4},{30,61},{30,61.6},{30.2,60.4},{30.4,63.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Scintillex"                  ,["maxlevel"] =62    ,["minlevel"] =62    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 55  , "Shale Spider"  }, ["familySkills" ] = SHALE_SPIDER_SKILLS  ,["displayID"] = 46290 ,["id"] = 51069  ,["coords"] = {{55.8  , 85.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Lopex"                       ,["maxlevel"] =62    ,["minlevel"] =35    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 50  , "Fox"           }, ["familySkills" ] = FOX_SKILLS           ,["displayID"] = 40191 ,["id"] = 51076  ,["coords"] = {{68.8  , 56    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Bushtail"                    ,["maxlevel"] =62    ,["minlevel"] =14    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 50  , "Fox"           }, ["familySkills" ] = FOX_SKILLS           ,["displayID"] = 30254 ,["id"] = 51077  ,["coords"] = {{81.6  , 85.2  },{82.4,84},{83,82.8},{83,84.4},{83,85.4},{83,85.8},{83.8,85}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 249  , [ "name" ] = "Madexx"                      ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 37360 ,["id"] = 51401  ,["coords"] = {{44.2  , 10.8  },{44.6,21.4},{47.4,19},{50.2,23.8},{50.4,20.2},{50.6,19.6},{50.6,24},{53.2,19.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 249  , [ "name" ] = "Madexx"                      ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 37362 ,["id"] = 51402  ,["coords"] = {{44.4  , 10.4  },{44.4,10.6},{44.4,22},{44.6,10.2},{44.6,21.8},{50.8,20.2},{53.2,19.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 249  , [ "name" ] = "Madexx"                      ,["maxlevel"] ="???" ,["minlevel"] ="???" , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 37359 ,["id"] = 51403  ,["coords"] = {{47.8  , 18.2  },{51,20.4},{53.4,19}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 249  , [ "name" ] = "Madexx"                      ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 37361 ,["id"] = 51404  ,["coords"] = {{44.4  , 10.2  },{44.4,10.8},{44.6,10.6},{44.6,22.8},{44.8,10},{44.8,21.6},{47.4,18.4},{47.6,17.6},{47.6,18.8},{50,20.6},{50,24},{50.4,19.8},{50.6,23.8},{51,19.6},{53.2,19.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Northern Stranglethorn"        , [ "zoneID" ] = 50   , [ "name" ] = "Tsul'Kalu"                   ,["maxlevel"] =62    ,["minlevel"] =31    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 9   , "Gorilla"       }, ["familySkills" ] = GORILLA_SKILLS       ,["displayID"] = 10133 ,["id"] = 51661  ,["coords"] = {{47    , 32    },{47.2,31.2},{47.2,33.4},{47.6,31.4},{47.6,31.6},{47.6,33.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Northern Stranglethorn"        , [ "zoneID" ] = 50   , [ "name" ] = "Mahamba"                     ,["maxlevel"] =62    ,["minlevel"] =28    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     }, ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 37613 ,["id"] = 51662  ,["coords"] = {{53.4  , 30.2  },{54,31},{54.2,30.2},{54.2,31.6},{54.4,29.2},{54.6,29},{54.6,30},{55,30.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Northern Stranglethorn"        , [ "zoneID" ] = 50   , [ "name" ] = "Pogeyan"                     ,["maxlevel"] =62    ,["minlevel"] =32    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 37615 ,["id"] = 51663  ,["coords"] = {{36.2  , 29.2  },{36.4,28.2},{36.4,29.6},{36.6,29.2},{37,28.4},{37,29.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Redridge Mountains"            , [ "zoneID" ] = 49   , [ "name" ] = "Chitter"                     ,["maxlevel"] =62    ,["minlevel"] =30    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 909   ,["id"] = 52146  ,["coords"] = {{63.2  , 66.6  },{63.4,65.2},{63.4,66},{63.6,66},{63.8,65.2},{64.2,64.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Mount Hyjal"                   , [ "zoneID" ] = 198  , [ "name" ] = "Ankha"                       ,["maxlevel"] =122   ,["minlevel"] =122   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 38748 ,["id"] = 54318  ,["coords"] = {{27.4  , 51.2  },{27.6,51.2},{28,52},{28.8,52.2},{29.6,52},{30,51.4},{30.6,51.4},{32.4,51.4},{33.2,52},{33.2,52.6},{33.8,52.4},{34.4,53.2},{34.6,53.4},{34.8,53.8},{35,54.6},{35.6,54.6},{36,53.8},{37,54},{38,54.2},{38.4,54.6},{39.2,54.8},{39.4,54.2},{39.6,54.8},{40.4,53.4},{40.4,53.6},{41.2,54}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Mount Hyjal"                   , [ "zoneID" ] = 198  , [ "name" ] = "Magria"                      ,["maxlevel"] =122   ,["minlevel"] =122   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 38749 ,["id"] = 54319  ,["coords"] = {{27.4  , 51.4  },{27.6,51.4},{28.4,52},{29,52.4},{29.4,52.6},{29.6,52.6},{30,51.6},{30.4,51.4},{31.2,51.2},{32.4,51.4},{32.6,51.2},{33,52.4},{33.4,52.6},{33.6,52.4},{34.4,53.2},{34.6,53},{34.8,54},{35.2,54.6},{35.6,54.8},{36.4,54.2},{36.6,54.6},{37.2,54},{37.8,54.2},{38.2,54.6},{38.8,55},{39,54.4},{39.6,53.8},{40.2,53.2},{40.6,53.2},{40.8,54},{41.2,54.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Mount Hyjal"                   , [ "zoneID" ] = 198  , [ "name" ] = "Ban'thalos"                  ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 38634 ,["id"] = 54320  ,["coords"] = {{25.8  , 61.2  },{25.8,61.8},{26,65.2},{26.2,62.8},{26.4,60},{27,59.8},{27,63.4},{27.2,64.2},{27.6,60.2},{27.8,62.6},{28,61},{28,62.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Solix"                       ,["maxlevel"] =122   ,["minlevel"] =122   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 38780 ,["id"] = 54321  ,["coords"] = {{60.2  , 58.6  },{60.4,60.2},{60.6,59.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Deth'tilac"                  ,["maxlevel"] =122   ,["minlevel"] =122   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 38424 ,["id"] = 54322  ,["coords"] = {{68    , 71.4  },{68,72.2},{68.8,71.2},{69.4,69.8},{73,58},{73.2,59.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Kirix"                       ,["maxlevel"] =122   ,["minlevel"] =122   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 38453 ,["id"] = 54323  ,["coords"] = {{26.6  , 66.4  },{27,62},{28,61.6},{29,73},{29.8,55.2},{30.2,58},{30.4,56.8},{31.2,57.4},{31.6,56.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Skitterflame"                ,["maxlevel"] =122   ,["minlevel"] =122   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 38779 ,["id"] = 54324  ,["coords"] = {{18.6  , 52.6  },{19.4,47.4},{19.4,48.4},{19.4,48.8},{19.6,48.4},{19.8,49},{20,50.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Anthriss"                    ,["maxlevel"] =122   ,["minlevel"] =112   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 38426 ,["id"] = 54338  ,["coords"] = {{52.6  , 41.2  },{53.8,39.6},{54.2,39.2},{54.6,38.8},{54.6,41.8},{54.8,38.4},{54.8,39.6},{54.8,41},{55.6,38.4},{56.6,41.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Prince Lakma"                ,["maxlevel"] =87    ,["minlevel"] =87    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      }, ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 39009 ,["id"] = 54533  ,["coords"] = {{47.6  , 74.6  },{48,78.4},{48.2,78.8},{48.6,79}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Vale of Eternal Blossoms"      , [ "zoneID" ] = 390  , [ "name" ] = "Bloodtip"                    ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 36513 ,["id"] = 58474  ,["coords"] = {{27    , 14.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Vale of Eternal Blossoms"      , [ "zoneID" ] = 390  , [ "name" ] = "Wulon"                       ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 128 , "Quilen"        }, ["familySkills" ] = QUILLEN_SKILLS       ,["displayID"] = 43097 ,["id"] = 63510  ,["coords"] = {{45.2  , 76.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Rockhoof"                    ,["maxlevel"] =102   ,["minlevel"] =97    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    }, ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 53607 ,["id"] = 72606  ,["coords"] = {{52.8  , 50.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Timeless Isle"                 , [ "zoneID" ] = 554  , [ "name" ] = "Emerald Gander"              ,["maxlevel"] =92    ,["minlevel"] =91    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 125 , "Crane"         }, ["familySkills" ] = CRANE_SKILLS         ,["displayID"] = 51264 ,["id"] = 73158  ,["coords"] = {{29.4  , 50.2  },{29.4,50.6},{29.6,50.2},{29.8,45.4},{29.8,61.4},{29.8,66},{30,62.6},{30.2,58},{30.4,43.6},{30.4,50.6},{30.4,58.6},{30.4,61.6},{30.4,64.8},{30.4,66.8},{30.6,43.4},{30.6,44},{30.6,52.4},{30.6,58.4},{30.6,62.2},{30.8,45.2},{30.8,50},{30.8,50.6},{31,66},{31.2,62.6},{31.2,66.6},{31.2,79.4},{31.4,65.2},{31.4,79.8},{31.6,40},{31.6,62.4},{31.6,66.8},{31.6,79.4},{31.8,66},{32,52.6},{32,79.8},{32.2,48.8},{32.2,80.6},{32.6,49.2},{32.6,49.6},{33,48.2},{33.2,39.4},{36.2,39.4},{36.2,40.4},{36.2,40.6},{36.4,83.8},{36.6,40.4},{36.6,83.8},{37.6,41.6},{38.2,41.4},{38.6,41.4},{39.2,43.4},{39.2,68},{39.6,67.6},{39.6,68.6},{40,39.4},{40.2,40.2},{40.2,43.6},{40.4,40.8},{40.4,43.4},{40.6,43.8},{40.8,39.2},{40.8,40.4},{40.8,42.4},{41,40.6},{41.4,42.8},{42.2,70.2},{42.2,70.8},{42.4,66.8},{42.4,68},{42.8,67},{42.8,70},{42.8,70.6},{43.4,55.2},{44.2,61},{44.2,61.8},{44.4,54},{44.4,55},{44.6,55},{44.6,61.4},{44.8,53.2},{44.8,53.6}                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Timeless Isle"                 , [ "zoneID" ] = 554  , [ "name" ] = "Ironfur Steelhorn"           ,["maxlevel"] =92    ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 157 , "Oxen"          }, ["familySkills" ] = OXEN_SKILLS          ,["displayID"] = 51284 ,["id"] = 73160  ,["coords"] = {{27.8  , 51.2  },{27.8,60},{28.2,40.2},{28.2,59},{28.6,47.4},{29.2,43},{29.2,44.4},{29.4,71.4},{29.4,72},{29.6,45.8},{29.8,70},{30.8,47.4},{30.8,70.8},{31.2,57.6},{31.6,43.2},{31.6,58.8},{31.8,58.4},{32.2,44.8},{33.2,38.6},{33.4,61.2},{33.6,37.2},{33.6,62.2},{34.2,71},{34.8,72},{35.2,41.8},{35.4,67.4},{36,67},{36,70.6},{39.4,38.4},{41.6,39.6},{43.8,43.8},{44.6,43.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Timeless Isle"                 , [ "zoneID" ] = 554  , [ "name" ] = "Great Turtle Furyshell"      ,["maxlevel"] =92    ,["minlevel"] =91    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        }, ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 51127 ,["id"] = 73161  ,["coords"] = {{20.6  , 43.2  },{21,44.4},{21.4,64.6},{21.4,66.2},{22,42.6},{22,44.2},{22,61.6},{22.2,53.6},{22.2,61.4},{22.2,67.8},{22.4,45.8},{22.4,53},{22.4,65.2},{22.4,66.2},{22.4,67.2},{22.6,53.4},{22.6,53.8},{22.6,65.4},{22.6,66.4},{22.6,66.8},{23,47.4},{23.2,63.2},{23.2,63.6},{23.2,68.4},{23.2,69.8},{23.4,49},{23.4,49.6},{23.4,60.6},{23.6,47.6},{23.6,49.8},{23.6,53.4},{23.6,59.8},{23.6,62.8},{23.8,54},{23.8,59.2},{24.2,49},{24.2,70},{24.4,57.8},{24.6,57.4},{24.6,57.6},{24.6,59.6},{25,58.6},{25.4,50.4},{25.4,52.4},{25.4,53},{25.4,55.8},{25.6,56},{25.6,57.8},{25.8,54.4},{25.8,57.4},{25.8,58.6},{25.8,71.6},{26,50.4},{26.2,50.8},{26.6,72.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Killmaw"                     ,["maxlevel"] =102   ,["minlevel"] =95    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 55523 ,["id"] = 74206  ,["coords"] = {{40.6  , 44.6  },{40.8,44.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Veloss"                      ,["maxlevel"] =102   ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 33  , "Sporebat"      }, ["familySkills" ] = SPOREBATS_SKILLS     ,["displayID"] = 53360 ,["id"] = 75482  ,["coords"] = {{21.4  , 20.8  },{21.6,21.6},{21.8,21}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Mother Araneae"              ,["maxlevel"] =102   ,["minlevel"] =95    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 17180 ,["id"] = 76473  ,["coords"] = {{53.4  , 78.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Coldtusk"                    ,["maxlevel"] =102   ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 52652 ,["id"] = 76914  ,["coords"] = {{54    , 68.2  },{54.2,67.4},{54.2,68.8},{54.4,69.6},{54.8,70},{55,71.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Amaukwa"                     ,["maxlevel"] =102   ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      }, ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 60896 ,["id"] = 77140  ,["coords"] = {{29.2  , 30.8  },{29.4,29.8},{29.6,32.2},{30,29.6},{30.4,29},{31,32.2},{31.2,28.6},{31.4,28.4},{31.4,32.6},{31.6,32.4},{32,33},{32.2,28},{32.6,28},{32.6,33.2},{33.2,33.6},{33.6,33.8},{34.2,28.2},{34.2,28.6},{35.2,29},{35.4,35},{36,29.2},{36,35.4},{36.2,35.6},{36.6,35.8},{37.2,29.6},{37.6,29.6},{38.2,36.6},{38.8,36.6},{40.4,35.4},{40.4,35.8},{41,34.6},{41.2,30.8},{41.4,31.6},{41.4,32.8},{41.6,32.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Coldstomp the Griever"       ,["maxlevel"] =102   ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     }, ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 52404 ,["id"] = 77513  ,["coords"] = {{25.4  , 55    },{25.6,55},{26.2,56.4},{26.2,56.6},{26.6,55.6},{26.8,55.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Giantbane"                   ,["maxlevel"] =102   ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     }, ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 53946 ,["id"] = 77519  ,["coords"] = {{57    , 38    },{57.4,37.4},{57.6,37},{57.6,37.6},{58.4,31.6},{58.4,35.4},{58.4,35.6},{58.6,33.6},{58.6,34.6},{58.6,35.6},{58.8,33.4},{59.4,31.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Hen-Mother Hami"             ,["maxlevel"] =102   ,["minlevel"] =96    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 58713 ,["id"] = 77626  ,["coords"] = {{75.4  , 50.8  },{75.6,51.6},{75.8,50.4},{76.2,50.8},{76.6,50.4},{77.2,51.6},{77.4,51.2},{77.6,51.8},{78,50.4},{78.4,50.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Taladorantula"               ,["maxlevel"] =102   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 54564 ,["id"] = 77634  ,["coords"] = {{58.8  , 87.6  },{59,87.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Hammertooth"                 ,["maxlevel"] =102   ,["minlevel"] =96    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    }, ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 52415 ,["id"] = 77715  ,["coords"] = {{60.2  , 47.8  },{60.6,47.4},{60.8,48.4},{61,46},{61.2,45.2},{61.4,44.4},{61.4,49.2},{61.6,48.6},{62,46},{62.2,47.2},{62.4,44.4},{62.4,45.4},{62.4,48},{62.8,44.2},{62.8,45.2},{63.6,43.6},{63.6,45},{64,43.2},{64.6,45.2},{65.2,43}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Glimmerwing"                 ,["maxlevel"] =102   ,["minlevel"] =96    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 37  , "Moth"          }, ["familySkills" ] = MOTH_SKILLS          ,["displayID"] = 59748 ,["id"] = 77719  ,["coords"] = {{30.4  , 64.2  },{30.4,65},{30.6,64.6},{31.4,63.6},{32.2,63.6},{32.2,65.6},{32.4,63.4},{32.4,65.2},{32.6,63.2},{32.6,65},{32.8,62.4},{33.2,63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Ra'kahn"                     ,["maxlevel"] =102   ,["minlevel"] =98    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 59725 ,["id"] = 77741  ,["coords"] = {{59.4  , 59.4  },{59.4,59.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Klikixx"                     ,["maxlevel"] =102   ,["minlevel"] =97    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 46518 ,["id"] = 78872  ,["coords"] = {{66.8  , 85.4  },{66.8,85.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "No'losh"                     ,["maxlevel"] =102   ,["minlevel"] =96    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 126 , "Water Strider" }, ["familySkills" ] = WATER_STRIDER_SKILLS ,["displayID"] = 18194 ,["id"] = 79334  ,["coords"] = {{85.8  , 29.2  },{86,29.6},{86.4,30.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Hypnocroak"                  ,["maxlevel"] =102   ,["minlevel"] =96    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 291 , "Toad"          }, ["familySkills" ] = TOAD_SKILLS          ,["displayID"] = 55232 ,["id"] = 79524  ,["coords"] = {{37.4  , 48.8  },{37.6,49}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Gaz'orda"                    ,["maxlevel"] =102   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         }, ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55460 ,["id"] = 80122  ,["coords"] = {{43.4  , 77.6  },{43.6,77.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Chillfang"                   ,["maxlevel"] =102   ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 24  , "Bat"           }, ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 55721 ,["id"] = 80242  ,["coords"] = {{41.2  , 68.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Gennadian"                   ,["maxlevel"] =102   ,["minlevel"] =97    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         }, ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55763 ,["id"] = 80471  ,["coords"] = {{67.4  , 80.4  },{67.4,80.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Spires of Arak"                , [ "zoneID" ] = 542  , [ "name" ] = "Varasha"                     ,["maxlevel"] =102   ,["minlevel"] =98    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         }, ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 58892 ,["id"] = 82050  ,["coords"] = {{29.4  , 41.4  },{29.4,41.6},{29.6,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Darktalon"                   ,["maxlevel"] =102   ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 59726 ,["id"] = 82411  ,["coords"] = {{49.4  , 41.8  },{49.6,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Jabberjaw"                   ,["maxlevel"] =102   ,["minlevel"] =95    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 42  , "Worm"          }, ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 55133 ,["id"] = 82616  ,["coords"] = {{48.2  , 24.2  },{48.4,23.4},{48.4,24.6},{48.6,23.6},{48.6,24.6},{48.8,23.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Slogtusk the Corpse-Eater"   ,["maxlevel"] =102   ,["minlevel"] =101   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 57263 ,["id"] = 82617  ,["coords"] = {{44.6  , 15.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Greatfeather"                ,["maxlevel"] =102   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 60416 ,["id"] = 82758  ,["coords"] = {{66.8  , 51.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Gnarlhoof the Rabid"         ,["maxlevel"] =102   ,["minlevel"] =101   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 151 , "Stag"          }, ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 53744 ,["id"] = 82778  ,["coords"] = {{66.6  , 56.4  },{66.6,56.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Grizzlemaw"                  ,["maxlevel"] =102   ,["minlevel"] =100   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 57383 ,["id"] = 82912  ,["coords"] = {{89.4  , 72.4  },{89.4,72.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Flinthide"                   ,["maxlevel"] =102   ,["minlevel"] =100   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     }, ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 57735 ,["id"] = 83483  ,["coords"] = {{69.8  , 41.4  },{69.8,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Hive Queen Skrikka"          ,["maxlevel"] =101   ,["minlevel"] =92    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       }, ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 57771 ,["id"] = 83522  ,["coords"] = {{52.2  , 70.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Insha'tar"                   ,["maxlevel"] =102   ,["minlevel"] =95    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  }, ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 57801 ,["id"] = 83553  ,["coords"] = {{57.4  , 48.4  },{57.4,48.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Tura'aka"                    ,["maxlevel"] =102   ,["minlevel"] =100   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      }, ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 56062 ,["id"] = 83591  ,["coords"] = {{65    , 39.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Spires of Arak"                , [ "zoneID" ] = 542  , [ "name" ] = "Stonespite"                  ,["maxlevel"] =102   ,["minlevel"] =98    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      }, ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 58506 ,["id"] = 84805  ,["coords"] = {{33.4  , 22    },{33.6,22}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Spires of Arak"                , [ "zoneID" ] = 542  , [ "name" ] = "Blightglow"                  ,["maxlevel"] =102   ,["minlevel"] =98    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 33  , "Sporebat"      }, ["familySkills" ] = SPOREBATS_SKILLS     ,["displayID"] = 52740 ,["id"] = 84856  ,["coords"] = {{64.2  , 65.2  },{64.4,65.6},{64.8,66.4},{65,67},{65.2,67.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Spires of Arak"                , [ "zoneID" ] = 542  , [ "name" ] = "Sunderthorn"                 ,["maxlevel"] =102   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 58569 ,["id"] = 84912  ,["coords"] = {{58.4  , 45.2  },{58.6,45}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Spires of Arak"                , [ "zoneID" ] = 542  , [ "name" ] = "Jiasska the Sporegorger"     ,["maxlevel"] =102   ,["minlevel"] =99    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         }, ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55723 ,["id"] = 84955  ,["coords"] = {{56.4  , 94.4  },{56.4,94.6},{56.6,94.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Berthora"                    ,["maxlevel"] =102   ,["minlevel"] =99    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    }, ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 59205 ,["id"] = 85907  ,["coords"] = {{39.4  , 74.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Riptar"                      ,["maxlevel"] =102   ,["minlevel"] =96    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 59579 ,["id"] = 85970  ,["coords"] = {{37.4  , 81.4  },{37.6,81.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Venolasix"                   ,["maxlevel"] =102   ,["minlevel"] =94    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         }, ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 61588 ,["id"] = 86266  ,["coords"] = {{63.4  , 30.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Stompalupagus"               ,["maxlevel"] =102   ,["minlevel"] =96    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     }, ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 57735 ,["id"] = 86520  ,["coords"] = {{53.8  , 73.2  },{53.8,73.6},{54.2,72.4},{54.4,71.4},{54.6,71.6},{55,71}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Ashran"                        , [ "zoneID" ] = 588  , [ "name" ] = "Gibby"                       ,["maxlevel"] =121   ,["minlevel"] =121   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 51  , "Monkey"        }, ["familySkills" ] = MONKEY_SKILLS        ,["displayID"] = 46574 ,["id"] = 87362  ,["coords"] = {{47.4  , 69    },{47.6,28.4},{47.8,30.2},{48.4,58.8},{49.8,36.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Pit Beast"                   ,["maxlevel"] =102   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 290 , "Pterrordax"    }, ["familySkills" ] = PTERRORDAXE_SKILLS   ,["displayID"] = 48084 ,["id"] = 88208  ,["coords"] = {{58    , 18.6  },{58.2,18.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Mogamago"                    ,["maxlevel"] =102   ,["minlevel"] =94    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    }, ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 55211 ,["id"] = 88586  ,["coords"] = {{61.4  , 39.2  },{61.6,39.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Daggerbeak"                  ,["maxlevel"] =110   ,["minlevel"] =99    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   }, ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 64535 ,["id"] = 90057  ,["coords"] = {{51    , 31.4  },{51,31.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Skystormer"                  ,["maxlevel"] ="???" ,["minlevel"] ="???" , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   }, ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 12589 ,["id"] = 90816  ,["coords"] = {{53.6  , 64.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Pridelord Meowl"             ,["maxlevel"] =110   ,["minlevel"] =100   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   }, ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 69191 ,["id"] = 90901  ,["coords"] = {{56    , 29    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "Broodlord Ixkor"             ,["maxlevel"] =102   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       }, ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 58756 ,["id"] = 92429  ,["coords"] = {{57.6  , 67.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Stormheim"                     , [ "zoneID" ] = 634  , [ "name" ] = "Bloodstalker Alpha"          ,["maxlevel"] =110   ,["minlevel"] =99    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 71540 ,["id"] = 92599  ,["coords"] = {{40.0  , 38.6  }, {38.2, 42.8}, {39.0, 44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "Rendrak"                     ,["maxlevel"] =102   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 24  , "Bat"           }, ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 63197 ,["id"] = 92627  ,["coords"] = {{37.2  , 68.6  },{37.8,67},{38.8,77},{39,74.8},{39.2,69},{39.2,70.4},{39.2,71},{39.4,72},{39.4,74},{39.8,75.4},{39.8,76.4},{39.8,76.6},{40.2,74},{40.4,71.4},{40.6,71.6},{40.8,73.2},{41.2,74.2},{41.2,77},{41.4,75.2},{41.6,74.4},{41.6,76.2},{42,70.4},{42,70.8},{42.4,71.8},{42.4,73.4},{42.4,77.6},{42.6,71.8},{42.6,76.4},{42.8,74},{43,70.4},{43,71.4},{43,73.4},{43,75.4},{43.2,76.6},{43.4,79.2},{43.6,72.4},{43.6,74},{43.6,77},{43.8,72.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "The Goreclaw"                ,["maxlevel"] =102   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 63223 ,["id"] = 92694  ,["coords"] = {{34.4  , 72.4  },{34.4,72.6},{34.6,72.4},{34.6,72.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "Steelsnout"                  ,["maxlevel"] =102   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 64723 ,["id"] = 92887  ,["coords"] = {{65.4  , 36.4  },{65.4,36.8},{65.6,36.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "Magwia"                      ,["maxlevel"] =102   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    }, ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 61301 ,["id"] = 93002  ,["coords"] = {{52.2  , 65.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "Shadowthrash"                ,["maxlevel"] =102   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  }, ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 21371 ,["id"] = 93236  ,["coords"] = {{49.6  , 61    },{49.8,61.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Majestic Elderhorn"          ,["maxlevel"] =110   ,["minlevel"] =100   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 151 , "Stag"          }, ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 64893 ,["id"] = 96410  ,["coords"] = {{45.2  , 25.8  },{45.4,30.2},{45.8,30.4},{46.4,30.8},{46.6,31.4},{47,33.6},{47.2,32.4},{47.4,33},{47.6,32.8},{47.8,30.4},{47.8,32},{48.4,25.2},{48.6,25.2},{49.2,29}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Arru"                        ,["maxlevel"] =110   ,["minlevel"] =100   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 20827 ,["id"] = 97220  ,["coords"] = {{48.8  , 50    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Crawshuk the Hungry"         ,["maxlevel"] =110   ,["minlevel"] =101   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 65258 ,["id"] = 97345  ,["coords"] = {{48.4  , 40.4  },{48.4,40.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Bristlemaul"                 ,["maxlevel"] =110   ,["minlevel"] =98    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 51827 ,["id"] = 97449  ,["coords"] = {{38    , 45.4  },{38,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Val'sharah"                    , [ "zoneID" ] = 641  , [ "name" ] = "Wraithtalon"                 ,["maxlevel"] =110   ,["minlevel"] =99    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   }, ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 65235 ,["id"] = 97504  ,["coords"] = {{66.6  , 37.6  },{66.8,36.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Tamed Coralback"             ,["maxlevel"] =110   ,["minlevel"] =100   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 70524 ,["id"] = 97928  ,["coords"] = {{43    , 10.4  },{43.4,10.8},{43.8,10},{44,11.2},{44.2,12.2},{44.4,12.6},{45.4,12.4},{45.4,12.6},{45.8,12.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Slumber"                     ,["maxlevel"] =110   ,["minlevel"] =98    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 37737 ,["id"] = 98890  ,["coords"] = {{41.4  , 31.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Thunder Totem"                 , [ "zoneID" ] = 652  , [ "name" ] = "Sekhan"                      ,["maxlevel"] =110   ,["minlevel"] =98    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 64387 ,["id"] = 101077 ,["coords"] = {{36    , 8     },{36.2,6.2},{36.4,7},{36.8,7.2},{36.8,12.8},{37,6.4},{37,8.2},{37.2,4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Val'sharah"                    , [ "zoneID" ] = 641  , [ "name" ] = "Well-Fed Bear"               ,["maxlevel"] =110   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 68383 ,["id"] = 103785 ,["coords"] = {{49.2  , 46.8  },{59.6,66.8},{60.2,66.4},{60.6,66.2},{69,59.4},{69,59.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Baconlisk"                   ,["maxlevel"] =110   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      }, ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 66850 ,["id"] = 103787 ,["coords"] = {{24.4  , 49.6  },{24.6,49.4},{24.8,49.8},{38.8,29.6},{39,29.4},{75.8,50.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Shadowquill"                 ,["maxlevel"] =110   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 64536 ,["id"] = 103841 ,["coords"] = {{16.2  , 25.4  },{16.4,26.4},{16.4,26.8},{16.8,26.4},{17,26.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Rauren"                      ,["maxlevel"] =110   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   }, ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 69191 ,["id"] = 105547 ,["coords"] = {{23.4  , 26    },{23.8,25.4},{23.8,25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Stormheim"                     , [ "zoneID" ] = 634  , [ "name" ] = "Starbuck"                    ,["maxlevel"] =110   ,["minlevel"] =102   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 151 , "Stag"          }, ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 70116 ,["id"] = 107487 ,["coords"] = {{54.6  , 29.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Grimrot"                     ,["maxlevel"] =60    ,["minlevel"] =60    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70193 ,["id"] = 107595 ,["coords"] = {{38.2  , 45.4  },{38.2,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Grimrot"                     ,["maxlevel"] =60    ,["minlevel"] =57    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70194 ,["id"] = 107596 ,["coords"] = {{38.2  , 45.4  },{38.2,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "The Hinterlands"               , [ "zoneID" ] = 26   , [ "name" ] = "Ol' Muddle"                  ,["maxlevel"] =60    ,["minlevel"] =36    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70190 ,["id"] = 107617 ,["coords"] = {{42.6  , 61.8  },{42.8,59.4},{42.8,62.6},{43,61.4},{43,63.8},{43.2,60},{44,55.2},{44,59.6},{44.4,64.6},{44.6,53.6},{47,56.2},{48.8,59.2},{49.2,57.2},{49.8,57.2},{51,55.6},{51.2,53.8},{51.2,59},{52.4,51},{54.2,45.4},{54.2,45.8},{54.8,46.2},{56,46},{58,46.6},{58.2,53.2},{59,48.8},{61,50.4},{62,54},{62.6,47.6},{62.8,45},{63.2,54.2},{63.4,42.4},{64,54.6},{64.2,41.2},{64.4,42.2},{64.6,42},{64.8,57.2},{65.4,58.4},{67.8,47},{67.8,57.4},{68.2,48},{69.4,50.6},{70.2,51.2},{71.6,50.2},{71.8,51.8},{72.2,50.6},{72.8,49.2},{72.8,50},{74,54.6},{75.8,51.8},{76.8,49.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Pinchshank"                  ,["maxlevel"] =110   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 699   ,["id"] = 107846 ,["coords"] = {{66.4  , 67.2  },{66.4,67.6},{66.6,66.4},{66.6,67.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Myonix"                      ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 71536 ,["id"] = 110340 ,["coords"] = {{40.4  , 33.4  },{40.8,32.4},{40.8,32.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Val'sharah"                    , [ "zoneID" ] = 641  , [ "name" ] = "Bahagar"                     ,["maxlevel"] =110   ,["minlevel"] =98    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 71578 ,["id"] = 110562 ,["coords"] = {{45.2  , 87.4  },{45.2,88 },{45.4,88.6},{45.6,88.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }, },
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Tideclaw"                    ,["maxlevel"] =110   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 70524 ,["id"] = 110824 ,["coords"] = {{18.4  , 61    },{18.6,60.2},{18.6,61}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Anax"                        ,["maxlevel"] =110   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 291 , "Toad"          }, ["familySkills" ] = TOAD_SKILLS          ,["displayID"] = 55080 ,["id"] = 111197 ,["coords"] = {{33.4  , 51    },{33.4,51.6},{33.6,51.4},{33.6,51.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Stormheim"                     , [ "zoneID" ] = 634  , [ "name" ] = "Bulvinkel"                   ,["maxlevel"] =110   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 70876 ,["id"] = 111463 ,["coords"] = {{73.8  , 84.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Maia the White"              ,["maxlevel"] =110   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 68526 ,["id"] = 112497 ,["coords"] = {{24.4  , 35.2  },{24.6,35 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }, },
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Sinister Leyrunner"          ,["maxlevel"] =110   ,["minlevel"] =98    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 151 , "Stag"          }, ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 69430 ,["id"] = 112636 ,["coords"] = {{50.4  , 52    },{50.6,52}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Devious Sunrunner"           ,["maxlevel"] =110   ,["minlevel"] =98    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 151 , "Stag"          }, ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 72132 ,["id"] = 112637 ,["coords"] = {{50.4  , 52    },{50.6,52.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Mar'tura"                    ,["maxlevel"] =110   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        }, ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 44781 ,["id"] = 112802 ,["coords"] = {{13.4  , 53.4  },{13.4,53.6},{13.6,53.4},{13.6,53.6},{13.8,52.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Pashya"                      ,["maxlevel"] =110   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 67421 ,["id"] = 113694 ,["coords"] = {{60.2  , 40.8  },{62 ,46.8},{62.4,52.2},{62.4,52.8},{62.6,53.2},{64.2,47.4},{64.2,48},{66.2,53.4},{66.2,53.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }, },
  { ["zone_name"] = "Duskwood"                      , [ "zoneID" ] = 47   , [ "name" ] = "Lightning Paw"               ,["maxlevel"] =60    ,["minlevel"] =25    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  }, ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 74736 ,["id"] = 118244 ,["coords"] = {{23    , 39    } , {23 , 29}, {30 , 41},{16 , 54},{16 , 60}, {23 , 76} ,                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Umbra'jin"                   ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 83645 ,["id"] = 122004 ,["coords"] = {{71.2  , 32.4  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Overstuffed Saurolisk"       ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 77980 ,["id"] = 124375 ,["coords"] = {{62    , 65    }, {62.4, 64.4}, {62.6, 64.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Kal'draxa"                   ,["maxlevel"] =120   ,["minlevel"] =118   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 290 , "Pterrordax"    }, ["familySkills" ] = PTERRORDAXE_SKILLS   ,["displayID"] = 80333 ,["id"] = 124397 ,["coords"] = {{52.8  , 13.2  }, {52.8, 13.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Infected Direhorn"           ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 138 , "Direhorn"      }, ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 74268 ,["id"] = 124399 ,["coords"] = {{24.4  , 78    }, {24.6, 77.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Krubbs"                      ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 50962 ,["id"] = 125214 ,["coords"] = {{75.8  , 36    }, {76, 36.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Ancient Jawbreaker"          ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     }, ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 78396 ,["id"] = 125250 ,["coords"] = {{67.4  , 29.4  }, {67.4, 29.6}, {67.6, 29.4}, {67.8, 29.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Quillrat Matriarch"          ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 127 , "Rodent"        }, ["familySkills" ] = RODENT_SKILLS        ,["displayID"] = 43647 ,["id"] = 125453 ,["coords"] = {{66.4  , 42.4  }, {66.4, 42.6}, {66.6, 42.4}, {66.6, 42.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Bajiatha"                    ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 78750 ,["id"] = 126142 ,["coords"] = {{42    , 60.6  }, {42.4, 60.4}, {42.6, 60.4}, {42.8, 60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Kandak"                      ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 79019 ,["id"] = 126637 ,["coords"] = {{68.6  , 48.4  }, {68.6, 48.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Venomjaw"                    ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     }, ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 40269 ,["id"] = 126926 ,["coords"] = {{29.2  , 50.4  }, {29.4, 50.6}, {29.6, 50.8}, {29.8, 50.4}, {29.8, 51.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Mugg"                        ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 81866 ,["id"] = 127290 ,["coords"] = {{58.4  , 14.8  }, {58.8, 14.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Barbthorn Queen"             ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 85629 ,["id"] = 127333 ,["coords"] = {{59    , 17    }, {59, 17.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Vicemaul"                    ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 21936 ,["id"] = 127651 ,["coords"] = {{72.8  , 60.4  }, {72.8, 60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Scaleclaw Broodmother"       ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 79365 ,["id"] = 127776 ,["coords"] = {{44.4  , 80.2  }, {44.4, 80.6}, {44.6, 80.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Scrounger Patriarch"         ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 83648 ,["id"] = 127873 ,["coords"] = {{57.4  , 9.4   }, {57.4, 9.6}, {57.6, 8.2}, {58.2, 9.2}, {58.4, 9.8}, {58.6, 9.4}, {58.6, 9.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Torraske the Eternal"        ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 79702 ,["id"] = 127939 ,["coords"] = {{46.4  , 65.2  }, {46.6, 65.2}, {46.8, 65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Bloodbulge"                  ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 296 , "Blood Beast"   }, ["familySkills" ] = BLOOD_BEAST_SKILLS   ,["displayID"] = 83539 ,["id"] = 128699 ,["coords"] = {{59.4  , 18.4  }, {59.6, 18.6}, {59.8, 18.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Queen Tzxi'kik"              ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 80307 ,["id"] = 128974 ,["coords"] = {{57.4  , 67.8  }, {57.6, 67.6}, {57.8, 67.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "King Kooba"                  ,["maxlevel"] =120   ,["minlevel"] =112   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 9   , "Gorilla"       }, ["familySkills" ] = GORILLA_SKILLS       ,["displayID"] = 80326 ,["id"] = 129005 ,["coords"] = {{53.2  , 42.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Jumbo Sandsnapper"           ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 80500 ,["id"] = 129283 ,["coords"] = {{37.4  , 84.4  }, {37.4, 84.8}, {37.6, 84.4}, {37.6, 84.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Bloated Krolusk"             ,["maxlevel"] =120   ,["minlevel"] =112   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 292 , "Krolusk"       }, ["familySkills" ] = KROLUSK_SKILLS       ,["displayID"] = 80618 ,["id"] = 129476 ,["coords"] = {{48.8  , 50.6  }, {49, 50}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Beshol"                      ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 37738 ,["id"] = 129805 ,["coords"] = {{50.4  , 30    }, {50.6, 30}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Gorehorn"                    ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 151 , "Stag"          }, ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 80884 ,["id"] = 129835 ,["coords"] = {{57    , 44.2  }, {57.2, 44.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Talon"                       ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 81102 ,["id"] = 129950 ,["coords"] = {{31.8  , 41    }, {32.2, 40}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Gahz'ralka"                  ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         }, ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 58892 ,["id"] = 129954 ,["coords"] = {{64.2  , 32.8  }, {64.4, 32.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Nevermore"                   ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 80965 ,["id"] = 130138 ,["coords"] = {{60    , 45.4  }, {60, 45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Vathikur"                    ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       }, ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 81189 ,["id"] = 130401 ,["coords"] = {{57.2  , 73.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Ashmane"                     ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         }, ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 49064 ,["id"] = 130439 ,["coords"] = {{54.6  , 15.2  }, {54.6, 15.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Hivemother Kraxi"            ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 81233 ,["id"] = 130443 ,["coords"] = {{53.6  , 53.4  }, {53.6, 53.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Broodmother Razora"          ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 81342 ,["id"] = 130508 ,["coords"] = {{83.2  , 44.4  }, {83.4, 44.8}, {83.6, 44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Lei-zhi"                     ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 128 , "Quilen"        }, ["familySkills" ] = QUILLEN_SKILLS       ,["displayID"] = 42065 ,["id"] = 131233 ,["coords"] = {{58.8  , 74.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Merianae"                    ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 82052 ,["id"] = 131252 ,["coords"] = {{43.2  , 16.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Pack Leader Asenya"          ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 68526 ,["id"] = 131262 ,["coords"] = {{39    , 15.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Kulett the Ornery"           ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        }, ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 47803 ,["id"] = 131520 ,["coords"] = {{48    , 22.2  }, {48.2, 22.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Tambano"                     ,["maxlevel"] =120   ,["minlevel"] =112   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 44916 ,["id"] = 131687 ,["coords"] = {{77.4  , 11.2  }, {77.6, 10.2}, {77.6, 11}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Bramblewing"                 ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 290 , "Pterrordax"    }, ["familySkills" ] = PTERRORDAXE_SKILLS   ,["displayID"] = 76655 ,["id"] = 131718 ,["coords"] = {{66.4  , 32.4  }, {66.4, 32.6}, {66.6, 32.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Bashmu"                      ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         }, ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55832 ,["id"] = 132068 ,["coords"] = {{34.2  , 30.6  }, {34.4, 30.2}, {34.6, 30.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Foxhollow Skyterror"         ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 82239 ,["id"] = 132127 ,["coords"] = {{60    , 22.6  }, {60.2, 22.2}, {60.6, 22}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Fowlmouth"                   ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 82292 ,["id"] = 132211 ,["coords"] = {{90.2  , 77.2  }, {90.2, 77.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Kiboku"                      ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    }, ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 77474 ,["id"] = 132244 ,["coords"] = {{75.4  , 35.8  }, {75.6, 36}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Bilefang Mother"             ,["maxlevel"] =120   ,["minlevel"] =112   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 34168 ,["id"] = 132319 ,["coords"] = {{35.2  , 33    }, {35.6, 32.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Tempestria"                  ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 82869 ,["id"] = 133356 ,["coords"] = {{60.6  , 17.4  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Juba the Scarred"            ,["maxlevel"] =120   ,["minlevel"] =113   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 138 , "Direhorn"      }, ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 47819 ,["id"] = 133527 ,["coords"] = {{27.4  , 34.2  }, {28, 34.2}, {28.2, 33.4}, {28.2, 35}, {28.6, 33.4}, {28.6, 33.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Lo'kuno"                     ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    }, ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 82989 ,["id"] = 133539 ,["coords"] = {{77.4  , 44.4  }, {77.4, 45.2}, {77.4, 45.6}, {77.6, 44.4}, {77.6, 45.2}, {77.6, 45.6}, {78.6, 44.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Zanxib"                      ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 83646 ,["id"] = 133812 ,["coords"] = {{38.4  , 71.4  }, {38.4, 71.6}, {38.8, 71.4}, {38.8, 71.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Warcrawler Karkithiss"       ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 292 , "Krolusk"       }, ["familySkills" ] = KROLUSK_SKILLS       ,["displayID"] = 79721 ,["id"] = 133842 ,["coords"] = {{44    , 25.4  }, {44, 25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "First Mate Swainbeak"        ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 80412 ,["id"] = 133843 ,["coords"] = {{41.2  , 24.2  }, {41.2, 24.6}, {41.6, 24}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Vukuba"                      ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  }, ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 4065  ,["id"] = 134048 ,["coords"] = {{62    , 46.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Murderbeak"                  ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 55918 ,["id"] = 134782 ,["coords"] = {{60.6  , 66.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Ak'tar"                      ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 290 , "Pterrordax"    }, ["familySkills" ] = PTERRORDAXE_SKILLS   ,["displayID"] = 76667 ,["id"] = 135852 ,["coords"] = {{50.2  , 81.6  }, {50.4, 81.4}, {50.6, 81.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Crushtacean"                 ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 83864 ,["id"] = 136183 ,["coords"] = {{51.4  , 55.4  }, {51.4, 55.6}, {51.6, 55.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Enraged Krolusk"             ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 292 , "Krolusk"       }, ["familySkills" ] = KROLUSK_SKILLS       ,["displayID"] = 75589 ,["id"] = 136335 ,["coords"] = {{61.8  , 37.4  }, {61.8, 37.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Scorpox"                     ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       }, ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 37539 ,["id"] = 136336 ,["coords"] = {{32.8  , 65.2  }, {32.8, 65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Jungleweb Hunter"            ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 1104  ,["id"] = 136341 ,["coords"] = {{60.4  , 17.4  }, {60.4, 17.8}, {60.6, 17.4}, {60.6, 17.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Bloodwing Bonepicker"        ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 3248  ,["id"] = 136393 ,["coords"] = {{56    , 53.4  }, {56, 53.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Broodmother"                 ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 85021 ,["id"] = 137025 ,["coords"] = {{29.2  , 69.4  }, {29.2, 69.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Honey-Coated Slitherer"      ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       }, ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78242 ,["id"] = 137183 ,["coords"] = {{64.2  , 19.4  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "King Clickyclack"            ,["maxlevel"] =120   ,["minlevel"] =113   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 85438 ,["id"] = 137681 ,["coords"] = {{38.2  , 41.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Arclight"                    ,["maxlevel"] =120   ,["minlevel"] =112   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       }, ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 85538 ,["id"] = 137824 ,["coords"] = {{29.2  , 68.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Avalanche"                   ,["maxlevel"] =120   ,["minlevel"] =113   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   }, ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 85539 ,["id"] = 137825 ,["coords"] = {{43.8  , 88.2  }, {43.8, 88.6}, {44.4, 85.4}, {44.4, 85.6}, {44.4, 87.2}, {44.6, 86.4}, {44.6, 86.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Gorged Boar"                 ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 5   , "Boar"          }, ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 55858 ,["id"] = 138675 ,["coords"] = {{27.8  , 25.4  }, {28, 26}, {28.6, 25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Nestmother Acada"            ,["maxlevel"] =120   ,["minlevel"] =112   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  }, ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 507   ,["id"] = 138963 ,["coords"] = {{43.4  , 45    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Blackthorne"                 ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 66132 ,["id"] = 139145 ,["coords"] = {{85.2  , 73.4  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Gulliver"                    ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  }, ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 78151 ,["id"] = 139233 ,["coords"] = {{57.4  , 56    }, {57.8, 56}, {57.8, 56.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Tort Jaw"                    ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        }, ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 42658 ,["id"] = 139235 ,["coords"] = {{70.4  , 55.4  }, {70.4, 55.6}, {70.6, 55.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Ranja"                       ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 913   ,["id"] = 139278 ,["coords"] = {{68.2  , 63.4  }, {68.2, 63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Sythian the Swift"           ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 151 , "Stag"          }, ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 45092 ,["id"] = 139280 ,["coords"] = {{66.2  , 14    }, {66.4, 13.4}, {66.4, 14.6}, {66.6, 14.6}, {66.8, 13.4}, {66.8, 13.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Shiverscale the Toxic"       ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       }, ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78240 ,["id"] = 139285 ,["coords"] = {{55    , 32.4  }, {55, 32.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Maison the Portable"         ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 75380 ,["id"] = 139290 ,["coords"] = {{58.2  , 50.2  }, {58.2, 50.6}, {58.4, 49.4}, {58.6, 49}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Pinku'shon"                  ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 86218 ,["id"] = 139298 ,["coords"] = {{38.2  , 51    }, {38.2, 51.6}, {38.6, 51}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Deepfang"                    ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          }, ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 71540 ,["id"] = 139385 ,["coords"] = {{52.8  , 51.4  }, {52.8, 51.6}, {53, 50.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Sandfang"                    ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       }, ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78242 ,["id"] = 139988 ,["coords"] = {{73.4  , 60.4  }, {73.4, 60.6}, {73.6, 60.4}, {73.6, 60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Croaker"                     ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 291 , "Toad"          }, ["familySkills" ] = TOAD_SKILLS          ,["displayID"] = 55080 ,["id"] = 140938 ,["coords"] = {{62.4  , 33.4  }, {62.4, 33.6}, {62.8, 32.8}, {62.8, 33.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Kickers"                     ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 129 , "Goat"          }, ["familySkills" ] = GOAT_SKILLS          ,["displayID"] = 82209 ,["id"] = 141029 ,["coords"] = {{31.2  , 61.8  }, {31.2, 62.6}, {31.4, 61.4}, {31.6, 61.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Osca the Bloodied"           ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 4   , "Bear"          }, ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 87178 ,["id"] = 141239 ,["coords"] = {{41.8  , 62.4  }, {42, 63}, {42, 63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Whirlwing"                   ,["maxlevel"] =120   ,["minlevel"] =111   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   }, ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 85524 ,["id"] = 142088 ,["coords"] = {{46.8  , 42.2  }, {46.8, 42.6}, {47, 41.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Redridge Mountains"            , [ "zoneID" ] = 49   , [ "name" ] = "Gnollfeaster"                ,["maxlevel"] =120   ,["minlevel"] =17    , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 3   , "Spider"        }, ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 8014  ,["id"] = 147222 ,["coords"] = {{24.4  , 70.4  },{24.4,70.6},{24.6,70.4},{24.6,70.6},{25,69.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "N'chala the Egg Thief"       ,["maxlevel"] =120   ,["minlevel"] =110   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        }, ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 83648 ,["id"] = 149147 ,["coords"] = {{69.2  , 35.2  }, {69.4, 35.8}, {69.4, 36.8}, {69.4, 37.8}, {69.6, 36.4}, {69.6, 36.6}, {69.6, 37.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Darkshore"                     , [ "zoneID" ] = 62   , [ "name" ] = "Glimmerspine"                ,["maxlevel"] =121   ,["minlevel"] =121   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 89029 ,["id"] = 149654 ,["coords"] = {{43.4  , 19.8  },{43.6,19.4},{43.6,19.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Darkshore"                     , [ "zoneID" ] = 62   , [ "name" ] = "Shadowclaw"                  ,["maxlevel"] =121   ,["minlevel"] =121   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 2   , "Cat"           }, ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 89243 ,["id"] = 149663 ,["coords"] = {{39.8  , 32.4  },{39.8,32.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Mechagon"                      , [ "zoneID" ] = 1462 , [ "name" ] = "Bonepicker"                  ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 77483 ,["id"] = 152001 ,["coords"] = {{65.4  , 23.4  },{65.4,23.6},{65.4,24.8},{65.4,25.6},{65.6,23.4},{65.6,24},{65.6,24.6},{65.6,25.6},{65.8,22.4},{65.8,26.6},{66.6,23.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Soundless"                   ,["maxlevel"] =121   ,["minlevel"] =121   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 34  , "Ray"           }, ["familySkills" ] = RAY_SKILLS           ,["displayID"] = 92542 ,["id"] = 152290 ,["coords"] = {{53.6  , 41.4  }, {54.4, 50}, {57.4, 51.4}, {58,41.8, }, {60, 47.8}, {62.4, 59.4}, {64.4, 51.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }, },
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Deepglider"                  ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 34  , "Ray"           }, ["familySkills" ] = RAY_SKILLS           ,["displayID"] = 90735 ,["id"] = 152291 ,["coords"] = {{52.2  , 52.8  }, {52.2, 54.4}, {52.2, 54.6}, {52.4, 42.4}, {52.4, 44}, {52.4, 52.4}, {52.6, 43.2}, {52.8, 44}, {53, 55}, {53.2, 42.2}, {53.2, 52}, {53.2, 52.8}, {53.2, 53.6}, {53.2, 56}, {53.6, 40}, {53.6, 41.4}, {53.6, 43.2}, {53.6, 44.2}, {53.6, 51.8}, {53.6, 53.2}, {53.6, 53.6}, {53.6, 54.6}, {54, 44.6}, {54.8, 52.4}, {55, 42.4}, {55.2, 42.6}, {55.6, 41.4}, {56.2, 44.8}, {56.2, 48.4}, {56.2, 51.6}, {56.4, 42.2}, {56.4, 42.8}, {56.4, 43.8}, {56.4, 48.8}, {56.4, 50.4}, {56.4, 51.4}, {56.4, 52.8}, {56.6, 42.4}, {56.6, 42.6}, {56.6, 44.4}, {56.8, 41.4}, {56.8, 44.8}, {56.8, 45.8}, {56.8, 47.8}, {56.8, 54.4}, {57, 47.4}, {57.2, 49.4}, {57.2, 49.8}, {57.2, 52.2}, {57.2, 52.6}, {57.4, 51.2}, {57.6, 49.4}, {57.6, 52.2}, {57.8, 50.4}, {58.2, 41.2}, {58.2, 55.6}, {58.4, 51.4}, {58.4, 53.2}, {58.4, 54.4}, {58.4, 54.8}, {58.6, 51.8}, {59, 48}, {59, 54}, {59, 56}, {59.2, 48.8}, {59.2, 51.4}, {59.2, 55.2}, {59.4, 52.6}, {59.6, 48}, {59.6, 52.8}, {59.6, 55.4}, {59.6, 56.6}, {59.8, 49.6}, {59.8, 51.2}, {59.8, 52.4}, {60, 48.8}, {60.2, 47.2}, {60.4, 55.8}, {60.6, 48.8}, {60.6, 51.2}, {60.6, 51.8}, {60.6, 55.4}, {60.8, 47.2}, {60.8, 49.6}, {61, 48.4}, {61, 52.8}, {61.8, 48}                        }, },
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Siltstalker the Packmother"  ,["maxlevel"] =121   ,["minlevel"] =121   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 90766 ,["id"] = 152359 ,["coords"] = {{71.6  , 54.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Toxigore the Alpha"          ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 90767 ,["id"] = 152360 ,["coords"] = {{64.4  , 47.2  }, {64.6, 46.6}, {64.8, 46.4}, {65.4, 50.4}, {65.4, 50.6}, {65.6, 50.2}, {67.4, 47}, {68.2, 46.4}, {68.4, 46.8}, {69.2, 45.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Banescale the Packfather"    ,["maxlevel"] =121   ,["minlevel"] =121   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        }, ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 90768 ,["id"] = 152361 ,["coords"] = {{71    , 54.4  }, {72, 54}, {73.2, 53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, },
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Iridescent Glimmershell"     ,["maxlevel"] =121   ,["minlevel"] =121   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 90947 ,["id"] = 152448 ,["coords"] = {{40.2  , 49.4  }, {40.4, 48.4}, {40.4, 49.6}, {40.6, 48.4}, {40.6, 48.6}, {42.4, 47.8}, {42.8, 47.4}, {42.8, 47.8}, {43.4, 54.8}, {43.6, 48}, {43.6, 54.2}, {44.4, 55.4}, {44.4, 55.6}, {44.6, 55.4}, {45.4, 47}, {45.4, 47.6}, {45.4, 56}, {45.6, 47.2}, {45.6, 47.6}, {45.6, 55.8}, {46, 54.4}, {46, 54.6}, {46.6, 52.4}, {46.8, 52.6}, {47, 55.4}, {47.2, 56}, {49.4, 51.4}, {49.6, 51.4}, {56.2, 57}, {58.8, 40.8}, {61.6, 42.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, },
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Needlespine"                 ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 91027 ,["id"] = 152465 ,["coords"] = {{39.4  , 27.4  }, {39.4, 28.2}, {39.6, 27.4}, {39.6, 28.2}, {46, 25.2}, {46, 25.6}, {46.8, 30.2}, {47, 30.8}, {48.4, 17}, {48.6, 17.4}, {48.6, 17.6}, {50.2, 19.2}, {50.4, 19.6}, {50.6, 19.2}, {56.4, 8.8}, {56.6, 8.6}, {56.8, 8}, {70.2, 24.4}, {70.4, 24.6}, {70.6, 24.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }, },
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Shassera"                    ,["maxlevel"] =121   ,["minlevel"] =121   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       }, ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 74318 ,["id"] = 152552 ,["coords"] = {{62.6  , 8.4   }, {62.8, 8.8}, {63.2, 7.4}, {64.2, 7.2}, {64.4, 5.4}, {64.4, 6}, {64.6, 5.4}, {64.6, 5.6}, {65.6, 5.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Garnetscale"                 ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        }, ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 50760 ,["id"] = 152553 ,["coords"] = {{31.4  , 35.4  }, {31.4, 35.6}, {31.6, 35.4}, {31.6, 35.6}, {32.2, 36.6}, {32.4, 33.4}, {32.4, 33.6}, {32.6, 33.4}, {32.6, 33.8}, {35.4, 45.2}, {35.8, 45.6}, {36.2, 45.2}, {36.4, 39}, {36.4, 44.2}, {36.6, 39.4}, {36.6, 40.8}, {36.6, 45.2}, {36.8, 41.6}, {37.4, 40.2}, {37.4, 47.4}, {37.4, 47.6}, {37.6, 39.4}, {37.6, 40.4}, {37.6, 40.6}, {37.6, 47.4}, {37.6, 47.6}, {38.4, 43}, {38.8, 43.4}, {39, 43.6}, {39.4, 42.2}, {39.6, 42.2}, {39.6, 42.6}, {39.6, 43.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Chasm-Haunter"               ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       }, ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78240 ,["id"] = 152556 ,["coords"] = {{49    , 88.4  }, {49.2, 88.6}, {49.6, 88}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, },
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Sandclaw Stoneshell"         ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 75368 ,["id"] = 152795 ,["coords"] = {{51.8  , 51.4  }, {51.8, 51.6}, {51.8, 52.6}, {56, 44}, {63.4, 47.2}, {63.6, 47.2}, {63.8, 48.2}, {63.8, 48.6}, {64.2, 54.8}, {65.2, 41.6}, {65.4, 41}, {68.4, 32.4}, {68.4, 32.8}, {68.6, 32.8}, {73.4, 45.6}, {73.6, 45.4}, {73.6, 45.6}, {74.4, 31}, {74.4, 44}, {74.6, 31.2}, {74.6, 44}, {76.2, 52}, {78.4, 32.2}, {78.6, 31.8}, {78.6, 32.6}, {79.4, 38.6}, {79.6, 38.6}, {79.8, 27.4}, {79.8, 27.6}, {80.4, 38.2}, {80.6, 42}, {81, 41.4}, {81.2, 40}, {82.8, 41.8}, {84.2, 40.4}, {84.4, 40.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, },
  { ["zone_name"] = "Mechagon"                      , [ "zoneID" ] = 1462 , [ "name" ] = "Scrapclaw"                   ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 8   , "Crab"          }, ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 91409 ,["id"] = 155583 ,["coords"] = {{81.4  , 76.2  },{81.4,77},{82,76.4},{82.2,77.4},{82.2,77.6},{82.6,77},{82.6,77.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Vision of Stormwind"           , [ "zoneID" ] = 1470 , [ "name" ] = "Sewer Beastling"             ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  }, ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 74885 ,["id"] = 160341 ,["coords"] = {{54.8  , 56.4  },{56.2,65.4},{59,63.2},{59.2,61.2},{59.6,58.8},{59.8,62.6},{60,58.2},{60,60.2},{60,60.8},{60,61.6},{60.4,42.8},{61,56.8},{61,58.4},{61,60.8},{61,62},{61.2,50},{61.2,60},{61.4,51},{61.4,51.8},{61.4,52.8},{61.4,59.2},{61.6,50.4},{61.6,57.4},{61.6,58.4},{61.6,59.4},{61.8,54.4},{61.8,55.4},{62,53},{62,55.8},{62,60.2},{62.2,51},{62.2,61.6},{62.4,52},{62.4,61},{62.6,50.4},{62.6,50.6},{62.6,55.2},{62.8,52},{62.8,53},{62.8,59.4},{63,60},{63.2,47.8},{63.4,61.2},{63.6,49.2},{63.8,50.2},{64.2,66.6},{64.4,51.2},{64.4,51.8},{64.4,60.4},{64.4,60.6},{64.6,51.8},{64.6,60.4},{64.8,50.8},{64.8,60.8},{65,52.6},{65,61.8},{65.2,65},{65.4,63},{65.6,64.2},{66.2,61},{66.2,62.4},{66.2,62.6},{66.4,52.2},{66.4,52.6},{66.4,59.4},{66.4,60},{66.6,52.8},{66.8,54.4},{66.8,56.6},{66.8,58.2},{66.8,59.2},{66.8,60.8},{67,50.8},{67,51.8},{67,56.4},{67,62.2},{67.2,60.4},{67.2,65.2},{67.4,54.8},{67.4,63},{67.4,64.2},{67.4,65.8},{67.6,52.2},{67.6,58.2},{67.6,59.2},{67.6,60.4},{67.8,54.4},{67.8,54.6},{67.8,56},{67.8,61.8},{68,51.2},{68,52.6},{68,64},{68.2,65.4},{68.2,66},{68.4,49.8},{68.4,60.8},{68.6,52.4},{68.6,53.2},{68.6,62.6},{68.8,53.8},{68.8,62.4},{69,60.2},{69.2,67.6},{69.6,53},{69.6,62.8},{70.2,61.8}}, },
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 1527 , [ "name" ] = "Skikx'traz"                  ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 91809 ,["id"] = 162140 ,["coords"] = {{23.4  , 62.2  },{23.4,62.6},{23.8,62.6},{24,62.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, },
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 1527 , [ "name" ] = "Qho"                         ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        }, ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 92904 ,["id"] = 162142 ,["coords"] = {{37.2  , 59.4  },{37.4,60.2},{37.4,60.6},{37.6,59.4},{37.6,60.2},{37.6,60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 1527 , [ "name" ] = "Corpse Eater"                ,["maxlevel"] =120   ,["minlevel"] =120   , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          }, ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 91811 ,["id"] = 162147 ,["coords"] = {{30.8  , 49.4  },{30.8,49.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, },
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 11   , [ "name" ] = "Trigore the Lasher"          ,["maxlevel"] ="???" ,["minlevel"] ="???" , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         }, ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 1092  ,["id"] = 3652   ,["coords"] = {{60.4  , 38.6  },{60.4,40.6},{60.6,40.8},{61,41.6},{61.6,41.2},{62,38.8},{62.2,42},{62.4,37.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, },
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "The Razza"                   ,["maxlevel"] ="???" ,["minlevel"] ="???" , ["info"] =   ""                         , ["class"] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      }, ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 37571 ,["id"] = 11497  ,["coords"] = {{84.5  , 49.7  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, },
  --instances
  { ["zone_name"] = "SethekkHalls"          , [ "zoneID" ] = 259  , [ "name" ] = "Anzu"                   ,["maxlevel"] =72    , ["minlevel"] =72    , ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"   } , ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 21492 ,["id"] = 23035  ,["coords"] = {{32.6  , 54.5  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "Karazhan"              , [ "zoneID" ] = 350  , [ "name" ] = "Shadikith the Glider"     ,["maxlevel"] =73    , ["minlevel"] =73    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 24  , "Bat"          } , ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 16053 ,["id"] = 16180  ,["coords"] = {{59.6  , 28.7  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "IsleOfGiants"          , [ "zoneID" ] = 507  , [ "name" ] = "Oondasta"               ,["maxlevel"] ="????", ["minlevel"] ="????", ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"    } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 47257 ,["id"] = 69161  ,["coords"] = {{49.9  , 54    },{50.6,54.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     } },
  { ["zone_name"] = "OrgrimmarRaid"         , [ "zoneID" ] = 559  , [ "name" ] = "Thok the Bloodthirsty"    ,["maxlevel"] ="????", ["minlevel"] ="????", ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"    } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 51144 ,["id"] = 71529  ,["coords"] = {{51.3  , 82.1  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "ThunderKingRaid"       , [ "zoneID" ] = 511  , [ "name" ] = "Ji-Kun"                 ,["maxlevel"] ="????", ["minlevel"] ="????", ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 46675 ,["id"] = 69712  ,["coords"] = {{49.3  , 41.5  },{49.7,41.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     } },
  { ["zone_name"] = "BlackwingLair"         , [ "zoneID" ] = 1560 , [ "name" ] = "Chromaggus"             ,["maxlevel"] ="????", ["minlevel"] ="????", ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 45  , "CoreHound"    } , ["familySkills" ] = COREHOUND_SKILLS     ,["displayID"] = 14367 ,["id"] = 14020  ,["coords"] = {{39.4  , 72.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "MoltenCore"            , [ "zoneID" ] = 232  , [ "name" ] = "Magmadar"               ,["maxlevel"] ="????", ["minlevel"] ="????", ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 45  , "CoreHound"    } , ["familySkills" ] = COREHOUND_SKILLS     ,["displayID"] = 10193 ,["id"] = 11982  ,["coords"] = {{69.4  , 23.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "DrakTharonKeep"        , [ "zoneID" ] = 160  , [ "name" ] = "KingDred"               ,["maxlevel"] =82    , ["minlevel"] =65    , ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"    } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 5240  ,["id"] = 27483  ,["coords"] = {{61.2  , 86.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "Maraudon"              , [ "zoneID" ] = 281  , [ "name" ] = "Rotgrip"                ,["maxlevel"] =62    , ["minlevel"] =36    , ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 6   , "Crocolisk"    } , ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 13589 ,["id"] = 13596  ,["coords"] = {{41.3  , 81.7  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "ThunderKingRaid"       , [ "zoneID" ] = 509  , [ "name" ] = "Horridon"               ,["maxlevel"] ="????", ["minlevel"] ="????", ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 138 , "Direhorn"     } , ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 47325 ,["id"] = 68476  ,["coords"] = {{26.2  , 78.2  },{26.8,78.7}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     } },
  { ["zone_name"] = "Karazhan"              , [ "zoneID" ] = 350  , [ "name" ] = "Rokad the Ravager"        ,["maxlevel"] =73    , ["minlevel"] =73    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 52  , "Dog"          } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 16054 ,["id"] = 16181  ,["coords"] = {{59.6  , 28.7  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "BlackwingDescent"      , [ "zoneID" ] = 286  , [ "name" ] = "Chimaeron"              ,["maxlevel"] ="????", ["minlevel"] ="????", ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"        } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 33308 ,["id"] = 43296  ,["coords"] = {{24.5  , 70.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "TheUnderbog"           , [ "zoneID" ] = 262  , [ "name" ] = "Ghaz'an"                ,["maxlevel"] =82    , ["minlevel"] =64    , ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"        } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 17528 ,["id"] = 18105  ,["coords"] = {{78.6  , 28.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "BlackrockDepths"       , [ "zoneID" ] = 243  , [ "name" ] = "Verek"                  ,["maxlevel"] =61    , ["minlevel"] =51    , ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 52  , "Dog"          } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 9019  ,["id"] = 9042   ,["coords"] = {{60.2  , 65.9  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "ZulFarrak"             , [ "zoneID" ] = 219  , [ "name" ] = "Gahz'rilla"             ,["maxlevel"] =61    , ["minlevel"] =45    , ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"        } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 7271  ,["id"] = 7273   ,["coords"] = {{28    , 38.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "RuinsofAhnQiraj"       , [ "zoneID" ] = 247  , [ "name" ] = "Buruthe Gorger"          ,["maxlevel"] ="????", ["minlevel"] ="????", ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 41  , "Silithid"     } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15654 ,["id"] = 15370  ,["coords"] = {{69.7  , 62    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "RuinsofAhnQiraj"       , [ "zoneID" ] = 247  , [ "name" ] = "Kurinnaxx"              ,["maxlevel"] ="????", ["minlevel"] ="????", ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 41  , "Silithid"     } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15742 ,["id"] = 15348  ,["coords"] = {{56.3  , 35.7  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "BlackrockSpire"        , [ "zoneID" ] = 251  , [ "name" ] = "Crystal Fang"            ,["maxlevel"] =62    , ["minlevel"] =58    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 3   , "Spider"       } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 9755  ,["id"] = 10376  ,["coords"] = {{61.1  , 74    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "BlackrockSpire"        , [ "zoneID" ] = 251  , [ "name" ] = "Mother Smolderweb"       ,["maxlevel"] =62    , ["minlevel"] =57    , ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 3   , "Spider"       } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 36506 ,["id"] = 10596  ,["coords"] = {{60.1  , 75    },{62,74.1}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       } },
  { ["zone_name"] = "TheUnderbog"           , [ "zoneID" ] = 262  , [ "name" ] = "The Black Stalker"        ,["maxlevel"] =82    , ["minlevel"] =64    , ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 126 , "WaterStrider" } , ["familySkills" ] = WATER_STRIDER_SKILLS ,["displayID"] = 18194 ,["id"] = 17882  ,["coords"] = {{24.7  , 45.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "RuinsofAhnQiraj"       , [ "zoneID" ] = 247  , [ "name" ] = "Ayamiss the Hunter"       ,["maxlevel"] ="????", ["minlevel"] ="????", ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 44  , "Wasp"         } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 15431 ,["id"] = 15369  ,["coords"] = {{61.6  , 90.5  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "BlackrockSpire"        , [ "zoneID" ] = 254  , [ "name" ] = "Gizrulthe Slavener"      ,["maxlevel"] =62    , ["minlevel"] =57    , ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"         } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 9564  ,["id"] = 10268  ,["coords"] = {{37.7  , 83.4  },{39.4,79.3}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     } },
  { ["zone_name"] = "BlackrockSpire"        , [ "zoneID" ] = 254  , [ "name" ] = "Halycon"                ,["maxlevel"] =62    , ["minlevel"] =57    , ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"         } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 9567  ,["id"] = 10220  ,["coords"] = {{37.7  , 83.4  },{37.9,84}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       } },
  { ["zone_name"] = "WailingCaverns"        , [ "zoneID" ] = 279  , [ "name" ] = "Kresh"                  ,["maxlevel"] =62    , ["minlevel"] =19    , ["info"] = "" , ["class"] = CLASS_ELITE      , ["family"] = { 21  , "Turtle"       } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 5126  ,["id"] = 3653   ,["coords"] = {{38.5  , 36    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "Nazjatar"              , [ "zoneID" ] = 1355 , [ "name" ] = "Elderspawn Nalaada"      ,["maxlevel"] =121   , ["minlevel"] =121   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 35  , "Serpent"      } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78243 ,["id"] = 152555 ,["coords"] = {{51.4  , 75.2  } ,{51.8,75.2},{52,75.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } },
  { ["zone_name"] = "Nazjatar"              , [ "zoneID" ] = 1355 , [ "name" ] = "Shiz'narasz the Consumer" ,["maxlevel"] =122   , ["minlevel"] =122   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 42  , "Worm"         } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 91870 ,["id"] = 153658 ,["coords"] = {{37.4  , 14.2  } ,{37.4,14.6},{37.8,14.6},{38,14.2},{38.4,9.4},{38.4,9.6},{38.4,17},{38.6,9.6},{38.6,10.8},{38.6,16.4},{38.6,17.4},{38.6,17.6},{38.8,9.2},{39.6,16.6},{40.4,12},{40.4,15.2},{40.4,15.6},{40.6,15.4},{40.6,15.6},{40.8,11.6},{41,11.2},{41.6,15.6},{41.8,15.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } },
  { ["zone_name"] = "Nazjatar"              , [ "zoneID" ] = 1355 , [ "name" ] = "ScaleMatriarch Zodia"    ,["maxlevel"] =121   , ["minlevel"] =121   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"        } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 90033 ,["id"] = 152542 ,["coords"] = {{28.8  , 46.4  } ,{28.8,46.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } },
  { ["zone_name"] = "Nazjatar"              , [ "zoneID" ] = 1355 , [ "name" ] = "ScaleMatriarch Gratinax" ,["maxlevel"] =121   , ["minlevel"] =121   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"        } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 90035 ,["id"] = 152548 ,["coords"] = {{35    , 41.6  } ,{35.4,41.2},{35.6,41}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } },
  { ["zone_name"] = "Nazjatar"              , [ "zoneID" ] = 1355 , [ "name" ] = "ScaleMatriarch Vynara"   ,["maxlevel"] =121   , ["minlevel"] =121   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"        } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 90034 ,["id"] = 152545 ,["coords"] = {{27.4  , 37    } ,{27.6,37}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } },
  { ["zone_name"] = "Silithus"              , [ "zoneID" ] = 81   , [ "name" ] = "Qroshekx"               ,["maxlevel"] =110   , ["minlevel"] =110   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 41  , "Silithid"     } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 82490 ,["id"] = 132578 ,["coords"] = {{57.2  , 12.4  } ,{57.2,13.2},{57.2,13.6},{57.6,13.4},{58,15},{58.2,12.2},{58.2,13.6},{58.6,14.6},{59,12},{59,12.6},{59.2,11.4},{59.6,12},{59.6,13.2},{60.8,14},{61.6,13.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } },
  { ["zone_name"] = "Silithus"              , [ "zoneID" ] = 81   , [ "name" ] = "Ssinkrix"               ,["maxlevel"] =110   , ["minlevel"] =110   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 41  , "Silithid"     } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 82491 ,["id"] = 132580 ,["coords"] = {{53    , 79.2  } ,{53.2,79.6},{54.4,78},{54.4,79.2},{54.4,79.6},{54.4,81},{54.6,79.4},{54.6,79.6},{55.8,77.8},{55.8,80}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } },
  { ["zone_name"] = "Silithus"              , [ "zoneID" ] = 81   , [ "name" ] = "Xaarshej"               ,["maxlevel"] =110   , ["minlevel"] =110   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 41  , "Silithid"     } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 82492 ,["id"] = 132584 ,["coords"] = {{29.4  , 34.2  } ,{29.4,35},{29.4,35.6},{29.6,34},{29.6,35},{29.6,35.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } },
  { ["zone_name"] = "Darkshore"             , [ "zoneID" ] = 62   , [ "name" ] = "Alash'anir"             ,["maxlevel"] =122   , ["minlevel"] =122   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 38  , "Chimaera"     } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 89749 ,["id"] = 148787 ,["coords"] = {{56.4  , 30.8  } ,{56.6,30.4},{56.6,30.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } },
  { ["zone_name"] = "ThousandNeedles"       , [ "zoneID" ] = 64   , [ "name" ] = "Rrakk"                  ,["maxlevel"] =63    , ["minlevel"] =63    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 24  , "Bat"          } , ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 46999 ,["id"] = 50329  ,["coords"] = {{89    , 40.4  } ,{90,39.8},{90.4,38.4},{90.4,38.8},{90.6,39.4},{90.6,39.8},{90.8,38.2},{90.8,40.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } },
  { ["zone_name"] = "ArathiHighlands"       , [ "zoneID" ] = 14   , [ "name" ] = "Skullripper"            ,["maxlevel"] =122   , ["minlevel"] =122   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 11  , "Raptor"       } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 61297 ,["id"] = 142437 ,["coords"] = {{56.2  , 46.6  } ,{56.4,44.2},{56.4,45.4},{56.4,46.2},{56.8,44.2},{56.8,45},{56.8,46},{56.8,46.6},{57,43.4},{57.6,44.4},{57.6,45},{57.6,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } },
  { ["zone_name"] = "ArathiHighlands"       , [ "zoneID" ] = 14   , [ "name" ] = "Venomarus"              ,["maxlevel"] =122   , ["minlevel"] =122   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 3   , "Spider"       } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 46232 ,["id"] = 142438 ,["coords"] = {{56.2  , 54.6  } ,{56.4,53.4},{56.4,54},{57,53.4},{57,54.6},{57.2,54},{57.6,53.4},{57.6,53.8},{57.6,54.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } },
  { ["zone_name"] = "ArathiHighlands"       , [ "zoneID" ] = 14   , [ "name" ] = "Plaguefeather"          ,["maxlevel"] =122   , ["minlevel"] =122   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 54845 ,["id"] = 142435 ,["coords"] = {{35.2  , 64.8  } ,{35.4,61.4},{35.4,62.4},{35.4,62.8},{35.4,64},{35.6,63.4},{35.8,61.4},{35.8,62.4},{35.8,64.2},{36.2,64.8},{36.6,61.4},{36.8,62.4},{36.8,65.2},{37,65.6},{37.2,63.4},{37.2,66.6},{37.4,64},{37.6,63.4},{37.6,64.2},{37.6,64.6},{37.8,65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } },
  { ["zone_name"] = "RazorfenKraul"         , [ "zoneID" ] = 301  , [ "name" ] = "Enormous Bullfrog"       ,["maxlevel"] =61    , ["minlevel"] =32    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 291 , "Toad"         } , ["familySkills" ] = TOAD_SKILLS          ,["displayID"] = 52785 ,["id"] = 75590  ,["coords"] = {{35.4  , 62.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "SearingGorge"          , [ "zoneID" ] = 32   , [ "name" ] = "Slavermaw"              ,["maxlevel"] =63    , ["minlevel"] =63    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 39  , "Devilsaur"    } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 5240  ,["id"] = 50846  ,["coords"] = {{57    , 25.6  } ,{57.2,23.8},{57.8,24.4},{58.2,22.4},{58.4,23.2},{58.8,23.4},{59,25.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } },
  { ["zone_name"] = "IsleofThunder"         , [ "zoneID" ] = 504  , [ "name" ] = "Goda"                   ,["maxlevel"] =93    , ["minlevel"] =93    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 21  , "Turtle"       } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 47809 ,["id"] = 69998  ,["coords"] = {{53.6  , 53    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "FrostfireRidge"        , [ "zoneID" ] = 525  , [ "name" ] = "Canyon Icemother"        ,["maxlevel"] =103   , ["minlevel"] =93    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 130 , "Basilisk"     } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 49096 ,["id"] = 71721  ,["coords"] = {{33.8  , 23    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "SpiresofArak"          , [ "zoneID" ] = 542  , [ "name" ] = "Echidna"                ,["maxlevel"] =103   , ["minlevel"] =99    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"        } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55712 ,["id"] = 80372  ,["coords"] = {{69.2  , 53.8  } ,{69.4,53},{69.6,53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } },
  { ["zone_name"] = "TanaanJungle"          , [ "zoneID" ] = 534  , [ "name" ] = "Deathtalon"             ,["maxlevel"] =103   , ["minlevel"] =103   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 26  , "Bird of Prey"   } , ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 64266 ,["id"] = 95053  ,["coords"] = {{23    , 40.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "TanaanJungle"          , [ "zoneID" ] = 534  , [ "name" ] = "Keravnos"               ,["maxlevel"] =103   , ["minlevel"] =103   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"        } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55718 ,["id"] = 80398  ,["coords"] = {{39.8  , 82.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  --RARE ELITES
  { ["zone_name"] = "Nagrand"               , [ "zoneID" ] = 550  , [ "name" ] = "Vileclaw"               ,["maxlevel"] =103   , ["minlevel"] =103   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 11  , "Raptor"       } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 61300 ,["id"] = 88951  ,["coords"] = {{37.2  , 39    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "Nagrand"               , [ "zoneID" ] = 550  , [ "name" ] = "Mu'gra"                 ,["maxlevel"] =103   , ["minlevel"] =103   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 150 , "Riverbeast"   } , ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 61301 ,["id"] = 87666  ,["coords"] = {{34    , 51.6  } ,{34.2,51.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } },
  { ["zone_name"] = "Nagrand"               , [ "zoneID" ] = 550  , [ "name" ] = "Direhoof"               ,["maxlevel"] =103   , ["minlevel"] =101   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 151 , "Stag"         } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 56848 ,["id"] = 86729  ,["coords"] = {{60.2  , 38.4  } ,{60.2,38.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } },
  { ["zone_name"] = "Nagrand"               , [ "zoneID" ] = 550  , [ "name" ] = "Thek'talon"             ,["maxlevel"] =103   , ["minlevel"] =103   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 26  , "Bird of Prey"   } , ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 61652 ,["id"] = 86750  ,["coords"] = {{49.4  , 38    } ,{49.4,38.8},{49.6,38.6},{50,38},{50.2,37},{50.4,40},{50.6,40.2},{50.8,38},{51,36.8},{51.4,40.6},{51.8,39.4},{52,40.2},{52.2,35.6},{53,35.8},{53,39.4},{53,39.6},{53.4,35},{53.8,39},{54.2,34.8},{54.8,34.6},{55,33.4},{55,33.8},{55.2,38},{55.4,37},{55.8,33.6},{55.8,38.2},{56,33.4},{56.4,36.8},{56.8,36.4},{56.8,36.6},{57.2,31.8},{57.4,31.4},{57.8,35.8},{58,35.4},{58.2,30.6},{58.4,30.4},{58.8,34.8},{59,34},{59.4,29.8},{59.8,29.2},{60,32.8},{60.2,32},{60.4,28.4},{60.8,27.2},{60.8,27.8},{60.8,32.2},{61,25.2},{61,31.4},{61.2,22.8},{61.4,22.4},{61.6,22.2},{61.6,31},{61.8,22.6},{62.2,30.2},{62.6,22.8},{63,29.6},{63.2,24.6},{63.2,29.2},{63.4,24.4},{63.6,24.4},{63.6,24.6},{63.8,28.8},{64,28.2},{64.2,29.6},{64.4,26.2},{64.4,26.8},{64.6,27.2}              } },
  { ["zone_name"] = "Nagrand"               , [ "zoneID" ] = 550  , [ "name" ] = "Aogexon"                ,["maxlevel"] =103   , ["minlevel"] =103   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 32  , "Warp Stalker"  } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 59928 ,["id"] = 86774  ,["coords"] = {{51.4  , 16    } ,{51.6,16}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } },
  { ["zone_name"] = "Nagrand"               , [ "zoneID" ] = 550  , [ "name" ] = "Nakk the Thunderer"       ,["maxlevel"] =103   , ["minlevel"] =103   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 43  , "Clefthoof"    } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 61219 ,["id"] = 50990  ,["coords"] = {{50    , 34.2  } ,{54.4,35.6},{55,35.4},{55.2,35.8},{60.2,32},{60.8,31.8},{62.4,14.8},{62.4,15.8},{62.6,18},{64.4,20}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } },
  { ["zone_name"] = "Nagrand"               , [ "zoneID" ] = 550  , [ "name" ] = "Bergruu"                ,["maxlevel"] =103   , ["minlevel"] =101   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 43  , "Clefthoof"    } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 58621 ,["id"] = 86732  ,["coords"] = {{61    , 12.2  } ,{61.2,12.6},{61.8,12.8},{62.2,17.2},{62.4,14.4},{62.4,15.8},{62.4,17.6},{62.6,17.8},{63.4,19.8},{63.6,19.4},{63.6,19.6},{64.6,20},{65.2,21.4},{65.6,22.2},{65.8,24.6},{66,24.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                } },
  { ["zone_name"] = "Nagrand"               , [ "zoneID" ] = 550  , [ "name" ] = "Xelganak"               ,["maxlevel"] =103   , ["minlevel"] =102   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 44  , "Wasp"         } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 61274 ,["id"] = 86835  ,["coords"] = {{41.4  , 44.8  } ,{41.6,44.4},{41.6,45}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } },
  { ["zone_name"] = "Nagrand"               , [ "zoneID" ] = 550  , [ "name" ] = "Lernaea"                ,["maxlevel"] =103   , ["minlevel"] =103   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"        } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55710 ,["id"] = 80370  ,["coords"] = {{51.8  , 89.4  } ,{52,89.8},{52.6,90}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } },
  { ["zone_name"] = "TimelessIsle"          , [ "zoneID" ] = 554  , [ "name" ] = "Tsavo'ka"               ,["maxlevel"] =93    , ["minlevel"] =93    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 2   , "Cat"          } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 51132 ,["id"] = 72808  ,["coords"] = {{54    , 42.4  } ,{54.2,42.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } },
  { ["zone_name"] = "TimelessIsle"          , [ "zoneID" ] = 554  , [ "name" ] = "Bufo"                   ,["maxlevel"] =93    , ["minlevel"] =93    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 291 , "Toad"         } , ["familySkills" ] = TOAD_SKILLS          ,["displayID"] = 48112 ,["id"] = 72775  ,["coords"] = {{62    , 76.4  } ,{62.2,76.8},{63.4,73},{63.6,72.4},{63.6,72.6},{64.8,74.2},{64.8,74.6},{65.2,69.2},{65.2,69.6},{65.2,70.6},{65.6,69.8},{66.4,67.2},{66.6,65.4},{66.8,66.6},{67,65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } },
  { ["zone_name"] = "TimelessIsle"          , [ "zoneID" ] = 554  , [ "name" ] = "Monstrous Spineclaw"     ,["maxlevel"] =93    , ["minlevel"] =93    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 8   , "Crab"         } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 51146 ,["id"] = 73166  ,["coords"] = {{17.4  , 52.4  } ,{17.4,52.6},{17.4,72.6},{17.8,72},{18.2,54.6},{18.2,75.2},{18.6,64},{18.8,54},{18.8,54.6},{18.8,57.8},{18.8,58.8},{19,75.6},{20.2,77},{20.4,48},{20.6,47.6},{20.6,70.8},{20.6,77.6},{21,36.2},{21,77.4},{21.2,46.8},{21.2,64.2},{21.4,32.6},{21.4,63.2},{21.6,35.8},{22.2,31},{22.6,30.8},{23.2,34.4},{23.2,35},{23.4,28.4},{23.4,35.8},{23.6,28.2},{23.6,28.6},{23.8,35.2},{23.8,36.8},{24.2,75},{25,74.8},{25.4,74.4},{25.6,74.6},{26.2,73.4},{27,75.2},{27.2,74.4},{27.4,79.8},{27.6,74.2},{28,79.6},{28.2,81.2},{30.6,31.2},{35.4,87},{36.4,86.2},{38,86},{38.6,87.2},{40.2,90.6},{40.4,90.2},{40.8,90.8},{44.8,89.2},{44.8,89.6},{45.6,90.4},{52.2,86.6},{61.6,83.2},{63.2,79.8},{65.4,77.8},{65.6,77.4},{65.6,78},{67.2,77.6},{67.8,78.2},{68,74.2},{68.2,77},{68.8,74.8}} },
  { ["zone_name"] = "Azsuna"                , [ "zoneID" ] = 630  , [ "name" ] = "Stormfeather"           ,["maxlevel"] =112   , ["minlevel"] =102   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 160 , "Feathermane"  } , ["familySkills" ] = FEATHERMANES_SKILLS  ,["displayID"] = 65235 ,["id"] = 109594 ,["coords"] = {{51    , 58    } ,{51.2,57.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } },
  { ["zone_name"] = "Highmountain"          , [ "zoneID" ] = 650  , [ "name" ] = "Ala'washte"             ,["maxlevel"] =112   , ["minlevel"] =112   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 26  , "Bird of Prey"   } , ["familySkills" ] = BIRDS_OF_PREY_SKILLS ,["displayID"] = 68615 ,["id"] = 104481 ,["coords"] = {{28.2  , 52.8  } ,{28.4,53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } },
  { ["zone_name"] = "BrokenShore"           , [ "zoneID" ] = 646  , [ "name" ] = "Somber Dawn"             ,["maxlevel"] =112   , ["minlevel"] =112   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 151 , "Stag"         } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 76109 ,["id"] = 121112 ,["coords"] = {{27    , 60.2  } ,{27,61},{27.4,61.8},{27.8,56.8},{27.8,58.6},{27.8,62.4},{28,57.6},{28,60.4},{28.4,61.2},{28.6,55.6},{28.8,61.6},{29,59.6},{29.2,59.4},{29.2,61.4},{29.6,55.4},{29.6,58.6},{29.8,57.2},{29.8,58.2},{30.2,55.8},{30.8,60.8},{31,55.6},{31,59.2},{31.4,60},{31.6,55.4},{31.6,60.6},{31.8,59.4},{32.2,59.8},{32.4,56.4},{32.4,56.8},{32.6,56.4},{32.6,59},{32.8,57.2},{33,60},{33.2,58},{33.6,57.4}                                                                                                                                                                                                                                                                                                                                                                                } },
  { ["zone_name"] = "Val'sharah"            , [ "zoneID" ] = 641  , [ "name" ] = "Gorebeak"               ,["maxlevel"] =110   , ["minlevel"] =98    , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 31979 ,["id"] = 92117  ,["coords"] = {{59.4  , 76.4  } ,{59.4,77},{59.6,77.4},{59.6,77.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } },
  { ["zone_name"] = "Vol'dun"               , [ "zoneID" ] = 864  , [ "name" ] = "Golanar"                ,["maxlevel"] =122   , ["minlevel"] =122   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"        } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 76904 ,["id"] = 129027 ,["coords"] = {{57.4  , 6.4   } ,{57.4,6.6},{57.6,6.4},{58.2,7},{58.4,7.6},{58.6,7.4},{59.2,8.4},{59.4,8.6},{59.6,8.2},{59.6,8.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               } },
  { ["zone_name"] = "Krokuun"               , [ "zoneID" ] = 830  , [ "name" ] = "Naroua"                 ,["maxlevel"] =112   , ["minlevel"] =112   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 2   , "Cat"          } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 78926 ,["id"] = 126419 ,["coords"] = {{70.4  , 34    } ,{70.6,33.8},{70.8,33},{71,32.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                } },
  { ["zone_name"] = "Mac'Aree"              , [ "zoneID" ] = 882  , [ "name" ] = "Sabuul"                 ,["maxlevel"] =112   , ["minlevel"] =112   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 2   , "Cat"          } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 79156 ,["id"] = 126898 ,["coords"] = {{43    , 47.4  } ,{43.4,48.2},{43.4,48.6},{43.4,49.6},{43.8,46.8},{43.8,48.4},{43.8,49},{44,49.6},{44,50.8},{44.6,49.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } },
  { ["zone_name"] = "Mac'Aree"              , [ "zoneID" ] = 882  , [ "name" ] = "Umbraliss"              ,["maxlevel"] =112   , ["minlevel"] =112   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 32  , "Warp Stalker"  } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 76479 ,["id"] = 126885 ,["coords"] = {{34    , 37.8  } ,{34.4,37.4},{34.4,38.6},{34.6,37.2},{34.6,38.6},{34.8,36.4},{34.8,37.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } },
  { ["zone_name"] = "StormsongValley"       , [ "zoneID" ] = 942  , [ "name" ] = "Beehemoth"              ,["maxlevel"] =122   , ["minlevel"] =122   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 44  , "Wasp"         } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 83359 ,["id"] = 134147 ,["coords"] = {{66.2  , 74.4  } ,{66.2,74.8},{66.6,74.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } },
  { ["zone_name"] = "ValeofEternalBlossoms" , [ "zoneID" ] = 1530 , [ "name" ] = "Stormhowl"              ,["maxlevel"] =122   , ["minlevel"] =122   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 1   , "Wolf"         } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 44449 ,["id"] = 157279 ,["coords"] = {{23.4  , 76.4  } ,{23.4,77},{23.4,77.6},{23.6,77},{23.6,77.6},{24,76.4},{25,76.2},{25,76.6},{25.4,75.4},{25.8,75.6},{26.4,73.4},{26.4,74.4},{26.4,74.6},{26.6,74.6},{27,73},{27,74},{27.2,71.4},{27.2,72.4},{27.6,72.2},{27.6,72.6},{27.6,73.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } },
  { ["zone_name"] = "ValeofEternalBlossoms" , [ "zoneID" ] = 1530 , [ "name" ] = "Jade Watcher"            ,["maxlevel"] =122   , ["minlevel"] =122   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 128 , "Quilen"       } , ["familySkills" ] = QUILLEN_SKILLS       ,["displayID"] = 45362 ,["id"] = 157290 ,["coords"] = {{26.4  , 10.4  } ,{26.8,10.4},{26.8,11},{27,11.6},{27.4,12.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } },
  { ["zone_name"] = "TheUnderrot"           , [ "zoneID" ] = 1041 , [ "name" ] = "Rotmaw"                 ,["maxlevel"] =122   , ["minlevel"] =112   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 42  , "Worm"         } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 57548 ,["id"] = 139194 ,["coords"] = {{64.8  , 29    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "ArathiHighlands"       , [ "zoneID" ] = 14   , [ "name" ] = "Plaguefeather"          ,["maxlevel"] =121   , ["minlevel"] =121   , ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 54845 ,["id"] = 142361 ,["coords"] = {{67.4  , 40.2  } ,{68.6,33.4},{70,35.4},{71,31.2},{72.2,41.2},{72.6,31.6},{72.6,40.6},{73.4,36.2},{73.8,36.4},{74.2,41.4},{74.4,33},{74.4,34.6},{74.8,33},{75.2,32.2},{75.4,28.6},{75.4,30.4},{75.4,31.2},{75.6,30.8},{75.6,31.6},{75.6,32.6},{75.8,28.4},{76.4,29.2},{76.4,30.2},{76.6,29.4},{76.8,30.8},{77.2,30.2},{77.2,31.6},{77.6,29.2},{77.6,29.6}                                                                                                                                                                                                                                                                                                                                                                                                                                        } },
  { ["zone_name"] = "Nazjatar"              , [ "zoneID" ] = 1355   , [ "name" ] = "Caverndark Terror"      ,["maxlevel"] =121   , ["minlevel"] =121, ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 8   , "Crab"         } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 91024 ,["id"] = 152464 ,["coords"] = {{42.24 , 13.51 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "Nazjatar"              , [ "zoneID" ] = 1500   , [ "name" ] = "Caverndark Terror"      ,["maxlevel"] =121   , ["minlevel"] =121, ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 8   , "Crab"         } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 91024 ,["id"] = 152464 ,["coords"] = {{35.17, 38.51 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } },
  { ["zone_name"] = "Ashran"                , [ "zoneID" ] = 588  , [ "name" ] = "Goregore"               ,["maxlevel"] ="????", ["minlevel"] ="????", ["info"] = "" , ["class"] = CLASS_RARE_ELITE , ["family"] = { 5   , "Boar"         } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 52698 ,["id"] = 84893  ,["coords"] = {{34.4  , 53.2  } ,{34.6,53.2},{35.8,53.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } },
  
  
  --ELITES
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Chitterspine Deeplurker"   ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={8   ,"Crab"         },["familySkills"]=CRAB_SKILLS          ,["displayID"]=91021 ,["id"]=152463 ,["coords"]= {{ 71   ,24.6 } ,{71.4,24.2},{71.6,24}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Glimmershell Hulk"         ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={8   ,"Crab"         },["familySkills"]=CRAB_SKILLS          ,["displayID"]=90871 ,["id"]=152426 ,["coords"]= {{ 40.2 ,49.2 } ,{40.4,48.4},{40.6,49},{42.4,47.8},{42.6,47.4},{42.8,47.8},{43.4,55},{43.6,54.2},{44.4,55.4},{44.4,55.6},{44.6,55.4},{45.4,47},{45.4,47.8},{45.4,55.8},{45.6,47.2},{45.6,47.6},{45.6,55.8},{46,54.4},{46,54.6},{46.8,52.6},{46.8,55.8},{47,51.6},{47,55.4},{49.4,51.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Chitterspine Guillotine"   ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={8   ,"Crab"         },["familySkills"]=CRAB_SKILLS          ,["displayID"]=91021 ,["id"]=153814 ,["coords"]= {{ 34.8 ,11.4 } ,{35.8,9.6},{36.2,13.6},{36.4,13.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Braxicus"                 ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={8   ,"Crab"         },["familySkills"]=CRAB_SKILLS          ,["displayID"]=90948 ,["id"]=153026 ,["coords"]= {{ 43.4 ,55.2 } ,{43.4,55.6},{43.6,55.4},{43.6,55.6},{44.2,54.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Siltridge Marauder"        ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=90033 ,["id"]=152541 ,["coords"]= {{ 30.4 ,48.4 } ,{30.4,48.6},{30.8,48.4},{30.8,48.6},{31.2,45.4},{31.2,45.8},{31.4,46.6},{31.6,45.6},{31.6,47.2},{31.8,45.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Stonemaw Devourer"         ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=90035 ,["id"]=152546 ,["coords"]= {{ 34.4 ,42.2 } ,{34.4,42.6},{35,42},{35.2,40.8},{35.2,42.6},{35.4,40.4},{35.6,40.6},{35.8,40},{36.2,39.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Voidscale Trenchstalker"   ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=90034 ,["id"]=152544 ,["coords"]= {{ 27.2 ,42   } ,{28.2,38.4},{28.4,37.2},{28.4,38.6},{28.4,39.6},{28.6,38.4},{28.6,39.2},{28.6,39.6},{28.8,36.6},{29,36.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "ScaleLord Theronar"        ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=90035 ,["id"]=153801 ,["coords"]= {{ 35.4 ,12.6 } ,{35.6,12.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Colossal SkyRay"           ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={34  ,"Ray"          },["familySkills"]=RAY_SKILLS           ,["displayID"]=92544 ,["id"]=150467 ,["coords"]= {{ 41.4 ,49.2 } ,{44,53.4},{44.2,54.6},{45.4,55.6},{46,58.6},{46,59.6},{46.2,35.4},{46.4,55},{46.8,59.4},{47,54},{47.2,49.2},{47.2,50.6},{48,59.8},{48.8,54.8},{49.6,54},{50.4,57.4},{50.6,57.6},{51.2,57.4},{51.8,52.8},{51.8,56},{52.2,57.4},{52.6,56.6},{53,55.8},{53.4,55.4},{53.6,55},{54.4,53.6},{54.6,53.6},{54.8,52.8},{55.6,53.2},{56.8,54},{57.6,54.6},{58.4,52.4},{58.4,53.2},{58.4,53.6},{58.6,52.4},{58.6,53.4},{58.6,53.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
--{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "BloatedSkyRay"            ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={34  ,"Ray"          },["familySkills"]=RAY_SKILLS           ,["displayID"]=92543 ,["id"]=150373 ,["coords"]= {{ 31.8 ,47.4 } ,{32,45},{32,47.6},{32.2,45.8},{34.2,42.6},{34.4,41.8},{34.6,42},{35,41.4},{36.2,46.6},{54.6,44.4},{54.6,44.6},{54.8,42.2},{54.8,54.8},{55,49.8},{55.4,48.8},{55.4,53.4},{55.4,53.6},{55.6,53.8},{56,44},{56.2,47.4},{56.2,48.4},{56.2,48.8},{56.2,54.6},{56.4,50},{56.4,51},{56.4,52.2},{56.4,53.2},{56.6,48.8},{56.8,50.4},{56.8,51.2},{56.8,54.2},{57,52.6},{57.2,52.4},{57.2,55},{57.4,47.4},{57.6,52.2},{57.8,54.8},{57.8,55.6},{58,47.4},{58.2,47.6},{58.2,49.6},{58.4,44.6},{58.4,49.2},{58.4,53.2},{58.4,54.2},{58.6,49.6},{58.6,52.2},{58.6,53.2},{58.8,48.4},{58.8,48.6},{59,47.4},{59,53.8},{59.4,51.4},{59.4,54.8},{59.6,51},{59.6,52},{59.6,54.8},{59.8,53.8},{60,49},{60.4,49.6},{61,52.4},{62.8,53.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Deepcoil Constrictor"      ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={35  ,"Serpent"      },["familySkills"]=SERPENT_SKILLS       ,["displayID"]=74317 ,["id"]=152551 ,["coords"]= {{ 68.2 ,18.6 } ,{68.4,19.8},{68.4,21.4},{69.2,20.4},{69.2,20.6},{69.2,22.6},{69.4,18.4},{69.4,18.6},{69.4,22.2},{69.6,18.4},{69.6,19.2},{69.6,19.6},{69.8,21.4},{69.8,21.6},{70,22.6},{70.6,19.4},{70.6,19.8},{70.6,22.2},{70.8,20.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Voltscale Guardian"        ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={42  ,"Worm"         },["familySkills"]=WORMS_SKILLS         ,["displayID"]=91862 ,["id"]=153654 ,["coords"]= {{ 36.8 ,11.4 } ,{37,14.4},{37,15.2},{37.2,16},{37.8,6.4},{37.8,14.4},{38,7},{38.2,18.4},{38.2,18.6},{38.4,8.2},{38.6,8.4},{39,9.4},{39,9.6},{39.4,10.6},{39.6,10.4},{39.8,10.8},{41.2,17.2},{41.4,16.4},{42,17.2},{43,16.2},{43.4,16.6},{43.6,16.4},{43.6,16.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Snapdragon Vicejaw"        ,["maxlevel" ]=121     , [ "minlevel" ]=121   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={288 ,"Lizard"       },["familySkills"]=LIZARD_SKILLS        ,["displayID"]=90764 ,["id"]=154752 ,["coords"]= {{ 64.6 ,49.4 } ,{64.8,49.6},{67,48.2},{67.6,48.8},{69.4,51},{69.6,51},{70,51.6},{70.4,50.2},{70.6,50.4},{70.6,50.6},{71.4,48.6},{71.6,48.8},{72,49.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Snapdragon Terrormaw"      ,["maxlevel" ]=121     , [ "minlevel" ]=121   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={288 ,"Lizard"       },["familySkills"]=LIZARD_SKILLS        ,["displayID"]=90764 ,["id"]=152358 ,["coords"]= {{ 67   ,50.2 } ,{67,50.6},{67.4,47.2},{68,47.4},{68.2,47.6},{68.4,45.4},{68.4,46},{68.6,45.8},{69,47.8},{69.2,47},{69.4,49.4},{69.4,49.6},{69.4,51},{69.4,51.8},{69.6,47.8},{69.6,51.6},{69.6,53.4},{69.8,49.2},{69.8,51.4},{70.4,50},{70.4,54},{70.6,50},{70.6,50.6},{71,54.4},{71.2,48.4},{71.4,49},{71.4,54.6},{71.6,48.8},{71.6,49.6},{71.6,54.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="Nazjatar"              ,["zoneID"]=1355 ,["name" ]= "Snapdragon Matriarch"      ,["maxlevel" ]=121     , [ "minlevel" ]=121   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={288 ,"Lizard"       },["familySkills"]=LIZARD_SKILLS        ,["displayID"]=90768 ,["id"]=154422 ,["coords"]= {{ 68.2 ,50.6 } ,{68.4,50.4},{68.6,50.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="UtgardePinnacle"       ,["zoneID"]=136  ,["name" ]= "Bloodthirsty TundraWolf"   ,["maxlevel" ]=81      , [ "minlevel" ]=66    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={1   ,"Wolf"         },["familySkills"]=WOLF_SKILLS          ,["displayID"]=22089 ,["id"]=26672  ,["coords"]= {{ 50   ,50   }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="Silithus"              ,["zoneID"]=81   ,["name" ]= "Lord Skwol"                ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=800   ,["id"]=117672 ,["coords"]= {{ 27   ,74.4 } ,{27 ,74.6},{45,41.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             } } ,
{["zone_name"]="Silithus"              ,["zoneID"]=81   ,["name" ]= "The Dukeof Fathoms"         ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=62    ,["id"]=117663 ,["coords"]= {{ 25.4 ,75.6 } ,{25.6,76 },{27,75 },{43.8,42.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Silithus"              ,["zoneID"]=81   ,["name" ]= "Deathclasp"               ,["maxlevel" ]=61      , [ "minlevel" ]=43    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={20  ,"Scorpid"      },["familySkills"]=SCORPID_SKILLS       ,["displayID"]=15327 ,["id"]=15196  ,["coords"]= {{ 48.2 ,80.6 } ,{48.4,80.4},{48.6,80.4},{49.2,81},{49.4,81.6},{49.4,82.6},{49.6,81.4},{49.6,82}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="DustwallowMarsh"       ,["zoneID"]=70   ,["name" ]= "Strashaz Hydra"            ,["maxlevel" ]=61      , [ "minlevel" ]=59    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=2423  ,["id"]=4374   ,["coords"]= {{ 69   ,19.2 } ,{69,19.6},{69.2,15.4},{69.8,17.8},{70.2,20.4},{70.6,20.6},{70.8,20.2},{71,18.4},{71,21.8},{71.2,15.6},{71.8,18.4},{71.8,18.6},{72.8,18.4},{73.4,18.6},{74,18.6},{74.2,16.6},{74.4,15.8},{74.4,17.6},{75,17.8},{75.6,18.4},{75.8,18.6},{76.4,19.8},{76.4,22.2},{76.6,21.2},{76.6,22}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="Icecrown"              ,["zoneID"]=118  ,["name" ]= "Grimkor's Hound"           ,["maxlevel" ]=80      , [ "minlevel" ]=78    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={52  ,"Dog"          },["familySkills"]=DOGS_SKILLS          ,["displayID"]=27790 ,["id"]=32163  ,["coords"]= {{ 45.4 ,46   }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="NorthernStranglethorn" ,["zoneID"]=50   ,["name" ]= "CrystalSpine Matriarch"    ,["maxlevel" ]=120     , [ "minlevel" ]=59    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={130 ,"Basilisk"     },["familySkills"]=BASILISK_SKILLS      ,["displayID"]=45467 ,["id"]=130598 ,["coords"]= {{ 11.4 ,31   } ,{12,30.4},{12,30.6},{12.6,29.8},{11.4,31}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=107  ,["name" ]= "Brokentoe"                ,["maxlevel" ]=81      , [ "minlevel" ]=65    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={43  ,"Clefthoof"    },["familySkills"]=CLEFTHOOVE_SKILLS    ,["displayID"]=19797 ,["id"]=18398  ,["coords"]= {{ 43.4 ,20.4 } ,{43.4,20.6},{43.6,20.4},{43.6,20.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="TerokkarForest"        ,["zoneID"]=108  ,["name" ]= "Deathskitter"             ,["maxlevel" ]=80      , [ "minlevel" ]=74    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={3   ,"Spider"       },["familySkills"]=SPIDER_SKILLS        ,["displayID"]=18923 ,["id"]=18647  ,["coords"]= {{ 53   ,59.8 } ,{53,61.2},{53.4,58.2},{53.4,58.6},{53.4,61.8},{53.4,64.4},{53.4,64.6},{53.6,57.2},{53.6,58.2},{53.6,58.6},{53.6,62.4},{53.6,62.6},{53.8,61.2},{53.8,63.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="TerokkarForest"        ,["zoneID"]=108  ,["name" ]= "Gezzarak the Huntress"      ,["maxlevel" ]=80      , [ "minlevel" ]=71    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={32  ,"WarpStalker"  },["familySkills"]=WARP_STALKERS_SKILLS ,["displayID"]=21371 ,["id"]=23163  ,["coords"]= {{ 61.4 ,78   } ,{62,74.6},{69.4,74.6},{69.6,74.6},{70,79.4},{70,79.6},{70.2,83.2},{72.2,88.2},{73.4,80.6},{74.8,87.4},{74.8,87.6},{75.2,81.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="ShadowmoonValley"      ,["zoneID"]=104  ,["name" ]= "Uvuros"                   ,["maxlevel" ]=80      , [ "minlevel" ]=68    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={45  ,"CoreHound"    },["familySkills"]=COREHOUND_SKILLS     ,["displayID"]=20522 ,["id"]=21102  ,["coords"]= {{ 54.4 ,49.4 } ,{55,49.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Zul'Aman"              ,["zoneID"]=333  ,["name" ]= "Amani Lynx"                ,["maxlevel" ]=80      , [ "minlevel" ]=68    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=19705 ,["id"]=52839  ,["coords"]= {{ 90.4 ,52.2 } ,{90.4,53.2},{90.4,53.6},{90.6,52.4},{90.6,52.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Zul'Aman"              ,["zoneID"]=333  ,["name" ]= "Amani Bear"                ,["maxlevel" ]=85      , [ "minlevel" ]=85    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={4   ,"Bear"         },["familySkills"]=BEAR_SKILLS          ,["displayID"]=22467 ,["id"]=23584  ,["coords"]= {{ 30.4 ,64   } ,{31.4,63.4},{31.4,63.6},{31.6,63.2},{31.6,63.6},{32,62.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Zul'Aman"              ,["zoneID"]=333  ,["name" ]= "Amani Bear Mount"           ,["maxlevel" ]=85      , [ "minlevel" ]=85    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={4   ,"Bear"         },["familySkills"]=BEAR_SKILLS          ,["displayID"]=22467 ,["id"]=24217  ,["coords"]= {{ 34   ,74.4 } ,{34,75.2},{34.4,76},{34.4,76.6},{34.6,75.4},{35,76.6},{35.4,76.2},{35.6,76.4},{35.6,76.6},{37.2,76.8},{37.4,76.4},{38,76.8},{38.2,75.2},{38.2,78.6},{38.4,76.2},{38.4,77.6},{38.6,76},{38.6,76.6},{38.6,77.6},{38.8,75},{39.6,76.6},{39.8,76.2},{40.6,76.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Zul'Aman"              ,["zoneID"]=333  ,["name" ]= "AmaniElder Lynx"           ,["maxlevel" ]=85      , [ "minlevel" ]=85    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=19705 ,["id"]=24530  ,["coords"]= {{ 58.2 ,50.6 } ,{58.4,49.4},{58.4,50},{58.6,49.4},{58.8,50.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="Zul'Aman"              ,["zoneID"]=333  ,["name" ]= "Amani Lynx"                ,["maxlevel" ]=85      , [ "minlevel" ]=85    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=19705 ,["id"]=24043  ,["coords"]= {{ 68.4 ,16.4 } ,{68.4,17},{68.4,17.6},{68.6,16.4},{68.6,16.6},{69,15.4},{69.6,15},{72.4,14.4},{72.4,14.6},{72.6,14.4},{73,14.8},{73.6,15},{74.4,15.6},{75.6,17.4},{76,18.4},{76.2,19.4},{76.2,19.6},{76.2,20.6},{76.4,21.6},{76.6,20.4},{76.6,21.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="Zul'Aman"              ,["zoneID"]=333  ,["name" ]= "Amani Dragonhawk"          ,["maxlevel" ]=85      , [ "minlevel" ]=85    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={30  ,"Dragonhawk"   },["familySkills"]=DRAGONHAWKS_SKILLS   ,["displayID"]=37573 ,["id"]=23834  ,["coords"]= {{ 45   ,90.4 } ,{45.4,90.6},{46.4,90.4},{46.4,90.8},{46.6,90.8},{47.4,90.4},{47.6,90.6},{47.8,90.4},{48.6,90.6},{49.2,90.2},{49.4,89.4},{49.6,89.4},{49.6,89.6},{52.6,83.4},{52.8,83.6},{53.8,83.4},{54,83.6},{54.6,83.4},{55.4,84},{55.6,83.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="GrizzlyHills"          ,["zoneID"]=116  ,["name" ]= "Goremaw"                  ,["maxlevel" ]=80      , [ "minlevel" ]=70    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={1   ,"Wolf"         },["familySkills"]=WOLF_SKILLS          ,["displayID"]=24708 ,["id"]=27578  ,["coords"]= {{ 86.8 ,26.8 } ,{87,26.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Desolace"              ,["zoneID"]=66   ,["name" ]= "Enraged Kodo"              ,["maxlevel" ]=60      , [ "minlevel" ]=31    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={156 ,"Scalehide"    },["familySkills"]=SCALEHIDE_SKILLS     ,["displayID"]=1241  ,["id"]=36094  ,["coords"]= {{ 57.4 ,58.6 } ,{58,58.8},{58.2,58.4},{58.4,55.4},{58.4,55.8},{58.4,59.6},{58.6,55.4},{58.6,55.8},{58.6,58.4},{58.6,58.6},{59.4,57.4},{60.2,57.4},{60.2,57.6},{60.2,59.8},{60.4,55.4},{60.4,56},{60.6,55.8},{60.6,57.4},{61,55.2},{61.4,58.2},{61.6,55.6},{61.6,62},{61.8,57.4},{61.8,57.8},{61.8,58.6},{62.4,54.2},{62.4,54.6},{62.6,54.4},{62.6,54.6},{62.6,56},{63.4,52.6},{64,56.2},{64,57.2},{64.2,57.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="RedridgeMountains"     ,["zoneID"]=49   ,["name" ]= "Blackrock Battle Worg"      ,["maxlevel" ]=60      , [ "minlevel" ]=17    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={1   ,"Wolf"         },["familySkills"]=WOLF_SKILLS          ,["displayID"]=780   ,["id"]=43340  ,["coords"]= {{ 44.4 ,37.8 } ,{45.8,38.6},{46.8,40.4},{47.4,37.6},{47.6,36.4},{48,37.8},{48.2,39.6},{48.4,37.4},{48.8,37.4},{49.2,38},{49.2,39},{49.6,38.4},{49.6,38.6},{50.4,40.2},{50.4,40.6},{50.6,38.8},{51.4,39.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Tanaris"               ,["zoneID"]=71   ,["name" ]= "Sarinexx"                 ,["maxlevel" ]=60      , [ "minlevel" ]=40    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={41  ,"Silithid"     },["familySkills"]=SILITHID_SKILLS      ,["displayID"]=25089 ,["id"]=39149  ,["coords"]= {{ 51.4 ,28.4 } ,{51.6,28.2},{51.6,28.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="TheHinterlands"        ,["zoneID"]=26   ,["name" ]= "Shadra"                   ,["maxlevel" ]=60      , [ "minlevel" ]=37    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={3   ,"Spider"       },["familySkills"]=SPIDER_SKILLS        ,["displayID"]=33275 ,["id"]=43007  ,["coords"]= {{ 34.2 ,69.8 } ,{34.2,70.8},{34.4,69.4},{34.6,69.4},{34.6,69.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Un'GoroCrater"         ,["zoneID"]=78   ,["name" ]= "Devilsaur"                ,["maxlevel" ]=60      , [ "minlevel" ]=45    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=5239  ,["id"]=6498   ,["coords"]= {{ 32.6 ,37.4 } ,{32.8,40},{33.2,38.4},{34.6,30.8},{36.2,36},{37.4,41.8},{37.4,43.6},{38.2,44.4},{40,59.6},{42,62.6},{42.8,61.6},{44,78.8},{44.2,66},{45,77.8},{46.2,64.8},{46.4,63.6},{57.6,69.6},{59,74.4},{59.2,71.6},{59.4,70.8},{59.8,71.8},{60.2,61.4},{61.4,64},{61.8,68},{64.8,31.8},{69.2,57.4},{70.2,26.2},{70.2,26.6},{73.8,37.6},{75.4,43},{75.8,40.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                } } ,
{["zone_name"]="Un'GoroCrater"         ,["zoneID"]=78   ,["name" ]= "Ironhide Devilsaur"        ,["maxlevel" ]=60      , [ "minlevel" ]=46    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=5238  ,["id"]=6499   ,["coords"]= {{ 31   ,58.8 } ,{33,42.6},{33.4,38.8},{33.6,37},{33.6,39},{34.4,38},{35.6,29.4},{35.6,30.2},{35.8,30.6},{36.4,34.6},{37.2,40.6},{37.4,41.8},{37.8,45},{38,44.2},{38.4,47.4},{39.8,46},{44.4,67.4},{44.6,71.8},{45.2,65.2},{45.2,68.2},{45.2,70.2},{45.8,69},{46,74.6},{48.2,62.2},{58.6,69.8},{61.2,56.6},{61.6,52.8},{61.6,61.4},{62,68.2},{69.8,30.8},{70.2,26.6},{70.4,30.4},{70.6,27.2},{70.6,27.8},{70.8,29.4},{73.8,38},{74.4,41.2},{75.2,41.4},{75.4,43.2},{75.6,43},{75.6,43.8},{75.8,42.2},{76.8,45}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="Un'GoroCrater"         ,["zoneID"]=78   ,["name" ]= "Tyrant Devilsaur"          ,["maxlevel" ]=60      , [ "minlevel" ]=42    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=5240  ,["id"]=6500   ,["coords"]= {{ 32.4 ,37.2 } ,{34,28.6},{34.2,37.6},{35.6,30.4},{35.6,30.6},{35.6,36.4},{35.6,37.6},{35.6,40.4},{35.8,35.2},{36,31.8},{38.4,44.2},{39.2,52.2},{39.4,59.2},{39.8,46},{44.8,77},{59.8,65.4},{60.4,63.6},{61.2,63},{66.2,33},{70.2,26.4},{70.2,26.6},{70.6,27.6},{71.2,29.4},{71.4,30.8},{74.4,42},{74.4,43.4},{75.2,41.2},{75.4,43},{75.4,43.6},{75.4,46},{75.8,42.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="Un'GoroCrater"         ,["zoneID"]=78   ,["name" ]= "Devilsaur Queen"           ,["maxlevel" ]=60      , [ "minlevel" ]=46    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=5305  ,["id"]=38346  ,["coords"]= {{ 34.4 ,81.2 } ,{34.6,81.2},{35,81.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="Un'GoroCrater"         ,["zoneID"]=78   ,["name" ]= "Spiked Stegodon"           ,["maxlevel" ]=60      , [ "minlevel" ]=44    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={156 ,"Scalehide"    },["familySkills"]=SCALEHIDE_SKILLS     ,["displayID"]=5288  ,["id"]=6503   ,["coords"]= {{ 25.4 ,54   } ,{25.6,53.8},{25.6,59.2},{26.8,67.2},{28,64.6},{28.4,58},{28.4,58.6},{28.6,58.8},{28.6,68.4},{28.8,63.8},{29.8,77.2},{30,66},{30,72.4},{30.2,61.2},{32,69.2},{33.4,78.2},{36,74.2},{37.2,67},{37.2,67.6},{41,72},{41,72.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Un'GoroCrater"         ,["zoneID"]=78   ,["name" ]= "Plated Stegodon"           ,["maxlevel" ]=61      , [ "minlevel" ]=46    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={156 ,"Scalehide"    },["familySkills"]=SCALEHIDE_SKILLS     ,["displayID"]=5287  ,["id"]=6502   ,["coords"]= {{ 25.6 ,59.2 } ,{26.6,55.4},{26.6,66.8},{26.8,56},{28.2,58.6},{28.4,58.4},{28.4,64.2},{28.8,58.6},{29.4,61},{29.8,64.6},{30,72.6},{30.2,72.4},{31.8,63.8},{31.8,69.2},{32,74.8},{32.8,74.4},{33.6,66.4},{33.8,61.2},{33.8,61.6},{33.8,77.6},{35.4,64},{35.8,69.2},{37.4,77},{38.8,69.4},{39.4,57.8},{39.4,62.4},{39.4,63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Un'GoroCrater"         ,["zoneID"]=78   ,["name" ]= "Stegodon"                 ,["maxlevel" ]=61      , [ "minlevel" ]=46    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={156 ,"Scalehide"    },["familySkills"]=SCALEHIDE_SKILLS     ,["displayID"]=5241  ,["id"]=6501   ,["coords"]= {{ 25.6 ,53.8 } ,{26.4,66.4},{26.6,56.2},{27,64.6},{28.2,58.8},{28.4,58.4},{28.4,63.8},{29.8,66},{30,61.2},{30,72.6},{30.2,61.8},{30.2,72},{30.6,64},{31.8,69.6},{32,74.6},{32.2,74.4},{33.6,66.4},{33.8,72.6},{33.8,77.2},{35.4,64.8},{35.6,69.4},{36.8,71.6},{37,77.6},{37.2,61.2},{37.4,61.6},{37.4,67.2},{38.6,68.6},{41,71.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                } } ,
{["zone_name"]="Un'GoroCrater"         ,["zoneID"]=78   ,["name" ]= "Thunderstomp Stegodon"     ,["maxlevel" ]=61      , [ "minlevel" ]=49    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={156 ,"Scalehide"    },["familySkills"]=SCALEHIDE_SKILLS     ,["displayID"]=5289  ,["id"]=6504   ,["coords"]= {{ 25.8 ,53.4 } ,{27,67.4},{29.8,61.6},{31.2,63.8},{32,74.6},{37.4,61.4},{40.8,77.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="Un'GoroCrater"         ,["zoneID"]=78   ,["name" ]= "Gorishi Fledgling Colossus" ,["maxlevel" ]=62      , [ "minlevel" ]=43    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={41  ,"Silithid"     },["familySkills"]=SILITHID_SKILLS      ,["displayID"]=31045 ,["id"]=38305  ,["coords"]= {{ 46.6 ,86.8 } ,{47.4,86.4},{47.6,86.4},{47.6,86.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="HallsofOrigination"    ,["zoneID"]=279  ,["name" ]= "Venomous Skitterer"        ,["maxlevel" ]=90      , [ "minlevel" ]=85    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={53  ,"Beetle"       },["familySkills"]=BEETLE_SKILLS        ,["displayID"]=37241 ,["id"]=39440  ,["coords"]= {{ 79.6 ,49.8 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="HallsofOrigination"    ,["zoneID"]=279  ,["name" ]= "Blistering Scarab"         ,["maxlevel" ]=90      , [ "minlevel" ]=85    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={53  ,"Beetle"       },["familySkills"]=BEETLE_SKILLS        ,["displayID"]=34900 ,["id"]=40310  ,["coords"]= {{ 76.4 ,49.4 } ,{76.4,49.6},{76.6,49.6},{77,49}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="TheBastionofTwilight"  ,["zoneID"]=294  ,["name" ]= "Lava Scarab"               ,["maxlevel" ]=85      , [ "minlevel" ]=85    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={53  ,"Beetle"       },["familySkills"]=BEETLE_SKILLS        ,["displayID"]=86670 ,["id"]=47079  ,["coords"]= {{ 52   ,45   } ,{52,47.8},{52.6,46.4},{52.8,44},{54.2,41.8},{54.4,45.2},{55.4,39},{55.4,44.4},{55.4,45.6},{55.4,46.8},{55.4,47.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                } } ,
{["zone_name"]="MoltenFront"           ,["zoneID"]=338  ,["name" ]= "Lost Emberspit Scorpion"    ,["maxlevel" ]=120     , [ "minlevel" ]=86    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={20  ,"Scorpid"      },["familySkills"]=SCORPID_SKILLS       ,["displayID"]=38123 ,["id"]=123636 ,["coords"]= {{ 42.6 ,45.2 } ,{42.6,49.6},{43.4,46.4},{43.4,48.4},{44.6,49.6},{50.8,52.2},{50.8,55},{51.6,51.2},{51.6,53.6},{52,55},{53,49.6},{53,55.8},{53,57.8},{53.6,55.2},{54.2,54},{54.2,55.6},{54.4,52.6},{54.4,57.6},{56.4,49.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="TheJadeForest"         ,["zoneID"]=371  ,["name" ]= "Rakira"                   ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=43104 ,["id"]=66622  ,["coords"]= {{ 56   ,74.6 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="TheJadeForest"         ,["zoneID"]=371  ,["name" ]= "Savage"                   ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=40719 ,["id"]=50850  ,["coords"]= {{ 35.8 ,57.4 } ,{35.8,57.8},{36.6,45},{37.4,63.4},{37.6,51.8},{43.2,37.2},{44.6,39},{46,37},{46.2,38.8},{46.4,36},{46.8,35.2},{47,29.8},{47,32.8},{47.8,29},{49,29.4},{51.2,30.8},{52.8,30.8},{53,24.6},{53.2,24},{54.6,28.2},{54.8,38.2},{55.4,29},{55.8,32.2},{56,32.6},{56.6,34},{56.8,30.2},{57,37.8},{57.2,35.4},{57.4,35.6},{57.4,37.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="TheJadeForest"         ,["zoneID"]=371  ,["name" ]= "Ruukti"                   ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=45258 ,["id"]=66633  ,["coords"]= {{ 62.2 ,74.6 } ,{62.4,74.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="TheJadeForest"         ,["zoneID"]=371  ,["name" ]= "Ro'shen"                  ,["maxlevel" ]=90      , [ "minlevel" ]=84    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=44486 ,["id"]=66617  ,["coords"]= {{ 65.2 ,78.6 } ,{65.4,78.4},{65.6,78.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="TheJadeForest"         ,["zoneID"]=371  ,["name" ]= "Hutia"                    ,["maxlevel" ]=90      , [ "minlevel" ]=81    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={46  ,"SpiritBeast"  },["familySkills"]=SPIRIT_BEAST_SKILLS  ,["displayID"]=47777 ,["id"]=69946  ,["coords"]= {{ 48.2 ,27.8 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="TheJadeForest"         ,["zoneID"]=371  ,["name" ]= "Sungraze Behemoth"         ,["maxlevel" ]=90      , [ "minlevel" ]=80    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={156 ,"Scalehide"    },["familySkills"]=SCALEHIDE_SKILLS     ,["displayID"]=45087 ,["id"]=58895  ,["coords"]= {{ 27.4 ,59.6 } ,{27.6,59.4},{27.6,59.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="TheJadeForest"         ,["zoneID"]=371  ,["name" ]= "Glimmer"                  ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={126 ,"WaterStrider" },["familySkills"]=WATER_STRIDER_SKILLS ,["displayID"]=42271 ,["id"]=50859  ,["coords"]= {{ 38.2 ,73   } ,{39.6,67}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="TheJadeForest"         ,["zoneID"]=371  ,["name" ]= "Chibee"                   ,["maxlevel" ]=90      , [ "minlevel" ]=80    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={42  ,"Worm"         },["familySkills"]=WORMS_SKILLS         ,["displayID"]=43342 ,["id"]=59756  ,["coords"]= {{ 46.6 ,70.8 } ,{47.2,68.2},{47.6,67.8},{48.6,71.8},{48.8,69.4},{48.8,70.6},{48.8,72.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="ValleyoftheFourWinds"  ,["zoneID"]=376  ,["name" ]= "Patrannache"              ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={125 ,"Crane"        },["familySkills"]=CRANE_SKILLS         ,["displayID"]=39729 ,["id"]=50885  ,["coords"]= {{ 20.6 ,47.8 } ,{21.6,58},{57.6,70}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="ValleyoftheFourWinds"  ,["zoneID"]=376  ,["name" ]= "Degu"                     ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={46  ,"SpiritBeast"  },["familySkills"]=SPIRIT_BEAST_SKILLS  ,["displayID"]=47778 ,["id"]=69947  ,["coords"]= {{ 41.4 ,78   } ,{42,77.8},{42.2,77.4},{43.2,77},{43.8,77},{45.2,76.8},{45.8,76.6},{46.2,76.4},{46.6,76.4},{46.8,76.6},{48.2,76.6},{48.6,76.8},{49.2,77.6},{50,77.8},{50.2,77.4},{50.6,77.6},{50.8,77.2},{51.8,77.6},{52,77.4},{52.8,77.2},{53,77.8},{53.6,77.4},{53.8,77.6},{54.6,77},{55.6,76.8},{56,77.8},{57.2,77},{57.4,77.6},{58,77.2},{59.2,77},{59.8,76.6},{60.4,76.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="ValleyoftheFourWinds"  ,["zoneID"]=376  ,["name" ]= "Mothallus"                ,["maxlevel" ]=92      , [ "minlevel" ]=84    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={37  ,"Moth"         },["familySkills"]=MOTH_SKILLS          ,["displayID"]=44770 ,["id"]=57421  ,["coords"]= {{ 64.4 ,57.8 } ,{64.6,57.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="ValleyoftheFourWinds"  ,["zoneID"]=376  ,["name" ]= "Darkhide"                 ,["maxlevel" ]=92      , [ "minlevel" ]=83    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={156 ,"Scalehide"    },["familySkills"]=SCALEHIDE_SKILLS     ,["displayID"]=44478 ,["id"]=58435  ,["coords"]= {{ 26   ,75.4 } ,{26,75.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="ValeofEternalBlossoms" ,["zoneID"]=390  ,["name" ]= "Portent"                  ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={128 ,"Quilen"       },["familySkills"]=QUILLEN_SKILLS       ,["displayID"]=45427 ,["id"]=50843  ,["coords"]= {{ 13.6 ,37.4 } ,{14.4,46.8},{15,40.2},{17.6,53},{50,32.6},{63.2,64.8},{65.8,60},{68,44.8},{68,58.2},{70,22},{71,22},{78.2,25.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Kun-LaiSummit"         ,["zoneID"]=379  ,["name" ]= "Enraged Mushan"            ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={156 ,"Scalehide"    },["familySkills"]=SCALEHIDE_SKILLS     ,["displayID"]=41539 ,["id"]=60623  ,["coords"]= {{ 66.4 ,77.2 } ,{66.4,77.6},{66.8,76.4},{66.8,76.8},{66.8,78.8},{67.2,78.4},{67.8,76.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Kun-LaiSummit"         ,["zoneID"]=379  ,["name" ]= "Furious Goat"              ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={129 ,"Goat"         },["familySkills"]=GOAT_SKILLS          ,["displayID"]=41073 ,["id"]=60668  ,["coords"]= {{ 53.4 ,65.4 } ,{53.4,65.6},{53.6,65.4},{53.6,65.6},{53.8,64.4},{54.6,65},{54.6,65.8},{55.2,64.2},{55.6,63.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="Kun-LaiSummit"         ,["zoneID"]=379  ,["name" ]= "King Spineclaw"            ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={8   ,"Crab"         },["familySkills"]=CRAB_SKILLS          ,["displayID"]=45167 ,["id"]=66472  ,["coords"]= {{ 44   ,20.8 } ,{44.2,23.8},{45.6,20.4},{48.6,18.8},{51.8,18.8},{53.2,19.8},{55.2,21.4},{56.8,21.6},{58.4,21.4},{58.4,21.6},{58.6,21.4},{58.6,21.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="Kun-LaiSummit"         ,["zoneID"]=379  ,["name" ]= "Stompy"                   ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={129 ,"Goat"         },["familySkills"]=GOAT_SKILLS          ,["displayID"]=40022 ,["id"]=50998  ,["coords"]= {{ 38   ,49   } ,{39.2,54.8},{39.8,47.8},{42,45.6},{43,53.2},{44.8,48.6},{45.2,47.6},{45.4,45.8},{46.6,48.2},{49.2,58.2},{50.4,58.6},{50.8,59},{51.6,56.6},{51.6,60.2},{52.6,54.8},{54.4,57.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="Kun-LaiSummit"         ,["zoneID"]=379  ,["name" ]= "Gumi"                     ,["maxlevel" ]=90      , [ "minlevel" ]=82    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={46  ,"SpiritBeast"  },["familySkills"]=SPIRIT_BEAST_SKILLS  ,["displayID"]=47776 ,["id"]=69943  ,["coords"]= {{ 54.2 ,57.6 } ,{54.4,57.4},{54.6,57.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Kun-LaiSummit"         ,["zoneID"]=379  ,["name" ]= "Bristlespine"             ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={127 ,"Rodent"       },["familySkills"]=RODENT_SKILLS        ,["displayID"]=41004 ,["id"]=50944  ,["coords"]= {{ 45.2 ,81.6 } ,{48.4,85.2},{53,85.8},{62,84.6},{64.4,86.4},{65.4,81.4},{65.8,85.2},{66,79},{73.2,70.8},{73.6,53.4},{74,70},{74.6,68}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="Kun-LaiSummit"         ,["zoneID"]=379  ,["name" ]= "Zhing"                    ,["maxlevel" ]=91      , [ "minlevel" ]=88    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={129 ,"Goat"         },["familySkills"]=GOAT_SKILLS          ,["displayID"]=45163 ,["id"]=66464  ,["coords"]= {{ 39   ,52.4 } ,{39,55.6},{39.2,54.4},{39.2,54.8},{39.4,53.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="TownlongSteppes"       ,["zoneID"]=388  ,["name" ]= "Rockhide the Immovable"     ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={130 ,"Basilisk"     },["familySkills"]=BASILISK_SKILLS      ,["displayID"]=45464 ,["id"]=51013  ,["coords"]= {{ 53.8 ,73.6 } ,{61.4,78.2},{65.4,62.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="KrasarangWilds"        ,["zoneID"]=418  ,["name" ]= "Bloodtooth"               ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={21  ,"Turtle"       },["familySkills"]=TURTLE_SKILLS        ,["displayID"]=45487 ,["id"]=50854  ,["coords"]= {{ 14.8 ,45.6 } ,{46.2,62.6},{48,59.8},{48.8,53.2},{50.2,65.6},{51.6,67.2},{54.2,49.2},{56.4,44},{57,45},{67.2,36.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="KrasarangWilds"        ,["zoneID"]=418  ,["name" ]= "Bombyx"                   ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={42  ,"Worm"         },["familySkills"]=WORMS_SKILLS         ,["displayID"]=46461 ,["id"]=67820  ,["coords"]= {{ 31   ,43.6 } ,{31.6,45},{31.8,46},{32,47.4},{32,47.6},{32.6,48},{34.2,45.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="KrasarangWilds"        ,["zoneID"]=418  ,["name" ]= "Venerable Viseclaw"        ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={8   ,"Crab"         },["familySkills"]=CRAB_SKILLS          ,["displayID"]=45334 ,["id"]=66748  ,["coords"]= {{ 10.2 ,44.6 } ,{10.8,44.2},{11,45.8},{11.2,46.8},{11.4,45.4},{11.4,47.6},{11.6,45},{11.6,47.4},{11.8,48.6},{12,48.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="KrasarangWilds"        ,["zoneID"]=418  ,["name" ]= "Elder Viseclaw"            ,["maxlevel" ]=90      , [ "minlevel" ]=81    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={8   ,"Crab"         },["familySkills"]=CRAB_SKILLS          ,["displayID"]=45058 ,["id"]=61091  ,["coords"]= {{ 41   ,62.8 } ,{47.8,54.2},{53.8,45},{55.4,44},{55.8,44},{56.2,46.8},{56.2,47.6},{56.4,46.4},{56.6,46.2},{56.8,49.6},{57,46.8},{58.2,43},{58.6,43.8},{60.2,40.6},{60.8,40.4},{61.4,39.2},{61.8,39.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="KrasarangWilds"        ,["zoneID"]=418  ,["name" ]= "Feverbite"                ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={3   ,"Spider"       },["familySkills"]=SPIDER_SKILLS        ,["displayID"]=40321 ,["id"]=58883  ,["coords"]= {{ 18.2 ,41.6 } ,{18.4,45.4},{18.4,45.6},{18.6,45.2},{18.6,45.6},{19.4,44.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="KrasarangWilds"        ,["zoneID"]=418  ,["name" ]= "Elder Seadragon"           ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={21  ,"Turtle"       },["familySkills"]=TURTLE_SKILLS        ,["displayID"]=44784 ,["id"]=58940  ,["coords"]= {{ 70.4 ,34.2 } ,{70.6,33.8},{71.4,33.2},{71.6,33.2},{73.8,31.2},{74,31.8},{74.2,29.8},{74.6,32.6},{75,29.4},{77.6,27.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="KrasarangWilds"        ,["zoneID"]=418  ,["name" ]= "Snapclaw"                 ,["maxlevel" ]=92      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={8   ,"Crab"         },["familySkills"]=CRAB_SKILLS          ,["displayID"]=45062 ,["id"]=60401  ,["coords"]= {{ 73.4 ,38.2 } ,{73.6,38.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="DreadWastes"           ,["zoneID"]=422  ,["name" ]= "Hexapos"                  ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={126 ,"WaterStrider" },["familySkills"]=WATER_STRIDER_SKILLS ,["displayID"]=20917 ,["id"]=50960  ,["coords"]= {{ 30   ,53.8 } ,{32.6,23.4},{33.6,23.6},{36,24.8},{40,52.6},{42,25.2},{42.8,51.6},{43.6,52.2},{44.2,53},{44.2,53.6},{50,65},{55,66.6},{56,66.6},{56.6,66.2},{59.2,22.2},{60.4,22.2},{60.6,22.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="DreadWastes"           ,["zoneID"]=422  ,["name" ]= "Dread Matriarch"           ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=44486 ,["id"]=66187  ,["coords"]= {{ 55   ,63.4 } ,{55.4,63.6},{55.8,63.8},{59.4,39.8},{60.2,38},{66.4,41.8},{66.8,42.4},{66.8,43.8},{66.8,44.6},{67,43.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="DreadWastes"           ,["zoneID"]=422  ,["name" ]= "Pengsong"                 ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={157 ,"Oxen"         },["familySkills"]=OXEN_SKILLS          ,["displayID"]=45242 ,["id"]=66587  ,["coords"]= {{ 51.4 ,69   } ,{51.4,71.6},{51.6,69.4},{51.6,71.4},{51.8,70.2},{51.8,71.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="DreadWastes"           ,["zoneID"]=422  ,["name" ]= "Ik'thik Amberstinger"      ,["maxlevel" ]=90      , [ "minlevel" ]=84    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={20  ,"Scorpid"      },["familySkills"]=SCORPID_SKILLS       ,["displayID"]=43143 ,["id"]=63728  ,["coords"]= {{ 58   ,71.4 } ,{58,71.6},{58.4,76.4},{58.4,76.6},{58.6,76.2},{58.8,73.2},{60.8,65.6},{60.8,70.4},{61,65.2},{61,68.4},{61,69},{61,71},{61,71.6},{61.2,73.4},{61.2,73.8},{61.4,63.4},{61.4,63.6},{61.6,63.4},{61.6,63.6},{61.6,70.4},{61.6,73.8},{61.8,70.8},{62.4,68.4},{62.8,68.4},{63,68.6},{64,70.6},{64.2,70.4},{64.4,67.2},{64.4,67.6},{64.6,66.4},{64.6,67.2},{64.6,67.6},{64.6,70.6},{65,69.6},{65.2,69.4},{66.2,66.4},{66.2,66.8},{66.2,67.6},{66.6,66.4},{66.8,66.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="DreadWastes"           ,["zoneID"]=422  ,["name" ]= "Ik'thik Terrorclaw"        ,["maxlevel" ]=90      , [ "minlevel" ]=84    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={20  ,"Scorpid"      },["familySkills"]=SCORPID_SKILLS       ,["displayID"]=43143 ,["id"]=65632  ,["coords"]= {{ 57.4 ,46.2 },{57.8,46.4},{58,46.8},{61.4,47.6},{61.8,47.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     } } ,
{["zone_name"]="MountHyjal"            ,["zoneID"]=198  ,["name" ]= "Smolderos the Carbonizer"   ,["maxlevel" ]=90      , [ "minlevel" ]=86    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={45  ,"CoreHound"    },["familySkills"]=COREHOUND_SKILLS     ,["displayID"]=10193 ,["id"]=39348  ,["coords"]= {{ 77.6 ,63   } ,{77.6,64.2},{78.6,64.2},{79,64.8},{80,62.6},{80,65},{81,65},{83.8,64.4},{84.4,62.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="CryptofForgottenKings" ,["zoneID"]=481  ,["name" ]= "Guardianof Sacrifice"      ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={128 ,"Quilen"       },["familySkills"]=QUILLEN_SKILLS       ,["displayID"]=41233 ,["id"]=71491  ,["coords"]= {{ 39.4 ,38   } ,{39.4,43},{39.6,37.8},{39.6,43.4},{40,36.6},{40.4,44.4},{40.6,44.4},{41.4,44.6},{47.4,62.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="CryptofForgottenKings" ,["zoneID"]=481  ,["name" ]= "Quilen Watcher"            ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={128 ,"Quilen"       },["familySkills"]=QUILLEN_SKILLS       ,["displayID"]=46049 ,["id"]=62254  ,["coords"]= {{ 61.6 ,83.2 } ,{62.2,80.4},{62.4,81},{62.4,81.4},{62.4,82.2},{62.4,85.4},{63,85.6},{63.2,83.6},{63.2,84.2},{63.2,85},{63.4,80.2},{63.4,80.4},{63.4,81.4},{63.4,82},{63.4,82.4},{63.4,82.8},{63.4,83.4},{63.4,84.6},{63.6,81.8},{63.8,82.6},{64,80.8},{64,84.2},{64,85},{64,85.8},{64.2,80.2},{64.2,80.4},{64.2,81.4},{64.2,81.8},{64.2,84},{64.4,82.6},{64.4,84.8},{64.6,80.4},{64.6,81.4},{64.6,81.8},{64.6,84.2},{64.8,80.2},{64.8,81.4},{64.8,82.2},{64.8,83},{64.8,84.8},{65,82.6},{65,84},{65.4,84.6},{65.4,85.8},{65.6,80.2},{65.6,81.2},{65.6,82},{65.6,82.6},{65.6,83},{65.6,84.4},{65.6,84.8},{65.8,86},{66,80.4},{66.6,83},{66.6,83.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                } } ,
{["zone_name"]="CryptofForgottenKings" ,["zoneID"]=481  ,["name" ]= "Quilen Statue"             ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={128 ,"Quilen"       },["familySkills"]=QUILLEN_SKILLS       ,["displayID"]=42157 ,["id"]=61565  ,["coords"]= {{ 58.8 ,86.2 } ,{58.8,86.6},{59.8,87},{63.4,81},{64,80.4},{64,80.6},{64,88},{67.6,87.8},{69.6,85}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                } } ,
{["zone_name"]="Dragonblight"          ,["zoneID"]=115  ,["name" ]= "Hulking Jormungar"         ,["maxlevel" ]=81      , [ "minlevel" ]=63    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={42  ,"Worm"         },["familySkills"]=WORMS_SKILLS         ,["displayID"]=24564 ,["id"]=26293  ,["coords"]= {{ 58   ,22.4 } ,{58.2,22.6},{58.2,25.6},{58.4,24.2},{58.4,25.4},{58.6,24.4},{58.6,25},{58.8,21},{58.8,22.8},{59.2,21.6},{59.6,22.8},{59.6,24.2},{59.6,26.6},{60.4,26.4},{60.6,27.2},{60.8,28.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="IsleofThunder"         ,["zoneID"]=504  ,["name" ]= "Bloodrender Devilsaur"     ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=47249 ,["id"]=69148  ,["coords"]= {{ 49.6 ,49.6 } ,{49.8,48.8},{50.2,51},{50.4,47.4},{50.4,47.6},{50.6,51.4},{50.6,52},{50.8,47.2},{50.8,47.6},{51.4,46.2},{51.6,45.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="IsleofThunder"         ,["zoneID"]=504  ,["name" ]= "Kroshik"                  ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=47355 ,["id"]=69218  ,["coords"]= {{ 48.6 ,80.2 } ,{49.2,81.4},{49.2,81.6},{49.4,79.4},{50.2,78.6},{50.2,83.2},{50.4,78.4},{51,78.4},{51.2,83},{51.4,78.6},{51.6,78.6},{51.8,78.4},{52.2,82.8},{52.6,82.6},{53,82.2},{53.4,77.6},{54,78.2},{54.4,79},{54.4,79.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="IsleofThunder"         ,["zoneID"]=504  ,["name" ]= "Kroshik"                  ,["maxlevel" ]=90      , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=47355 ,["id"]=70226  ,["coords"]= {{ 55   ,87.8 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="IsleofThunder"         ,["zoneID"]=504  ,["name" ]= "Adolescent Direhorn"       ,["maxlevel" ]=92      , [ "minlevel" ]=92    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={138 ,"Direhorn"     },["familySkills"]=DIREHORN_SKILLS      ,["displayID"]=47805 ,["id"]=67576  ,["coords"]= {{ 48.4 ,41.4 } ,{48.4,41.6},{48.8,41},{48.8,41.6},{50,34},{50.4,36.2},{50.6,32.8},{50.6,36.2},{50.8,33.6},{51.4,37.6},{51.6,37.4},{51.6,37.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="IsleofThunder"         ,["zoneID"]=504  ,["name" ]= "Zandalari Battlebeast"     ,["maxlevel" ]=9999    , [ "minlevel" ]=9999  ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={138 ,"Direhorn"     },["familySkills"]=DIREHORN_SKILLS      ,["displayID"]=47660 ,["id"]=69795  ,["coords"]= {{ 49.6 ,49.2 } ,{50,50.2},{50.4,47.4},{50.4,47.6},{50.4,51.2},{50.6,47.2},{50.8,47.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="IsleofThunder"         ,["zoneID"]=504  ,["name" ]= "Defiant Direhorn"          ,["maxlevel" ]=9999    , [ "minlevel" ]=9999  ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={138 ,"Direhorn"     },["familySkills"]=DIREHORN_SKILLS      ,["displayID"]=47660 ,["id"]=69277  ,["coords"]= {{ 45.2 ,33.8 } ,{51.4,33.8},{51.6,33.6},{51.8,32.8},{51.8,35.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Talador"               ,["zoneID"]=535  ,["name" ]= "Kil'uun"                  ,["maxlevel" ]=102     , [ "minlevel" ]=96    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={7   ,"CarrionBird"  },["familySkills"]=CARRION_BIRD_SKILLS  ,["displayID"]=58718 ,["id"]=77430  ,["coords"]= {{ 66   ,33.4 } ,{66,34},{66.2,31.2},{66.2,34.6},{66.4,28.8},{66.4,32},{66.6,32.6},{66.6,35.4},{66.6,36},{66.8,28.6},{66.8,29.8},{67,28.2},{67,34.4},{67.2,30.8},{67.4,37},{67.6,37.2},{67.8,28},{68.4,27.2},{68.8,27.6},{69.2,25.8},{69.2,27.2},{69.2,37},{69.4,25.4},{69.6,26.2},{69.6,26.8},{69.6,37.2},{70,29},{70,37.8},{70.2,25},{70.8,38},{71,24.6},{71.2,24.2},{71.4,36.6},{71.6,36.6},{71.8,24},{71.8,28.6},{72,36},{72.2,35.4},{72.4,24.6},{72.6,24.4},{72.6,25},{72.6,35},{72.6,35.8},{72.8,29.8},{73,26},{73,29},{73,31.4},{73,32.4},{73,33.2},{73.2,26.6},{73.2,27.8},{73.2,33.8},{73.6,28}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Talador"               ,["zoneID"]=535  ,["name" ]= "Grom'kar Warbeast"         ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={43  ,"Clefthoof"    },["familySkills"]=CLEFTHOOVE_SKILLS    ,["displayID"]=61679 ,["id"]=85537  ,["coords"]= {{ 74   ,8.4  } ,{74,8.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         } } ,
{["zone_name"]="Talador"               ,["zoneID"]=535  ,["name" ]= "Hilaani"                  ,["maxlevel" ]=102     , [ "minlevel" ]=97    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={150 ,"Riverbeast"   },["familySkills"]=RIVERBEAST_SKILLS    ,["displayID"]=52749 ,["id"]=77431  ,["coords"]= {{ 66.4 ,64.8 } ,{66.6,65.2},{66.6,65.6},{66.8,64.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="TheStormPeaks"         ,["zoneID"]=120  ,["name" ]= "Oloh"                     ,["maxlevel" ]=81      , [ "minlevel" ]=79    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={1   ,"Wolf"         },["familySkills"]=WOLF_SKILLS          ,["displayID"]=27042 ,["id"]=30456  ,["coords"]= {{ 65.4 ,60   } ,{65.6,60}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="ShadowmoonValley"      ,["zoneID"]=539  ,["name" ]= "Shadowmoon Packleader"     ,["maxlevel" ]=100     , [ "minlevel" ]=95    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={1   ,"Wolf"         },["familySkills"]=WOLF_SKILLS          ,["displayID"]=56156 ,["id"]=82307  ,["coords"]= {{ 39.4 ,65.6 } ,{39.8,66},{40.2,60.4},{40.2,61.2},{40.2,64.2},{40.4,59.2},{40.4,61.8},{40.4,62.6},{40.6,62.6},{40.6,63.6},{40.8,59.4},{40.8,60.4},{41.2,61},{41.4,61.6},{41.6,61.8},{42,61.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="ShadowmoonValley"      ,["zoneID"]=539  ,["name" ]= "Maa'run"                  ,["maxlevel" ]=102     , [ "minlevel" ]=93    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={151 ,"Stag"         },["familySkills"]=STAG_SKILLS          ,["displayID"]=53222 ,["id"]=76442  ,["coords"]= {{ 51.8 ,54   } ,{52,54.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="ShadowmoonValley"      ,["zoneID"]=539  ,["name" ]= "Kliaa"                    ,["maxlevel" ]=102     , [ "minlevel" ]=92    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={44  ,"Wasp"         },["familySkills"]=WASP_SKILLS          ,["displayID"]=61634 ,["id"]=76438  ,["coords"]= {{ 24.4 ,36.4 } ,{24.4,36.6},{24.6,36.4},{24.6,36.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="FrostfireRidge"        ,["zoneID"]=525  ,["name" ]= "Blazing Pyreclaw"          ,["maxlevel" ]=100     , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=54957 ,["id"]=80241  ,["coords"]= {{ 42   ,65.8 } ,{42.4,65.2},{42.8,64.8},{43.2,67.4},{43.6,65.6},{44.2,66.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="FrostfireRidge"        ,["zoneID"]=525  ,["name" ]= "Ironwing Flamespitter"     ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=58013 ,["id"]=86373  ,["coords"]= {{ 82   ,58   } ,{82.4,56.8},{82.6,56.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="FrostfireRidge"        ,["zoneID"]=525  ,["name" ]= "Chilltongue"              ,["maxlevel" ]=100     , [ "minlevel" ]=95    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=53817 ,["id"]=76477  ,["coords"]= {{ 65.8 ,65.4 } ,{65.8,65.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="FrostfireRidge"        ,["zoneID"]=525  ,["name" ]= "Icemaw Matriarch"          ,["maxlevel" ]=100     , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=55671 ,["id"]=80321  ,["coords"]= {{ 38.8 ,55.6 } ,{39,55},{39.6,55.2},{39.8,57.6},{40,57.2},{40.2,56.2},{41.4,57.4},{41.4,57.8},{41.8,58.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="FrostfireRidge"        ,["zoneID"]=525  ,["name" ]= "Nok-Karosh"               ,["maxlevel" ]=100     , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={1   ,"Wolf"         },["familySkills"]=WOLF_SKILLS          ,["displayID"]=61674 ,["id"]=81001  ,["coords"]= {{ 13   ,50.4 } ,{13.2,50.6},{13.6,51}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="FrostfireRidge"        ,["zoneID"]=525  ,["name" ]= "Garn Nighthowl"            ,["maxlevel" ]=100     , [ "minlevel" ]=90    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={1   ,"Wolf"         },["familySkills"]=WOLF_SKILLS          ,["displayID"]=61675 ,["id"]=81000  ,["coords"]= {{ 11.6 ,47.8 } ,{12,49.6},{12.4,45.2},{12.6,48.2},{12.8,52.8},{13,50.4},{13.2,50.6},{13.2,55.2},{13.6,51},{13.8,49.6},{13.8,55},{13.8,55.8},{14,52},{14.6,56.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Gorgrond"              ,["zoneID"]=543  ,["name" ]= "Roardan the Sky Terror"      ,["maxlevel" ]=100     , [ "minlevel" ]=92    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=58290 ,["id"]=77093  ,["coords"]= {{ 50.8 ,67.4 } ,{50.8,67.6},{51.2,65.6},{53,63},{60.8,66.4},{61.4,61.6},{61.6,61.4},{61.6,61.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Gorgrond"              ,["zoneID"]=543  ,["name" ]= "Charl Doomwing"            ,["maxlevel" ]=100     , [ "minlevel" ]=92    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=56432 ,["id"]=81548  ,["coords"]= {{ 45.2 ,51.6 } ,{45.4,49},{45.6,50},{46,46.8},{47.8,46.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Gorgrond"              ,["zoneID"]=543  ,["name" ]= "Iron Banshee"              ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=59913 ,["id"]=85184  ,["coords"]= {{ 47.6 ,30.8 } ,{47.8,21.2},{48.2,30.4},{48.4,22.4},{48.6,22},{48.6,30.2},{48.8,23.6},{49.2,22.6},{49.4,27.8},{49.8,23.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Gorgrond"              ,["zoneID"]=543  ,["name" ]= "Khargax the Devourer"       ,["maxlevel" ]=100     , [ "minlevel" ]=92    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=56429 ,["id"]=81537  ,["coords"]= {{ 50.4 ,66.4 } ,{50.8,66},{51.4,65.4},{51.4,66.8},{51.6,65.4},{51.6,67.2},{52.2,67.6},{52.4,65.8},{52.6,65.2},{52.6,65.8},{52.6,67.8},{53,66.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Gorgrond"              ,["zoneID"]=543  ,["name" ]= "Typhon Broodmother"        ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=55454 ,["id"]=89031  ,["coords"]= {{ 76   ,40   }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="SpiresofArak"          ,["zoneID"]=542  ,["name" ]= "Dread Raven"               ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={26  ,"BirdofPrey"   },["familySkills"]=BIRDS_OF_PREY_SKILLS ,["displayID"]=59369 ,["id"]=84083  ,["coords"]= {{ 58.4 ,8.4  } ,{59.4,8.4},{59.4,8.6},{59.6,8.4},{59.6,8.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="SpiresofArak"          ,["zoneID"]=542  ,["name" ]= "Dread Raven"               ,["maxlevel" ]=100     , [ "minlevel" ]=96    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={26  ,"BirdofPrey"   },["familySkills"]=BIRDS_OF_PREY_SKILLS ,["displayID"]=54715 ,["id"]=80589  ,["coords"]= {{ 55   ,60   } ,{55.6,60.4},{57.6,63.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="SpiresofArak"          ,["zoneID"]=542  ,["name" ]= "Dread Raven"               ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={26  ,"BirdofPrey"   },["familySkills"]=BIRDS_OF_PREY_SKILLS ,["displayID"]=59369 ,["id"]=94495  ,["coords"]= {{ 58.4 ,8.4  } ,{59.4,8.4},{59.4,8.6},{59.6,8.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } } ,
{["zone_name"]="SpiresofArak"          ,["zoneID"]=542  ,["name" ]= "Brood Mother Xylax"         ,["maxlevel" ]=100     , [ "minlevel" ]=96    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={31  ,"Ravager"      },["familySkills"]=RAVAGER_SKILLS       ,["displayID"]=58756 ,["id"]=86455  ,["coords"]= {{ 30.4 ,30.4 } ,{30.6,29.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="SpiresofArak"          ,["zoneID"]=542  ,["name" ]= "Venombarb"                ,["maxlevel" ]=102     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=55095 ,["id"]=82646  ,["coords"]= {{ 61   ,19   }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="SpiresofArak"          ,["zoneID"]=542  ,["name" ]= "Spineslicer"              ,["maxlevel" ]=102     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={31  ,"Ravager"      },["familySkills"]=RAVAGER_SKILLS       ,["displayID"]=56020 ,["id"]=82632  ,["coords"]= {{ 53.2 ,69.4 } ,{53.2,69.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="SpiresofArak"          ,["zoneID"]=542  ,["name" ]= "Rukhmar"                  ,["maxlevel" ]=9999    , [ "minlevel" ]=9999  ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={26  ,"BirdofPrey"   },["familySkills"]=BIRDS_OF_PREY_SKILLS ,["displayID"]=59089 ,["id"]=83746  ,["coords"]= {{ 34.4 ,31.4 } ,{34.4,36.2},{34.4,36.6},{34.6,31.4},{35,38.6},{36.8,39.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="TanaanJungle"          ,["zoneID"]=534  ,["name" ]= "Keravnos Scout"            ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=55722 ,["id"]=80403  ,["coords"]= {{ 9.8  ,54.8 } ,{12.2,56.6},{12.6,57},{12.8,56.4},{14,56.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="TanaanJungle"          ,["zoneID"]=534  ,["name" ]= "Fel Raven"                 ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={26  ,"BirdofPrey"   },["familySkills"]=BIRDS_OF_PREY_SKILLS ,["displayID"]=64266 ,["id"]=95328  ,["coords"]= {{ 33.6 ,60.2 } ,{34.2,62.6},{34.8,64.4},{35.6,54.6},{35.8,64.6},{37.2,53.6},{38.4,61.8},{39,62.2},{39.8,59.4},{41.8,62.6},{44,52.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="TanaanJungle"          ,["zoneID"]=534  ,["name" ]= "Diresnout Felboar"         ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={51  ,"Monkey"       },["familySkills"]=MONKEY_SKILLS        ,["displayID"]=64854 ,["id"]=89689  ,["coords"]= {{ 45.2 ,60.4 } ,{45.6,60.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="TanaanJungle"          ,["zoneID"]=534  ,["name" ]= "Reassigned Warbeast"       ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={43  ,"Clefthoof"    },["familySkills"]=CLEFTHOOVE_SKILLS    ,["displayID"]=53311 ,["id"]=108181 ,["coords"]= {{ 38.8 ,41.8 } ,{39.2,41.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="TanaanJungle"          ,["zoneID"]=534  ,["name" ]= "Fathomless Mauler"         ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={8   ,"Crab"         },["familySkills"]=CRAB_SKILLS          ,["displayID"]=64628 ,["id"]=93226  ,["coords"]= {{ 43   ,87.4 } ,{43.2,85.6},{43.4,83},{43.4,85.4},{43.6,85.4},{43.6,85.6},{46.4,89},{46.4,89.6},{47.2,88.4},{47.2,88.6},{47.6,88.4},{47.6,89.4},{49.4,91},{49.8,89.2},{49.8,91.6},{50,91},{50.4,90.4},{50.6,91.8},{55.4,93},{55.4,93.8},{55.6,93.6},{55.8,92.4},{55.8,92.8},{56.6,92},{63.4,89.8},{63.4,90.6},{63.6,90.4},{63.6,90.6},{64,91.6},{67.4,87},{67.4,87.6},{67.6,87.4},{67.6,87.6},{67.8,88.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="TanaanJungle"          ,["zoneID"]=534  ,["name" ]= "Keravnos Monitor"          ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=55723 ,["id"]=80404  ,["coords"]= {{ 38.4 ,81.2 } ,{38.4,82},{38.6,80.8},{38.8,82.4},{38.8,82.6},{40,82.2},{40.2,83.6},{40.4,81.2},{40.4,82.8},{40.6,81.2},{40.6,82.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="TanaanJungle"          ,["zoneID"]=534  ,["name" ]= "Ancient Matriarch"         ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=63400 ,["id"]=93010  ,["coords"]= {{ 60.6 ,92.4 } ,{60.6,92.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="TanaanJungle"          ,["zoneID"]=534  ,["name" ]= "Keravnos Wanderer"         ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=55723 ,["id"]=80453  ,["coords"]= {{ 39.2 ,83   } ,{39.2,83.6},{39.4,80.6},{39.4,81.8},{39.6,82.6},{39.8,81.4},{39.8,81.6},{39.8,84},{40.6,83},{40.6,84.4},{40.8,81.2},{40.8,81.8},{41.8,81.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="TanaanJungle"          ,["zoneID"]=534  ,["name" ]= "Keravnos Broodmother"      ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=55460 ,["id"]=80405  ,["coords"]= {{ 39.4 ,83   } ,{39.6,82.2},{39.6,82.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Leatherhide Earthshaker"   ,["maxlevel" ]= "????" , [ "minlevel" ]="????",["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={43  ,"Clefthoof"    },["familySkills"]=CLEFTHOOVE_SKILLS    ,["displayID"]=58621 ,["id"]=85031  ,["coords"]= {{ 55.6 ,11.8 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Direbeak Windroc"          ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={26  ,"BirdofPrey"   },["familySkills"]=BIRDS_OF_PREY_SKILLS ,["displayID"]=61646 ,["id"]=86748  ,["coords"]= {{ 52.4 ,39   } ,{52.6,39},{56.8,34},{56.8,36.2},{57,37.6},{57.8,35},{58.4,30},{58.6,30},{60.8,24.2},{60.8,33}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Ironhide Bull"             ,["maxlevel" ]=100     , [ "minlevel" ]=98    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={43  ,"Clefthoof"    },["familySkills"]=CLEFTHOOVE_SKILLS    ,["displayID"]=60083 ,["id"]=86731  ,["coords"]= {{ 51.4 ,39.4 } ,{51.4,39.8},{51.6,36.4},{51.6,39.4},{51.6,39.8},{51.8,37},{52.2,38.2},{52.6,37.4},{52.8,38},{54,36.4},{54,36.8},{54.2,34.4},{54.2,34.6},{55.4,36.2},{55.4,36.6},{55.6,36.4},{55.6,36.6},{56.2,33.6},{56.4,33.2},{57.4,30.4},{57.4,33},{57.8,29.8},{58,29.4},{58,33.4},{58.2,33.6},{58.4,35},{58.4,35.6},{58.6,35.2},{58.6,35.6},{58.8,28.4},{59,29},{59.2,32.2},{59.2,32.6},{59.4,33.8},{59.6,33.4},{59.6,33.6},{60.4,13},{60.4,20.4},{60.4,20.6},{60.4,26.4},{60.4,26.8},{60.4,28.4},{60.4,28.8},{60.4,31.2},{60.4,31.6},{60.6,13.2},{60.6,20.4},{60.6,20.6},{60.6,27},{60.6,28.4},{60.6,31},{60.8,29.6},{61,21.6},{61.2,25.4},{61.4,17.4},{61.4,17.8},{61.4,19.2},{61.4,25.6},{61.4,29},{61.4,32.2},{61.4,32.6},{61.6,14.8},{61.6,17.2},{61.6,18.4},{61.6,25.4},{61.6,29},{61.6,32.4},{61.8,14.4},{61.8,15.6},{62,26},{62.2,30},{62.2,33},{62.4,19.4},{62.4,19.6},{62.4,23.6},{62.4,26.6},{62.6,17.2},{62.6,17.6},{62.6,19.4},{62.6,19.6},{62.6,26.4},{62.6,26.8},{62.8,24},{62.8,25.2},{62.8,28.6},{63,15.4},{63,15.6},{63,28},{63,30.6},{63.2,13.6},{63.2,30.2},{63.4,13.4},{63.6,13},{63.6,13.8},{63.6,29},{64,28.2},{64.2,20.2},{64.4,20.6},{64.6,20.8},{65,19.4},{65,19.6}} } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Lernaean Scout"            ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=55820 ,["id"]=80543  ,["coords"]= {{ 49   ,79   } ,{51.4,80.2},{51.8,81.2},{61.6,12.4},{62,13.4},{62.2,13.6},{63,10.4},{63.2,11.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Vicious Razorclaw"         ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={11  ,"Raptor"       },["familySkills"]=RAPTOR_SKILLS        ,["displayID"]=61299 ,["id"]=88956  ,["coords"]= {{ 36.2 ,39.6 } ,{36.2,43.4},{36.4,39},{36.4,43.6},{36.6,43.6},{36.8,40.4},{36.8,40.6},{37.4,38.4},{37.4,39.2},{37.4,41.6},{37.4,42.8},{37.6,39.4},{37.6,41.4},{37.8,37.4},{37.8,38},{37.8,40.2},{37.8,41.6},{38.8,38.2},{39,40.6},{39.2,39.2},{39.4,39.8},{39.8,39.4},{41,47},{41.2,47.6},{42.2,44},{42.4,43},{42.6,43}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Lernaean Broodmother"      ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=55459 ,["id"]=80541  ,["coords"]= {{ 51.8 ,89.4 } ,{52.2,90.2},{53.2,84.4},{63.2,10.4},{63.2,10.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Lernaean Monitor"          ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={68  ,"Hydra"        },["familySkills"]=HYDRA_SKILLS         ,["displayID"]=55819 ,["id"]=80542  ,["coords"]= {{ 50   ,82.2 } ,{50.2,82.6},{52,89.2},{52.4,81},{52.8,81},{61.4,10.4},{61.4,10.8},{61.6,10.4},{61.6,11},{62.6,10}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Wetland Trampler"          ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={150 ,"Riverbeast"   },["familySkills"]=RIVERBEAST_SKILLS    ,["displayID"]=55211 ,["id"]=87021  ,["coords"]= {{ 30.4 ,49.2 } ,{30.6,49.4},{30.6,49.6},{31.4,51.2},{31.8,48.8},{32,47.8},{32.2,50.4},{32.2,50.6},{32.6,51},{33.4,47.6},{33.4,49.2},{33.4,49.6},{33.6,48},{34,46.4},{34.2,48.6},{34.6,48.8},{34.8,49.6},{35,46.4},{35,47.6},{35.2,46.8},{35.4,45.4},{36,44.4},{36,44.6},{36,47.8},{36.2,48.6},{36.4,45.6},{36.4,46.8},{36.6,45.4},{37.4,46.2},{37.4,46.6},{37.4,48.4},{37.4,48.6},{37.6,48.4},{38.2,45.8},{45.2,46}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Thorncoat Buck"            ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={151 ,"Stag"         },["familySkills"]=STAG_SKILLS          ,["displayID"]=60086 ,["id"]=86728  ,["coords"]= {{ 51.4 ,43.2 } ,{51.6,43.2},{53,40.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Direfang Alpha"            ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={1   ,"Wolf"         },["familySkills"]=WOLF_SKILLS          ,["displayID"]=61302 ,["id"]=86932  ,["coords"]= {{ 39   ,34.2 } ,{39.2,32.4},{39.4,31.2},{39.6,31.4},{40.2,34},{40.2,34.8},{40.4,30.2},{40.4,31.6},{40.6,30.2},{40.6,31.8},{41.2,31.2},{41.2,32.6},{41.4,34},{42,31.6},{42.6,31.6},{47,33.6},{47,36.4},{47.2,33.4},{47.2,37},{47.8,37},{48.2,35.4},{48.2,35.6},{48.4,33},{48.4,37.6},{48.6,33},{48.6,37.4},{48.6,37.6},{48.8,34.4},{48.8,34.6},{49.2,36.2},{52,42.4},{52.2,42.6},{52.8,41.6},{53,41.4},{53.6,40.8},{53.8,40},{54.2,39.4},{54.8,39.4},{54.8,39.6},{55.8,39.2},{56.4,39.6},{56.8,39.2},{57.8,38},{58.4,38.6},{58.8,38.6},{59,38.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Deadly Gloomstalker"       ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={32  ,"WarpStalker"  },["familySkills"]=WARP_STALKERS_SKILLS ,["displayID"]=61265 ,["id"]=86773  ,["coords"]= {{ 42.2 ,26.6 } ,{42.8,28.2},{43,28.8},{43.2,26.4},{43.4,26.8},{45.2,21.6},{45.6,21.6},{46,23.2},{46.2,23.6},{46.2,25.8},{47.2,29.4},{47.6,28.8},{51.2,29},{52,16.4},{52.2,16.6},{52.4,23.4},{52.6,15.8},{52.6,16.6},{52.6,22.4},{52.6,23.2},{52.6,26.2},{52.6,26.8},{53,17.8},{53.2,29.2},{53.6,25.8},{53.6,29.2},{53.8,23.4},{53.8,24.2},{54.4,25.2},{54.6,25.6},{54.8,29.2},{55.2,25.4},{55.4,21.4},{55.4,21.8},{55.6,21.4},{56,25}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="Nagrand"               ,["zoneID"]=550  ,["name" ]= "Venombore Hive Guard"       ,["maxlevel" ]=100     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={44  ,"Wasp"         },["familySkills"]=WASP_SKILLS          ,["displayID"]=61273 ,["id"]=86834  ,["coords"]= {{ 38.2 ,43   } ,{39.4,36.2},{39.6,36.2},{39.6,36.6},{41,44.4},{41.4,44.6},{41.8,45.4},{42,44.2},{42,45.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="TimelessIsle"          ,["zoneID"]=554  ,["name" ]= "Primal Stalker"            ,["maxlevel" ]=90      , [ "minlevel" ]=89    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=51326 ,["id"]=72805  ,["coords"]= {{ 49   ,58.8 } ,{49.4,58.4},{49.6,58.4},{49.6,58.6},{50.4,56.2},{50.4,56.6},{50.6,56},{52.2,61.6},{52.4,61.2},{52.4,63.4},{52.4,64.4},{52.6,61.4},{52.6,63.8},{52.8,63.4},{55.4,45},{55.6,45},{56,44.4},{57.4,47.2},{57.4,47.6},{57.6,47.6},{57.8,46.8},{59.8,66.2},{59.8,66.8},{61.2,52.6},{61.4,52.4},{61.6,52.6},{62.4,52.4},{62.6,52.6},{62.8,52.2},{63.4,57.6},{63.4,59.2},{63.4,59.6},{63.6,57.8},{63.6,59.2},{63.6,59.6},{63.8,57.4},{64.4,54.6},{64.6,54.4},{64.8,54.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="TimelessIsle"          ,["zoneID"]=554  ,["name" ]= "Brilliant Windfeather"     ,["maxlevel" ]=90      , [ "minlevel" ]=85    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={125 ,"Crane"        },["familySkills"]=CRANE_SKILLS         ,["displayID"]=51262 ,["id"]=72762  ,["coords"]= {{ 29.2 ,50.4 } ,{29.4,50.6},{29.6,50.6},{29.8,50.4},{30.2,43.4},{30.2,58.2},{30.2,59.2},{30.4,44},{30.4,61.4},{30.4,62.4},{30.4,62.8},{30.4,65.8},{30.6,43.4},{30.6,49.4},{30.6,50.2},{30.6,51.2},{30.6,62.4},{30.6,62.8},{30.6,65.4},{30.8,43.8},{30.8,66.4},{30.8,66.6},{31.2,51.6},{31.2,52.6},{31.4,39.4},{31.4,40.2},{31.4,79.8},{31.6,39.4},{31.6,40.2},{31.6,79.4},{31.8,40.6},{31.8,62.8},{31.8,66.4},{31.8,66.6},{31.8,79.8},{32.2,48.6},{32.2,52.2},{32.2,80.6},{32.4,48.2},{32.6,48.6},{36.2,40.6},{36.4,39.4},{36.4,40},{36.4,83.4},{36.4,83.6},{36.6,40},{36.6,40.6},{36.8,83.8},{37.8,41.8},{38.4,41.4},{38.6,41.4},{38.6,41.6},{39.2,67.4},{39.4,68},{39.4,68.6},{39.6,67.4},{39.6,68.2},{39.6,68.6},{40.4,40.2},{40.4,42.4},{40.4,43.2},{40.6,39.4},{40.6,39.8},{40.6,42.4},{40.8,40.6},{40.8,43.2},{41,43.6},{42.4,67},{42.4,67.6},{42.4,69.4},{42.4,70},{42.4,70.6},{42.6,67.2},{42.6,67.6},{42.6,69.4},{42.6,70.4},{42.6,70.6},{44.2,61},{44.2,61.8},{44.4,54.4},{44.4,55},{44.6,54.8},{44.6,61.4},{44.8,53.4},{44.8,53.6}                                                                                                                                                    } } ,
{["zone_name"]="TimelessIsle"          ,["zoneID"]=554  ,["name" ]= "Ancient Spineclaw"         ,["maxlevel" ]=90      , [ "minlevel" ]=89    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={8   ,"Crab"         },["familySkills"]=CRAB_SKILLS          ,["displayID"]=50962 ,["id"]=72766  ,["coords"]= {{ 15.6 ,36.8 } ,{16.4,60.6},{17.6,53},{18,75.2},{18.2,54.6},{18.2,58},{18.2,58.6},{18.2,63},{18.2,64.4},{18.8,54.4},{19,55},{19,76.4},{20.2,47.2},{20.4,47.8},{20.6,47.4},{20.6,47.6},{20.8,71.6},{21,63.4},{21,71},{21.2,32.4},{21.2,63.6},{21.4,32.8},{21.4,35.4},{21.4,35.8},{21.6,32.4},{21.6,32.6},{21.6,35.4},{21.8,36},{22.4,30.4},{22.4,30.8},{22.6,30.2},{22.6,30.8},{22.6,35.2},{22.8,35.6},{23.4,27.4},{23.4,28.2},{23.4,28.6},{23.6,27.4},{23.6,28.4},{23.6,28.8},{23.6,35.8},{23.8,34.8},{24.4,74.4},{24.4,74.8},{25.4,74.4},{25.4,74.6},{25.6,74.4},{25.6,74.6},{27.4,74.2},{27.4,74.6},{27.6,74.2},{27.6,80.4},{27.8,74.6},{29.2,84},{30.4,30.8},{30.6,30.4},{30.6,31},{30.8,31.6},{33,85.8},{33.4,85.2},{38.4,87.2},{38.6,86.8},{40.2,90.8},{40.6,90.8},{41,90},{44.8,90.4},{52,86.8},{61.8,83},{62.2,82.4},{62.6,81.8},{66,78.4},{68,77.8},{68.6,74.2},{70.2,70.4},{70.8,63.4}                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="TimelessIsle"          ,["zoneID"]=554  ,["name" ]= "Ironfur Great Bull"         ,["maxlevel" ]=90      , [ "minlevel" ]=85    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={157 ,"Oxen"         },["familySkills"]=OXEN_SKILLS          ,["displayID"]=51283 ,["id"]=72844  ,["coords"]= {{ 27.2 ,39.6 } ,{27.4,60.4},{28,39.4},{28,46.2},{28,49},{28,59.4},{28.2,40.4},{28.4,41},{28.4,46.8},{28.4,48},{28.4,50.4},{28.8,43},{28.8,59.2},{29.2,39.6},{29.2,44.4},{29.2,70.2},{29.6,43.4},{29.6,70},{29.8,71.4},{30,44.2},{30.2,47.6},{30.2,69.4},{30.4,47.4},{30.6,48},{30.6,49.4},{30.8,68.2},{30.8,70.8},{31.4,69.2},{31.6,43.8},{32,44.6},{32,59.4},{32.2,58.2},{32.8,62},{33.2,63},{33.4,38.6},{33.6,38.6},{33.8,61.4},{33.8,68},{34.2,37.2},{34.2,38.4},{34.2,70.6},{34.4,66.8},{34.6,69.8},{34.8,40.8},{34.8,68.2},{35,43},{35,71},{35.8,70.2},{36,67.6},{36.2,66.8},{37.2,43.4},{37.2,44},{37.6,42.4},{37.6,42.8},{37.8,36.6},{37.8,44.2},{40.8,65.2},{41,37.6},{41,65.8},{41.4,39.4},{43.2,55.2},{43.4,55.6},{43.6,51.6},{43.6,54.8},{44,55.8},{44.2,52.6},{44.2,54.2},{44.4,58.4},{44.6,43.4},{44.8,52.6},{44.8,58.4},{45,51.8},{45,56.6},{45.2,45.6},{45.6,63.2},{46.2,63.6},{46.8,63},{47.2,61.6}                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="TimelessIsle"          ,["zoneID"]=554  ,["name" ]= "Gulp Frog"                 ,["maxlevel" ]=90      , [ "minlevel" ]=89    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={291 ,"Toad"         },["familySkills"]=TOAD_SKILLS          ,["displayID"]=51346 ,["id"]=72777  ,["coords"]= {{ 59.8 ,70.6 } ,{60.4,72.4},{60.8,71.4},{61,72.2},{61.4,72.6},{61.4,74.4},{61.4,74.6},{61.6,72.4},{61.6,74.4},{61.6,74.6},{62,79.6},{62.2,77.2},{62.2,77.6},{62.4,60.8},{62.4,73.4},{62.4,75.6},{62.6,74.2},{62.6,77.6},{63,72.4},{63,72.8},{63,80.8},{63.2,76.6},{63.4,75.4},{63.4,75.6},{63.6,75.2},{63.6,77.6},{63.8,77},{64,72.2},{64,72.6},{64,76.2},{64.2,73.8},{64.6,76.4},{65,71},{65,73.6},{65.2,64.4},{65.2,64.6},{65.2,67.4},{65.2,67.8},{65.2,71.6},{65.2,73.2},{65.2,78.2},{65.4,66.4},{65.4,68.6},{65.4,70.4},{65.6,66.4},{65.6,74},{65.8,68.8},{66,67.2},{66,69.8},{66,72.2},{66,72.6},{66.4,64.4},{66.4,64.6},{66.4,68},{66.4,71.4},{66.6,65},{66.6,67.8},{66.6,68.6},{66.6,76.4},{66.8,66.2},{66.8,70},{67,66.6},{67,71.4},{67,71.6},{67.6,69.8},{67.8,70.8},{70.2,70.4}                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="TimelessIsle"          ,["zoneID"]=554  ,["name" ]= "Elder Great Turtle"         ,["maxlevel" ]=90      , [ "minlevel" ]=85    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={21  ,"Turtle"       },["familySkills"]=TURTLE_SKILLS        ,["displayID"]=51125 ,["id"]=72765  ,["coords"]= {{ 16.2 ,37   } ,{16.2,48.4},{16.4,35.8},{16.4,48.6},{16.6,48.8},{16.6,49.6},{16.8,36.4},{17,37},{17.2,37.6},{17.2,47.6},{17.4,38.8},{17.4,46.8},{17.6,37.2},{17.8,46},{18,38.4},{18.2,30.6},{18.2,63.6},{18.6,30.2},{18.8,39},{18.8,62.4},{19,29.4},{19,54.2},{19,54.6},{19,64},{19.2,31},{19.2,32.4},{19.2,63.4},{19.4,56},{19.4,65.2},{19.6,31.8},{19.6,39.8},{19.6,54},{19.6,55.6},{19.6,65},{19.8,54.8},{19.8,57},{20,30.2},{20,63.2},{20,63.6},{20.2,65.8},{20.4,30.8},{20.6,56},{20.8,64},{21,31.4},{21,54.4},{21,54.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="TimelessIsle"          ,["zoneID"]=554  ,["name" ]= "Great Turtle"              ,["maxlevel" ]=90      , [ "minlevel" ]=89    ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={21  ,"Turtle"       },["familySkills"]=TURTLE_SKILLS        ,["displayID"]=51128 ,["id"]=72764  ,["coords"]= {{ 20.6 ,42.6 } ,{21,42.4},{21,44.8},{21.6,43.8},{21.6,44.6},{22,42.4},{22,42.6},{22,46},{22,61.6},{22.2,53.6},{22.2,61.4},{22.4,46.6},{22.4,53},{22.4,65},{22.4,65.6},{22.4,67.2},{22.4,67.8},{22.6,53.8},{22.6,65.4},{22.6,65.6},{22.6,67.2},{22.6,68},{22.8,52},{22.8,61.6},{23.2,47},{23.2,57.4},{23.4,47.6},{23.4,49},{23.4,49.6},{23.4,53},{23.4,58},{23.4,58.6},{23.4,60.4},{23.4,60.8},{23.4,62.8},{23.4,63.8},{23.6,48.6},{23.6,49.6},{23.6,53.4},{23.6,63.4},{23.6,63.6},{23.6,67.2},{23.6,68.8},{23.8,48},{23.8,54},{23.8,60.4},{23.8,60.6},{24.2,70},{24.4,57.4},{24.4,57.6},{24.6,57.4},{24.8,58.4},{24.8,59},{24.8,59.6},{25.2,52.2},{25.4,50},{25.4,50.6},{25.4,53},{25.4,56.4},{25.4,72.2},{25.6,50.2},{25.6,58.6},{25.8,50.6},{25.8,57.4},{25.8,57.8},{26,55.4},{26,56.4},{26,71.4},{26,72.8},{26.2,72},{26.6,72.2},{26.6,72.6}                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="BlackrockFoundry"      ,["zoneID"]=599  ,["name" ]= "Faultline"                ,["maxlevel" ]=9999    , [ "minlevel" ]=9999  ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={43  ,"Clefthoof"    },["familySkills"]=CLEFTHOOVE_SKILLS    ,["displayID"]=53542 ,["id"]=76946  ,["coords"]= {{ 66.3 ,72.1 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="BlackrockFoundry"      ,["zoneID"]=599  ,["name" ]= "Dreadwing"                ,["maxlevel" ]=9999    , [ "minlevel" ]=9999  ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=53505 ,["id"]=76874  ,["coords"]= {{ 66.3 ,72.1 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="UpperBlackrockSpire"   ,["zoneID"]=618  ,["name" ]= "Ironbarb Skyreaver"        ,["maxlevel" ]=102     , [ "minlevel" ]=102   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=59180 ,["id"]=80098  ,["coords"]= {{ 48.5 ,24.5 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="Azsuna"                ,["zoneID"]=630  ,["name" ]= "Leytusk"                  ,["maxlevel" ]=110     , [ "minlevel" ]=101   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={51  ,"Monkey"       },["familySkills"]=MONKEY_SKILLS        ,["displayID"]=62708 ,["id"]=100846 ,["coords"]= {{ 62   ,11.4 } ,{62,11.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Azsuna"                ,["zoneID"]=630  ,["name" ]= "CoveGull"                 ,["maxlevel" ]=110     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={26  ,"BirdofPrey"   },["familySkills"]=BIRDS_OF_PREY_SKILLS ,["displayID"]=71849 ,["id"]=111570 ,["coords"]= {{ 39.6 ,85.8 } ,{46.8,91.4},{46.8,91.6},{48.4,92},{50.8,75.2},{50.8,76}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Azsuna"                ,["zoneID"]=630  ,["name" ]= "Mac the Bear"               ,["maxlevel" ]=110     , [ "minlevel" ]=103   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={4   ,"Bear"         },["familySkills"]=BEAR_SKILLS          ,["displayID"]=41014 ,["id"]=109324 ,["coords"]= {{ 53   ,21.4 } ,{53,21.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Azsuna"                ,["zoneID"]=630  ,["name" ]= "Resting Dauorbjorn"        ,["maxlevel" ]=110     , [ "minlevel" ]=101   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={4   ,"Bear"         },["familySkills"]=BEAR_SKILLS          ,["displayID"]=41014 ,["id"]=92735  ,["coords"]= {{ 53   ,21.2 } ,{53.4,22.2},{53.6,22.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Azsuna"                ,["zoneID"]=630  ,["name" ]= "Bloodgazer Patriarch"      ,["maxlevel" ]=110     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={11  ,"Raptor"       },["familySkills"]=RAPTOR_SKILLS        ,["displayID"]=73913 ,["id"]=115670 ,["coords"]= {{ 34.4 ,6.4  } ,{34.4,10},{34.6,6.4},{34.8,7.8},{35,6.8},{35,10},{35.2,9},{36,8.6},{36.4,7.4},{36.4,8.2},{36.6,8.2},{36.6,8.6},{37.2,7.4},{37.4,5.4},{37.4,5.6},{37.8,6},{37.8,6.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="Azsuna"                ,["zoneID"]=630  ,["name" ]= "Bloodgazer Matriarch"      ,["maxlevel" ]=111     , [ "minlevel" ]=111   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={11  ,"Raptor"       },["familySkills"]=RAPTOR_SKILLS        ,["displayID"]=73920 ,["id"]=115674 ,["coords"]= {{ 35.4 ,5.4  } ,{35.4,5.6},{35.6,5.4},{35.6,5.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } } ,
{["zone_name"]="Azsuna"                ,["zoneID"]=630  ,["name" ]= "Netherbeak"               ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={160 ,"Feathermane"  },["familySkills"]=FEATHERMANES_SKILLS  ,["displayID"]=63623 ,["id"]=16875  ,["coords"]= {{ 42.6 ,21   } ,{43.4,24.6},{43.6,24.4},{43.6,24.6},{43.6,26.2},{43.8,27}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Highmountain"          ,["zoneID"]=650  ,["name" ]= "Irewing"                  ,["maxlevel" ]=110     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={26  ,"BirdofPrey"   },["familySkills"]=BIRDS_OF_PREY_SKILLS ,["displayID"]=66088 ,["id"]=95762  ,["coords"]= {{ 43.4 ,45   } ,{43.6,44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Highmountain"          ,["zoneID"]=650  ,["name" ]= "Spinesever"               ,["maxlevel" ]=110     , [ "minlevel" ]=105   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={130 ,"Basilisk"     },["familySkills"]=BASILISK_SKILLS      ,["displayID"]=66850 ,["id"]=100841 ,["coords"]= {{ 39.2 ,13.4 } ,{39.2,13.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Highmountain"          ,["zoneID"]=650  ,["name" ]= "Great Eagle"               ,["maxlevel" ]=110     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={26  ,"BirdofPrey"   },["familySkills"]=BIRDS_OF_PREY_SKILLS ,["displayID"]=70260 ,["id"]=108552 ,["coords"]= {{ 26   ,61.4 } ,{27,57.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Highmountain"          ,["zoneID"]=650  ,["name" ]= "Rashar"                   ,["maxlevel" ]=110     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=62609 ,["id"]=97454  ,["coords"]= {{ 37.4 ,49.2 } ,{37.6,49}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Highmountain"          ,["zoneID"]=650  ,["name" ]= "Snowfeather Patriarch"     ,["maxlevel" ]=110     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={11  ,"Raptor"       },["familySkills"]=RAPTOR_SKILLS        ,["displayID"]=73914 ,["id"]=115669 ,["coords"]= {{ 32.2 ,23.8 } ,{32.4,24.6},{32.8,24},{33.2,25.6},{33.4,22.8},{33.4,25.4},{33.8,25.6},{34,23.6},{34,25.2},{34.2,22.8},{35,22.8},{35.4,21},{35.4,22},{35.6,20},{35.6,21.4},{35.6,22},{35.6,24.2},{35.8,18},{36.4,19.2},{36.8,18.4},{36.8,18.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="Highmountain"          ,["zoneID"]=650  ,["name" ]= "Morashu"                  ,["maxlevel" ]=110     , [ "minlevel" ]=100   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={151 ,"Stag"         },["familySkills"]=STAG_SKILLS          ,["displayID"]=64256 ,["id"]=94694  ,["coords"]= {{ 45.4 ,42.4 } ,{45.4,42.6},{45.6,42.4},{45.6,42.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="Highmountain"          ,["zoneID"]=650  ,["name" ]= "Thornback Spinner"         ,["maxlevel" ]=110     , [ "minlevel" ]=103   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={3   ,"Spider"       },["familySkills"]=SPIDER_SKILLS        ,["displayID"]=46709 ,["id"]=97494  ,["coords"]= {{ 41   ,41.6 } ,{41.2,40.6},{41.4,43},{41.6,43.2},{41.8,44},{42.4,42.4},{47.4,37},{47.4,37.8},{48.2,36.4},{48.4,36.8},{48.4,38.4},{48.4,39.4},{48.6,37.4},{48.6,38},{48.8,40},{49,38.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Highmountain"          ,["zoneID"]=650  ,["name" ]= "Snowfeather Matriarch"     ,["maxlevel" ]=111     , [ "minlevel" ]=111   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={11  ,"Raptor"       },["familySkills"]=RAPTOR_SKILLS        ,["displayID"]=73919 ,["id"]=115673 ,["coords"]= {{ 35   ,22   } ,{35,22.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Stormheim"             ,["zoneID"]=634  ,["name" ]= "Stonefang"                ,["maxlevel" ]=110     , [ "minlevel" ]=103   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={130 ,"Basilisk"     },["familySkills"]=BASILISK_SKILLS      ,["displayID"]=70340 ,["id"]=107914 ,["coords"]= {{ 46.4 ,60.8 } ,{46.6,60.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Stormheim"             ,["zoneID"]=634  ,["name" ]= "Spitefeather"             ,["maxlevel" ]=110     , [ "minlevel" ]=102   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={26  ,"BirdofPrey"   },["familySkills"]=BIRDS_OF_PREY_SKILLS ,["displayID"]=70334 ,["id"]=97124  ,["coords"]= {{ 48.4 ,32.8 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="Stormheim"             ,["zoneID"]=634  ,["name" ]= "Direbeak Patriarch"        ,["maxlevel" ]=110     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={11  ,"Raptor"       },["familySkills"]=RAPTOR_SKILLS        ,["displayID"]=73916 ,["id"]=115667 ,["coords"]= {{ 76.4 ,84   } ,{76.6,84},{77.2,82.2},{77.2,82.8},{77.4,80.2},{77.4,81.4},{77.6,79.4},{77.6,79.8},{77.6,80.8},{77.6,82.8},{77.8,72.4},{77.8,72.6},{78,74.2},{78.4,77.4},{78.4,77.6},{78.6,76.8},{78.8,74.4},{78.8,75.2},{78.8,76.2},{79.4,70.4},{79.6,70.2},{80.4,69.2},{80.6,69.4},{80.6,69.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } } ,
{["zone_name"]="Stormheim"             ,["zoneID"]=634  ,["name" ]= "Direbeak Matriarch"        ,["maxlevel" ]=111     , [ "minlevel" ]=111   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={11  ,"Raptor"       },["familySkills"]=RAPTOR_SKILLS        ,["displayID"]=73917 ,["id"]=115671 ,["coords"]= {{ 78.2 ,76.4 } ,{78.2,76.6},{78.6,73.4},{78.6,76.6},{78.8,74.4},{78.8,75.2},{78.8,75.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="HellfireCitadel"       ,["zoneID"]=665  ,["name" ]= "FelRaven"                 ,["maxlevel" ]=102     , [ "minlevel" ]=102   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={26  ,"BirdofPrey"   },["familySkills"]=BIRDS_OF_PREY_SKILLS ,["displayID"]=62494 ,["id"]=93952  ,["coords"]= {{ 40.1 ,76.1 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="Val'sharah"            ,["zoneID"]=641  ,["name" ]= "Sharptalon Patriarch"      ,["maxlevel" ]=110     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={11  ,"Raptor"       },["familySkills"]=RAPTOR_SKILLS        ,["displayID"]=73915 ,["id"]=115668 ,["coords"]= {{ 48   ,7.4  } ,{48.8,7.4},{49,8.4},{49.2,9},{49.8,7.4},{50.4,8.2},{50.6,8.4},{50.6,8.6},{51.6,8.4},{51.8,9.2},{53,9.2},{53,9.6},{53.6,9.2},{55,7.8},{55.2,8.8},{55.4,7.4},{55.4,9.6},{55.6,9.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 } } ,
{["zone_name"]="Val'sharah"            ,["zoneID"]=641  ,["name" ]= "Sharptalon Matriarch"      ,["maxlevel" ]=111     , [ "minlevel" ]=111   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={11  ,"Raptor"       },["familySkills"]=RAPTOR_SKILLS        ,["displayID"]=73918 ,["id"]=115672 ,["coords"]= {{ 48   ,9.4  } ,{48,9.6},{48.6,9.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="Val'sharah"            ,["zoneID"]=641  ,["name" ]= "Wandering Shellback"       ,["maxlevel" ]=110     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={21  ,"Turtle"       },["familySkills"]=TURTLE_SKILLS        ,["displayID"]=51124 ,["id"]=111633 ,["coords"]= {{ 45.2 ,57.6 } ,{45.8,65.4},{46.2,65.8},{48,63},{48.2,69.4},{48.8,62.8},{48.8,69.4},{49,69.6},{49.2,66},{49.4,68.4},{49.6,65.2},{49.6,66.6},{49.6,68.4},{49.6,69},{49.6,69.8},{49.8,65.8},{50,71},{50.6,65.4},{50.6,68.2},{50.6,70.2},{50.8,66.8},{51,58},{51.2,58.6},{51.8,64.8},{51.8,66.4},{52,62.8},{52,67.2},{52.2,62.2},{52.4,64.4},{52.6,62.8},{52.6,65.6},{52.8,68.2},{53,68.6},{53.2,64.2},{53.6,67.6},{54.6,68.8},{56.8,69.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Val'sharah"            ,["zoneID"]=641  ,["name" ]= "Varoudnir"                ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={160 ,"Feathermane"  },["familySkills"]=FEATHERMANES_SKILLS  ,["displayID"]=76531 ,["id"]=121623 ,["coords"]= {{ 57   ,78.4 } ,{57,80}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Zuldazar"              ,["zoneID"]=862  ,["name" ]= "KingK'tal"                ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=47511 ,["id"]=123502 ,["coords"]= {{ 68   ,22.2 } ,{68.4,22.8},{68.6,22.2},{68.6,23},{70,22.6},{70.4,22.4},{70.6,22.6},{71.2,21.6},{71.4,21.4},{71.6,20.4},{71.6,21.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="Zuldazar"              ,["zoneID"]=862  ,["name" ]= "Ten'gor"                  ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=47808 ,["id"]=130713 ,["coords"]= {{ 61.4 ,25.2 } ,{61.8,25.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Zuldazar"              ,["zoneID"]=862  ,["name" ]= "Xibalan Apex"              ,["maxlevel" ]=120     , [ "minlevel" ]=113   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=81975 ,["id"]=131632 ,["coords"]= {{ 40.4 ,75.4 } ,{40.6,75.4},{40.8,74.2},{40.8,75.6},{42,74.4},{42,74.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Zuldazar"              ,["zoneID"]=862  ,["name" ]= "Savagelands Devilsaur"     ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=82974 ,["id"]=139706 ,["coords"]= {{ 69   ,31.4 } ,{69.6,33.2},{69.6,36.8},{70.2,34.2},{70.4,35},{70.8,35},{71,34.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                } } ,
{["zone_name"]="Zuldazar"              ,["zoneID"]=862  ,["name" ]= "Pinky"                    ,["maxlevel" ]=120     , [ "minlevel" ]=111   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=76972 ,["id"]=126732 ,["coords"]= {{ 67.8 ,44.8 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="Zuldazar"              ,["zoneID"]=862  ,["name" ]= "Azuresail the Ancient"      ,["maxlevel" ]=120     , [ "minlevel" ]=115   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={288 ,"Lizard"       },["familySkills"]=LIZARD_SKILLS        ,["displayID"]=76835 ,["id"]=135510 ,["coords"]= {{ 67   ,26.4 } ,{67,26.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Zuldazar"              ,["zoneID"]=862  ,["name" ]= "Kil'Tawan"                ,["maxlevel" ]=120     , [ "minlevel" ]=115   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={138 ,"Direhorn"     },["familySkills"]=DIREHORN_SKILLS      ,["displayID"]=47236 ,["id"]=135508 ,["coords"]= {{ 69   ,30.8 } ,{69.2,30.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Zuldazar"              ,["zoneID"]=862  ,["name" ]= "Sabertusk Empress"         ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={288 ,"Lizard"       },["familySkills"]=LIZARD_SKILLS        ,["displayID"]=86802 ,["id"]=129323 ,["coords"]= {{ 46.8 ,56.2 } ,{52.2,47.4},{52.2,47.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Zuldazar"              ,["zoneID"]=862  ,["name" ]= "Prime Thumpknuckle"        ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={9   ,"Gorilla"      },["familySkills"]=GORILLA_SKILLS       ,["displayID"]=3186  ,["id"]=136334 ,["coords"]= {{ 47.4 ,34.2 } ,{52.4,44.4},{52.4,45.2},{52.6,45},{52.8,43.4},{52.8,43.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Zuldazar"              ,["zoneID"]=862  ,["name" ]= "Nol'ixwan"                ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={138 ,"Direhorn"     },["familySkills"]=DIREHORN_SKILLS      ,["displayID"]=47819 ,["id"]=130741 ,["coords"]= {{ 61.4 ,25.4 } ,{61.6,25.2},{61.6,25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="Zuldazar"              ,["zoneID"]=862  ,["name" ]= "Ji'arak Broodling"         ,["maxlevel" ]=122     , [ "minlevel" ]=113   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={290 ,"Pterrordax"   },["familySkills"]=PTERRORDAXE_SKILLS   ,["displayID"]=76910 ,["id"]=132653 ,["coords"]= {{ 69.4 ,33.4 } ,{69.4,33.8},{69.6,33.4},{69.6,33.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="Nazmir"                ,["zoneID"]=863  ,["name" ]= "Monstrous Pterrordax"      ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={290 ,"Pterrordax"   },["familySkills"]=PTERRORDAXE_SKILLS   ,["displayID"]=82392 ,["id"]=139493 ,["coords"]= {{ 28.4 ,92.8 } ,{28.4,93.8},{28.8,94}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            } } ,
{["zone_name"]="Nazmir"                ,["zoneID"]=863  ,["name" ]= "Gruesh"                   ,["maxlevel" ]=120     , [ "minlevel" ]=111   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={39  ,"Devilsaur"    },["familySkills"]=DEVILSAUR_SKILLS     ,["displayID"]=79823 ,["id"]=128051 ,["coords"]= {{ 48.6 ,24   } ,{48.8,26},{50,21},{51,22.2},{51.2,20.8},{51.4,19.6},{52,23.8},{52.2,23.2},{52.4,19.4},{52.4,19.6},{52.4,21},{52.4,22.4},{52.6,22.2},{52.8,19.4},{53,21},{53.2,23.2},{53.4,17.4},{53.4,18.4},{53.4,19.6},{53.6,17.8},{53.6,18.6},{53.6,19.8},{53.6,21.2},{53.6,22},{54.8,19.8},{55.2,22.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="Nazmir"                ,["zoneID"]=863  ,["name" ]= "Makatau"                  ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={290 ,"Pterrordax"   },["familySkills"]=PTERRORDAXE_SKILLS   ,["displayID"]=76656 ,["id"]=143898 ,["coords"]= {{ 23   ,68.6 } ,{23.2,70},{23.2,71.2},{23.2,71.8},{23.2,72.6},{23.6,68.8},{23.6,73},{23.8,69.8},{24,71.4},{24,71.6},{24.4,74.2},{24.4,75},{24.6,69.4},{24.8,72.4},{24.8,72.6},{25,70.6},{25.4,69.8},{25.4,74.8},{25.6,69.8},{25.6,70.8},{25.6,71.8},{25.8,75.2},{26,75.6},{26.2,73.2},{26.4,73.8},{26.6,75.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="Nazmir"                ,["zoneID"]=863  ,["name" ]= "Zulajin"                  ,["maxlevel" ]=120     , [ "minlevel" ]=112   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={11  ,"Raptor"       },["familySkills"]=RAPTOR_SKILLS        ,["displayID"]=82053 ,["id"]=134436 ,["coords"]= {{ 25   ,52   } ,{25.8,51.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Nazmir"                ,["zoneID"]=863  ,["name" ]= "Tojek"                    ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={138 ,"Direhorn"     },["familySkills"]=DIREHORN_SKILLS      ,["displayID"]=47236 ,["id"]=136381 ,["coords"]= {{ 26.4 ,65.4 } ,{26.4,65.6},{26.4,66.6},{26.6,65.4},{26.6,65.6},{26.8,67.6},{27,67},{27.6,67.4},{27.6,67.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Vol'dun"               ,["zoneID"]=864  ,["name" ]= "Sevriss"                  ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={35  ,"Serpent"      },["familySkills"]=SERPENT_SKILLS       ,["displayID"]=78251 ,["id"]=136593 ,["coords"]= {{ 39.4 ,59.2 } ,{39.8,59.4},{40.2,59.6},{40.8,58.8},{41.2,59.6},{41.4,58.4},{41.6,58.2},{41.6,58.6},{42.8,58}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    } } ,
{["zone_name"]="TiragardeSound"        ,["zoneID"]=895  ,["name" ]= "Old Frostclaw"             ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={4   ,"Bear"         },["familySkills"]=BEAR_SKILLS          ,["displayID"]=20827 ,["id"]=128093 ,["coords"]= {{ 79.4 ,65.6 } ,{79.8,65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="TiragardeSound"        ,["zoneID"]=895  ,["name" ]= "Wild Gryphon"              ,["maxlevel" ]=120     , [ "minlevel" ]=111   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={160 ,"Feathermane"  },["familySkills"]=FEATHERMANES_SKILLS  ,["displayID"]=82019 ,["id"]=129001 ,["coords"]= {{ 43.4 ,23.4 } ,{43.4,23.6},{44,22},{44,23.2},{44.2,19},{44.2,21.2},{44.6,21.2},{44.6,22},{44.8,20.2},{45.2,18.6},{45.2,22.8},{45.8,21.2},{45.8,22.6},{46,17.8},{46.2,20.4},{46.4,18.8},{47,20},{47.6,17.2},{48.8,18.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } } ,
{["zone_name"]="TiragardeSound"        ,["zoneID"]=895  ,["name" ]= "Wild Gryphon"              ,["maxlevel" ]=120     , [ "minlevel" ]=120   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={160 ,"Feathermane"  },["familySkills"]=FEATHERMANES_SKILLS  ,["displayID"]=81338 ,["id"]=140433 ,["coords"]= {{ 42.4 ,22.6 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,
{["zone_name"]="TiragardeSound"        ,["zoneID"]=895  ,["name" ]= "The Hornet"                ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={44  ,"Wasp"         },["familySkills"]=WASP_SKILLS          ,["displayID"]=82379 ,["id"]=137450 ,["coords"]= {{ 47.2 ,18.2 } ,{47.6,18.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      } } ,
{["zone_name"]="Drustvar"              ,["zoneID"]=896  ,["name" ]= "The Rime Huntress"          ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={1   ,"Wolf"         },["familySkills"]=WOLF_SKILLS          ,["displayID"]=84897 ,["id"]=136697 ,["coords"]= {{ 42.4 ,43.4 } ,{42.4,43.6},{43,42.6},{43.4,42.4},{43.6,42.2},{44,41.2},{44.4,40.2},{45,39.6},{45.2,39.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="StormsongValley"       ,["zoneID"]=942  ,["name" ]= "Thundersnout"             ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={51  ,"Monkey"       },["familySkills"]=MONKEY_SKILLS        ,["displayID"]=52696 ,["id"]=135293 ,["coords"]= {{ 40.4 ,71.4 } ,{40.4,71.6},{40.6,71.4},{40.6,71.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              } } ,
{["zone_name"]="StormsongValley"       ,["zoneID"]=942  ,["name" ]= "Razorclaw Alpha"           ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={1   ,"Wolf"         },["familySkills"]=WOLF_SKILLS          ,["displayID"]=63016 ,["id"]=136417 ,["coords"]= {{ 28   ,79.4 } ,{28,79.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        } } ,
{["zone_name"]="TempleofSethraliss"    ,["zoneID"]=1038 ,["name" ]= "Sand-crustedStriker"      ,["maxlevel" ]=120     , [ "minlevel" ]=110   ,["info" ]= "" ,["class" ]= CLASS_ELITE,["family"]={35  ,"Serpent"      },["familySkills"]=SERPENT_SKILLS       ,["displayID"]=78247 ,["id"]=134390 ,["coords"]= {{ 42.9 ,51.2 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   } } ,

  
  --Stable Masters
{["zone_name"] = "Dun Morogh"                ,[ "zoneID" ] =27   ,["name"]="Shelby Stoneflint"               ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9253  ,["id"]=9980   ,["react"]={    1,-1 }	,[ "coords"]= {{ 54    ,51    }}} ,
{["zone_name"] = "Duskwood"                  ,[ "zoneID" ] =47   ,["name"]="Steven Black"                    ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=10062 ,["id"]=10062  ,["react"]={    1,-1 }	,[ "coords"]= {{ 74    ,46.2  }}} ,
{["zone_name"] = "Nazjatar"                  ,[ "zoneID" ] =1355 ,["name"]="Tamer Orami"                     ,["maxlevel"]=120 ,["minlevel"]=120 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=92566 ,["id"]=155941 ,["react"]={    1,-1 }	,[ "coords"]= {{ 39.4  ,55.4  }}} ,
{["zone_name"] = "Nazjatar"                  ,[ "zoneID" ] =1355 ,["name"]="Lily Bopip"                      ,["maxlevel"]=120 ,["minlevel"]=120 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=90579 ,["id"]=151352 ,["react"]={    1,1  }	,[ "coords"]= {{ 47.4  ,62    }}} ,
{["zone_name"] = "Mechagon"                  ,[ "zoneID" ] =1462 ,["name"]="Vera Lonelycog"                  ,["maxlevel"]=120 ,["minlevel"]=120 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=90823 ,["id"]=150629 ,["react"]={    1,1  }	,[ "coords"]= {{ 69.2  ,30.4  }}} ,
{["zone_name"] = "Uldum"                     ,[ "zoneID" ] =1527 ,["name"]="Darwishi"                        ,["maxlevel"]=120 ,["minlevel"]=120 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=35929 ,["id"]=164249 ,["react"]={    1,1  }	,[ "coords"]= {{ 54.6  ,33.8  }}} ,
{["zone_name"] = "Wetlands"                  ,[ "zoneID" ] =56   ,["name"]="Salustred"                       ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9275  ,["id"]=43994  ,["react"]={    1,-1 }	,[ "coords"]= {{ 57.6  ,40.2  }}} ,
{["zone_name"] = "Wetlands"                  ,[ "zoneID" ] =56   ,["name"]="Bethaine Flinthammer"            ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9264  ,["id"]=10046  ,["react"]={    1,-1 }	,[ "coords"]= {{ 10.4  ,59.4  }}} ,
{["zone_name"] = "Elwynn Forest"             ,[ "zoneID" ] =37   ,["name"]="Erma"                            ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9257  ,["id"]=6749   ,["react"]={    1,-1 }	,[ "coords"]= {{ 42.8  ,65.8  }}} ,
{["zone_name"] = "Silverpine Forest"         ,[ "zoneID" ] =21   ,["name"]="Sarah Goode"                     ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9251  ,["id"]=9979   ,["react"]={-   1,1  }	,[ "coords"]= {{ 46    ,42.4  }}} ,
{["zone_name"] = "Silverpine Forest"         ,[ "zoneID" ] =21   ,["name"]="\"Salty\" Rocka"                 ,["maxlevel"]=60  ,["minlevel"]=14  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=34616 ,["id"]=45498  ,["react"]={-   1,1  }	,[ "coords"]= {{ 44.4  ,20.8  }}} ,
{["zone_name"] = "Silithus"                  ,[ "zoneID" ] =81   ,["name"]="Squire Leoren Mal'derath"        ,["maxlevel"]=60  ,["minlevel"]=57  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=15685 ,["id"]=15722  ,["react"]={    1,1  }	,[ "coords"]= {{ 53.2  ,34.4  }}} ,
{["zone_name"] = "Durotar"                   ,[ "zoneID" ] =1    ,["name"]="Shoja'my"                        ,["maxlevel"]=20  ,["minlevel"]=10  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9262  ,["id"]=9987   ,["react"]={-   1,1  }	,[ "coords"]= {{ 52    ,41.8  }}} ,
{["zone_name"] = "Darkshore"                 ,[ "zoneID" ] =62   ,["name"]="Jaelysia"                        ,["maxlevel"]=60  ,["minlevel"]=19  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9294  ,["id"]=10085  ,["react"]={    1,-1 }	,[ "coords"]= {{ 50.4  ,19.2  }}} ,
{["zone_name"] = "Undercity"                 ,[ "zoneID" ] =998  ,["name"]="Anya Maulray"                    ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9273  ,["id"]=10053  ,["react"]={-   1,1  }	,[ "coords"]= {{ 66.8  ,38.6  }}} ,
{["zone_name"] = "Dustwallow Marsh"          ,[ "zoneID" ] =70   ,["name"]="Michael"                         ,["maxlevel"]=60  ,["minlevel"]=49  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9266  ,["id"]=10047  ,["react"]={    1,-1 }	,[ "coords"]= {{ 65.8  ,45.4  }}} ,
{["zone_name"] = "Stormwind City"            ,[ "zoneID" ] =84   ,["name"]="Karin"                           ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33756 ,["id"]=44252  ,["react"]={    1,-1 }	,[ "coords"]= {{ 77.8  ,67.2  }}} ,
{["zone_name"] = "Stormwind City"            ,[ "zoneID" ] =84   ,["name"]="Jenova Stoneshield"              ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=10477 ,["id"]=11069  ,["react"]={    1,-1 }	,[ "coords"]= {{ 67    ,37.4  }}} ,
{["zone_name"] = "Stormwind City"            ,[ "zoneID" ] =84   ,["name"]="Ashlee Umberleaf"                ,["maxlevel"]=110 ,["minlevel"]=110 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=82897 ,["id"]=133408 ,["react"]={    1,nil}	,[ "coords"]= {{ 53.4  ,12.6  }}} ,
{["zone_name"] = "Stormwind City"            ,[ "zoneID" ] =84   ,["name"]="Sylista"                         ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9249  ,["id"]=9977   ,["react"]={    1,nil}	,[ "coords"]= {{ 42.4  ,60.8  }}} ,
{["zone_name"] = "Ironforge"                 ,[ "zoneID" ] =87   ,["name"]="Ulbrek Firehand"                 ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9258  ,["id"]=9984   ,["react"]={    1,nil}	,[ "coords"]= {{ 69.4  ,84    }}} ,
{["zone_name"] = "Blackrock Depths"          ,[ "zoneID" ] =242  ,["name"]="Kasea Angerforge"                ,["maxlevel"]=120 ,["minlevel"]=120 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=88363 ,["id"]=144119 ,["react"]={    1,nil}	,[ "coords"]= {{ 47.6  ,47.2  }}} ,
{["zone_name"] = "Orgrimmar"                 ,[ "zoneID" ] =85   ,["name"]="Murog"                           ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=35816 ,["id"]=47764  ,["react"]={-   1,1  }	,[ "coords"]= {{ 62.6  ,35.4  }}} ,
{["zone_name"] = "Orgrimmar"                 ,[ "zoneID" ] =85   ,["name"]="Bezzil"                          ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=34673 ,["id"]=45789  ,["react"]={nil,1    }	,[ "coords"]= {{ 40.8  ,80.4  }}} ,
{["zone_name"] = "Orgrimmar"                 ,[ "zoneID" ] =85   ,["name"]="Lonto"                           ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=34111 ,["id"]=44788  ,["react"]={-   1,1  }	,[ "coords"]= {{ 39.4  ,49.2  }}} ,
{["zone_name"] = "Orgrimmar"                 ,[ "zoneID" ] =85   ,["name"]="Xon'cha"                         ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9261  ,["id"]=9988   ,["react"]={nil,1    }	,[ "coords"]= {{ 32.4  ,64.4  }}} ,
{["zone_name"] = "Orgrimmar"                 ,[ "zoneID" ] =85   ,["name"]="Hern Cragfeather"                ,["maxlevel"]=110 ,["minlevel"]=110 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=82725 ,["id"]=133108 ,["react"]={nil,1    }	,[ "coords"]= {{ 38    ,86.8  }}} ,
{["zone_name"] = "Thunder Bluff"             ,[ "zoneID" ] =88   ,["name"]="Bulrug"                          ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9272  ,["id"]=10054  ,["react"]={-   1,1  }	,[ "coords"]= {{ 44.8  ,60.6  }}} ,
{["zone_name"] = "Darnassus"                 ,[ "zoneID" ] =89   ,["name"]="Alassin"                         ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9275  ,["id"]=10056  ,["react"]={    1,nil}	,[ "coords"]= {{ 43.4  ,29.6  }}} ,
{["zone_name"] = "Northern Barrens"          ,[ "zoneID" ] =10   ,["name"]="Reggifuz"                        ,["maxlevel"]=60  ,["minlevel"]=20  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9286  ,["id"]=10063  ,["react"]={    1,1  }	,[ "coords"]= {{ 67.4  ,74.2  }}} ,
{["zone_name"] = "Northern Barrens"          ,[ "zoneID" ] =10   ,["name"]="Sikwa"                           ,["maxlevel"]=60  ,["minlevel"]=19  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9254  ,["id"]=9981   ,["react"]={-   1,1  }	,[ "coords"]= {{ 49    ,57.4  }}} ,
{["zone_name"] = "Northern Barrens"          ,[ "zoneID" ] =10   ,["name"]="Carthok"                         ,["maxlevel"]=60  ,["minlevel"]=21  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=38007 ,["id"]=43988  ,["react"]={-   1,1  }	,[ "coords"]= {{ 56.4  ,39.8  }}} ,
{["zone_name"] = "Northern Barrens"          ,[ "zoneID" ] =10   ,["name"]="Vernon Soursprye"                ,["maxlevel"]=60  ,["minlevel"]=27  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=37699 ,["id"]=43982  ,["react"]={-   1,1  }	,[ "coords"]= {{ 62.4  ,16.8  }}} ,
{["zone_name"] = "Icecrown"                  ,[ "zoneID" ] =118  ,["name"]="Moonbell"                        ,["maxlevel"]=75  ,["minlevel"]=75  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=29739 ,["id"]=35291  ,["react"]={    1,-1 }	,[ "coords"]= {{ 75.8  ,20.2  }}} ,
{["zone_name"] = "Hillsbrad Foothills"       ,[ "zoneID" ] =25   ,["name"]="Ansel Tunsleworth"               ,["maxlevel"]=52  ,["minlevel"]=52  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=36477 ,["id"]=49431  ,["react"]={-   1,1  }	,[ "coords"]= {{ 59.6  ,64.8  }}} ,
{["zone_name"] = "Hillsbrad Foothills"       ,[ "zoneID" ] =25   ,["name"]="Theodore Mont Claire"            ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9279  ,["id"]=10057  ,["react"]={-   1,1  }	,[ "coords"]= {{ 56.8  ,46.8  }}} ,
{["zone_name"] = "Western Plaguelands"       ,[ "zoneID" ] =22   ,["name"]="Lois Henderson"                  ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=35871 ,["id"]=47866  ,["react"]={-   1,1  }	,[ "coords"]= {{ 47.8  ,64    }}} ,
{["zone_name"] = "Badlands"                  ,[ "zoneID" ] =15   ,["name"]="Deedee Dropbolt"                 ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=36005 ,["id"]=48055  ,["react"]={    1,1  }	,[ "coords"]= {{ 65.4  ,36.4  }}} ,
{["zone_name"] = "Northern Stranglethorn"    ,[ "zoneID" ] =50   ,["name"]="Durik"                           ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=3519  ,["id"]=16094  ,["react"]={-   1,1  }	,[ "coords"]= {{ 38    ,51.2  }}} ,
{["zone_name"] = "Ashenvale"                 ,[ "zoneID" ] =63   ,["name"]="Vorcha"                          ,["maxlevel"]=60  ,["minlevel"]=20  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33441 ,["id"]=43634  ,["react"]={-   1,1  }	,[ "coords"]= {{ 50.2  ,65.8  }}} ,
{["zone_name"] = "Ashenvale"                 ,[ "zoneID" ] =63   ,["name"]="Lursa"                           ,["maxlevel"]=60  ,["minlevel"]=37  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33572 ,["id"]=43617  ,["react"]={-   1,1  }	,[ "coords"]= {{ 12.6  ,33.8  }}} ,
{["zone_name"] = "Ashenvale"                 ,[ "zoneID" ] =63   ,["name"]="Maluressian"                     ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9271  ,["id"]=10052  ,["react"]={    1,-1 }	,[ "coords"]= {{ 36.4  ,50.4  }}} ,
{["zone_name"] = "Ashenvale"                 ,[ "zoneID" ] =63   ,["name"]="Qeeju"                           ,["maxlevel"]=32  ,["minlevel"]=23  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=14773 ,["id"]=15131  ,["react"]={-   1,1  }	,[ "coords"]= {{ 73.2  ,60.6  }}} ,
{["zone_name"] = "Ashenvale"                 ,[ "zoneID" ] =63   ,["name"]="Drek"                            ,["maxlevel"]=60  ,["minlevel"]=49  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=31438 ,["id"]=43630  ,["react"]={-   1,1  }	,[ "coords"]= {{ 38.6  ,42.4  }}} ,
{["zone_name"] = "Ghostlands"                ,[ "zoneID" ] =95   ,["name"]="Paniar"                          ,["maxlevel"]=60  ,["minlevel"]=22  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=16821 ,["id"]=16665  ,["react"]={-   1,1  }	,[ "coords"]= {{ 48.4  ,31.2  }}} ,
{["zone_name"] = "Ghostlands"                ,[ "zoneID" ] =95   ,["name"]="Huntsman Torf Angerhoof"         ,["maxlevel"]=80  ,["minlevel"]=58  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=16303 ,["id"]=16586  ,["react"]={-   1,1  }	,[ "coords"]= {{ 54.4  ,41    }}} ,
{["zone_name"] = "Ghostlands"                ,[ "zoneID" ] =95   ,["name"]="Master Sergeant Lorin Thalmerok" ,["maxlevel"]=80  ,["minlevel"]=58  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=16367 ,["id"]=16824  ,["react"]={    1,-1 }	,[ "coords"]= {{ 54.4  ,62.6  }}} ,
{["zone_name"] = "Silvermoon City"           ,[ "zoneID" ] =110  ,["name"]="Shalenn"                         ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=16751 ,["id"]=16656  ,["react"]={-   1,1  }	,[ "coords"]= {{ 82.8  ,30.8  }}} ,
{["zone_name"] = "Terokkar Forest"           ,[ "zoneID" ] =108  ,["name"]="Leassian"                        ,["maxlevel"]=83  ,["minlevel"]=78  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=22730 ,["id"]=24905  ,["react"]={    1,-1 }	,[ "coords"]= {{ 56.8  ,53.8  }}} ,
{["zone_name"] = "Terokkar Forest"           ,[ "zoneID" ] =108  ,["name"]="Trag"                            ,["maxlevel"]=63  ,["minlevel"]=63  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=18415 ,["id"]=18984  ,["react"]={-   1,1  }	,[ "coords"]= {{ 49.4  ,44.6  }}} ,
{["zone_name"] = "Shadowmoon Valley"         ,[ "zoneID" ] =104  ,["name"]="Crinn Pathfinder"                ,["maxlevel"]=65  ,["minlevel"]=65  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=18777 ,["id"]=19368  ,["react"]={    1,nil}	,[ "coords"]= {{ 37.4  ,56    }}} ,
{["zone_name"] = "Shadowmoon Valley"         ,[ "zoneID" ] =104  ,["name"]="Gedrah"                          ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=20228 ,["id"]=21336  ,["react"]={nil,1    }	,[ "coords"]= {{ 29.2  ,29.4  }}} ,
{["zone_name"] = "Zangarmarsh"               ,[ "zoneID" ] =102  ,["name"]="Joraal"                          ,["maxlevel"]=80  ,["minlevel"]=65  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17637 ,["id"]=18250  ,["react"]={    1,-1 }	,[ "coords"]= {{ 67.6  ,49.6  }}} ,
{["zone_name"] = "Zangarmarsh"               ,[ "zoneID" ] =102  ,["name"]="Khalan"                          ,["maxlevel"]=81  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17631 ,["id"]=18244  ,["react"]={-   1,1  }	,[ "coords"]= {{ 31.8  ,49.8  }}} ,
{["zone_name"] = "Zangarmarsh"               ,[ "zoneID" ] =102  ,["name"]="Kameel Longstride"               ,["maxlevel"]=81  ,["minlevel"]=61  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17319 ,["id"]=17896  ,["react"]={    1,1  }	,[ "coords"]= {{ 78.8  ,64.2  }}} ,
{["zone_name"] = "Blade's Edge Mountains"    ,[ "zoneID" ] =105  ,["name"]="Lor"                             ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=18915 ,["id"]=19476  ,["react"]={nil,1    }	,[ "coords"]= {{ 53.4  ,53.2  }}} ,
{["zone_name"] = "Netherstorm"               ,[ "zoneID" ] =109  ,["name"]="Liza Cutlerflix"                 ,["maxlevel"]=66  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=22780 ,["id"]=24974  ,["react"]={    1,1  }	,[ "coords"]= {{ 32    ,64.8  }}} ,
{["zone_name"] = "Borean Tundra"             ,[ "zoneID" ] =114  ,["name"]="Durkot Wolfbrother"              ,["maxlevel"]=80  ,["minlevel"]=59  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=23502 ,["id"]=26044  ,["react"]={-   1,1  }	,[ "coords"]= {{ 40.2  ,55    }}} ,
{["zone_name"] = "Borean Tundra"             ,[ "zoneID" ] =114  ,["name"]="Toby \"Mother Goose\" Ironbolt"  ,["maxlevel"]=80  ,["minlevel"]=62  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=23957 ,["id"]=26597  ,["react"]={    1,-1 }	,[ "coords"]= {{ 57    ,19    }}} ,
{["zone_name"] = "Borean Tundra"             ,[ "zoneID" ] =114  ,["name"]="Celidh Aletracker"               ,["maxlevel"]=75  ,["minlevel"]=58  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=24298 ,["id"]=27010  ,["react"]={    1,-1 }	,[ "coords"]= {{ 58.4  ,68.4  }}} ,
{["zone_name"] = "Borean Tundra"             ,[ "zoneID" ] =114  ,["name"]="Arthaid"                         ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17217 ,["id"]=16764  ,["react"]={    1,nil}	,[ "coords"]= {{ 59.8  ,24.2  }}} ,
{["zone_name"] = "Feralas"                   ,[ "zoneID" ] =69   ,["name"]="Antarius"                        ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9282  ,["id"]=10059  ,["react"]={    1,-1 }	,[ "coords"]= {{ 46.8  ,45.4  }}} ,
{["zone_name"] = "Feralas"                   ,[ "zoneID" ] =69   ,["name"]="Shyrka Wolfrunner"               ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9260  ,["id"]=9986   ,["react"]={nil,1    }	,[ "coords"]= {{ 74.4  ,43.2  }}} ,
{["zone_name"] = "Felwood"                   ,[ "zoneID" ] =77   ,["name"]="Hurah"                           ,["maxlevel"]=60  ,["minlevel"]=55  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17319 ,["id"]=48216  ,["react"]={    1,1  }	,[ "coords"]= {{ 44.4  ,28.4  }}} ,
{["zone_name"] = "Felwood"                   ,[ "zoneID" ] =77   ,["name"]="Nalesette Wildbringer"           ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=12749 ,["id"]=543    ,["react"]={    1,-1 }	,[ "coords"]= {{ 61.4  ,25.4  }}} ,
{["zone_name"] = "Shattrath City"            ,[ "zoneID" ] =111  ,["name"]="Ilthuril"                        ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=16706 ,["id"]=21517  ,["react"]={    1,1  }	,[ "coords"]= {{ 55.4  ,80.2  }}} ,
{["zone_name"] = "Shattrath City"            ,[ "zoneID" ] =111  ,["name"]="Oruhe"                           ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17327 ,["id"]=21518  ,["react"]={    1,1  }	,[ "coords"]= {{ 28.4  ,47.4  }}} ,
{["zone_name"] = "Sholazar Basin"            ,[ "zoneID" ] =119  ,["name"]="Hadrius Harlowe"                 ,["maxlevel"]=80  ,["minlevel"]=66  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=25068 ,["id"]=28047  ,["react"]={    1,1  }	,[ "coords"]= {{ 27.2  ,59.4  }}} ,
{["zone_name"] = "Loch Modan"                ,[ "zoneID" ] =48   ,["name"]="Gravin Steelbeard"               ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33596 ,["id"]=43979  ,["react"]={    1,-1 }	,[ "coords"]= {{ 83.8  ,62.4  }}} ,
{["zone_name"] = "Loch Modan"                ,[ "zoneID" ] =48   ,["name"]="Lina Hearthstove"                ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9263  ,["id"]=9989   ,["react"]={    1,-1 }	,[ "coords"]= {{ 34.4  ,48    }}} ,
{["zone_name"] = "Grizzly Hills"             ,[ "zoneID" ] =116  ,["name"]="Craga Ironsting"                 ,["maxlevel"]=80  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=26471 ,["id"]=29740  ,["react"]={nil,1    }	,[ "coords"]= {{ 21.6  ,64    }}} ,
{["zone_name"] = "Grizzly Hills"             ,[ "zoneID" ] =116  ,["name"]="Squire Percy"                    ,["maxlevel"]=9   ,["minlevel"]=9   ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=23796 ,["id"]=26377  ,["react"]={    1,nil}	,[ "coords"]= {{ 59    ,26.4  }}} ,
{["zone_name"] = "Grizzly Hills"             ,[ "zoneID" ] =116  ,["name"]="Matthew Ackerman"                ,["maxlevel"]=70  ,["minlevel"]=70  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=24277 ,["id"]=27068  ,["react"]={    1,-1 }	,[ "coords"]= {{ 32.4  ,59.6  }}} ,
{["zone_name"] = "Grizzly Hills"             ,[ "zoneID" ] =116  ,["name"]="Soulok Stormfury"                ,["maxlevel"]=80  ,["minlevel"]=66  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=24184 ,["id"]=26944  ,["react"]={-   1,1  }	,[ "coords"]= {{ 65    ,47.8  }}} ,
{["zone_name"] = "Blasted Lands"             ,[ "zoneID" ] =17   ,["name"]="Gina Gellar"                     ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33812 ,["id"]=44330  ,["react"]={    1,-1 }	,[ "coords"]= {{ 60.2  ,16    }}} ,
{["zone_name"] = "Blasted Lands"             ,[ "zoneID" ] =17   ,["name"]="Willard C. Bennington"           ,["maxlevel"]=63  ,["minlevel"]=63  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33808 ,["id"]=44335  ,["react"]={    1,-1 }	,[ "coords"]= {{ 46    ,85.4  }}} ,
{["zone_name"] = "Blasted Lands"             ,[ "zoneID" ] =17   ,["name"]="Kroff"                           ,["maxlevel"]=65  ,["minlevel"]=65  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33822 ,["id"]=44310  ,["react"]={-   1,1  }	,[ "coords"]= {{ 41.4  ,12.8  }}} ,
{["zone_name"] = "Westfall"                  ,[ "zoneID" ] =52   ,["name"]="Kirk Maxwell"                    ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9265  ,["id"]=10045  ,["react"]={    1,-1 }	,[ "coords"]= {{ 53    ,53    }}} ,
{["zone_name"] = "Desolace"                  ,[ "zoneID" ] =66   ,["name"]="Shelgrayn"                       ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=10567 ,["id"]=11104  ,["react"]={    1,-1 }	,[ "coords"]= {{ 65.4  ,7.8   }}} ,
{["zone_name"] = "Desolace"                  ,[ "zoneID" ] =66   ,["name"]="Fina Stillgrove"                 ,["maxlevel"]=60  ,["minlevel"]=35  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33562 ,["id"]=43877  ,["react"]={    1,1  }	,[ "coords"]= {{ 57    ,49.4  }}} ,
{["zone_name"] = "Stonetalon Mountains"      ,[ "zoneID" ] =65   ,["name"]="Adrius"                          ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9282  ,["id"]=43021  ,["react"]={    1,-1 }	,[ "coords"]= {{ 58.4  ,56.6  }}} ,
{["zone_name"] = "Dalaran"                   ,[ "zoneID" ] =125  ,["name"]="Tassia Whisperglen"              ,["maxlevel"]=75  ,["minlevel"]=75  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=25607 ,["id"]=28690  ,["react"]={    1,1  }	,[ "coords"]= {{ 59.4  ,37.4  }}} ,
{["zone_name"] = "Redridge Mountains"        ,[ "zoneID" ] =49   ,["name"]="Penny"                           ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9255  ,["id"]=9982   ,["react"]={    1,-1 }	,[ "coords"]= {{ 26.2  ,43    }}} ,
{["zone_name"] = "Tanaris"                   ,[ "zoneID" ] =71   ,["name"]="Laziphus"                        ,["maxlevel"]=60  ,["minlevel"]=50  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9259  ,["id"]=9985   ,["react"]={    1,1  }	,[ "coords"]= {{ 52.6  ,27.4  }}} ,
{["zone_name"] = "Arathi Highlands"          ,[ "zoneID" ] =14   ,["name"]="Emily Jackson"                   ,["maxlevel"]=60  ,["minlevel"]=32  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33685 ,["id"]=44123  ,["react"]={    1,-1 }	,[ "coords"]= {{ 40    ,49    }}} ,
{["zone_name"] = "Arathi Highlands"          ,[ "zoneID" ] =14   ,["name"]="Tharlidun"                       ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9250  ,["id"]=9976   ,["react"]={-   1,1  }	,[ "coords"]= {{ 69    ,34    }}} ,
{["zone_name"] = "The Hinterlands"           ,[ "zoneID" ] =26   ,["name"]="Huntsman Markhor"                ,["maxlevel"]=45  ,["minlevel"]=45  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=28263 ,["id"]=14741  ,["react"]={-   1,1  }	,[ "coords"]= {{ 79    ,79.4  }}} ,
{["zone_name"] = "The Hinterlands"           ,[ "zoneID" ] =26   ,["name"]="Roslyn Paxton"                   ,["maxlevel"]=60  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33502 ,["id"]=43766  ,["react"]={-   1,1  }	,[ "coords"]= {{ 31.8  ,57.4  }}} ,
{["zone_name"] = "The Hinterlands"           ,[ "zoneID" ] =26   ,["name"]="Tathan Thunderstone"             ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33504 ,["id"]=43770  ,["react"]={    1,-1 }	,[ "coords"]= {{ 66.4  ,45    }}} ,
{["zone_name"] = "The Hinterlands"           ,[ "zoneID" ] =26   ,["name"]="Killium Bouldertoe"              ,["maxlevel"]=60  ,["minlevel"]=36  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9283  ,["id"]=10061  ,["react"]={    1,-1 }	,[ "coords"]= {{ 14.4  ,45.2  }}} ,
{["zone_name"] = "Southern Barrens"          ,[ "zoneID" ] =199  ,["name"]="Munada"                          ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33801 ,["id"]=44349  ,["react"]={-   1,1  }	,[ "coords"]= {{ 39.2  ,19.8  }}} ,
{["zone_name"] = "Southern Barrens"          ,[ "zoneID" ] =199  ,["name"]="Werner Eastbrook"                ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33798 ,["id"]=44347  ,["react"]={    1,-1 }	,[ "coords"]= {{ 49    ,68.2  }}} ,
{["zone_name"] = "Southern Barrens"          ,[ "zoneID" ] =199  ,["name"]="Grantor"                         ,["maxlevel"]=60  ,["minlevel"]=32  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33803 ,["id"]=44354  ,["react"]={-   1,1  }	,[ "coords"]= {{ 40.8  ,69.6  }}} ,
{["zone_name"] = "Twilight Highlands"        ,[ "zoneID" ] =241  ,["name"]="Matthew Churchill"               ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=36986 ,["id"]=49600  ,["react"]={    1,-1 }	,[ "coords"]= {{ 43.6  ,57.4  }}} ,
{["zone_name"] = "Twilight Highlands"        ,[ "zoneID" ] =241  ,["name"]="Zay'hana"                        ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=37003 ,["id"]=49755  ,["react"]={-   1,1  }	,[ "coords"]= {{ 45.2  ,76.4  }}} ,
{["zone_name"] = "Howling Fjord"             ,[ "zoneID" ] =117  ,["name"]="Horatio the Stable Boy"          ,["maxlevel"]=10  ,["minlevel"]=10  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=338   ,["id"]=23733  ,["react"]={    1,nil}	,[ "coords"]= {{ 58.6  ,63    }}} ,
{["zone_name"] = "Howling Fjord"             ,[ "zoneID" ] =117  ,["name"]="Mary Darrow"                     ,["maxlevel"]=80  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=22165 ,["id"]=24154  ,["react"]={nil,1    }	,[ "coords"]= {{ 52    ,66.6  }}} ,
{["zone_name"] = "Howling Fjord"             ,[ "zoneID" ] =117  ,["name"]="Mahana Frosthoof"                ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=22052 ,["id"]=24067  ,["react"]={nil,1    }	,[ "coords"]= {{ 49.4  ,11    }}} ,
{["zone_name"] = "Howling Fjord"             ,[ "zoneID" ] =117  ,["name"]="Robert Clarke"                   ,["maxlevel"]=80  ,["minlevel"]=58  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=22333 ,["id"]=24350  ,["react"]={nil,1    }	,[ "coords"]= {{ 79    ,30.8  }}} ,
{["zone_name"] = "Uldum"                     ,[ "zoneID" ] =249  ,["name"]="Farah Tamina"                    ,["maxlevel"]=90  ,["minlevel"]=83  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=36486 ,["id"]=49408  ,["react"]={    1,1  }	,[ "coords"]= {{ 26.8  ,7.4   }}} ,
{["zone_name"] = "Deepholm"                  ,[ "zoneID" ] =207  ,["name"]="Mule Driver Ironshod"            ,["maxlevel"]=90  ,["minlevel"]=82  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=34393 ,["id"]=45298  ,["react"]={    1,-1 }	,[ "coords"]= {{ 47.4  ,51.4  }}} ,
{["zone_name"] = "Searing Gorge"             ,[ "zoneID" ] =32   ,["name"]="Karn Cragcare"                   ,["maxlevel"]=50  ,["minlevel"]=50  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=35913 ,["id"]=47934  ,["react"]={    1,1  }	,[ "coords"]= {{ 40.6  ,68.4  }}} ,
{["zone_name"] = "Abyssal Depths"            ,[ "zoneID" ] =204  ,["name"]="Shurrak"                         ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33247 ,["id"]=43151  ,["react"]={-   1,1  }	,[ "coords"]= {{ 53    ,59.2  }}} ,
{["zone_name"] = "The Cape of Stranglethorn" ,[ "zoneID" ] =210  ,["name"]="Grimestack"                      ,["maxlevel"]=46  ,["minlevel"]=46  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9284  ,["id"]=10060  ,["react"]={    1,1  }	,[ "coords"]= {{ 41.4  ,73.4  }}} ,
{["zone_name"] = "The Cape of Stranglethorn" ,[ "zoneID" ] =210  ,["name"]="Finzy Watchwoozle"               ,["maxlevel"]=35  ,["minlevel"]=35  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33714 ,["id"]=44191  ,["react"]={-   1,1  }	,[ "coords"]= {{ 34.8  ,27.4  }}} ,
{["zone_name"] = "The Jade Forest"           ,[ "zoneID" ] =371  ,["name"]="Hong the Kindly"                 ,["maxlevel"]=90  ,["minlevel"]=84  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44904 ,["id"]=66241  ,["react"]={    1,1  }	,[ "coords"]= {{ 46.4  ,43.8  }}} ,
{["zone_name"] = "The Jade Forest"           ,[ "zoneID" ] =371  ,["name"]="Cheung"                          ,["maxlevel"]=90  ,["minlevel"]=81  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44959 ,["id"]=66266  ,["react"]={    1,nil}	,[ "coords"]= {{ 44.6  ,84.8  }}} ,
{["zone_name"] = "The Jade Forest"           ,[ "zoneID" ] =371  ,["name"]="Su Mi"                           ,["maxlevel"]=90  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44886 ,["id"]=66230  ,["react"]={-   1,1  }	,[ "coords"]= {{ 28.6  ,13    }}} ,
{["zone_name"] = "Valley of the Four Winds"  ,[ "zoneID" ] =376  ,["name"]="Little Tib"                      ,["maxlevel"]=90  ,["minlevel"]=85  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=43256 ,["id"]=66242  ,["react"]={    1,1  }	,[ "coords"]= {{ 83.8  ,21.8  }}} ,
{["zone_name"] = "Valley of the Four Winds"  ,[ "zoneID" ] =376  ,["name"]="Su the Tamer"                    ,["maxlevel"]=90  ,["minlevel"]=84  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44906 ,["id"]=66244  ,["react"]={    1,1  }	,[ "coords"]= {{ 55.2  ,49.4  }}} ,
--{["zone_name"] = "Vale of Eternal Blossoms"  ,[ "zoneID" ] =390  ,["name"]="Tracker Lang"                    ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=43410 ,["id"]=63986  ,["react"]={-   1,1  }	,[ "coords"]= {{ 60.4  ,22.6  }}} ,
--{["zone_name"] = "Vale of Eternal Blossoms"  ,[ "zoneID" ] =390  ,["name"]="Jaul Hsu"                        ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44171 ,["id"]=63988  ,["react"]={    1,-1 }	,[ "coords"]= {{ 84.6  ,63.2  }}} ,
--{["zone_name"] = "Vale of Eternal Blossoms"  ,[ "zoneID" ] =390  ,["name"]="Mount-Haver Nik Nik"             ,["maxlevel"]=90  ,["minlevel"]=85  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44907 ,["id"]=66245  ,["react"]={    1,1  }	,[ "coords"]= {{ 36    ,75.2  }}} ,
{["zone_name"] = "Vale of Eternal Blossoms"  ,[ "zoneID" ] =1530  ,["name"]="Tracker Lang"                    ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=43410 ,["id"]=63986  ,["react"]={-   1,1  }	,[ "coords"]= {{ 60.4  ,22.6  }}} ,
{["zone_name"] = "Vale of Eternal Blossoms"  ,[ "zoneID" ] =1530  ,["name"]="Jaul Hsu"                        ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44171 ,["id"]=63988  ,["react"]={    1,-1 }	,[ "coords"]= {{ 84.6  ,63.2  }}} ,
{["zone_name"] = "Vale of Eternal Blossoms"  ,[ "zoneID" ] =1530  ,["name"]="Mount-Haver Nik Nik"             ,["maxlevel"]=90  ,["minlevel"]=85  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44907 ,["id"]=66245  ,["react"]={    1,1  }	,[ "coords"]= {{ 36    ,75.2  }}} ,
{["zone_name"] = "Kun-Lai Summit"            ,[ "zoneID" ] =379  ,["name"]="Herder Muskfree"                 ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=40834 ,["id"]=59509  ,["react"]={    1,1  }	,[ "coords"]= {{ 65.4  ,61.4  }}} ,
{["zone_name"] = "Townlong Steppes"          ,[ "zoneID" ] =388  ,["name"]="Tigermaster Liu-Do"              ,["maxlevel"]=90  ,["minlevel"]=85  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44908 ,["id"]=66247  ,["react"]={    1,1  }	,[ "coords"]= {{ 74.8  ,81.2  }}} ,
{["zone_name"] = "Townlong Steppes"          ,[ "zoneID" ] =388  ,["name"]="Tigermistress Min-To"            ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44909 ,["id"]=66248  ,["react"]={    1,1  }	,[ "coords"]= {{ 50    ,71.4  }}} ,
{["zone_name"] = "Townlong Steppes"          ,[ "zoneID" ] =388  ,["name"]="Tigermaster Gai-Lin"             ,["maxlevel"]=90  ,["minlevel"]=89  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44908 ,["id"]=66246  ,["react"]={    1,1  }	,[ "coords"]= {{ 71.4  ,57.4  }}} ,
{["zone_name"] = "The Veiled Stair"          ,[ "zoneID" ] =433  ,["name"]="Kama the Beast Tamer"            ,["maxlevel"]=90  ,["minlevel"]=82  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=42795 ,["id"]=62935  ,["react"]={    1,1  }	,[ "coords"]= {{ 55.8  ,75.2  }}} ,
{["zone_name"] = "Dread Wastes"              ,[ "zoneID" ] =422  ,["name"]="Handler Kla'vik"                 ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44911 ,["id"]=66250  ,["react"]={    1,1  }	,[ "coords"]= {{ 53.6  ,32.4  }}} ,
{["zone_name"] = "Mount Hyjal"               ,[ "zoneID" ] =198  ,["name"]="Aili Greenwillow"                ,["maxlevel"]=90  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33357 ,["id"]=43408  ,["react"]={    1,1  }	,[ "coords"]= {{ 63.2  ,23    }}} ,
{["zone_name"] = "Mount Hyjal"               ,[ "zoneID" ] =198  ,["name"]="Limiah Whitebranch"              ,["maxlevel"]=82  ,["minlevel"]=82  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33336 ,["id"]=53780  ,["react"]={    1,1  }	,[ "coords"]= {{ 19.4  ,36.2  }}} ,
{["zone_name"] = "Mount Hyjal"               ,[ "zoneID" ] =198  ,["name"]="Oltarin Graycloud"               ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33387 ,["id"]=50069  ,["react"]={    1,1  }	,[ "coords"]= {{ 41.8  ,45    }}} ,
{["zone_name"] = "Winterspring"              ,[ "zoneID" ] =83   ,["name"]="Azzleby"                         ,["maxlevel"]=60  ,["minlevel"]=47  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=10656 ,["id"]=11119  ,["react"]={    1,1  }	,[ "coords"]= {{ 58.6  ,50.2  }}} ,
{["zone_name"] = "Dragonblight"              ,[ "zoneID" ] =115  ,["name"]="Garmin Herzog"                   ,["maxlevel"]=80  ,["minlevel"]=73  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=25079 ,["id"]=28057  ,["react"]={nil,1    }	,[ "coords"]= {{ 76.8  ,62.6  }}} ,
{["zone_name"] = "Dragonblight"              ,[ "zoneID" ] =115  ,["name"]="Sentinel Sweetspring"            ,["maxlevel"]=80  ,["minlevel"]=65  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=24261 ,["id"]=27056  ,["react"]={    1,-1 }	,[ "coords"]= {{ 28.8  ,56    }}} ,
{["zone_name"] = "Dragonblight"              ,[ "zoneID" ] =115  ,["name"]="Soar Hawkfury"                   ,["maxlevel"]=80  ,["minlevel"]=62  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=23874 ,["id"]=26504  ,["react"]={-   1,1  }	,[ "coords"]= {{ 37    ,48.4  }}} ,
{["zone_name"] = "zul'drak"                  ,[ "zoneID" ] =121  ,["name"]="Fala Softhoof"                   ,["maxlevel"]=80  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=25687 ,["id"]=28790  ,["react"]={    1,1  }	,[ "coords"]= {{ 40.2  ,65.2  }}} ,
{["zone_name"] = "zul'drak"                  ,[ "zoneID" ] =121  ,["name"]="Asgari"                          ,["maxlevel"]=80  ,["minlevel"]=75  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=26697 ,["id"]=30039  ,["react"]={    1,1  }	,[ "coords"]= {{ 59    ,57.6  }}} ,
{["zone_name"] = "Talador"                   ,[ "zoneID" ] =535  ,["name"]="Beastmaster Tagh"                ,["maxlevel"]=100 ,["minlevel"]=95  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=56081 ,["id"]=80833  ,["react"]={-   1,1  }	,[ "coords"]= {{ 70.8  ,29.6  }}} ,
{["zone_name"] = "Talador"                   ,[ "zoneID" ] =535  ,["name"]="Patrick Messer"                  ,["maxlevel"]=100 ,["minlevel"]=94  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=56083 ,["id"]=80854  ,["react"]={    1,nil}	,[ "coords"]= {{ 69.4  ,21.2  }}} ,
{["zone_name"] = "The Storm Peaks"           ,[ "zoneID" ] =120  ,["name"]="Andurg Slatechest"               ,["maxlevel"]=80  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=26091 ,["id"]=29959  ,["react"]={    1,1  }	,[ "coords"]= {{ 30.6  ,36.8  }}} ,
{["zone_name"] = "The Storm Peaks"           ,[ "zoneID" ] =120  ,["name"]="Heksi"                           ,["maxlevel"]=80  ,["minlevel"]=78  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=26631 ,["id"]=29906  ,["react"]={    1,1  }	,[ "coords"]= {{ 40.8  ,86    }}} ,
{["zone_name"] = "The Storm Peaks"           ,[ "zoneID" ] =120  ,["name"]="Boarmaster Bragh"                ,["maxlevel"]=80  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=26686 ,["id"]=29948  ,["react"]={    1,-1 }	,[ "coords"]= {{ 28.6  ,74.4  }}} ,
{["zone_name"] = "Shadowmoon Valley"         ,[ "zoneID" ] =539  ,["name"]="Ertai"                           ,["maxlevel"]=100 ,["minlevel"]=92  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=58472 ,["id"]=84730  ,["react"]={    1,nil}	,[ "coords"]= {{ 59.2  ,26.6  }}} ,
{["zone_name"] = "Frostfire Ridge"           ,[ "zoneID" ] =525  ,["name"]="Wolfhandler Ang'cha"             ,["maxlevel"]=100 ,["minlevel"]=100 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=55801 ,["id"]=77461  ,["react"]={nil,1    }	,[ "coords"]= {{ 22    ,56.2  }}} ,
{["zone_name"] = "Frostfire Ridge"           ,[ "zoneID" ] =525  ,["name"]="Grimble the Pupmaster"           ,["maxlevel"]=100 ,["minlevel"]=99  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=20545 ,["id"]=77455  ,["react"]={-   1,1  }	,[ "coords"]= {{ 38.8  ,52    }}} ,
{["zone_name"] = "Frostfire Ridge"           ,[ "zoneID" ] =525  ,["name"]="Ko'ari"                          ,["maxlevel"]=100 ,["minlevel"]=100 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=54642 ,["id"]=78698  ,["react"]={nil,1    }	,[ "coords"]= {{ 52.4  ,40.2  }}} ,
{["zone_name"] = "Gorgrond"                  ,[ "zoneID" ] =543  ,["name"]="Ribchewer"                       ,["maxlevel"]=100	,["minlevel"]=93  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=56923	,["id"]=82731  ,["react"]={-   1,1  }	,[ "coords"]= {{ 45.8  ,69.8  }}} ,
{["zone_name"] = "Tanaan Jungle"             ,[ "zoneID" ] =534  ,["name"]="Dal Palesmoke"                   ,["maxlevel"]=100	,["minlevel"]=100 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=7364  ,["id"]=90992  ,["react"]={-   1,1  }	,[ "coords"]= {{ 59.8  ,45.6  }}} ,
{["zone_name"] = "Timeless Isle"             ,[ "zoneID" ] =554  ,["name"]="Cowardly Zue"                    ,["maxlevel"]=85  ,["minlevel"]=85  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=41898	,["id"]=73632  ,["react"]={    1,1  }	,[ "coords"]= {{ 37.2  ,46.8  }}} ,
{["zone_name"] = "Frostwall"                 ,[ "zoneID" ] =590  ,["name"]="Drokil"                          ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=56564	,["id"]=79816  ,["react"]={nil,1    }	,[ "coords"]= {{ 52    ,58.2  }}} ,
{["zone_name"] = "Frostwall"                 ,[ "zoneID" ] =590  ,["name"]="Zagara"                          ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=56564	,["id"]=79860  ,["react"]={nil,1    }	,[ "coords"]= {{ 61.4  ,52.2  }}} ,
{["zone_name"] = "Lunarfall"                 ,[ "zoneID" ] =582  ,["name"]="Raven"                           ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=60992	,["id"]=77381  ,["react"]={    1,nil}	,[ "coords"]= {{ 45.4  ,40.2  }}} ,
{["zone_name"] = "Stormshield"               ,[ "zoneID" ] =622  ,["name"]="Orville Manfred"                 ,["maxlevel"]=100	,["minlevel"]=100 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=59249	,["id"]=85963  ,["react"]={    1,-1 }	,[ "coords"]= {{ 33.4  ,65.6  }}} ,
{["zone_name"] = "Warspear"                  ,[ "zoneID" ] =624  ,["name"]="Ujia"                            ,["maxlevel"]=100	,["minlevel"]=100 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=59325	,["id"]=86052  ,["react"]={-   1,1  }	,[ "coords"]= {{ 77.2  ,58.4  }}} ,
{["zone_name"] = "Dalaran"                   ,[ "zoneID" ] =625  ,["name"]="Tassia Whisperglen"              ,["maxlevel"]=105	,["minlevel"]=105 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=25607	,["id"]=96507  ,["react"]={    1,1  }	,[ "coords"]= {{ 59    ,37.8  }}} ,
{["zone_name"] = "Highmountain"              ,[ "zoneID" ] =650  ,["name"]="Haren Stonepath"                 ,["maxlevel"]=110	,["minlevel"]=107 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=65471	,["id"]=97874  ,["react"]={    1,1  }	,[ "coords"]= {{ 53.2  ,64    }}} ,
{["zone_name"] = "Highmountain"              ,[ "zoneID" ] =650  ,["name"]="Parek Splitfeather"              ,["maxlevel"]=110	,["minlevel"]=100 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=65473	,["id"]=97862  ,["react"]={    1,1  }	,[ "coords"]= {{ 52.8  ,45.2  }}} ,
{["zone_name"] = "Broken Shore"              ,[ "zoneID" ] =646  ,["name"]="Pan the Kind Hand"               ,["maxlevel"]=110	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=44905	,["id"]=117813	,["react"]={    1,1  }	,[ "coords"]= {{ 43.4  ,63    }}} ,
{["zone_name"] = "Thunder Totem"             ,[ "zoneID" ] =750  ,["name"]="Liza Galestride"                 ,["maxlevel"]=110	,["minlevel"]=98  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=65468	,["id"]=97854  ,["react"]={    1,1  }	,[ "coords"]= {{ 53.6  ,45.4  }}} ,
{["zone_name"] = "Trueshot Lodge"            ,[ "zoneID" ] =739  ,["name"]="Pan the Kind Hand"               ,["maxlevel"]=100	,["minlevel"]=100 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=44905	,["id"]=100661	,["react"]={    1,1  }	,[ "coords"]= {{ 58.8  ,32.6  }}} ,
{["zone_name"] = "Swamp of Sorrows"          ,[ "zoneID" ] =51   ,["name"]="Joran"                           ,["maxlevel"]=65  ,["minlevel"]=65  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=35563	,["id"]=47368  ,["react"]={    1,-1 }	,[ "coords"]= {{ 28.6  ,33.2  }}} ,
{["zone_name"] = "Swamp of Sorrows"          ,[ "zoneID" ] =51   ,["name"]="Hekkru"                          ,["maxlevel"]=65  ,["minlevel"]=65  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=9268  ,["id"]=10049  ,["react"]={-   1,1  }	,[ "coords"]= {{ 47.2  ,55.2  }}} ,
{["zone_name"] = "Swamp of Sorrows"          ,[ "zoneID" ] =51   ,["name"]="Shecky Shrimpshoot"              ,["maxlevel"]=60  ,["minlevel"]=57  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=35554	,["id"]=47337  ,["react"]={    1,1  }	,[ "coords"]= {{ 72    ,14.8  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Habradu"                         ,["maxlevel"]=120	,["minlevel"]=112 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=79535	,["id"]=137333	,["react"]={-   1,1  }	,[ "coords"]= {{ 51.2  ,50.2  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Beast Handler Kooley"            ,["maxlevel"]=120	,["minlevel"]=113 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=82065	,["id"]=124455	,["react"]={nil,1    }	,[ "coords"]= {{ 76.8  ,16.4  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Birgita"                         ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=86024	,["id"]=138850	,["react"]={    1,-1 }	,[ "coords"]= {{ 77.4  ,54.8  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Johnathan Ebrills"               ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=84527	,["id"]=136004	,["react"]={    1,-1 }	,[ "coords"]= {{ 44.4  ,36.6  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Tailmaster Tacklesnatz"          ,["maxlevel"]=120	,["minlevel"]=112 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=89906	,["id"]=148168	,["react"]={-   1,1  }	,[ "coords"]= {{ 53.4  ,57.2  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Mitzi Pawsprinkle"               ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=86563	,["id"]=140057	,["react"]={    1,-1 }	,[ "coords"]= {{ 64.4  ,47.2  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Saranklei"                       ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=84569	,["id"]=136082	,["react"]={    1,-1 }	,[ "coords"]= {{ 55.6  ,25    }}} ,
{["zone_name"] = "Tirisfal Glades"           ,[ "zoneID" ] =18   ,["name"]="Morganus"                        ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=9274  ,["id"]=10055  ,["react"]={-   1,1  }	,[ "coords"]= {{ 61.8  ,52    }}} ,
{["zone_name"] = "Nazmir"                    ,[ "zoneID" ] =863  ,["name"]="Yash"                            ,["maxlevel"]=120	,["minlevel"]=113 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=77687	,["id"]=131993	,["react"]={    1,1  }	,[ "coords"]= {{ 66.8  ,42    }}} ,
{["zone_name"] = "Nazmir"                    ,[ "zoneID" ] =863  ,["name"]="Beastmaster Veayeka"             ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=84381	,["id"]=135750	,["react"]={-   1,1  }	,[ "coords"]= {{ 39.4  ,79.6  }}} ,
{["zone_name"] = "Vol'dun"                   ,[ "zoneID" ] =864  ,["name"]="Orville Manfred"                 ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=59249	,["id"]=144121	,["react"]={    1,-1 }	,[ "coords"]= {{ 38.4  ,34.4  }}} ,
{["zone_name"] = "Vol'dun"                   ,[ "zoneID" ] =864  ,["name"]="Teego"                           ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=85953	,["id"]=138701	,["react"]={    1,1  }	,[ "coords"]= {{ 57.2  ,49.2  }}} ,
{["zone_name"] = "Vol'dun"                   ,[ "zoneID" ] =864  ,["name"]="Vithur"                          ,["maxlevel"]=120	,["minlevel"]=112 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=80668	,["id"]=139827	,["react"]={    1,1  }	,[ "coords"]= {{ 27    ,51    }}} ,
{["zone_name"] = "Tiragarde Sound"           ,[ "zoneID" ] =895  ,["name"]="Dolan Northfield"                ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=78467	,["id"]=125035	,["react"]={    1,-1 }	,[ "coords"]= {{ 51.4  ,26    }}} ,
{["zone_name"] = "Tiragarde Sound"           ,[ "zoneID" ] =895  ,["name"]="Tallelah Clearpath"              ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=85745	,["id"]=138160	,["react"]={-   1,1  }	,[ "coords"]= {{ 87.4  ,50.2  }}} ,
{["zone_name"] = "Boralus"                   ,[ "zoneID" ] =1161	,["name"]="Leila Stafford"                  ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=87599	,["id"]=142073	,["react"]={    1,-1 }	,[ "coords"]= {{ 69.62 ,13.13 }}} ,
{["zone_name"] = "Krokuun"                   ,[ "zoneID" ] =830  ,["name"]="Lead Rider Jerek"                ,["maxlevel"]=110	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=75163	,["id"]=126160	,["react"]={    1,1  }	,[ "coords"]= {{ 64.4  ,62.6  }}} ,
{["zone_name"] = "Krokuun"                   ,[ "zoneID" ] =830  ,["name"]="Raelaara the Kind"               ,["maxlevel"]=110	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=77962	,["id"]=127752	,["react"]={    1,1  }	,[ "coords"]= {{ 62.6  ,47.4  }}} ,
{["zone_name"] = "Dazar'alor"                ,[ "zoneID" ] =1165	,["name"]="Beast Handler Sujani"            ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=82207	,["id"]=132066	,["react"]={-   1,1  }	,[ "coords"]= {{ 47.8  ,89    }}} ,
{["zone_name"] = "Dazar'alor"                ,[ "zoneID" ] =1165	,["name"]="Beast Handler Kalatak"           ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=79372	,["id"]=122696	,["react"]={-   1,1  }	,[ "coords"]= {{ 45.8  ,36.2  }}} ,
{["zone_name"] = "Dazar'alor"                ,[ "zoneID" ] =1165	,["name"]="Beast Handler Tahno"             ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=82208	,["id"]=132067	,["react"]={-   1,1  }	,[ "coords"]= {{ 59.8  ,4.4   }}} ,
{["zone_name"] = "Dazar'alor"                ,[ "zoneID" ] =1165	,["name"]="Beast Handler Sonaba"            ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=82800	,["id"]=133253	,["react"]={-   1,1  }	,[ "coords"]= {{ 55    ,14.8  }}} ,
{["zone_name"] = "Drustvar"                  ,[ "zoneID" ] =896  ,["name"]="Klause Fairwind"                 ,["maxlevel"]=120	,["minlevel"]=118 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=84609	,["id"]=136142	,["react"]={    0,0  }	,[ "coords"]= {{ 19.4  ,43.6  }}} ,
{["zone_name"] = "Drustvar"                  ,[ "zoneID" ] =896  ,["name"]="Willow Tempest"                  ,["maxlevel"]=120	,["minlevel"]=114 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=85015	,["id"]=137010	,["react"]={    1,-1 }	,[ "coords"]= {{ 38.6  ,52.4  }}} ,
{["zone_name"] = "Stormsong Valley"          ,[ "zoneID" ] =942  ,["name"]="Calik the Skinny"                ,["maxlevel"]=120	,["minlevel"]=113 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=84243	,["id"]=135386	,["react"]={    1,nil}	,[ "coords"]= {{ 43.2  ,54.6  }}} ,
{["zone_name"] = "Stormsong Valley"          ,[ "zoneID" ] =942  ,["name"]="Crabmaster Daijo"                ,["maxlevel"]=120	,["minlevel"]=111 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=77687	,["id"]=138451	,["react"]={    1,1  }	,[ "coords"]= {{ 40.4  ,36.4  }}} ,
{["zone_name"] = "Stormsong Valley"          ,[ "zoneID" ] =942  ,["name"]="Beast Handler Khajuku"           ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=85733	,["id"]=138108	,["react"]={-   1,1  }	,[ "coords"]= {{ 50.8  ,33    }}} ,
{["zone_name"] = "Stormsong Valley"          ,[ "zoneID" ] =942  ,["name"]="Hayworth"                        ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=87217	,["id"]=141349	,["react"]={    1,-1 }	,[ "coords"]= {{ 58.4  ,70.6  }}} ,


}
  

AOTH.tamablePets = {
--BASILISKS
688,689,690,1550,1551,1552,4041,4044,4728,4729,4863,5419,5420,5935,5990,6215,8095,8120,8130,8138,8149,8302,11785,11786,14227,17560,17561,17562,17563,18461,18463,18648,19706,19729,19730,20279,20280,20283,20607,20783,20924,20925,20987,21816,21854,22256,28145,28203,35245,35409,35750,39186,39658,40403,42543,43181,43339,43981,44113,44138,48146,48151,48724,51013,56650,65236,66188,66448,69358,70858,71721,72329,74962,75009,77155,77492,83405,84805,85694,86134,88481,91128,96878,97030,97991,98653,98957,99598,99779,99785,99793,100100,100841,101068,101069,101785,101868,102106,102863,103514,103527,103787,103808,104882,104895,107914,107965,108185,108529,109867,114113,118252,119139,126197,128670,130229,130598,153691,153731,

--BATS
1512,1513,1553,1554,3866,3868,4425,4538,4539,4861,4862,8600,8601,8602,8927,9521,10357,11368,11897,14965,16173,16174,16175,16180,16353,16354,16355,17221,23959,26017,26622,28233,42338,42523,42714,43182,48456,50328,50329,50330,59197,59235,59984,61415,75247,75466,75467,79643,79895,80192,80242,84935,87085,89788,92627,96287,97895,123423,126353,126433,128547,

--BIRDSOFPREY
1995,1996,1997,7097,7098,7099,7455,7456,14283,14343,17034,17035,17039,17053,17128,17129,18220,18257,18963,18996,19055,19429,20327,21042,21804,21891,21904,22265,22979,23035,23051,23132,23206,23693,23945,24172,24747,24787,25748,25817,26028,26369,27244,27249,28004,29044,29453,30988,31263,32481,34886,34982,38154,38206,40194,41084,42657,42658,42659,42660,42663,42664,44020,44475,44481,44628,46161,46162,47680,48137,48138,48155,48447,48448,48449,48450,48451,50044,50335,50337,50342,50343,50345,52347,54897,56034,56171,56199,56396,56751,57215,57216,58231,58457,58910,59112,59384,59528,59641,59700,59757,59774,60196,60198,60200,60866,61747,61748,62476,62479,62480,64551,64937,66451,70172,76143,76253,77442,79061,79285,79398,79420,79486,79851,79854,80226,80589,80687,81333,82037,82175,82306,82312,82354,82411,82514,82515,82758,82828,82829,83436,83746,83976,83982,83984,84013,84083,84231,84919,85417,85564,85753,85852,85856,86747,86748,86750,87088,87649,87651,87652,87671,88587,88592,88677,89391,89718,89829,90245,90246,91050,91269,91527,91539,91715,91717,92235,92912,93333,93952,94495,94708,94986,95053,95328,95762,97124,97345,97755,97809,97976,98743,99794,100496,102415,102741,103079,103480,103540,103592,103841,104310,104481,104827,105531,107928,107957,108552,109809,111404,111570,111643,112010,112328,112336,112421,112444,113110,113127,113408,113700,118275,120226,122548,122961,123210,123316,124996,125098,125500,126387,126463,126626,126953,127010,127493,127530,127553,127636,127780,128188,128389,128625,128799,128852,128938,129301,129482,129950,130359,130575,130577,130832,130835,130846,131076,131136,131598,131600,131695,131780,132127,132211,132275,133843,133988,134377,134780,134782,135632,136280,136311,136914,137182,137575,137720,138286,139233,139641,140464,141049,141877,142199,146396,151811,151994,153585,153594,153615,153629,153726,156931,

--BEARS
822,1128,1129,1130,1186,1188,1189,1196,1225,1778,1797,1815,1816,1961,2163,2164,2165,2351,2354,2356,3809,3810,3811,5268,5272,5274,5352,6788,7443,7444,7445,7446,8956,8957,8958,10806,11836,12037,12432,14280,14344,17345,17347,17348,17661,23584,24217,24547,24633,26482,26643,26644,26706,27131,29319,29562,33009,33024,33905,33978,34025,34178,34302,34417,34500,39049,39439,39850,40819,42336,42713,44016,44473,44482,44638,45613,47204,48765,49249,50926,50929,50930,50931,51962,51972,56200,69177,90134,90947,91171,91569,92735,93095,93318,93330,95270,96146,97214,97220,97449,98512,98890,101515,102361,102385,103785,104147,106467,106804,107595,107596,107617,108499,109324,109521,112644,123308,123309,126929,128093,129002,130085,130256,130257,131697,132674,136591,137739,137835,139278,139793,141034,141239,141911,142342,144329,144993,153589,

--BEETLES
3253,5451,5453,5457,5459,6555,7269,8932,10177,10699,11721,11726,11731,15168,15316,15461,15462,15621,15718,16698,21306,24794,39440,40310,40458,42556,46123,46126,46127,46128,46129,47079,47390,47801,51053,51057,51058,51061,51062,51063,51674,52009,63587,121440,122157,122176,124019,124029,124211,125308,126505,126645,127201,128404,130244,135850,136487,136663,137721,140591,140830,141720,141755,142699,151859,158511,161280,162142,162363,162382,163154,163170,

--CATS
681,682,683,684,698,700,728,729,731,736,756,758,767,768,772,976,977,1085,1199,1201,1713,2031,2032,2033,2034,2042,2043,2069,2070,2071,2175,2237,2384,2385,2406,2407,2522,2731,2732,2734,2850,2961,3035,3121,3241,3243,3415,3416,3425,3475,3566,3619,4067,4124,4126,5766,5807,5828,5865,7430,7431,7432,7433,7434,10200,10737,10741,11360,11361,11364,11365,11366,11376,14222,14430,15067,15068,15101,15366,15372,15651,15652,15653,16347,16348,16349,17202,17203,17411,18982,20412,20671,21022,21723,21724,22005,23014,24043,24064,24530,26021,28001,28097,28297,28404,29327,31636,33127,34034,35904,37206,37207,38046,40064,42170,42171,42286,42718,43498,44188,45096,46155,46156,47053,47687,47726,48511,50159,50815,50818,50819,50825,50833,50837,50838,50850,50866,51663,52345,52622,52839,54688,54699,54700,54988,55095,55236,55238,55607,55946,56198,56272,56329,56382,56652,56653,56654,56655,56683,58070,58221,58432,58641,58884,58887,58950,59037,59102,59116,59196,59534,59753,60875,62131,62945,63537,63538,63540,63756,63767,65612,66164,66184,66187,66617,66622,66633,66668,66799,67071,67085,70595,72805,72807,72808,76685,76687,77741,79703,79705,79909,79959,88579,89395,94149,94196,95908,96165,96268,97348,97454,98021,99481,99749,100328,101077,101541,103616,104364,104404,105657,109320,109807,110562,112910,113198,116921,119874,122010,122023,122362,122408,122560,122957,123076,123310,123508,124269,124271,124303,124486,126198,126419,126898,129644,130943,131069,131384,140738,149644,149663,151809,162361,
--BLOODBEASTS
120560,120589,121896,121898,122242,122335,123871,123901,124476,126313,126749,127060,127176,127925,128005,128066,128067,128344,128699,128780,132030,133173,133357,133835,134057,134433,134434,135193,135674,136299,136796,138491,138727,138812,141935,142500,142935,

--CHIMAERAS
4031,4032,6167,7447,7448,7449,8660,8763,8764,10807,11497,12800,12801,12802,12803,20932,21033,21879,24673,33504,36304,50346,50348,54533,72251,72273,72849,74981,75280,76255,76477,76874,76916,76919,76920,76956,76967,77091,77093,77122,77140,77307,77516,78183,78273,78314,78400,78404,78508,78514,78521,78547,78550,80034,80098,80227,80241,80321,80832,80836,80838,80839,80841,80842,80844,80845,80846,80848,80849,81548,82646,83389,83591,83740,84002,84151,84644,84927,85184,85357,85888,86373,87343,88643,95327,95615,113757,142713,148787,

--CLEFTHOOFS
16931,17132,17133,18205,18259,18398,19183,22105,22287,25487,25488,25489,28009,28288,29469,29838,29931,30445,30447,32361,33506,50990,50993,50995,50997,72162,72881,73234,74597,74933,74935,74957,75298,75312,75605,75680,75737,75771,76326,76389,76576,76710,76711,76857,76946,77112,77115,77141,77142,77513,77519,78329,78331,78332,78364,78528,78570,78571,78572,78574,78575,78576,78918,78919,78920,79034,79035,79386,80136,80420,81598,81898,82119,83483,84798,85031,85537,86000,86520,86730,86731,86732,86847,90124,108181,113761,115093,115097,

--BOARS
113,119,157,330,345,390,454,524,547,708,1125,1126,1127,1190,1191,1192,1689,1984,1985,2954,2966,3098,3099,3100,3225,4511,4512,4514,4535,5992,5993,6021,8303,16117,16863,16879,16880,16992,21195,21878,22180,26020,34647,36696,37559,38141,39224,40337,42357,42504,42719,42859,44089,44627,46575,50302,50937,50940,50942,50945,50946,50947,50948,50949,72934,74566,74567,74620,75037,75115,75151,75206,75241,75416,75954,76178,76914,77124,77129,77298,77478,77655,77742,77785,77881,77994,79483,79756,80174,82617,82726,82728,83719,83804,83897,84893,84943,86150,86151,86153,86850,88460,88508,88589,89132,89688,89689,91936,92875,92876,92887,93903,100846,101575,107503,119337,119339,125347,127699,127800,129869,130130,130164,130165,131951,133822,135293,137140,138675,148296,

--Carrion BirdS
154,199,428,462,1109,1194,1809,1810,1811,2578,2579,2580,2829,2830,2831,2931,2969,2970,2971,4154,4158,4692,4693,4694,4695,5428,5429,5430,5982,5983,6013,7376,8207,8299,14268,16972,16973,17042,18470,18707,21470,21515,25963,26019,26174,26483,26838,34640,40650,42235,44184,47202,50803,50804,50807,50809,50810,50812,50813,50814,51726,51760,57851,58111,59251,59672,59782,61843,65629,66368,69349,69712,71729,72650,74414,75348,76786,76819,77306,77430,77626,77627,78108,79645,79746,79752,79920,80164,80228,81583,84233,92117,94718,100411,108927,110846,120386,121446,121610,122165,122790,123313,123937,124382,124527,124890,124921,125411,126133,126502,126695,126831,126909,128937,129868,130018,130070,130138,130147,130248,130314,130814,131188,131229,132102,132136,132526,132758,132799,134108,134181,134774,135049,135574,135726,136393,136664,136908,136993,137209,137211,137329,137468,138186,138258,138596,138963,139071,139072,142335,142337,142341,142361,142400,142435,142717,145204,150645,153592,153598,157143,162368,

--CRANES
50885,55015,56752,57299,58116,58450,58694,58741,58766,58885,59105,59665,59763,59786,59787,60616,63584,63796,65237,65339,65819,67128,71143,72761,72762,73158,89014,89652,102960,103639,103817,105838,112498,118471,130224,133285,134316,137181,139456,156780,160691,

--GOATS
50998,54132,58448,58892,59139,59431,59680,60242,60493,60511,60668,60748,62937,63503,65122,65238,66208,66464,69523,72275,91824,92707,94198,97828,98808,99636,105104,107663,112453,116975,127822,129110,129742,130705,130751,134349,136939,138316,139796,141029,141313,143929,144477,153596,153613,154505,154506,156756,

--DIREHORNS
67576,68476,69246,69277,69679,69795,69812,69983,69992,70012,70013,70014,70015,70016,70017,70018,70019,70493,113759,122060,122223,122224,123427,123487,123809,124399,127494,127514,127824,128968,130712,130741,130743,131626,131628,133527,133603,134453,135175,135508,136381,138139,143391,151993,

--FEATHERMANES
2347,2658,4011,4012,4013,4014,4015,4107,4109,4110,5300,5304,5305,5306,5347,5928,6375,6377,6378,6379,6380,6648,12676,16872,16874,16875,23772,24514,28614,36147,46158,47485,49251,89386,90057,90313,90480,90816,90901,93647,93669,94463,97504,101596,103497,103549,104219,105547,106920,109351,109594,110253,112839,112909,121502,121540,121623,121624,121625,129001,129126,131332,137724,137825,140433,142088,

--DRAGONHAWK
15649,15650,18155,18851,18854,20038,20039,20502,20517,23598,23834,25867,26024,42710,50353,50357,

--DEVILSAURS
6498,6499,6500,6584,20931,27483,32485,33505,38346,50846,69148,69161,69218,69991,69993,70004,70005,70006,70007,70008,70009,70010,70011,70226,70422,71529,120592,123502,126732,127746,128051,130713,131632,131672,139703,139706,152296,

--COREHOUNDS
10430,11671,11672,11673,11982,14020,17447,19207,21102,21108,33502,39348,41166,46910,47544,50839,50842,51442,52795,77927,143416,

--FOXS
36512,36623,37492,38881,43083,43084,44474,44551,44635,45335,45380,47676,49565,51076,51077,52011,53704,55565,57797,58548,58549,89385,91265,91267,96265,99647,101315,110066,110501,111487,112008,113184,113185,126455,127602,131387,137353,137640,138179,139080,142198,

--DOGS
819,1547,1548,1549,4304,7377,7378,8596,8597,8598,8599,8921,8922,9042,10356,10979,11885,16038,16041,16176,16177,16178,16181,16448,22394,23930,23939,23994,24156,25355,25718,26281,26730,27329,28278,28903,29452,29889,30157,30158,30664,30952,30963,31010,31404,31528,32163,32392,36405,37718,38468,38844,41561,41917,41919,42722,44014,44476,45367,45453,51031,51037,51040,51042,51044,51045,51046,51048,51761,52010,53414,53614,58674,58876,59309,83815,92956,115553,128551,129070,129857,135234,135773,136469,137152,139562,139563,141118,141729,144122,

--CROCOLISKS
1082,1084,1087,1150,1151,1152,1400,1417,1693,2089,2476,2635,3110,3231,3581,4341,4342,4343,4344,4345,4841,5053,13596,14233,15043,17144,17952,20075,20773,24047,24138,28002,28325,34027,36882,37078,39452,41419,41420,42373,43658,44108,44892,45321,45807,45896,46150,46152,46278,46280,46281,46317,47591,50964,50967,51662,51675,52413,54558,56183,58455,58755,58804,60201,60202,60203,60282,62008,62023,73476,109934,113126,113190,120588,123090,123519,123655,125205,125211,125212,125250,126723,126926,127267,127482,128620,131603,131766,132031,133815,134896,156760,162334,162335,162336,

--CRABS
830,831,922,1088,1216,2231,2232,2233,2234,2235,2236,2544,3106,3107,3108,3228,3460,3812,3814,4821,4822,4823,6250,12347,17216,17217,18241,23929,24287,24478,24479,25481,26521,32935,32976,33712,33713,34026,34369,39004,39418,39943,40238,40239,40276,40527,40685,40764,40798,40889,41295,41520,41595,41609,41922,42715,44116,44390,45087,46369,46606,50952,50955,50957,50958,50959,51714,54557,58809,58880,58881,60401,60437,61090,61091,61446,63172,63201,63347,63722,63723,64436,65823,66472,66476,66748,67896,68583,68584,69384,72766,73166,74508,83840,84341,84432,87268,87283,88076,88922,88926,89216,89288,92298,92301,93058,93226,97122,97926,97928,99504,99633,99720,101554,101624,102516,102819,104585,107667,107846,108163,108702,109702,109803,110824,111387,111571,111647,111784,111887,113493,113508,118725,120570,123236,123455,123810,123814,124567,124761,125214,126356,126642,127259,127381,127496,127526,127630,127651,128623,128631,128942,128996,129283,129318,130042,130812,131013,131221,131675,131687,131693,132650,133587,133689,134907,134934,136183,137255,137681,137713,137716,137763,137885,139290,139298,141021,141643,141872,142577,142579,143718,143928,144460,144462,144611,144842,145337,145740,148454,149654,149680,151172,151327,151354,152319,152426,152445,152448,152460,152461,152462,152463,152464,152465,152642,152795,152800,152801,153026,153462,153593,153804,153812,153814,153818,153902,153965,153966,153971,153992,154935,154936,155073,155583,

--RAPTORS
685,686,687,730,854,855,856,1015,1016,1017,1018,1019,1020,1021,1022,1023,1140,1353,2559,2560,2561,3122,3123,3227,3254,3255,3256,3257,3632,3633,3634,3636,3637,4351,4352,4355,4356,4357,5842,6505,6506,6507,6508,6581,9683,9684,14232,14821,20634,20728,20729,20734,20751,20754,21124,22052,23873,26029,26628,26641,26824,29334,29698,34262,34263,34543,34829,36740,37083,37084,37090,37956,37961,38187,39385,41342,41343,41400,41401,42721,44164,44165,44167,50865,50874,50875,50876,50882,58071,61556,62654,64638,65428,69180,69244,69306,69311,71297,80694,85565,85970,86423,86425,87084,87409,88495,88951,88956,88957,89742,89744,89745,92694,97247,97248,101145,115663,115664,115665,115666,115667,115668,115669,115670,115671,115672,115673,115674,115675,115676,115677,115678,120587,122004,122504,123096,124217,124226,125206,126023,126132,126142,126331,126443,126631,126653,126689,127000,127278,127279,127294,127869,127873,127907,128435,128585,128616,130191,130370,130589,130722,130727,131560,131623,131624,132754,133812,134046,134047,134167,134207,134436,135306,135490,135790,136426,136566,137545,139326,139365,139488,140699,142312,142338,142339,142340,142437,143392,145110,145444,149147,

--RODENTS
50944,54896,58411,59772,64745,65118,65239,65839,113122,113123,119745,119968,121562,122364,122365,123512,124278,125401,125453,126445,126991,156759,

--QUILLENS
50843,56274,58419,58645,59157,59773,59915,59971,59973,60043,60047,60051,60223,60294,60373,60573,60576,60833,61306,61307,61387,61453,61455,61565,61945,62254,62266,62372,63282,63509,63510,63600,63605,63739,63950,64046,64183,64186,64669,64670,64671,64686,65240,65450,65816,66772,67475,68079,68080,68081,70327,71491,99675,127805,129345,131233,136550,153096,156046,157290,158409,

--RIVERBEASTS
72606,74995,75468,77431,77715,79577,79587,79662,82310,82905,83388,83455,83841,85743,85762,85906,85907,86780,86848,87020,87021,87666,88075,88586,88669,92979,92981,93002,113758,121444,123463,123651,123653,123731,124084,124631,124783,125477,128667,128708,128729,130022,130023,130754,130757,130770,130772,130817,132244,133539,133896,133897,135467,141977,

--SCALEHIDES
2972,2973,2974,3058,3234,3235,3236,3237,3240,3474,4008,4700,4701,4702,4726,4727,5827,5832,5833,6501,6502,6503,6504,6583,8928,14406,35412,35434,36094,36113,37208,37555,37556,48111,56239,56523,58424,58427,58435,58893,58895,58896,59295,59670,59671,59675,60623,61618,61875,62029,62760,63729,63827,64309,65627,66096,66213,66431,66463,66599,101619,102556,108048,123093,123095,

--OXENS
23690,23691,24681,24791,26418,29479,29486,29487,58415,58449,59319,59339,59367,59523,59970,59975,60860,61294,65773,65774,66549,66587,66595,72842,72843,72844,73160,89388,96611,97787,97789,97820,103786,107803,107805,107808,107852,108538,108935,153549,153608,153609,153656,153657,153659,

--HYENAS
4127,4128,4129,4248,4249,4250,4316,4534,4548,4660,4662,4688,4689,4690,4691,5425,5426,5427,5829,5984,5985,5986,8208,8300,12418,13036,14228,27294,34019,35811,37086,39185,45202,45204,45353,46679,47327,50855,50856,51671,60800,60932,71728,72247,78489,121442,124287,124681,124709,126643,126644,128397,130405,130406,130439,134718,134744,135338,135339,138342,142755,142780,149836,151945,162381,

--LIZARDS
9162,9163,9164,9318,13323,21408,21462,21897,40338,113041,121441,122111,123098,123135,123647,123714,123727,123868,124039,124179,124182,124300,124301,124375,124524,125452,126243,126452,126562,126637,126722,126725,126726,126984,127132,127140,127203,127290,127758,127765,127776,127854,127939,128065,128390,128950,129284,129323,129337,129554,129558,129576,130019,130489,130508,130668,130752,130753,130756,130774,131252,131608,132022,133158,133356,133853,133862,133888,135510,135543,136901,137098,137356,137829,139161,140276,140664,141599,141641,141696,141832,143393,144496,145339,145457,148293,149262,149851,150154,150857,151998,152001,152035,152114,152356,152357,152358,152359,152360,152361,152362,152363,152444,152797,152989,153699,153959,154181,154182,154422,154752,154753,154754,154755,154756,154757,155914,156097,156098,156099,156100,156101,

--PTERRODAXS
9166,9167,21900,69162,69207,70020,70021,70120,70494,70558,73223,88208,113040,120593,122113,122114,122986,124397,125207,126618,126702,126703,127847,127864,128434,128653,128658,130403,131718,132653,132987,135450,135494,135852,139493,139534,143898,

--KROLUSKS
121448,124016,124526,124654,126237,127542,129476,129638,130415,133234,133842,134557,134562,134675,134686,135500,135582,136335,136548,136553,136667,140034,140585,148480,

--RAVAGERS
16932,16933,16934,17198,17199,17525,17526,17527,17620,19189,19349,19350,19461,21423,22123,23326,50320,50370,50724,50725,50726,50727,50728,50730,50731,78856,78931,79726,80224,80715,80782,81538,81561,82632,83517,83522,84058,85453,85516,85756,85779,86263,86286,86294,86455,88523,88578,88630,89741,89755,92429,16900,78857,26030,17556,80779,24922,

--RAYS
17731,18130,18131,18285,18880,20196,20681,21128,21901,22181,23501,26027,50361,50362,75487,88962,101110,119748,119969,122022,122410,123511,124279,125003,130937,145967,150373,150376,150467,150569,150696,152290,152291,152379,152798,153350,153764,155141,

--MOTHS
16520,17349,17350,18437,18438,18468,18469,20611,20752,21372,21373,21839,25464,25498,27421,34021,42712,50858,50864,56172,57232,57421,57422,59785,63725,65799,66319,66514,76668,77328,77331,77441,77719,78390,79595,79910,79923,82192,86757,86810,87089,87425,109180,112905,146321,

--MONKEYS
34699,35812,42616,43050,43417,48278,48440,48441,48442,51052,52012,52441,68961,87362,

--HYDRAS
1819,1820,3398,3652,3721,3722,4374,4829,6140,6347,6348,6349,7273,12207,12940,15114,15207,15305,18105,18213,18214,18286,20324,20775,22884,28003,29033,43296,52418,79020,80052,80122,80370,80372,80398,80401,80403,80404,80405,80445,80453,80471,80522,80541,80542,80543,80558,80559,80560,80752,80915,81537,82050,82530,82722,83393,83530,84391,84955,85429,85473,85693,85760,86265,86266,86755,86756,88489,89031,89379,89653,93010,108535,111383,112861,113756,117663,117672,128710,129027,129954,130110,132068,145340,152541,152542,152543,152544,152545,152546,152547,152548,153801,154339,

--GORILLAS
1108,1114,1511,1516,1557,1558,1559,2521,5260,5262,5264,6513,6514,6516,6585,9622,14491,28096,28098,28213,34028,50986,51661,59742,59747,128959,129005,129346,129347,130486,130512,130543,130545,130557,130948,130953,130954,131190,131191,136334,136396,136400,137840,139435,139483,139484,141940,142497,

--TALLSTRIDERS
2172,2321,2322,2323,2955,2956,2957,3068,3244,3245,3246,4724,4725,17372,17373,17374,22807,32997,34022,37085,37089,37091,39337,42720,45825,50884,50886,56753,58678,96167,

--STAGS
3242,3426,3816,3817,3818,4018,4019,4166,5831,7094,7095,7096,8759,8760,8761,12296,12297,17130,17131,17200,17201,18226,18258,18964,20610,20777,21922,25667,25680,25750,25989,26363,26615,26616,27230,31236,33311,34318,35096,37088,37786,39588,40193,44166,44639,45302,46970,47263,48184,48455,48918,51713,51961,56532,58454,58489,58490,59104,59743,59744,59745,62763,65115,66421,66605,72244,75519,76442,78274,78275,78276,78277,78278,78279,82031,82116,82513,82778,83470,83843,86727,86728,86729,86801,87007,87008,87009,87010,87011,87013,89384,89828,91308,93313,93314,93316,93327,93328,93329,93856,94151,94238,94386,94452,94694,95043,95268,96266,96267,96410,97129,97516,97752,98230,98884,99119,99760,103681,103805,104815,105644,106039,106837,107487,107755,107758,108313,108322,108890,108891,109349,109819,110042,110043,110350,110502,110503,112636,112637,112691,112692,112825,112827,113205,113739,114575,114576,121112,121564,121565,122363,123312,123527,124225,124265,124439,124528,124529,126708,126709,126939,126945,126952,126966,126967,127569,127611,127806,127807,127959,128361,128384,128385,129764,129835,130316,130321,130935,131074,134690,134699,137336,137349,139280,139790,140735,142183,142195,144837,144839,149134,149138,152092,153587,153588,153611,153612,153660,153661,156788,163072,
--MECHS
44576,44616,45399,48873,76199,76276,103620,103621,103622,103623,103624,103625,103627,103628,103629,103635,103637,107431,107477,107552,107676,107677,107678,107679,107836,107951,108088,108106,111820,111884,113755,114991,114992,114993,115479,137743,139205,139328,139335,139336,139356,139359,149839,149843,150254,150293,151159,151301,151634,151672,151684,151709,151740,151764,151773,151933,152287,152288,152315,152992,152994,153465,153473,153980,154219,155687,155709,155710,155711,155712,155713,155714,155715,155716,155892,155893,155894,155895,160414,

--SCORPIDS
3124,3125,3126,3127,3226,3250,3281,4139,4140,4696,4697,4699,5422,5423,5424,5823,5937,5987,5988,5989,7022,7078,7405,7803,8301,8926,9691,9695,9698,11735,11736,11737,14476,15196,15240,15317,15336,21864,22100,22193,26031,30613,39183,40581,40656,40717,44546,44587,44599,45859,47750,47803,48130,50154,50862,50873,51000,51001,51002,51004,51007,51008,51010,51401,51402,51403,51404,51673,53240,61299,62162,62759,63586,63588,63726,63728,63833,63870,63956,63978,64005,64982,64983,65632,65878,67712,72288,85562,91314,96021,105141,108009,108014,121457,122153,122154,122749,123571,123636,124807,124877,125882,126508,127543,129259,131897,134019,135728,136336,137198,137217,137332,152768,161382,162364,162378,162380,

--TURTLES
2408,2505,3461,3653,4142,4143,4144,4396,4397,4398,4399,4400,4824,4825,4887,5431,5432,6352,6369,7977,8213,13599,13896,14123,14223,22885,25482,33710,33711,34029,36732,38845,44109,44626,45950,48128,50058,50854,51014,56256,56447,56832,56833,57239,58218,58219,58431,58811,58940,58941,58942,59084,61619,61971,62160,62739,63116,63981,64725,64726,66099,66462,67703,67763,67895,68585,69998,72763,72764,72765,73161,74446,74722,76954,77065,77110,77145,89377,89696,89891,97434,97810,101982,102229,102515,108624,108626,110050,110703,110838,111273,111633,112802,112948,113125,113189,121461,122002,127477,127626,130160,130776,131520,134906,136149,139235,145970,152383,152384,152553,152799,

--TOADS
71786,72775,72777,73805,74176,75588,75590,78671,78673,79411,79413,79481,79524,79660,88674,89749,93124,105014,109124,111197,111216,122570,123603,128099,131614,137233,140938,

--SPIDERS
30,43,120,217,442,471,505,539,569,574,616,769,858,930,949,1111,1112,1184,1185,1195,1504,1505,1555,1688,1780,1781,1821,1822,1824,1986,1994,1998,1999,2000,2001,2348,2349,2350,2563,2565,2686,2707,3819,3820,3821,4005,4006,4007,4040,4263,4264,4376,4377,4378,4379,4380,4411,4412,4413,4414,4415,5856,5857,5858,7319,8277,8762,8933,10359,10375,10376,10596,11370,11738,11739,11921,12433,14266,14279,14472,14532,15041,15974,15975,15976,16170,16171,16179,16350,16351,16352,16453,17236,17522,17523,17683,18466,18467,18647,18983,20027,20682,20714,20998,22044,22132,23958,26033,26625,28221,28342,29411,29412,29461,30206,31747,32475,36197,36813,37045,41185,42337,42879,43007,44130,44284,44906,45227,45582,46507,46508,46751,47115,47117,47205,48248,48268,49346,50752,50759,50763,50764,50765,50770,50775,50777,50778,51107,51983,51987,52146,52648,52981,53753,54321,54322,54323,54324,54338,56070,58459,58474,58475,58568,58588,58808,58883,59488,61981,62000,64321,64323,65622,65653,65658,66686,66695,67087,67099,69239,74583,74584,75113,75258,75273,76473,76517,76891,77634,77957,78291,78864,78872,80211,80212,80247,82356,84097,84190,85404,86507,89756,89757,89758,89791,92532,97494,105049,109779,112370,113150,113417,116571,123813,124212,124530,124800,124853,125130,125132,128612,129495,129496,129500,129505,129626,129805,129810,129833,129913,130233,130235,131283,131284,131890,132317,132318,132319,132760,133857,134206,134825,135546,136341,137000,137025,137967,139521,141981,141988,142301,142333,142334,142438,142711,147222,

--Warp StalkerS
18464,18465,18878,18884,19770,19771,20906,21012,21013,21014,21015,21016,21017,22191,22255,23163,23219,26037,41645,50313,51017,51018,51021,74311,75483,77177,77443,79721,79745,79779,80081,80082,83553,86772,86773,86774,87086,93003,93236,119884,121673,122407,125081,126885,131072,160341,

--SPOREBATS
17724,17736,18128,18129,18280,20387,21246,22120,34018,50779,73013,75482,79332,81138,82323,83720,84639,84856,85316,87796,

--SERPENTS
5048,5224,5225,5755,5762,7268,8437,11371,11372,11373,15274,15966,16310,16491,16492,18883,19306,19784,19785,20618,24761,24917,25711,25721,26032,26322,26761,28011,28358,40657,41212,41374,44594,48131,48132,50317,50735,50737,50738,52085,52173,52224,89393,99744,102091,105884,107098,109023,113202,114835,115795,120477,121449,122015,124523,125299,126672,127169,127547,127600,127745,128356,129980,130020,130232,130401,134390,135846,136593,137183,137824,137944,138540,139285,139988,140038,140604,145338,145343,149707,152551,152552,152554,152555,152556,152796,153694,154092,155455,160413,

--SILITHID
3252,4132,5246,5247,5452,5454,5458,5460,6552,6553,6582,8204,8205,10040,11722,11723,11725,11728,11729,11730,11733,11734,14473,15229,15230,15233,15286,15290,15300,15318,15319,15320,15323,15348,15370,15421,15422,15510,15511,15521,15543,15544,15620,15622,15962,24732,33508,38305,38357,39149,47386,47387,47388,47389,48177,48178,50741,50742,50743,50744,50745,50746,50747,50748,51368,51369,83448,87250,87251,87253,128116,131892,131893,132578,132580,132584,154307,154309,154316,154331,

--SPIRITBEASTS
32517,33510,33776,35189,38453,50051,50138,54318,54319,54320,69943,69946,69947,88708,88710,89243,103326,110340,111463,112068,113201,113694,118244,121567,121571,125875,151096,151133,151144,151145,151147,151148,151149,160975,

--SHALESPIDERS
42845,43917,44425,46580,47071,47072,49815,49816,49822,51066,51067,51069,52013,56401,56404,56543,61159,67758,67759,68653,74509,99814,101062,101580,105585,105613,109326,123712,123713,134521,135745,

--WOLVES
69,118,213,299,521,525,565,628,704,705,833,834,923,995,1131,1132,1133,1138,1258,1508,1509,1765,1766,1817,1922,1923,1979,1980,2275,2680,2681,2727,2728,2729,2730,2753,2923,2924,2925,2926,2958,2959,2960,3056,3823,3824,3825,3826,3861,3862,3939,4482,4950,5286,5287,5288,5356,5596,7055,8211,8959,8960,8961,9416,9690,9694,9696,9697,10077,10220,10221,10268,10644,10981,12431,14339,17280,17548,17669,18033,18476,18477,18670,18706,19423,19458,19459,20058,20330,20748,21340,21952,21956,22353,22946,23083,23232,24026,24076,24128,24133,24206,24475,24516,24517,24677,25447,25675,25774,25791,26016,26592,26672,27408,27523,27578,29358,29735,30164,30320,30430,30455,30456,31233,39851,41478,42002,42104,42193,42242,42290,42717,43340,43704,45450,45517,46153,46570,47190,47769,48479,48945,49871,50908,50915,50916,50918,50922,50925,53523,56106,56357,56524,58456,58768,58889,58890,58891,59658,59780,60131,60783,71921,71923,72287,72452,72753,72991,73619,73679,74169,74206,74208,74424,74453,74513,74712,74748,74909,74921,75527,76150,76181,76337,76593,76597,76705,76707,77845,77886,79019,79755,80160,80261,80263,81000,81001,81718,81774,81902,82205,82209,82307,82308,82535,82912,82976,83048,84044,84045,84108,84793,86394,86414,86846,86851,86931,86932,87107,87241,88295,90427,90502,91250,91253,91423,92521,92599,92600,92906,93349,94098,94459,95305,96608,97091,97957,98273,100409,100890,103563,104224,104226,107669,107753,109627,109628,111206,112497,112661,112662,119181,119990,121620,123352,123425,124814,124885,125464,127874,127876,128774,129124,129760,131262,131365,132194,132195,132644,135197,136204,136416,136417,136418,136690,136697,137461,138086,138181,139385,141051,144052,145736,153575,153614,153663,153664,156778,157279,157589,162374,


--WATERSTRIDERS
17882,18134,18135,18281,18680,22056,22299,50859,50960,58067,58112,59239,60134,60411,60804,63755,65241,66880,66881,66882,66891,66892,66895,66898,79334,82933,84640,84642,84643,106309,112331,112334,114577,

--WINDSERPENTS
3247,3249,3424,3472,3630,3631,4117,4118,4119,4346,4347,4348,5056,5291,5307,5308,5349,5708,5756,5834,8336,8438,10581,10882,11357,11359,14234,19428,20673,20749,20797,20999,21123,26038,26446,26806,28477,29693,37557,46146,48249,50784,50785,50786,50788,50790,50792,50797,55317,63543,10209,12912,13041,13057,13155,13155,13240,13241,13332,13404,13530,

--WORMS
2462,5226,8925,9498,10925,11320,11740,11741,11787,11788,11789,14237,14370,14477,15630,21381,25454,26293,26358,26359,26360,29390,29605,30093,30148,30291,30422,30423,33511,49347,51022,51025,51026,51027,51028,51029,57237,57403,57404,57442,59002,59754,59756,63865,65650,65711,66418,67084,67820,73227,74032,78213,81198,81276,81277,82616,84799,84858,85742,88524,91916,94687,98038,102918,106192,136653,139194,153654,153655,153658,

--WASPS
5244,5245,5326,5350,5441,5450,5455,5456,6551,6554,10041,11698,11724,11727,11732,13136,13301,14474,14475,14661,15235,15236,15288,15325,15327,15369,15414,15449,15509,15546,15934,17732,18132,18133,18283,19632,20197,20198,22182,24731,24793,28085,28086,28087,31871,34024,44620,45402,46159,48038,48179,50891,50892,50895,50897,50901,50903,50905,50906,51712,52373,52375,52376,52377,52379,52442,54559,56201,56283,58363,59351,59768,62386,63298,65616,65617,65802,65814,66194,75014,75471,76438,77146,77314,77609,81168,81557,82370,82371,82908,83444,83447,83520,83681,84852,84865,84866,84905,84909,84912,85403,85526,85532,85695,85807,86264,86833,86834,86835,89789,89837,95951,109025,117851,119287,121447,122678,124172,124177,124187,124188,124536,126973,126974,127333,128669,128966,128974,129287,129288,129289,129298,129516,130329,130443,130664,131377,131380,131895,132311,132341,133901,133996,133997,133999,134001,134147,134155,134519,135769,137450,137714,139145,140275,140594,141901,143510,153268,154308,154354,154367,155489,157565,157567,159925,159926,162140,162147,162150,162373,163045,163091,

}

AOTH.petscan = {
  {31048 , 69     },
  {11415 , 118    },
  {18156 , 299    },
  {22320 , 330    },
  {377   , 390    },
  {366   , 442    },
  {8871  , 454    },
  {389   , 524    },
  {3035  , 547    },
  {2437  , 683    },
  {8797  , 690    },
  {45450 , 688    },
  {11317 , 687    },
  {616   , 731    },
  {46056 , 689    },
  {614   , 772    },
  {46057 , 689    },
  {615   , 854    },
  {649   , 1017   },
  {698   , 1085   },
  {670   , 1015   },
  {648   , 1022   },
  {1039  , 1150   },
  {748   , 1199   },
  {843   , 1108   },
  {283   , 1112   },
  {719   , 1129   },
  {845   , 1114   },
  {8843  , 1128   },
  {410   , 1194   },
  {11416 , 1133   },
  {70185 , 1130   },
  {762   , 1189   },
  {447   , 1508   },
  {47213 , 1554   },
  {9020  , 1548   },
  {45449 , 1550   },
  {47211 , 1553   },
  {45446 , 1551   },
  {45945 , 1552   },
  {792   , 1559   },
  {11452 , 1713   },
  {1993  , 1820   },
  {709   , 1986   },
  {869   , 1980   },
  {11448 , 2032   },
  {11454 , 2031   },
  {868   , 1979   },
  {10832 , 1995   },
  {14318 , 2043   },
  {2300  , 2407   },
  {815   , 2635   },
  {381   , 3099   },
  {1034  , 3231   },
  {4472  , 3619   },
  {1092  , 3652   },
  {2297  , 4014   },
  {8015  , 4031   },
  {925   , 4342   },
  {3202  , 5287   },
  {35353 , 10979  },
  {711   , 11739  },
  {6368  , 13599  },
  {4615  , 17034  },
  {782   , 21340  },
  {22388 , 24388  },
  {23333 , 25721  },
  {22501 , 27523  },
  {45200 , 50353  },
  {22204 , 50866  },
  {46248 , 51010  },
  {2177  , 62893  },
  {1284  , 96167  },
  {1104  , 142711 },
  {14316 , 144993 },
  {982   , 153589 },
  {9372  , 2753   },
  {8869  , 2966   },
  {2486  , 3125   },
  {2574  , 4355   },
  {814   , 4343   },
  {2548  , 4344   },
  {9565  , 4823   },
  {11097 , 5246   },
  {11093 , 5451   },
  {4457  , 5857   },
  {16882 , 5983   },
  {5291  , 6508   },
  {3212  , 6648   },
  {6293  , 7547   },
  {5207  , 7387   },
  {45471 , 8130   },
  {37770 , 8213   },
  {9280  , 8961   },
  {3005  , 8928   },
  {2194  , 8928   },
  {2489  , 8926   },
  {8412  , 9167   },
  {8910  , 9657   },
  {15182 , 11371  },
  {37571 , 11497  },
  {12149 , 11698  },
  {45462 , 11786  },
  {2714  , 14228  },
  {34437 , 14266  },
  {70186 , 14344  },
  {37579 , 14475  },
  {15533 , 15240  },
  {11142 , 15325  },
  {12151 , 15461  },
  {15739 , 15509  },
  {6633  , 15622  },
  {15593 , 15653  },
  {15592 , 16349  },
  {76365 , 16874  },
  {20066 , 17556  },
  {741   , 18033  },
  {19404 , 18130  },
  {9370  , 20748  },
  {21171 , 20783  },
  {37553 , 26358  },
  {29113 , 28085  },
  {25460 , 28477  },
  {25864 , 29033  },
  {25785 , 29889  },
  {26331 , 30455  },
  {26262 , 30422  },
  {24908 , 30952  },
  {20763 , 32435  },
  {28084 , 32591  },
  {28489 , 33194  },
  {25384 , 33529  },
  {25173 , 33530  },
  {28820 , 33711  },
  {26940 , 34302  },
  {29810 , 35397  },
  {31000 , 37091  },
  {19732 , 38187  },
  {1220  , 39337  },
  {2766  , 40656  },
  {4689  , 45353  },
  {34899 , 46123  },
  {11997 , 46910  },
  {37549 , 47386  },
  {36273 , 48132  },
  {36150 , 48450  },
  {70191 , 50931  },
  {46543 , 50916  },
  {46520 , 50915  },
  {15336 , 51002  },
  {37814 , 52226  },
  {37860 , 52376  },
  {30181 , 52441  },
  {30182 , 52441  },
  {30183 , 52441  },
  {37991 , 52622  },
  {38543 , 53753  },
  {74790 , 53884  },
  {38614 , 54027  },
  {38638 , 54128  },
  {38693 , 54227  },
  {38634 , 54320  },
  {41074 , 56239  },
  {34067 , 56401  },
  {40227 , 57404  },
  {23234 , 57422  },
  {39807 , 57797  },
  {39806 , 57797  },
  {44478 , 58435  },
  {2537  , 58808  },
  {32064 , 58809  },
  {39723 , 58884  },
  {25868 , 59251  },
  {15227 , 59235  },
  {40876 , 59670  },
  {43342 , 59756  },
  {10830 , 59757  },
  {23985 , 59782  },
  {45062 , 60401  },
  {26823 , 60783  },
  {41445 , 60875  },
  {41833 , 61086  },
  {45058 , 61091  },
  {36282 , 61090  },
  {45059 , 61090  },
  {41962 , 61159  },
  {35424 , 61259  },
  {632   , 2731   },
  {1059  , 3035   },
  {1451  , 2972   },
  {2732  , 3127   },
  {1000  , 3228   },
  {6884  , 4032   },
  {2307  , 4144   },
  {2699  , 5307   },
  {8838  , 7443   },
  {5448  , 7383   },
  {46060 , 8138   },
  {34048 , 8207   },
  {11414 , 8211   },
  {37536 , 8299   },
  {24741 , 8303   },
  {37409 , 8596   },
  {37569 , 8660   },
  {9030  , 8925   },
  {7829  , 11359  },
  {46059 , 11785  },
  {10996 , 14370  },
  {14523 , 14477  },
  {6068  , 14476  },
  {15327 , 15196  },
  {15357 , 15290  },
  {15742 , 15348  },
  {15436 , 15429  },
  {15498 , 15414  },
  {15743 , 15510  },
  {15576 , 15620  },
  {15660 , 15698  },
  {15969 , 16041  },
  {16049 , 16178  },
  {15938 , 16179  },
  {7897  , 16175  },
  {16054 , 16181  },
  {15934 , 16310  },
  {16245 , 16348  },
  {15964 , 16448  },
  {19331 , 16492  },
  {27943 , 16698  },
  {16587 , 16701  },
  {18701 , 16863  },
  {18380 , 18220  },
  {45045 , 18680  },
  {17545 , 18851  },
  {19219 , 18964  },
  {9562  , 19423  },
  {18417 , 20075  },
  {19405 , 20196  },
  {75391 , 20682  },
  {17528 , 22884  },
  {6299  , 23206  },
  {10808 , 24673  },
  {16050 , 29411  },
  {19252 , 31871  },
  {16189 , 32841  },
  {9031  , 33511  },
  {141   , 35409  },
  {1042  , 39337  },
  {10957 , 39588  },
  {19998 , 41645  },
  {1106  , 42235  },
  {75392 , 45227  },
  {16872 , 48918  },
  {704   , 50302  },
  {20309 , 50725  },
  {46994 , 50952  },
  {36896 , 51122  },
  {37709 , 52011  },
  {37988 , 52345  },
  {12168 , 52795  },
  {37712 , 52831  },
  {38232 , 53232  },
  {38455 , 53658  },
  {38780 , 54321  },
  {38776 , 54374  },
  {38342 , 54541  },
  {39066 , 54688  },
  {41324 , 59309  },
  {41003 , 59772  },
  {45412 , 59772  },
  {42644 , 59915  },
  {41239 , 60134  },
  {5505  , 60198  },
  {74529 , 61087  },
  {1986  , 61325  },
  {7920  , 62119  },
  {41073 , 62937  },
  {16259 , 63060  },
  {42783 , 62914  },
  {42898 , 63116  },
  {42926 , 63298  },
  {43110 , 63537  },
  {43105 , 63538  },
  {11449 , 2070   },
  {1250  , 3110   },
  {37581 , 3253   },
  {37583 , 4132   },
  {1962  , 4356   },
  {1453  , 4701   },
  {1232  , 4700   },
  {4486  , 4863   },
  {94302 , 5326   },
  {20027 , 21064  },
  {20029 , 21056  },
  {20634 , 21956  },
  {22131 , 23691  },
  {37573 , 23834  },
  {20857 , 24172  },
  {23516 , 26027  },
  {23574 , 26119  },
  {3188  , 28213  },
  {20833 , 34018  },
  {1978  , 37206  },
  {30990 , 38206  },
  {24736 , 40337  },
  {45477 , 40403  },
  {35103 , 40458  },
  {35109 , 40458  },
  {35105 , 40458  },
  {35106 , 40458  },
  {31956 , 40624  },
  {73332 , 41166  },
  {960   , 41343  },
  {25298 , 41420  },
  {954   , 42170  },
  {69047 , 42183  },
  {903   , 42717  },
  {29056 , 42712  },
  {32927 , 43182  },
  {45947 , 44113  },
  {34262 , 45128  },
  {34413 , 45340  },
  {36220 , 48242  },
  {32031 , 50468  },
  {41004 , 50944  },
  {31046 , 51369  },
  {46871 , 68584  },
  {820   , 91171  },
  {31981 , 92117  },
  {1244  , 97434  },
  {6909  , 111884 },
  {999   , 124567 },
  {34168 , 132319 },
  {1157  , 137967 },
  {26760 , 139521 },
  {180   , 142339 },
  {46232 , 142438 },
  {801   , 144052 },
  {2609  , 149836 },
  {32025 , 154936 },
  {34248 , 162361 },
  {2729  , 162364 },
  {1454  , 2972   },
  {35655 , 4015   },
  {6191  , 7390   },
  {3200  , 7446   },
  {6298  , 7554   },
  {7896  , 8601   },
  {8182  , 8925   },
  {9032  , 8925   },
  {8511  , 9163   },
  {37671 , 10077  },
  {9469  , 10177  },
  {11009 , 10925  },
  {633   , 11365  },
  {11088 , 11727  },
  {12152 , 11724  },
  {15439 , 15320  },
  {15582 , 15630  },
  {15506 , 15651  },
  {18167 , 16347  },
  {27681 , 16548  },
  {16572 , 16880  },
  {18378 , 17129  },
  {16885 , 17620  },
  {17653 , 18286  },
  {17723 , 18381  },
  {20093 , 20729  },
  {20839 , 20749  },
  {19766 , 20754  },
  {15433 , 21864  },
  {19249 , 21878  },
  {1038  , 24138  },
  {9354  , 24794  },
  {9029  , 24794  },
  {23507 , 26050  },
  {9755  , 29412  },
  {19995 , 41645  },
  {38    , 45825  },
  {15275 , 46146  },
  {15657 , 47387  },
  {45201 , 50357  },
  {47126 , 50797  },
  {38913 , 50833  },
  {20814 , 50940  },
  {10193 , 51442  },
  {909   , 52146  },
  {17795 , 66514  },
  {17180 , 76473  },
  {16876 , 86134  },
  {78841 , 154779 },
  {94713 , 161962 },
  {94712 , 161961 },
  {917   , 2734   },
  {11451 , 2961   },
  {1537  , 4008   },
  {1080  , 4341   },
  {157   , 5458   },
  {2278  , 5766   },
  {6288  , 7543   },
  {14524 , 11741  },
  {11413 , 12431  },
  {2742  , 16931  },
  {19742 , 21124  },
  {20605 , 21922  },
  {21282 , 22181  },
  {21192 , 23014  },
  {30030 , 36147  },
  {17654 , 36732  },
  {30306 , 36740  },
  {30462 , 36871  },
  {31174 , 37865  },
  {30964 , 38141  },
  {31073 , 38374  },
  {45946 , 39186  },
  {1035  , 39452  },
  {31722 , 40198  },
  {22778 , 40295  },
  {32670 , 42078  },
  {2446  , 42193  },
  {785   , 42290  },
  {29057 , 42720  },
  {780   , 43340  },
  {3031  , 43498  },
  {30963 , 44188  },
  {703   , 44627  },
  {31588 , 47204  },
  {10270 , 47327  },
  {91    , 47388  },
  {3886  , 48873  },
  {36637 , 48982  },
  {37200 , 49586  },
  {33004 , 50342  },
  {22791 , 50313  },
  {36901 , 50545  },
  {33990 , 52224  },
  {15137 , 55317  },
  {1206  , 61325  },
  {41935 , 61618  },
  {41540 , 61618  },
  {42203 , 61689  },
  {45899 , 61752  },
  {40944 , 61875  },
  {5585  , 62019  },
  {42453 , 62372  },
  {42983 , 63358  },
  {4440  , 63555  },
  {36617 , 63548  },
  {36616 , 63548  },
  {17834 , 63725  },
  {30409 , 68502  },
  {47818 , 70018  },
  {48112 , 72775  },
  {51277 , 73364  },
  {51301 , 73543  },
  {47856 , 73732  },
  {52723 , 74208  },
  {51990 , 74405  },
  {53610 , 77021  },
  {59888 , 78390  },
  {61633 , 78547  },
  {28212 , 80082  },
  {55671 , 80321  },
  {55718 , 80398  },
  {55460 , 80405  },
  {55459 , 80541  },
  {59926 , 80694  },
  {59741 , 82370  },
  {59730 , 82515  },
  {57263 , 82617  },
  {55931 , 82722  },
  {18194 , 82933  },
  {56062 , 83591  },
  {57970 , 83817  },
  {58576 , 84935  },
  {60746 , 85429  },
  {47931 , 85527  },
  {60875 , 85667  },
  {59084 , 85762  },
  {38473 , 85872  },
  {59085 , 85906  },
  {59330 , 86067  },
  {57956 , 86263  },
  {58106 , 86286  },
  {59577 , 86420  },
  {60086 , 86728  },
  {60156 , 86848  },
  {60282 , 87107  },
  {61307 , 87250  },
  {70430 , 87250  },
  {60819 , 88222  },
  {60889 , 88415  },
  {55977 , 88630  },
  {64721 , 89688  },
  {54228 , 89749  },
  {61892 , 90206  },
  {70439 , 90206  },
  {62440 , 91407  },
  {7937  , 2671   },
  {1229  , 2970   },
  {1397  , 3398   },
  {1058  , 3416   },
  {949   , 3633   },
  {979   , 3812   },
  {643   , 3939   },
  {2173  , 4044   },
  {14319 , 4694   },
  {12336 , 14237  },
  {14779 , 14756  },
  {14938 , 14878  },
  {15136 , 15041  },
  {15335 , 15236  },
  {3956  , 16354  },
  {37949 , 17254  },
  {17751 , 18128  },
  {18314 , 18213  },
  {17812 , 18463  },
  {17408 , 18706  },
  {18269 , 18839  },
  {19690 , 18883  },
  {19788 , 19428  },
  {20838 , 20749  },
  {20842 , 20749  },
  {19759 , 20751  },
  {16217 , 24761  },
  {1955  , 26622  },
  {744   , 50302  },
  {17062 , 50731  },
  {46285 , 50957  },
  {19705 , 52839  },
  {22089 , 58889  },
  {17752 , 87796  },
  {10824 , 142335 },
  {1055  , 2732   },
  {6807  , 2954   },
  {2485  , 3124   },
  {2187  , 3426   },
  {755   , 3637   },
  {2764  , 4727   },
  {3211  , 5305   },
  {2703  , 14234  },
  {613   , 15101  },
  {2031  , 26021  },
  {47120 , 50790  },
  {4735  , 61415  },
  {1917  , 99119  },
  {388   , 142341 },
  {981   , 153462 },
  {90513 , 154833 },
  {91111 , 154838 },
  {4317  , 5048   },
  {5297  , 5456   },
  {1308  , 5827   },
  {11091 , 6552   },
  {8837  , 7445   },
  {4768  , 8437   },
  {15386 , 11740  },
  {11348 , 11921  },
  {1954  , 16173  },
  {20026 , 21055  },
  {10916 , 35434  },
  {1337  , 39385  },
  {759   , 48248  },
  {11032 , 59197  },
  {2571  , 62654  },
  {92    , 117851 },
  {2705  , 133321 },
  {88619 , 154840 },
  {10898 , 3721   },
  {1992  , 3818   },
  {4585  , 4110   },
  {7839  , 4400   },
  {11319 , 6581   },
  {6190  , 7389   },
  {6805  , 17202  },
  {6076  , 37089  },
  {6196  , 44014  },
  {1746  , 50876  },
  {2536  , 61253  },
  {45995 , 62953  },
  {23481 , 80228  },
  {3248  , 136393 },
  {75369 , 154823 },
  {75370 , 154823 },
  {37555 , 2175   },
  {5027  , 2505   },
  {598   , 3121   },
  {2741  , 4725   },
  {706   , 5352   },
  {11107 , 5457   },
  {4456  , 5856   },
  {3026  , 5992   },
  {5985  , 7405   },
  {6192  , 7391   },
  {11106 , 11730  },
  {70188 , 12037  },
  {6737  , 12207  },
  {10810 , 12801  },
  {37568 , 14343  },
  {37548 , 14474  },
  {14572 , 15067  },
  {15338 , 15235  },
  {11417 , 18477  },
  {17094 , 21033  },
  {37404 , 23930  },
  {23506 , 26056  },
  {23895 , 26521  },
  {26280 , 28009  },
  {26279 , 28009  },
  {26583 , 28098  },
  {45469 , 28203  },
  {10618 , 29319  },
  {19768 , 29698  },
  {26758 , 30093  },
  {26822 , 30158  },
  {26263 , 30148  },
  {27006 , 32361  },
  {45960 , 33227  },
  {29042 , 34034  },
  {29808 , 35398  },
  {788   , 37084  },
  {36211 , 48609  },
  {33217 , 48641  },
  {23992 , 49249  },
  {46227 , 50337  },
  {5240  , 50846  },
  {26267 , 50993  },
  {37540 , 51022  },
  {33998 , 51037  },
  {15288 , 52418  },
  {10828 , 59774  },
  {2956  , 61367  },
  {1987  , 61439  },
  {42224 , 61747  },
  {42225 , 61747  },
  {42334 , 61890  },
  {4732  , 61829  },
  {32813 , 62023  },
  {36620 , 62189  },
  {45913 , 62375  },
  {42575 , 62620  },
  {36332 , 62900  },
  {25390 , 62835  },
  {25391 , 62835  },
  {42859 , 63293  },
  {36388 , 63550  },
  {28998 , 63558  },
  {22468 , 63849  },
  {43911 , 63981  },
  {43127 , 64232  },
  {45854 , 64633  },
  {43895 , 65339  },
  {45338 , 65428  },
  {40228 , 65650  },
  {44605 , 65799  },
  {44646 , 65799  },
  {40879 , 66213  },
  {45505 , 66448  },
  {45463 , 66448  },
  {45254 , 66605  },
  {45255 , 66605  },
  {45776 , 67128  },
  {44551 , 67230  },
  {46171 , 67329  },
  {47805 , 67576  },
  {48131 , 67576  },
  {48132 , 67576  },
  {48133 , 67576  },
  {47800 , 67703  },
  {47799 , 67703  },
  {47804 , 67763  },
  {46628 , 68079  },
  {42874 , 68585  },
  {46872 , 68585  },
  {46902 , 68666  },
  {46941 , 68819  },
  {47690 , 69794  },
  {48211 , 69849  },
  {47776 , 69943  },
  {47820 , 70020  },
  {47821 , 70020  },
  {47822 , 70020  },
  {47957 , 70258  },
  {47240 , 70493  },
  {47441 , 70493  },
  {48664 , 71020  },
  {2715  , 72247  },
  {51282 , 72843  },
  {51127 , 73161  },
  {51183 , 73223  },
  {51270 , 73355  },
  {40908 , 73533  },
  {51742 , 73542  },
  {51505 , 73741  },
  {51530 , 73809  },
  {55523 , 74206  },
  {52010 , 74446  },
  {11453 , 4067   },
  {38585 , 4263   },
  {37405 , 8598   },
  {37773 , 10356  },
  {10990 , 11325  },
  {471   , 11364  },
  {37748 , 14233  },
  {20329 , 21381  },
  {20730 , 23206  },
  {23519 , 26030  },
  {37554 , 26360  },
  {37781 , 26418  },
  {23962 , 26483  },
  {37550 , 30291  },
  {24235 , 31233  },
  {28539 , 33274  },
  {28647 , 33505  },
  {28645 , 33502  },
  {28871 , 33776  },
  {29809 , 35399  },
  {1241  , 36094  },
  {1960  , 37956  },
  {19734 , 38187  },
  {787   , 41400  },
  {33275 , 43007  },
  {45455 , 43339  },
  {33512 , 43800  },
  {28819 , 44626  },
  {22003 , 46153  },
  {20521 , 47544  },
  {37196 , 49590  },
  {40147 , 49871  },
  {37567 , 50044  },
  {37282 , 50058  },
  {36726 , 50138  },
  {46665 , 50328  },
  {46250 , 50726  },
  {36634 , 51067  },
  {30180 , 52441  },
  {36006 , 60200  },
  {6303  , 61142  },
  {45852 , 62998  },
  {42877 , 63116  },
  {47235 , 70015  },
  {33559 , 76199  },
  {59747 , 86757  },
  {46574 , 87362  },
  {68292 , 103621 },
  {62385 , 113202 },
  {73708 , 115152 },
  {800   , 117672 },
  {83283 , 124187 },
  {76594 , 124271 },
  {79634 , 127852 },
  {38283 , 127951 },
  {82697 , 130757 },
  {80502 , 133997 },
  {33863 , 134521 },
  {34194 , 134825 },
  {321   , 140738 },
  {8180  , 144122 },
  {78243 , 152555 },
  {90515 , 154837 },
  {90521 , 154837 },
  {78240 , 154832 },
  {11450 , 2237   },
  {1149  , 2347   },
  {1228  , 2969   },
  {3195  , 5454   },
  {4716  , 6021   },
  {46058 , 6215   },
  {10900 , 6347   },
  {5287  , 6502   },
  {34324 , 8300   },
  {12682 , 8763   },
  {7569  , 26806  },
  {2710  , 34019  },
  {4435  , 50735  },
  {802   , 53523  },
  {21268 , 58678  },
  {5586  , 62257  },
  {1744  , 97247  },
  {3030  , 2033   },
  {1230  , 2973   },
  {1959  , 3123   },
  {776   , 3825   },
  {1991  , 3817   },
  {2175  , 4041   },
  {4312  , 5755   },
  {4424  , 5828   },
  {2743  , 5990   },
  {45948 , 5990   },
  {10892 , 6379   },
  {844   , 6514   },
  {6290  , 7544   },
  {12155 , 11734  },
  {34691 , 11897  },
  {12966 , 13036  },
  {2303  , 13301  },
  {13589 , 13596  },
  {7046  , 13896  },
  {14367 , 14020  },
  {37735 , 14222  },
  {9749  , 15317  },
  {11095 , 15521  },
  {16873 , 17201  },
  {178   , 17373  },
  {2352  , 19459  },
  {18719 , 19771  },
  {19347 , 20058  },
  {19678 , 20324  },
  {19758 , 20728  },
  {19987 , 21010  },
  {20146 , 21195  },
  {17797 , 21373  },
  {20831 , 22180  },
  {1281  , 22807  },
  {22349 , 22943  },
  {21381 , 23231  },
  {22457 , 24479  },
  {22641 , 24793  },
  {22938 , 25147  },
  {23316 , 25464  },
  {23237 , 25498  },
  {23403 , 25817  },
  {15903 , 25989  },
  {35152 , 47071  },
  {36151 , 48449  },
  {14951 , 48455  },
  {37199 , 49588  },
  {29740 , 50313  },
  {19838 , 50320  },
  {19839 , 50320  },
  {19607 , 50815  },
  {18029 , 50779  },
  {37861 , 52377  },
  {38749 , 54319  },
  {38777 , 54383  },
  {46001 , 54491  },
  {39009 , 54533  },
  {45682 , 56198  },
  {45423 , 56198  },
  {36636 , 56404  },
  {39511 , 58449  },
  {36648 , 62181  },
  {8971  , 62256  },
  {45991 , 63094  },
  {2957  , 63004  },
  {36944 , 62916  },
  {45992 , 63094  },
  {1141  , 62885  },
  {40217 , 63282  },
  {45996 , 63291  },
  {47806 , 70011  },
  {53719 , 77137  },
  {53117 , 78275  },
  {53764 , 82031  },
  {58570 , 84915  },
  {16879 , 86134  },
  {60862 , 88356  },
  {60876 , 88401  },
  {60923 , 88480  },
  {58766 , 88572  },
  {61127 , 88805  },
  {55454 , 89031  },
  {61484 , 89132  },
  {58606 , 89198  },
  {61583 , 89243  },
  {61703 , 89388  },
  {35132 , 89758  },
  {62466 , 90213  },
  {20996 , 92235  },
  {21371 , 93236  },
  {58760 , 93352  },
  {70334 , 97124  },
  {19403 , 101110 },
  {806   , 106467 },
  {68296 , 107552 },
  {72720 , 113185 },
  {1772  , 113756 },
  {73689 , 115143 },
  {73690 , 115143 },
  {73919 , 115673 },
  {76299 , 124439 },
  {1418  , 124594 },
  {79639 , 127863 },
  {32926 , 2926   },
  {2423  , 4374   },
  {7840  , 4399   },
  {2716  , 4662   },
  {10914 , 4700   },
  {6292  , 7546   },
  {12150 , 11723  },
  {15654 , 15370  },
  {15452 , 15449  },
  {10269 , 15699  },
  {25733 , 15966  },
  {15992 , 16085  },
  {17061 , 16900  },
  {4566  , 17035  },
  {19581 , 17133  },
  {37560 , 17525  },
  {19582 , 18205  },
  {18923 , 18647  },
  {18416 , 18982  },
  {18494 , 19055  },
  {19584 , 19183  },
  {19531 , 20330  },
  {19669 , 20517  },
  {37779 , 20610  },
  {19702 , 20618  },
  {19979 , 21013  },
  {19893 , 20906  },
  {22130 , 24133  },
  {22458 , 24478  },
  {246   , 26016  },
  {23513 , 26017  },
  {1283  , 37085  },
  {1938  , 40527  },
  {161   , 42104  },
  {18723 , 45402  },
  {46983 , 50743  },
  {18722 , 59768  },
  {3201  , 93318  },
  {958   , 128612 },
  {17709 , 146321 },
  {11411 , 2275   },
  {34636 , 2462   },
  {557   , 2728   },
  {10890 , 5304   },
  {10933 , 5833   },
  {10893 , 6378   },
  {5239  , 6498   },
  {12159 , 11726  },
  {15395 , 15361  },
  {15663 , 15705  },
  {15984 , 16069  },
  {6121  , 16117  },
  {7893  , 16177  },
  {19844 , 16932  },
  {19220 , 17131  },
  {18353 , 18226  },
  {11419 , 18476  },
  {18042 , 18648  },
  {20725 , 19429  },
  {19298 , 20038  },
  {19299 , 20039  },
  {20001 , 20327  },
  {17753 , 20387  },
  {19600 , 20408  },
  {20263 , 20502  },
  {19771 , 20611  },
  {19779 , 20777  },
  {19695 , 21816  },
  {16631 , 24922  },
  {22776 , 24968  },
  {22855 , 25062  },
  {22903 , 25109  },
  {23329 , 25711  },
  {19663 , 25867  },
  {18043 , 28342  },
  {26304 , 29487  },
  {27014 , 30423  },
  {28010 , 32517  },
  {28482 , 33188  },
  {28649 , 33510  },
  {28734 , 33578  },
  {29806 , 35394  },
  {4434  , 37088  },
  {5305  , 38346  },
  {31275 , 39049  },
  {25089 , 39149  },
  {1990  , 40819  },
  {676   , 41401  },
  {604   , 41478  },
  {32640 , 41922  },
  {6195  , 41919  },
  {32057 , 41922  },
  {32702 , 42171  },
  {1082  , 42336  },
  {45456 , 42543  },
  {4734  , 42714  },
  {807   , 45807  },
  {18724 , 46159  },
  {10831 , 46162  },
  {12341 , 48151  },
  {36153 , 48448  },
  {503   , 50302  },
  {21133 , 50345  },
  {46287 , 50875  },
  {28215 , 54897  },
  {34006 , 56283  },
  {19408 , 59351  },
  {22502 , 59780  },
  {28507 , 61383  },
  {41945 , 61299  },
  {45900 , 62904  },
  {43344 , 63549  },
  {43352 , 63549  },
  {43111 , 63543  },
  {43194 , 63716  },
  {43251 , 63827  },
  {43346 , 63954  },
  {43350 , 63954  },
  {43597 , 64632  },
  {31939 , 65236  },
  {40229 , 65650  },
  {44620 , 65839  },
  {45023 , 66164  },
  {17796 , 66514  },
  {44785 , 66599  },
  {44870 , 66599  },
  {45334 , 66748  },
  {45942 , 66950  },
  {44576 , 67084  },
  {45755 , 67085  },
  {36505 , 67099  },
  {40521 , 67233  },
  {46163 , 67319  },
  {45571 , 67758  },
  {46629 , 68080  },
  {46720 , 68267  },
  {46809 , 68466  },
  {47325 , 68476  },
  {40714 , 68506  },
  {46897 , 68655  },
  {46938 , 68806  },
  {47577 , 69993  },
  {23483 , 75348  },
  {23521 , 80081  },
  {28502 , 85710  },
  {60053 , 87013  },
  {64751 , 88524  },
  {58214 , 88460  },
  {19401 , 88962  },
  {1056  , 96165  },
  {38004 , 7433   },
  {2730  , 48130  },
  {70192 , 50930  },
  {1100  , 59658  },
  {41834 , 63064  },
  {42861 , 63064  },
  {42860 , 63064  },
  {45989 , 63095  },
  {43632 , 63509  },
  {41934 , 63729  },
  {46923 , 68664  },
  {47814 , 70009  },
  {53639 , 86727  },
  {78595 , 128172 },
  {78597 , 128172 },
  {79888 , 128388 },
  {2543  , 129810 },
  {37738 , 129805 },
  {65052 , 130229 },
  {55924 , 130575 },
  {81425 , 130817 },
  {1974  , 132410 },
  {10991 , 132409 },
  {80750 , 137000 },
  {79920 , 141940 },
  {839   , 142497 },
  {88007 , 143819 },
  {8014  , 147222 },
  {52738 , 148296 },
  {90181 , 148988 },
  {90279 , 149348 },
  {36743 , 149375 },
  {78849 , 150120 },
  {90715 , 150356 },
  {90035 , 153801 },
  {91883 , 154092 },
  {91023 , 154706 },
  {78241 , 154814 },
  {1961  , 3068   },
  {336   , 4264   },
  {1742  , 4346   },
  {6084  , 5831   },
  {4872  , 6140   },
  {10899 , 6348   },
  {5288  , 6503   },
  {7271  , 7273   },
  {865   , 7444   },
  {37417 , 7977   },
  {46054 , 8095   },
  {37685 , 8277   },
  {46053 , 8302   },
  {37408 , 8597   },
  {7347  , 8926   },
  {520   , 8933   },
  {37782 , 9166   },
  {8844  , 9622   },
  {8970  , 9691   },
  {14559 , 19784  },
  {20037 , 21063  },
  {20630 , 21952  },
  {20790 , 22100  },
  {20901 , 22255  },
  {21393 , 23266  },
  {37574 , 23598  },
  {21900 , 23909  },
  {22132 , 24681  },
  {23520 , 26033  },
  {16462 , 26625  },
  {24630 , 27421  },
  {25002 , 27914  },
  {25005 , 28001  },
  {25110 , 28001  },
  {25111 , 28001  },
  {25156 , 28011  },
  {25163 , 28011  },
  {25164 , 28011  },
  {809   , 28096  },
  {842   , 28098  },
  {19770 , 29698  },
  {22042 , 30430  },
  {26285 , 32361  },
  {29058 , 34024  },
  {11709 , 34364  },
  {70232 , 34724  },
  {29404 , 34770  },
  {29505 , 34982  },
  {29673 , 35189  },
  {45950 , 35245  },
  {29802 , 35387  },
  {963   , 36197  },
  {10918 , 37555  },
  {31843 , 44138  },
  {10664 , 45399  },
  {34508 , 45450  },
  {418   , 45582  },
  {34912 , 46128  },
  {16244 , 46155  },
  {35578 , 47389  },
  {35951 , 47687  },
  {24708 , 47769  },
  {14557 , 48131  },
  {2768  , 48111  },
  {17093 , 50346  },
  {26618 , 50818  },
  {9074  , 59984  },
  {45880 , 63005  },
  {43202 , 63739  },
  {46905 , 68663  },
  {46954 , 68850  },
  {47341 , 69177  },
  {47548 , 69207  },
  {47439 , 69306  },
  {47487 , 69358  },
  {47887 , 69818  },
  {47994 , 69818  },
  {47747 , 69891  },
  {56174 , 80160  },
  {56108 , 80915  },
  {61674 , 81001  },
  {29878 , 81198  },
  {60445 , 82119  },
  {56900 , 82209  },
  {59517 , 82312  },
  {51579 , 82323  },
  {57724 , 83448  },
  {55978 , 83517  },
  {57771 , 83522  },
  {57803 , 83562  },
  {49259 , 84441  },
  {58410 , 84643  },
  {58615 , 85007  },
  {59913 , 85184  },
  {58736 , 85231  },
  {58768 , 85281  },
  {58770 , 85284  },
  {58826 , 85388  },
  {58822 , 85417  },
  {58169 , 86061  },
  {59352 , 86081  },
  {59541 , 86423  },
  {58621 , 86732  },
  {54112 , 86846  },
  {1221  , 2957   },
  {720   , 3056   },
  {30904 , 3252   },
  {37171 , 3868   },
  {1973  , 5807   },
  {6291  , 7545   },
  {15383 , 11735  },
  {15507 , 15366  },
  {19985 , 21008  },
  {22389 , 24389  },
  {28501 , 24480  },
  {22546 , 24514  },
  {22611 , 30164  },
  {27690 , 34029  },
  {1074  , 35750  },
  {30356 , 36607  },
  {1532  , 37208  },
  {30847 , 37961  },
  {31437 , 39224  },
  {18375 , 40194  },
  {19285 , 41374  },
  {1036  , 41419  },
  {3916  , 41919  },
  {14312 , 41919  },
  {7891  , 41919  },
  {69048 , 42177  },
  {3027  , 42859  },
  {33450 , 44892  },
  {45940 , 45247  },
  {34911 , 46127  },
  {30302 , 47676  },
  {45441 , 48724  },
  {46988 , 50343  },
  {46985 , 50737  },
  {31352 , 50856  },
  {19733 , 50874  },
  {34900 , 51058  },
  {31045 , 51368  },
  {34918 , 58231  },
  {30301 , 58549  },
  {40321 , 58883  },
  {41944 , 61299  },
  {41939 , 61294  },
  {43411 , 62160  },
  {45970 , 62906  },
  {30412 , 62900  },
  {48857 , 71015  },
  {48651 , 71159  },
  {49836 , 72463  },
  {51269 , 73354  },
  {26685 , 74620  },
  {56838 , 76253  },
  {53133 , 76276  },
  {61634 , 76438  },
  {52607 , 76705  },
  {52652 , 77129  },
  {61172 , 77306  },
  {53549 , 77516  },
  {45570 , 77957  },
  {54593 , 79034  },
  {52706 , 80174  },
  {61638 , 80420  },
  {61639 , 80420  },
  {55588 , 80845  },
  {59732 , 82371  },
  {55133 , 82616  },
  {57515 , 83393  },
  {57770 , 83520  },
  {57824 , 83594  },
  {53862 , 84151  },
  {58469 , 84642  },
  {58832 , 84919  },
  {58610 , 85003  },
  {58614 , 85007  },
  {58746 , 85255  },
  {58747 , 85254  },
  {58825 , 85387  },
  {54193 , 86414  },
  {59158 , 86747  },
  {60083 , 86731  },
  {54855 , 87111  },
  {56480 , 87241  },
  {58932 , 87257  },
  {42476 , 87649  },
  {59970 , 87652  },
  {2487  , 3126   },
  {1975  , 3424   },
  {4091  , 3631   },
  {10917 , 4701   },
  {2996  , 5053   },
  {2592  , 5247   },
  {10903 , 5427   },
  {5292  , 6507   },
  {10807 , 7447   },
  {11318 , 9684   },
  {15151 , 11360  },
  {12154 , 11733  },
  {70189 , 14280  },
  {36341 , 14339  },
  {37558 , 14430  },
  {14778 , 14755  },
  {13096 , 15168  },
  {15369 , 15186  },
  {15356 , 15288  },
  {17711 , 17350  },
  {17079 , 17548  },
  {8271  , 18466  },
  {19986 , 21009  },
  {20729 , 21904  },
  {20999 , 22132  },
  {20068 , 23326  },
  {22467 , 24217  },
  {4767  , 26032  },
  {9276  , 34302  },
  {23515 , 42710  },
  {955   , 44130  },
  {6087  , 44166  },
  {1088  , 44284  },
  {34908 , 46129  },
  {1207  , 48945  },
  {17092 , 50348  },
  {15658 , 50745  },
  {21825 , 50865  },
  {37711 , 52013  },
  {37846 , 52344  },
  {38065 , 52894  },
  {38463 , 52981  },
  {38134 , 53048  },
  {38229 , 53225  },
  {38426 , 54338  },
  {46050 , 54557  },
  {39067 , 54700  },
  {39179 , 55236  },
  {34167 , 56070  },
  {44509 , 56106  },
  {44507 , 56106  },
  {27018 , 56357  },
  {9569  , 56652  },
  {40004 , 58112  },
  {40005 , 58112  },
  {40157 , 58645  },
  {39728 , 59105  },
  {40106 , 59384  },
  {40875 , 59671  },
  {6189  , 61313  },
  {16633 , 61677  },
  {15905 , 61877  },
  {42343 , 62050  },
  {36599 , 62185  },
  {35113 , 62524  },
  {36594 , 62524  },
  {45953 , 62628  },
  {42735 , 62852  },
  {42409 , 63001  },
  {43360 , 63096  },
  {43361 , 63096  },
  {43228 , 63767  },
  {25857 , 65616  },
  {23482 , 66368  },
  {51262 , 72762  },
  {49289 , 73011  },
  {51146 , 73166  },
  {51272 , 73357  },
  {53310 , 76576  },
  {55810 , 78277  },
  {55979 , 78856  },
  {55083 , 79413  },
  {54128 , 81276  },
  {54592 , 81598  },
  {53722 , 81598  },
  {18615 , 84640  },
  {52373 , 86000  },
  {61531 , 91250  },
  {19997 , 93003  },
  {64435 , 93058  },
  {64436 , 93058  },
  {63447 , 93142  },
  {65090 , 97127  },
  {71835 , 97205  },
  {22321 , 103480 },
  {64437 , 111571 },
  {27692 , 111784 },
  {40000 , 114577 },
  {68857 , 115158 },
  {73675 , 115141 },
  {70059 , 115665 },
  {62    , 117663 },
  {47233 , 122223 },
  {76305 , 124439 },
  {43155 , 125882 },
  {78956 , 126508 },
  {1538  , 3240   },
  {2546  , 4412   },
  {5127  , 5432   },
  {37545 , 7431   },
  {165   , 10644  },
  {15431 , 15369  },
  {15495 , 15414  },
  {15496 , 15414  },
  {15497 , 15414  },
  {15904 , 15706  },
  {13610 , 15710  },
  {14522 , 15934  },
  {16052 , 16176  },
  {16724 , 17053  },
  {37578 , 18707  },
  {18430 , 18996  },
  {20062 , 19189  },
  {19367 , 19632  },
  {19163 , 19730  },
  {19776 , 20775  },
  {19369 , 41645  },
  {18431 , 42660  },
  {10833 , 42663  },
  {18377 , 42659  },
  {193   , 42859  },
  {15937 , 49346  },
  {15656 , 50746  },
  {20308 , 50728  },
  {35356 , 51048  },
  {20142 , 51017  },
  {17574 , 59785  },
  {83641 , 143196 },
  {88036 , 143818 },
  {91862 , 155455 },
  {91872 , 155455 },
  {8808  , 3866   },
  {2713  , 4248   },
  {45475 , 4728   },
  {6070  , 5989   },
  {10894 , 6377   },
  {5241  , 6501   },
  {4305  , 7268   },
  {10891 , 23772  },
  {11090 , 24731  },
  {1977  , 37207  },
  {2298  , 47485  },
  {46996 , 50788  },
  {46558 , 50955  },
  {6069  , 162380 },
  {4442  , 3256   },
  {11421 , 3862   },
  {10273 , 4693   },
  {3203  , 5288   },
  {6756  , 5306   },
  {7345  , 5419   },
  {10985 , 9698   },
  {11447 , 11376  },
  {12156 , 11731  },
  {11084 , 15323  },
  {8411  , 21900  },
  {37744 , 22105  },
  {21003 , 23206  },
  {21355 , 23232  },
  {15590 , 23945  },
  {1083  , 26706  },
  {23951 , 27230  },
  {8842  , 29562  },
  {27042 , 30456  },
  {28946 , 33238  },
  {46939 , 33810  },
  {46955 , 33810  },
  {46956 , 33810  },
  {28726 , 33975  },
  {29803 , 35400  },
  {1540  , 35412  },
  {30414 , 36911  },
  {30413 , 36909  },
  {33308 , 43296  },
  {45474 , 43981  },
  {18933 , 44020  },
  {4829  , 44109  },
  {33995 , 44599  },
  {33451 , 44892  },
  {33453 , 44892  },
  {33452 , 44892  },
  {1148  , 46158  },
  {34163 , 47072  },
  {8392  , 48146  },
  {34130 , 50330  },
  {46251 , 50838  },
  {28648 , 50995  },
  {2726  , 60800  },
  {42229 , 61758  },
  {37686 , 61827  },
  {42265 , 61826  },
  {5556  , 62019  },
  {27881 , 62121  },
  {42553 , 62555  },
  {43949 , 62763  },
  {45416 , 63796  },
  {43430 , 63956  },
  {42413 , 64046  },
  {45985 , 64242  },
  {45288 , 64323  },
  {45429 , 64670  },
  {43431 , 64982  },
  {43875 , 65323  },
  {44596 , 65774  },
  {44791 , 66104  },
  {45987 , 66450  },
  {45247 , 66595  },
  {40679 , 66595  },
  {40002 , 66891  },
  {42272 , 66881  },
  {46174 , 67332  },
  {43333 , 67475  },
  {46461 , 67820  },
  {46630 , 68081  },
  {46811 , 68468  },
  {45573 , 68653  },
  {46925 , 68662  },
  {47813 , 70008  },
  {48662 , 71033  },
  {51279 , 73367  },
  {59170 , 77122  },
  {58718 , 77430  },
  {54564 , 77634  },
  {52668 , 77881  },
  {52371 , 79386  },
  {55232 , 79524  },
  {53729 , 79662  },
  {55571 , 80192  },
  {53532 , 80838  },
  {57825 , 83588  },
  {47992 , 83642  },
  {57882 , 83681  },
  {59089 , 83746  },
  {52414 , 83841  },
  {61207 , 84002  },
  {54563 , 84044  },
  {54130 , 84108  },
  {46898 , 84190  },
  {52740 , 84856  },
  {54371 , 84858  },
  {61213 , 85357  },
  {59099 , 85773  },
  {52378 , 86730  },
  {61548 , 86717  },
  {46870 , 89288  },
  {26773 , 89756  },
  {41155 , 99675  },
  {37551 , 106192 },
  {55461 , 112861 },
  {26775 , 116571 },
  {18406 , 124529 },
  {79629 , 127847 },
  {79783 , 128137 },
  {77950 , 130943 },
  {18041 , 131284 },
  {81946 , 131608 },
  {55832 , 132068 },
  {82239 , 132127 },
  {35688 , 132318 },
  {82492 , 132584 },
  {84822 , 133234 },
  {82870 , 133357 },
  {84869 , 133603 },
  {79721 , 133842 },
  {36635 , 134521 },
  {3194  , 5450   },
  {7348  , 5429   },
  {5242  , 9683   },
  {15385 , 11737  },
  {2712  , 12418  },
  {12153 , 15318  },
  {15398 , 16445  },
  {19685 , 18155  },
  {37745 , 18259  },
  {20025 , 18464  },
  {16887 , 19461  },
  {19793 , 20797  },
  {20013 , 23132  },
  {2706  , 26038  },
  {42742 , 50759  },
  {46995 , 50785  },
  {4714  , 50949  },
  {46534 , 51027  },
  {46235 , 50901  },
  {16943 , 53623  },
  {295   , 4012   },
  {2700  , 4347   },
  {17814 , 4380   },
  {2765  , 4697   },
  {10889 , 5347   },
  {5290  , 6506   },
  {10809 , 7449   },
  {46740 , 50809  },
  {46667 , 50908  },
  {46230 , 50964  },
  {41938 , 61294  },
  {45968 , 62648  },
  {43351 , 62759  },
  {58382 , 62818  },
  {36953 , 62916  },
  {36955 , 65124  },
  {83052 , 143214 },
  {88005 , 143816 },
  {88006 , 143816 },
  {65774 , 153608 },
  {75367 , 154823 },
  {78843 , 154779 },
  {78842 , 154779 },
  {48173 , 154936 },
  {75333 , 154853 },
  {75334 , 154853 },
  {75337 , 154853 },
  {90734 , 155141 },
  {10723 , 155248 },
  {92233 , 161954 },
  {95144 , 161992 },
  {37743 , 162373 },
  {3210  , 5300   },
  {9990  , 7386   },
  {7114  , 14123  },
  {2767  , 48111  },
  {45427 , 50843  },
  {42892 , 50843  },
  {45433 , 50843  },
  {1043  , 62131  },
  {27682 , 143178 },
  {75354 , 154791 },
  {75352 , 154791 },
  {2708  , 4348   },
  {2308  , 6369   },
  {6294  , 9662   },
  {11086 , 10041  },
  {9563  , 10259  },
  {9564  , 10268  },
  {11010 , 11320  },
  {9229  , 15327  },
  {14562 , 16355  },
  {9277  , 17661  },
  {834   , 24047  },
  {22185 , 37045  },
  {26323 , 48765  },
  {20596 , 50361  },
  {46990 , 50786  },
  {46998 , 50895  },
  {43195 , 62999  },
  {5369  , 63585  },
  {45431 , 64686  },
  {41607 , 65450  },
  {20042 , 66194  },
  {46896 , 68657  },
  {46948 , 68839  },
  {29963 , 68961  },
  {47257 , 69161  },
  {47348 , 69208  },
  {47812 , 69991  },
  {27718 , 85404  },
  {44614 , 111571 },
  {79702 , 127939 },
  {79795 , 128156 },
  {47808 , 130713 },
  {81405 , 130757 },
  {46043 , 134906 },
  {30222 , 135234 },
  {82001 , 143038 },
  {80029 , 143207 },
  {78846 , 143057 },
  {6296  , 143057 },
  {88017 , 143798 },
  {88021 , 143798 },
  {87997 , 144005 },
  {781   , 144052 },
  {380   , 144052 },
  {8840  , 144329 },
  {90422 , 147583 },
  {77752 , 148480 },
  {90141 , 148844 },
  {90184 , 148995 },
  {44445 , 150365 },
  {90733 , 152379 },
  {90730 , 153350 },
  {91885 , 154092 },
  {90033 , 154339 },
  {2453  , 4514   },
  {2424  , 4411   },
  {11079 , 5460   },
  {6757  , 6375   },
  {5294  , 6513   },
  {9958  , 7430   },
  {13009 , 11788  },
  {45445 , 14227  },
  {17798 , 20752  },
  {20098 , 21128  },
  {20849 , 22256  },
  {19797 , 22287  },
  {21382 , 23258  },
  {19400 , 23501  },
  {22536 , 24547  },
  {22966 , 25110  },
  {21304 , 25146  },
  {8409  , 25706  },
  {23517 , 26028  },
  {24564 , 26293  },
  {16901 , 26446  },
  {24461 , 27249  },
  {26359 , 28087  },
  {25860 , 28086  },
  {37546 , 28297  },
  {25330 , 28358  },
  {25708 , 28404  },
  {25457 , 28470  },
  {28089 , 29147  },
  {26165 , 29327  },
  {22639 , 29486  },
  {37780 , 29479  },
  {26265 , 29931  },
  {23793 , 30430  },
  {26282 , 30445  },
  {27543 , 31263  },
  {27627 , 31575  },
  {24907 , 32392  },
  {27975 , 32481  },
  {28217 , 32592  },
  {45937 , 32643  },
  {16205 , 33200  },
  {28948 , 33239  },
  {1037  , 34027  },
  {14344 , 34263  },
  {5510  , 34417  },
  {29254 , 34543  },
  {32323 , 34647  },
  {607   , 34647  },
  {29348 , 34694  },
  {1339  , 34829  },
  {29605 , 34930  },
  {29805 , 35396  },
  {2491  , 44587  },
  {35568 , 46153  },
  {34169 , 46751  },
  {36902 , 46898  },
  {1561  , 50741  },
  {481   , 50748  },
  {45878 , 50722  },
  {19996 , 51018  },
  {46226 , 51063  },
  {37906 , 52442  },
  {38779 , 54324  },
  {46046 , 56833  },
  {40126 , 58363  },
  {42234 , 58811  },
  {40538 , 59020  },
  {25925 , 59528  },
  {42295 , 59675  },
  {40996 , 59742  },
  {45432 , 60573  },
  {41886 , 61160  },
  {9905  , 62022  },
  {42381 , 62187  },
  {36603 , 62915  },
  {6297  , 63849  },
  {40664 , 66595  },
  {41233 , 71491  },
  {35569 , 72753  },
  {20476 , 99744  },
  {34069 , 109326 },
  {24453 , 122548 },
  {45598 , 125132 },
  {42658 , 139235 },
  {78162 , 139488 },
  {86805 , 143189 },
  {1924  , 143057 },
  {88057 , 143811 },
  {22255 , 153629 },
  {45162 , 154505 },
  {45410 , 156759 },
  {40124 , 156759 },
  {37603 , 162378 },
  {8050  , 162381 },
  {2154  , 4011   },
  {12333 , 11789  },
  {13211 , 11789  },
  {4269  , 12800  },
  {21240 , 14223  },
  {15362 , 15962  },
  {67596 , 50763  },
  {46830 , 50905  },
  {45434 , 50843  },
  {45879 , 62927  },
  {901   , 62892  },
  {19999 , 82192  },
  {12589 , 90816  },
  {75381 , 143206 },
  {88004 , 143805 },
  {65862 , 153659 },
  {88789 , 154773 },
  {92159 , 154843 },
  {75371 , 154823 },
  {4713  , 4511   },
  {8129  , 6585   },
  {10829 , 7099   },
  {9954  , 7434   },
  {9278  , 8960   },
  {9019  , 9042   },
  {76842 , 9318   },
  {7572  , 9498   },
  {9371  , 9690   },
  {11420 , 9694   },
  {11031 , 11361  },
  {12158 , 11725  },
  {37593 , 14473  },
  {15491 , 15422  },
  {15492 , 15422  },
  {15493 , 15422  },
  {15494 , 15422  },
  {17547 , 15649  },
  {76364 , 16872  },
  {19583 , 17132  },
  {17028 , 17447  },
  {17003 , 17411  },
  {19223 , 18258  },
  {19913 , 20932  },
  {20094 , 21123  },
  {18030 , 21246  },
  {20966 , 21423  },
  {20300 , 21470  },
  {20348 , 21515  },
  {20424 , 21723  },
  {17086 , 22123  },
  {20965 , 22123  },
  {20963 , 22257  },
  {9028  , 24794  },
  {22990 , 25110  },
  {22991 , 25110  },
  {22992 , 25110  },
  {14661 , 25482  },
  {26297 , 25487  },
  {26268 , 25489  },
  {46684 , 26322  },
  {24909 , 26281  },
  {42981 , 26761  },
  {6469  , 26824  },
  {24071 , 26838  },
  {24393 , 27217  },
  {10271 , 27294  },
  {35355 , 27329  },
  {24620 , 27346  },
  {15145 , 28002  },
  {25107 , 28002  },
  {45451 , 28145  },
  {25466 , 28325  },
  {4185  , 28513  },
  {17693 , 28614  },
  {28456 , 28883  },
  {25900 , 29089  },
  {8472  , 29334  },
  {1340  , 29334  },
  {24892 , 29390  },
  {26452 , 29726  },
  {22088 , 29735  },
  {26816 , 30157  },
  {27019 , 30430  },
  {24910 , 31404  },
  {27790 , 32163  },
  {26286 , 32361  },
  {28052 , 32485  },
  {28216 , 32595  },
  {28493 , 33205  },
  {6473  , 34262  },
  {45943 , 34278  },
  {29279 , 34587  },
  {29807 , 35395  },
  {28646 , 36304  },
  {30402 , 36910  },
  {19736 , 37090  },
  {22633 , 38154  },
  {599   , 40064  },
  {10987 , 40717  },
  {34996 , 46278  },
  {35338 , 46896  },
  {35503 , 47053  },
  {30187 , 48278  },
  {30185 , 48442  },
  {30186 , 48441  },
  {30184 , 48440  },
  {36152 , 48451  },
  {37198 , 49587  },
  {37396 , 50051  },
  {36728 , 50154  },
  {37352 , 50159  },
  {19845 , 50320  },
  {26255 , 50335  },
  {20834 , 50727  },
  {15334 , 50747  },
  {27683 , 50765  },
  {11105 , 52009  },
  {37710 , 52012  },
  {15150 , 52085  },
  {38277 , 52173  },
  {25008 , 52347  },
  {37857 , 52379  },
  {2538  , 4378   },
  {3204  , 5308   },
  {37587 , 6583   },
  {2414  , 7803   },
  {15487 , 15421  },
  {15488 , 15421  },
  {15489 , 15421  },
  {15490 , 15421  },
  {17781 , 18134  },
  {18383 , 18257  },
  {18063 , 18670  },
  {19416 , 18880  },
  {20063 , 19350  },
  {37576 , 19458  },
  {19704 , 20673  },
  {16877 , 20925  },
  {14334 , 22946  },
  {7470  , 24794  },
  {19735 , 38187  },
  {5052  , 48128  },
  {12335 , 51025  },
  {20297 , 50730  },
  {5555  , 62019  },
  {27883 , 62994  },
  {1536  , 134744 },
  {15468 , 143042 },
  {88064 , 143815 },
  {88259 , 143928 },
  {90183 , 148991 },
  {81097 , 150119 },
  {90510 , 150254 },
  {90830 , 150357 },
  {90745 , 150377 },
  {68901 , 151147 },
  {91219 , 151631 },
  {91250 , 151700 },
  {91271 , 151788 },
  {91266 , 151764 },
  {40075 , 153596 },
  {91868 , 153655 },
  {92057 , 154309 },
  {92058 , 154309 },
  {90768 , 154422 },
  {40024 , 154505 },
  {43485 , 154506 },
  {91026 , 154708 },
  {91024 , 154829 },
  {78242 , 154814 },
  {32022 , 154936 },
  {74810 , 155712 },
  {74809 , 155709 },
  {74811 , 155715 },
  {74807 , 155711 },
  {74806 , 155716 },
  {74808 , 155710 },
  {74805 , 155713 },
  {80513 , 155895 },
  {44449 , 157279 },
  {45362 , 157290 },
  {93204 , 157524 },
  {86532 , 158685 },
  {94166 , 160196 },
  {74885 , 160341 },
  {95141 , 161919 },
  {94711 , 161959 },
  {95145 , 161997 },
  {88784 , 162525 },
  {95150 , 162663 },
  {2541  , 4376   },
  {4458  , 5858   },
  {11012 , 5928   },
  {10988 , 5937   },
  {10897 , 6349   },
  {6214  , 7319   },
  {10826 , 7376   },
  {10984 , 9695   },
  {9567  , 10220  },
  {9572  , 10259  },
  {10992 , 11326  },
  {12160 , 11729  },
  {15483 , 15319  },
  {19974 , 20999  },
  {5238  , 20931  },
  {20592 , 21897  },
  {45046 , 22299  },
  {19757 , 22353  },
  {21396 , 23051  },
  {21328 , 23198  },
  {9021  , 23939  },
  {21241 , 25447  },
  {2837  , 28003  },
  {16053 , 28233  },
  {1452  , 36113  },
  {30157 , 36482  },
  {2570  , 37083  },
  {31094 , 38453  },
  {21457 , 38845  },
  {31351 , 39183  },
  {37241 , 39440  },
  {21912 , 40276  },
  {20979 , 40581  },
  {21492 , 41084  },
  {677   , 41342  },
  {1950  , 42242  },
  {32764 , 42286  },
  {8870  , 42357  },
  {17090 , 42718  },
  {23518 , 42721  },
  {9476  , 44576  },
  {26522 , 44594  },
  {34913 , 46126  },
  {37136 , 47944  },
  {36499 , 48107  },
  {35577 , 48178  },
  {36148 , 48447  },
  {46999 , 50329  },
  {7837  , 51014  },
  {30507 , 52343  },
  {21362 , 61324  },
  {35956 , 62386  },
  {37538 , 91569  },
  {30256 , 139080 },
  {80512 , 155892 },
  {42838 , 156788 },
  {93311 , 157716 },
  {93349 , 157969 },
  {45823 , 158409 },
  {86531 , 158681 },
  {94706 , 161921 },
  {95148 , 162013 },
  {92904 , 162142 },
  {32812 , 162334 },
  {80504 , 162335 },
  {10825 , 162368 },
  {11143 , 162382 },
  {94896 , 162518 },
  {95151 , 162677 },
  {5554  , 7382   },
  {37406 , 8599   },
  {8181  , 8922   },
  {8184  , 8928   },
  {9033  , 8928   },
  {8909  , 9656   },
  {10031 , 10699  },
  {10114 , 10741  },
  {10054 , 10737  },
  {10278 , 10981  },
  {10993 , 11327  },
  {11085 , 11728  },
  {12683 , 12803  },
  {482   , 15546  },
  {11029 , 22005  },
  {36506 , 29461  },
  {5026  , 45950  },
  {4124  , 46570  },
  {10915 , 48111  },
  {7894  , 48456  },
  {44923 , 50958  },
  {43948 , 62763  },
  {2955  , 62999  },
  {46518 , 78872  },
  {9756  , 80212  },
  {1336  , 129128 },
  {2237  , 156788 },
  {1534  , 162381 },
  {46982 , 50742  },
  {46566 , 50948  },
  {38380 , 63001  },
  {88038 , 143806 },
  {88012 , 143796 },
  {88016 , 143795 },
  {74802 , 154794 },
  {88764 , 154850 },
  {92158 , 154848 },
  {9951  , 50819  },
  {46575 , 50837  },
  {19743 , 50882  },
  {71912 , 50918  },
  {22044 , 58890  },
  {2958  , 61142  },
  {41936 , 61294  },
  {41937 , 61294  },
  {42068 , 61459  },
  {40950 , 62029  },
  {36598 , 62114  },
  {45998 , 62583  },
  {45885 , 62640  },
  {45853 , 62998  },
  {42872 , 63098  },
  {47811 , 70004  },
  {61274 , 86835  },
  {60617 , 88367  },
  {60909 , 88452  },
  {60974 , 88576  },
  {73684 , 115142 },
  {73924 , 115678 },
  {73921 , 115675 },
  {70071 , 115784 },
  {33122 , 120570 },
  {76406 , 121565 },
  {76595 , 122033 },
  {34902 , 122157 },
  {25867 , 122165 },
  {76588 , 122957 },
  {78205 , 123571 },
  {42750 , 126991 },
  {81928 , 127203 },
  {81081 , 127780 },
  {79712 , 127956 },
  {78502 , 128168 },
  {78508 , 128170 },
  {77760 , 128162 },
  {81082 , 128389 },
  {76853 , 128658 },
  {76904 , 129027 },
  {86628 , 129124 },
  {75320 , 134718 },
  {75596 , 136667 },
  {80307 , 140275 },
  {81079 , 143177 },
  {75349 , 143142 },
  {42855 , 143037 },
  {83685 , 143360 },
  {87870 , 143503 },
  {87977 , 143739 },
  {88037 , 143822 },
  {83647 , 145110 },
  {50919 , 150381 },
  {90439 , 151149 },
  {37168 , 151809 },
  {92457 , 151933 },
  {77489 , 152035 },
  {77490 , 151998 },
  {90871 , 152426 },
  {50760 , 152553 },
  {70179 , 153614 },
  {90525 , 154836 },
  {91409 , 155583 },
  {80030 , 157565 },
  {80032 , 157567 },
  {25009 , 50738  },
  {41076 , 58896  },
  {41077 , 58896  },
  {42051 , 61425  },
  {45896 , 62130  },
  {42467 , 62395  },
  {20923 , 62638  },
  {41931 , 63756  },
  {44816 , 65054  },
  {47576 , 70005  },
  {79358 , 128175 },
  {45467 , 130598 },
  {81340 , 130668 },
  {30257 , 142198 },
  {75374 , 154824 },
  {90868 , 154826 },
  {45487 , 50854  },
  {46980 , 50897  },
  {75327 , 154783 },
  {46277 , 50807  },
  {61219 , 50990  },
  {4343  , 61318  },
  {69092 , 143181 },
  {88058 , 143809 },
  {76763 , 148990 },
  {78851 , 154777 },
  {91656 , 154904 },
  {92161 , 154843 },
  {95172 , 161966 },
  {95147 , 162012 },
  {2711  , 162381 },
  {94884 , 162499 },
  {20347 , 50810  },
  {46552 , 50929  },
  {46984 , 51004  },
  {45994 , 63006  },
  {81851 , 131191 },
  {77852 , 131380 },
  {40722 , 131384 },
  {40727 , 131384 },
  {47803 , 131520 },
  {81975 , 131632 },
  {47659 , 131626 },
  {81979 , 131623 },
  {81980 , 131623 },
  {81897 , 133321 },
  {41940 , 137217 },
  {81061 , 138181 },
  {85887 , 138540 },
  {55858 , 138675 },
  {86021 , 138741 },
  {66132 , 139145 },
  {86228 , 139359 },
  {82392 , 139493 },
  {86574 , 140125 },
  {513   , 141981 },
  {30255 , 142198 },
  {37570 , 142713 },
  {88469 , 143035 },
  {88472 , 143035 },
  {81966 , 143176 },
  {81964 , 143510 },
  {88035 , 143817 },
  {90176 , 148981 },
  {77901 , 149363 },
  {89029 , 149654 },
  {80287 , 149851 },
  {87397 , 149851 },
  {81213 , 150126 },
  {77484 , 151998 },
  {74317 , 152551 },
  {7469  , 154316 },
  {40025 , 154505 },
  {40021 , 154505 },
  {90413 , 154894 },
  {74804 , 155687 },
  {74812 , 155714 },
  {40077 , 156756 },
  {29539 , 50839  },
  {36957 , 62895  },
  {36956 , 65187  },
  {47816 , 70016  },
  {79707 , 127947 },
  {79823 , 128051 },
  {14521 , 128116 },
  {5245  , 129347 },
  {55922 , 134780 },
  {87760 , 143160 },
  {44656 , 143048 },
  {75347 , 154785 },
  {75345 , 154785 },
  {37992 , 50803  },
  {46252 , 51007  },
  {37154 , 51090  },
  {37362 , 51402  },
  {38135 , 51635  },
  {37615 , 51663  },
  {37859 , 52375  },
  {38424 , 54322  },
  {38803 , 54438  },
  {27678 , 54487  },
  {38343 , 54539  },
  {45700 , 54896  },
  {29081 , 55095  },
  {38344 , 55187  },
  {40019 , 58163  },
  {40694 , 59975  },
  {40695 , 59975  },
  {43101 , 61619  },
  {42323 , 61971  },
  {62734 , 62178  },
  {42771 , 62899  },
  {15469 , 63548  },
  {39388 , 64937  },
  {76383 , 143197 },
  {81098 , 143814 },
  {75355 , 154791 },
  {39554 , 156780 },
  {39553 , 160691 },
  {42271 , 50859  },
  {2450  , 50946  },
  {34898 , 51057  },
  {40285 , 58766  },
  {29271 , 58891  },
  {26751 , 59197  },
  {40992 , 59747  },
  {40733 , 59975  },
  {40703 , 59975  },
  {41893 , 60051  },
  {45321 , 60196  },
  {42157 , 61565  },
  {45936 , 61703  },
  {42226 , 61747  },
  {42344 , 62051  },
  {36578 , 62127  },
  {45907 , 62186  },
  {42396 , 62760  },
  {42709 , 62819  },
  {40877 , 62760  },
  {42721 , 62829  },
  {45990 , 63095  },
  {47955 , 63559  },
  {46000 , 63850  },
  {45882 , 64352  },
  {34590 , 64352  },
  {42974 , 64436  },
  {43583 , 64551  },
  {45938 , 64634  },
  {43648 , 64745  },
  {45984 , 64804  },
  {45386 , 64899  },
  {28434 , 65617  },
  {45163 , 66464  },
  {43199 , 67087  },
  {40358 , 67071  },
  {42537 , 67475  },
  {43192 , 67712  },
  {44779 , 68585  },
  {46924 , 68660  },
  {47021 , 68841  },
  {47383 , 69246  },
  {47732 , 69848  },
  {47960 , 70260  },
  {48122 , 70422  },
  {48055 , 70451  },
  {48855 , 71017  },
  {48705 , 71200  },
  {48934 , 71488  },
  {48935 , 71488  },
  {48932 , 71488  },
  {48933 , 71488  },
  {49096 , 71721  },
  {49132 , 71786  },
  {51758 , 71923  },
  {49846 , 71942  },
  {855   , 72160  },
  {53113 , 72244  },
  {47991 , 73359  },
  {47858 , 73688  },
  {51502 , 73730  },
  {75359 , 74508  },
  {52230 , 74620  },
  {52459 , 74620  },
  {52595 , 75247  },
  {52731 , 75467  },
  {53360 , 75482  },
  {59008 , 76143  },
  {53222 , 76442  },
  {53317 , 76597  },
  {60837 , 76685  },
  {53542 , 76946  },
  {53328 , 77091  },
  {52379 , 77141  },
  {59740 , 77314  },
  {53890 , 77492  },
  {55603 , 78314  },
  {52376 , 78574  },
  {52375 , 79034  },
  {55082 , 79411  },
  {59894 , 79595  },
  {56401 , 79726  },
  {52559 , 80849  },
  {59726 , 82411  },
  {38281 , 83405  },
  {54413 , 83843  },
  {58547 , 84885  },
  {55604 , 87085  },
  {61308 , 87251  },
  {70431 , 87251  },
  {48084 , 88208  },
  {59130 , 88385  },
  {45473 , 88481  },
  {58974 , 88592  },
  {61070 , 88592  },
  {61071 , 88592  },
  {61128 , 88807  },
  {61299 , 88956  },
  {61890 , 90203  },
  {52415 , 92979  },
  {61982 , 93349  },
  {28397 , 93316  },
  {63622 , 93669  },
  {63691 , 93808  },
  {64722 , 93903  },
  {58411 , 95327  },
  {61632 , 95615  },
  {66088 , 95762  },
  {64585 , 95841  },
  {64720 , 96126  },
  {65089 , 97118  },
  {65130 , 97238  },
  {72868 , 97323  },
  {62609 , 97454  },
  {65274 , 97569  },
  {43798 , 97559  },
  {65390 , 97743  },
  {65418 , 97787  },
  {45883 , 98446  },
  {66414 , 101068 },
  {67000 , 101145 },
  {77552 , 101315 },
  {66605 , 101580 },
  {66310 , 101624 },
  {67550 , 103497 },
  {46278 , 50792  },
  {88019 , 154835 },
  {88033 , 154835 },
  {88766 , 154852 },
  {40719 , 50850  },
  {37360 , 51401  },
  {45458 , 56650  },
  {36642 , 57232  },
  {45417 , 57299  },
  {40225 , 57403  },
  {44770 , 57421  },
  {44662 , 58432  },
  {43324 , 59754  },
  {45077 , 59744  },
  {654   , 61165  },
  {41943 , 61299  },
  {41981 , 61386  },
  {45952 , 61905  },
  {45958 , 62176  },
  {46049 , 62254  },
  {35112 , 62524  },
  {40848 , 62945  },
  {40226 , 63304  },
  {36671 , 65215  },
  {47815 , 70010  },
  {58048 , 78277  },
  {55316 , 79756  },
  {57410 , 80715  },
  {57412 , 80715  },
  {57413 , 80715  },
  {61121 , 80779  },
  {56106 , 80841  },
  {61675 , 81000  },
  {57451 , 81168  },
  {56333 , 81277  },
  {58722 , 81431  },
  {56429 , 81537  },
  {55974 , 81538  },
  {59729 , 82514  },
  {54411 , 82513  },
  {52911 , 82530  },
  {55095 , 82646  },
  {55777 , 83530  },
  {57823 , 83584  },
  {58406 , 84640  },
  {58407 , 84640  },
  {57560 , 85316  },
  {59301 , 86153  },
  {60975 , 88577  },
  {55834 , 89379  },
  {57516 , 89653  },
  {63168 , 89745  },
  {63169 , 89745  },
  {57881 , 89837  },
  {61887 , 90201  },
  {58829 , 90246  },
  {63631 , 90480  },
  {65087 , 97128  },
  {65151 , 97283  },
  {65159 , 97324  },
  {64651 , 97555  },
  {64353 , 97752  },
  {65857 , 97820  },
  {70578 , 97820  },
  {40717 , 98211  },
  {65716 , 98386  },
  {65854 , 98506  },
  {66157 , 99403  },
  {64541 , 99749  },
  {66340 , 99785  },
  {65493 , 101069 },
  {68399 , 103817 },
  {68615 , 104481 },
  {68719 , 104827 },
  {44169 , 105104 },
  {2189  , 105644 },
  {66485 , 106152 },
  {69254 , 106181 },
  {68858 , 106270 },
  {70381 , 108009 },
  {54644 , 109124 },
  {70974 , 109320 },
  {38425 , 109779 },
  {68398 , 109807 },
  {70524 , 110824 },
  {71003 , 111296 },
  {71827 , 111423 },
  {70447 , 112692 },
  {44781 , 112802 },
  {72624 , 113041 },
  {72734 , 113126 },
  {73704 , 115148 },
  {73705 , 115148 },
  {73914 , 115669 },
  {70070 , 115785 },
  {73245 , 115919 },
  {74036 , 116080 },
  {58823 , 116871 },
  {74469 , 117182 },
  {26846 , 117182 },
  {74470 , 117182 },
  {74471 , 117182 },
  {74513 , 117340 },
  {75317 , 119500 },
  {75475 , 119745 },
  {75498 , 119794 },
  {60404 , 119884 },
  {75569 , 119969 },
  {65964 , 120226 },
  {47574 , 120592 },
  {75852 , 120592 },
  {76409 , 121571 },
  {68861 , 121715 },
  {44811 , 122002 },
  {76686 , 122154 },
  {81493 , 122363 },
  {45555 , 122629 },
  {77271 , 123309 },
  {70180 , 123425 },
  {76789 , 123603 },
  {76788 , 123603 },
  {76972 , 126732 },
  {62636 , 126929 },
  {46551 , 50858  },
  {6122  , 50937  },
  {37707 , 52010  },
  {37858 , 52373  },
  {38359 , 53283  },
  {38413 , 53614  },
  {38429 , 53661  },
  {38748 , 54318  },
  {39065 , 54699  },
  {39694 , 54745  },
  {45939 , 55215  },
  {17192 , 55367  },
  {39163 , 55571  },
  {39333 , 55574  },
  {41894 , 60043  },
  {41238 , 60131  },
  {37613 , 60203  },
  {45437 , 60411  },
  {41539 , 60623  },
  {40914 , 60866  },
  {42447 , 61945  },
  {46940 , 62116  },
  {42509 , 62476  },
  {42617 , 62669  },
  {6302  , 63557  },
  {43106 , 63540  },
  {42243 , 63755  },
  {78587 , 63724  },
  {42171 , 66549  },
  {47573 , 70007  },
  {59928 , 86774  },
  {60930 , 88490  },
  {59034 , 88574  },
  {63171 , 89744  },
  {61900 , 90215  },
  {69488 , 96405  },
  {65853 , 96611  },
  {65065 , 97030  },
  {65263 , 97348  },
  {51292 , 97547  },
  {65697 , 98038  },
  {65630 , 98116  },
  {65671 , 98183  },
  {65982 , 98192  },
  {65715 , 98385  },
  {65813 , 98463  },
  {66155 , 99394  },
  {59042 , 99505  },
  {65091 , 108568 },
  {62387 , 109023 },
  {29819 , 115141 },
  {73922 , 115676 },
  {32641 , 120570 },
  {76529 , 121625 },
  {62382 , 122015 },
  {76736 , 122242 },
  {75468 , 122365 },
  {76956 , 122612 },
  {74903 , 123511 },
  {74268 , 124399 },
  {76310 , 124439 },
  {78106 , 124589 },
  {78222 , 124858 },
  {40674 , 125401 },
  {78791 , 126198 },
  {60055 , 126353 },
  {79025 , 126644 },
  {76309 , 126945 },
  {76314 , 126945 },
  {76317 , 126945 },
  {79363 , 128163 },
  {78372 , 128658 },
  {838   , 128959 },
  {80027 , 129289 },
  {80413 , 129301 },
  {81086 , 130359 },
  {81233 , 130443 },
  {46516 , 50813  },
  {35394 , 50922  },
  {10827 , 50804  },
  {46981 , 50744  },
  {46290 , 67759  },
  {47711 , 70082  },
  {48213 , 70154  },
  {48663 , 71022  },
  {48704 , 71199  },
  {51144 , 71529  },
  {64587 , 71655  },
  {49835 , 72462  },
  {53607 , 72606  },
  {51125 , 72765  },
  {51278 , 73366  },
  {58290 , 77093  },
  {53780 , 78673  },
  {59723 , 79703  },
  {58612 , 85005  },
  {58748 , 85257  },
  {58824 , 85389  },
  {61679 , 85537  },
  {56042 , 85695  },
  {37552 , 85742  },
  {59538 , 86425  },
  {60016 , 86879  },
  {59603 , 88573  },
  {59537 , 88957  },
  {40713 , 98211  },
  {40716 , 98211  },
  {73692 , 115144 },
  {73918 , 115672 },
  {74901 , 124279 },
  {78261 , 124944 },
  {84161 , 126645 },
  {8512  , 126725 },
  {79637 , 127858 },
  {80021 , 128966 },
  {82231 , 131892 },
  {4065  , 134048 },
  {83681 , 134519 },
  {1547  , 134690 },
  {833   , 134896 },
  {42751 , 134907 },
  {84121 , 135175 },
  {83864 , 136183 },
  {53092 , 136204 },
  {85538 , 137824 },
  {3187  , 137840 },
  {86135 , 139081 },
  {57548 , 139194 },
  {75380 , 139290 },
  {83645 , 140699 },
  {85524 , 142088 },
  {85797 , 143036 },
  {32790 , 143036 },
  {32789 , 143036 },
  {81076 , 143054 },
  {77486 , 148293 },
  {77903 , 154710 },
  {46987 , 50825  },
  {46741 , 51031  },
  {42064 , 61453  },
  {36580 , 62190  },
  {22447 , 62907  },
  {88786 , 154771 },
  {91235 , 154820 },
  {47124 , 50784  },
  {37856 , 52379  },
  {46229 , 76819  },
  {39729 , 50885  },
  {50613 , 154841 },
  {23998 , 51029  },
  {46517 , 51042  },
  {42365 , 61420  },
  {15471 , 61326  },
  {9556  , 62476  },
  {30159 , 62820  },
  {36644 , 62925  },
  {36613 , 62925  },
  {15470 , 62896  },
  {42897 , 63116  },
  {43097 , 63510  },
  {48212 , 70083  },
  {74908 , 130937 },
  {81984 , 131644 },
  {81998 , 131672 },
  {1072  , 143034 },
  {60901 , 143039 },
  {86533 , 143049 },
  {81055 , 143055 },
  {92157 , 154825 },
  {1208  , 50942  },
  {88834 , 50959  },
  {42297 , 61883  },
  {42408 , 62246  },
  {42407 , 63001  },
  {38672 , 63288  },
  {46385 , 63370  },
  {45894 , 63621  },
  {51281 , 72842  },
  {52707 , 72934  },
  {51264 , 73158  },
  {57300 , 73234  },
  {51268 , 73352  },
  {51413 , 73534  },
  {51475 , 73668  },
  {51476 , 73668  },
  {51477 , 73668  },
  {52280 , 74509  },
  {52737 , 77298  },
  {51582 , 79332  },
  {58175 , 79746  },
  {59194 , 84905  },
  {61265 , 86773  },
  {55972 , 88523  },
  {58767 , 88571  },
  {55831 , 88710  },
  {61133 , 88814  },
  {43432 , 88926  },
  {61300 , 88951  },
  {36585 , 89194  },
  {43221 , 89194  },
  {28869 , 89395  },
  {64535 , 90057  },
  {61888 , 90202  },
  {65111 , 97178  },
  {46709 , 97494  },
  {52372 , 115093 },
  {73673 , 115140 },
  {73920 , 115674 },
  {83281 , 124188 },
  {77918 , 124269 },
  {79075 , 126725 },
  {79630 , 127850 },
  {79631 , 127850 },
  {79796 , 128157 },
  {32807 , 128620 },
  {79748 , 131074 },
  {44916 , 131687 },
  {55923 , 131695 },
  {79303 , 132030 },
  {84093 , 132341 },
  {82414 , 132409 },
  {82490 , 132578 },
  {82688 , 133064 },
  {82740 , 133158 },
  {75850 , 133815 },
  {69809 , 133857 },
  {83359 , 134147 },
  {82053 , 134436 },
  {52599 , 136204 },
  {60433 , 136653 },
  {84897 , 136697 },
  {85021 , 137025 },
  {82052 , 137098 },
  {77900 , 137209 },
  {86224 , 139328 },
  {39725 , 139456 },
  {86302 , 139435 },
  {86313 , 139484 },
  {77476 , 141977 },
  {19729 , 141988 },
  {961   , 142340 },
  {47234 , 143391 },
  {83649 , 145444 },
  {37539 , 152768 },
  {62207 , 153615 },
  {80466 , 154847 },
  {91112 , 154724 },
  {32023 , 154936 },
  {95173 , 161967 },
  {45464 , 51013  },
  {20910 , 51021  },
  {46569 , 51026  },
  {26295 , 50997  },
  {44784 , 58940  },
  {44513 , 59773  },
  {41887 , 61171  },
  {6300  , 62242  },
  {9554  , 62476  },
  {45897 , 62924  },
  {46052 , 114575 },
  {81099 , 143209 },
  {70587 , 153663 },
  {90514 , 154712 },
  {77902 , 154710 },
  {48174 , 154935 },
  {61702 , 154936 },
  {92266 , 155240 },
  {80510 , 155893 },
  {40155 , 156046 },
  {92438 , 161946 },
  {46532 , 50947  },
  {20995 , 61313  },
  {36583 , 62894  },
  {80467 , 143211 },
  {88008 , 143820 },
  {80458 , 143958 },
  {87998 , 144004 },
  {42655 , 145970 },
  {30298 , 147586 },
  {90030 , 148525 },
  {23000 , 148841 },
  {90182 , 148989 },
  {90866 , 150385 },
  {68900 , 151148 },
  {91220 , 151632 },
  {91248 , 151696 },
  {44778 , 152383 },
  {91327 , 152426 },
  {90034 , 152545 },
  {90767 , 152797 },
  {78832 , 154775 },
  {88765 , 154767 },
  {95149 , 162014 },
  {1164  , 162374 },
  {15423 , 51001  },
  {36952 , 62916  },
  {81219 , 143202 },
  {88000 , 143801 },
  {90177 , 148982 },
  {39739 , 150372 },
  {36372 , 151159 },
  {75373 , 151327 },
  {75375 , 151327 },
  {91224 , 151651 },
  {91249 , 151697 },
  {91267 , 151779 },
  {73601 , 152315 },
  {90947 , 152448 },
  {74318 , 152552 },
  {90738 , 153764 },
  {75705 , 154307 },
  {92154 , 154704 },
  {90763 , 156097 },
  {42856 , 63057  },
  {43259 , 63842  },
  {42752 , 65237  },
  {45064 , 65324  },
  {44606 , 65802  },
  {45161 , 66463  },
  {46900 , 68665  },
  {46953 , 68846  },
  {47634 , 69649  },
  {46675 , 69712  },
  {47989 , 69819  },
  {47990 , 69819  },
  {47778 , 69947  },
  {15289 , 71297  },
  {47249 , 127746 },
  {81124 , 130321 },
  {42065 , 131233 },
  {81943 , 131603 },
  {36034 , 131895 },
  {47819 , 133527 },
  {40209 , 134825 },
  {42978 , 134907 },
  {47534 , 135049 },
  {78423 , 137233 },
  {85539 , 137825 },
  {76669 , 138727 },
  {507   , 138963 },
  {86101 , 139049 },
  {86218 , 139298 },
  {86226 , 139336 },
  {81834 , 139483 },
  {86488 , 139770 },
  {2378  , 141034 },
  {87178 , 141239 },
  {87422 , 141729 },
  {78161 , 143198 },
  {88034 , 143799 },
  {89262 , 145947 },
  {90411 , 147619 },
  {88785 , 147679 },
  {90173 , 148979 },
  {70444 , 149138 },
  {15339 , 151859 },
  {68855 , 153465 },
  {82550 , 153462 },
  {91087 , 154724 },
  {47252 , 154842 },
  {88761 , 154851 },
  {89128 , 154935 },
  {90762 , 156098 },
  {90765 , 156100 },
  {20912 , 51008  },
  {45746 , 59744  },
  {45917 , 61375  },
  {36342 , 61690  },
  {10090 , 61828  },
  {42335 , 62020  },
  {9906  , 62022  },
  {9904  , 62022  },
  {26532 , 62120  },
  {5379  , 63002  },
  {44655 , 63365  },
  {38404 , 63726  },
  {43428 , 63841  },
  {43260 , 63842  },
  {43311 , 63919  },
  {14342 , 64638  },
  {14341 , 64638  },
  {46045 , 64726  },
  {44568 , 64983  },
  {43143 , 65632  },
  {45195 , 66491  },
  {46922 , 68659  },
  {47635 , 68845  },
  {47809 , 69998  },
  {43409 , 72288  },
  {61652 , 86750  },
  {61547 , 86719  },
  {61302 , 86932  },
  {60864 , 88359  },
  {60915 , 88466  },
  {58970 , 88589  },
  {61896 , 90212  },
  {69709 , 91308  },
  {63446 , 93143  },
  {63584 , 93483  },
  {63693 , 93814  },
  {66370 , 93856  },
  {63623 , 94463  },
  {59369 , 94495  },
  {44479 , 94718  },
  {64194 , 94867  },
  {64987 , 94986  },
  {23966 , 95270  },
  {64266 , 95328  },
  {62216 , 97079  },
  {65273 , 97568  },
  {65389 , 97741  },
  {65637 , 98128  },
  {65667 , 98172  },
  {65717 , 98237  },
  {66213 , 99528  },
  {64385 , 100328 },
  {68290 , 103628 },
  {64893 , 103681 },
  {64595 , 104364 },
  {30254 , 110501 },
  {52403 , 113757 },
  {73661 , 115135 },
  {73662 , 115135 },
  {70057 , 115664 },
  {77501 , 123650 },
  {79641 , 127862 },
  {71972 , 127953 },
  {20827 , 128093 },
  {78509 , 128171 },
  {78598 , 128173 },
  {76829 , 128396 },
  {52835 , 130165 },
  {81371 , 130224 },
  {81145 , 130164 },
  {76659 , 130403 },
  {76657 , 130403 },
  {43156 , 137721 },
  {82019 , 137724 },
  {86530 , 143049 },
  {86463 , 143821 },
  {92540 , 150376 },
  {68856 , 151684 },
  {63606 , 152092 },
  {91488 , 152445 },
  {34160 , 153594 },
  {65050 , 153691 },
  {70443 , 153612 },
  {88762 , 154767 },
  {91022 , 155073 },
  {91028 , 155073 },
  {90511 , 160414 },
  {46225 , 51062  },
  {40093 , 63003  },
  {40022 , 65238  },
  {81835 , 130948 },
  {88060 , 143810 },
  {88763 , 154769 },
  {46668 , 51044  },
  {9829  , 61253  },
  {1160  , 61253  },
  {42745 , 62201  },
  {45047 , 99633  },
  {4960  , 111158 },
  {40191 , 51076  },
  {45087 , 58895  },
  {45172 , 59139  },
  {45060 , 61090  },
  {36544 , 62991  },
  {4959  , 63957  },
  {40607 , 70327  },
  {88874 , 154822 },
  {44452 , 156778 },
  {44451 , 156778 },
  {44453 , 156778 },
  {43226 , 156931 },
  {18351 , 163072 },
  {37541 , 51600  },
  {41673 , 58415  },
  {44455 , 58768  },
  {45061 , 58880  },
  {74405 , 61167  },
  {35802 , 63004  },
  {41672 , 65773  },
  {45691 , 108626 },
  {368   , 113150 },
  {30223 , 129857 },
  {45908 , 143047 },
  {84857 , 143191 },
  {83653 , 143374 },
  {87871 , 143507 },
  {84157 , 143611 },
  {16880 , 143628 },
  {88059 , 143812 },
  {78928 , 144460 },
  {21936 , 144460 },
  {70286 , 153657 },
  {65051 , 153731 },
  {75332 , 154853 },
  {95143 , 162006 },
  {94895 , 162506 },
  {94943 , 162670 },
  {20917 , 50960  },
  {37361 , 51404  },
  {10133 , 51661  },
  {39380 , 56266  },
  {40881 , 56523  },
  {40718 , 56683  },
  {45081 , 57237  },
  {42233 , 59084  },
  {45749 , 59745  },
  {41892 , 60047  },
  {41297 , 60202  },
  {41296 , 60282  },
  {42906 , 60649  },
  {41676 , 60860  },
  {41674 , 60860  },
  {41675 , 60860  },
  {3126  , 61258  },
  {40154 , 61306  },
  {42412 , 62250  },
  {42554 , 62564  },
  {45923 , 62621  },
  {134   , 62818  },
  {40874 , 64309  },
  {40520 , 65650  },
  {39999 , 66895  },
  {41928 , 88579  },
  {40880 , 101619 },
  {28435 , 109025 },
  {39726 , 139456 },
  {91866 , 153655 },
  {91864 , 153655 },
  {74801 , 154854 },
  {90769 , 156101 },
  {26566 , 156931 },
  {46831 , 50864  },
  {37359 , 51403  },
  {37527 , 51649  },
  {37526 , 51649  },
  {36513 , 58474  },
  {42202 , 61686  },
  {1560  , 61751  },
  {44710 , 62008  },
  {36584 , 62114  },
  {45886 , 62640  },
  {45887 , 62640  },
  {42737 , 62854  },
  {36357 , 63957  },
  {43935 , 91314  },
  {84863 , 143193 },
  {10095 , 154803 },
  {91293 , 154798 },
  {38453 , 54323  },
  {44413 , 54559  },
  {38919 , 54730  },
  {39579 , 54988  },
  {40123 , 54896  },
  {15381 , 55356  },
  {39109 , 55386  },
  {34220 , 55607  },
  {39577 , 55946  },
  {39578 , 55946  },
  {39137 , 56031  },
  {39588 , 59037  },
  {45138 , 59139  },
  {41323 , 59139  },
  {45171 , 59139  },
  {45957 , 59358  },
  {40934 , 59671  },
  {41960 , 61329  },
  {42523 , 62526  },
  {45988 , 62627  },
  {43157 , 63587  },
  {43255 , 63832  },
  {45430 , 64671  },
  {43347 , 65190  },
  {45881 , 65203  },
  {43874 , 65321  },
  {44792 , 66105  },
  {44787 , 66096  },
  {44812 , 66099  },
  {44635 , 66431  },
  {43104 , 66622  },
  {44786 , 66599  },
  {45297 , 66686  },
  {40001 , 66892  },
  {46909 , 68658  },
  {46937 , 68805  },
  {47731 , 69796  },
  {47660 , 69812  },
  {47708 , 69820  },
  {47749 , 69893  },
  {48091 , 70098  },
  {47958 , 70259  },
  {40608 , 70327  },
  {48056 , 70452  },
  {48129 , 70558  },
  {749   , 70595  },
  {16878 , 70858  },
  {48878 , 71014  },
  {48661 , 71019  },
  {48128 , 73223  },
  {48130 , 73223  },
  {51417 , 73350  },
  {51741 , 73368  },
  {51408 , 73532  },
  {51504 , 73738  },
  {51994 , 74413  },
  {59742 , 75471  },
  {52606 , 76707  },
  {53502 , 76873  },
  {52416 , 77155  },
  {53748 , 77221  },
  {53725 , 77307  },
  {52404 , 77513  },
  {59748 , 77719  },
  {54190 , 77927  },
  {53152 , 78514  },
  {56729 , 78857  },
  {54752 , 78895  },
  {59021 , 79410  },
  {55291 , 79730  },
  {58713 , 79920  },
  {56159 , 80263  },
  {53744 , 82778  },
  {52698 , 84943  },
  {58617 , 85014  },
  {56522 , 85403  },
  {38993 , 85694  },
  {59079 , 85694  },
  {55783 , 85760  },
  {30969 , 85846  },
  {15595 , 86445  },
  {59889 , 86810  },
  {60277 , 87089  },
  {61635 , 87425  },
  {49122 , 88134  },
  {60861 , 88355  },
  {58613 , 88514  },
  {60972 , 88575  },
  {60976 , 88579  },
  {56044 , 89789  },
  {54178 , 89791  },
  {61678 , 90124  },
  {40224 , 90208  },
  {51346 , 93124  },
  {65120 , 97207  },
  {36604 , 99814  },
  {59465 , 103629 },
  {70231 , 107679 },
  {43488 , 108624 },
  {65235 , 109594 },
  {69710 , 109819 },
  {67551 , 110253 },
  {71536 , 110340 },
  {69275 , 110350 },
  {43491 , 110703 },
  {71002 , 111202 },
  {31993 , 111571 },
  {71938 , 111984 },
  {64330 , 112336 },
  {72132 , 112637 },
  {72658 , 113136 },
  {45856 , 113493 },
  {59766 , 115137 },
  {73915 , 115668 },
  {76404 , 121562 },
  {46565 , 122223 },
  {77948 , 123076 },
  {68139 , 126726 },
  {79085 , 126726 },
  {81866 , 127290 },
  {55205 , 128099 },
  {79797 , 128158 },
  {79995 , 128547 },
  {80079 , 128658 },
  {87401 , 129049 },
  {49064 , 130439 },
  {81342 , 130508 },
  {45770 , 58489  },
  {45315 , 59743  },
  {4268  , 62184  },
  {42415 , 62255  },
  {45820 , 62888  },
  {15467 , 62925  },
  {36336 , 62900  },
  {45999 , 63547  },
  {43865 , 65313  },
  {44631 , 65839  },
  {38431 , 65878  },
  {41462 , 66208  },
  {44578 , 66208  },
  {37566 , 66319  },
  {45175 , 66421  },
  {45210 , 66421  },
  {45096 , 66418  },
  {45097 , 66418  },
  {45209 , 66605  },
  {44486 , 66617  },
  {45296 , 66695  },
  {45424 , 66799  },
  {42270 , 66880  },
  {46921 , 68654  },
  {46936 , 68804  },
  {47848 , 69778  },
  {47748 , 69892  },
  {47565 , 70020  },
  {48001 , 70144  },
  {44843 , 72329  },
  {51132 , 72808  },
  {51283 , 72844  },
  {51271 , 73356  },
  {51988 , 74402  },
  {53093 , 76181  },
  {59895 , 76668  },
  {53741 , 78274  },
  {53116 , 78278  },
  {61271 , 78508  },
  {53309 , 78528  },
  {59180 , 80098  },
  {58714 , 80164  },
  {59520 , 80226  },
  {55712 , 80372  },
  {55722 , 80403  },
  {54173 , 80687  },
  {55960 , 80752  },
  {56092 , 80842  },
  {58170 , 82464  },
  {60416 , 82758  },
  {57383 , 82912  },
  {57324 , 83455  },
  {57325 , 83455  },
  {57709 , 83444  },
  {57326 , 83455  },
  {58534 , 84853  },
  {61214 , 84927  },
  {52417 , 85743  },
  {59205 , 85907  },
  {52736 , 86151  },
  {55723 , 86265  },
  {58013 , 86373  },
  {59602 , 86447  },
  {59578 , 86422  },
  {61550 , 86718  },
  {61273 , 86834  },
  {55947 , 86931  },
  {60172 , 87084  },
  {61306 , 87253  },
  {70432 , 87253  },
  {60441 , 87669  },
  {59017 , 87704  },
  {60732 , 88103  },
  {54131 , 88295  },
  {60891 , 88417  },
  {60914 , 88465  },
  {52748 , 88589  },
  {52778 , 88674  },
  {56020 , 89755  },
  {61894 , 90207  },
  {61891 , 90204  },
  {36549 , 91267  },
  {70576 , 94238  },
  {53094 , 97957  },
  {33920 , 102385 },
  {67021 , 104882 },
  {69191 , 105547 },
  {70230 , 107678 },
  {78649 , 108048 },
  {71578 , 110562 },
  {71611 , 110666 },
  {47633 , 111172 },
  {21635 , 112644 },
  {67552 , 112839 },
  {43100 , 112948 },
  {45777 , 58489  },
  {40347 , 59763  },
  {42416 , 62258  },
  {35804 , 62523  },
  {43109 , 63543  },
  {38731 , 63865  },
  {43454 , 65240  },
  {44480 , 65629  },
  {44537 , 65711  },
  {46042 , 66462  },
  {46044 , 66462  },
  {45098 , 66418  },
  {45099 , 66418  },
  {45242 , 66587  },
  {45258 , 66633  },
  {45527 , 66984  },
  {46810 , 68467  },
  {47742 , 68560  },
  {46882 , 68601  },
  {46947 , 68838  },
  {47777 , 69946  },
  {47355 , 70226  },
  {45289 , 127948 },
  {81078 , 128188 },
  {78599 , 128173 },
  {80324 , 129126 },
  {80476 , 129259 },
  {80884 , 129835 },
  {50690 , 129868 },
  {58892 , 129954 },
  {80965 , 130138 },
  {81154 , 130165 },
  {64978 , 130164 },
  {81189 , 130401 },
  {5244  , 130557 },
  {78163 , 134047 },
  {86801 , 137829 },
  {47236 , 138139 },
  {80326 , 139435 },
  {86529 , 143203 },
  {91114 , 154839 },
  {2954  , 61367  },
  {42218 , 61718  },
  {42448 , 61945  },
  {22175 , 62641  },
  {42708 , 62816  },
  {40090 , 63062  },
  {40094 , 63062  },
  {7511  , 62925  },
  {42757 , 63551  },
  {43152 , 63585  },
  {43153 , 63585  },
  {40584 , 63847  },
  {43425 , 64005  },
  {45898 , 64238  },
  {40089 , 64246  },
  {43631 , 64669  },
  {43868 , 65314  },
  {44611 , 65814  },
  {45167 , 66472  },
  {46903 , 68661  },
  {47636 , 68820  },
  {47796 , 69983  },
  {48057 , 70453  },
  {48668 , 71021  },
  {48650 , 71163  },
  {49084 , 71693  },
  {51759 , 71921  },
  {49428 , 72287  },
  {51757 , 72452  },
  {51584 , 73013  },
  {51284 , 73160  },
  {51267 , 73351  },
  {52418 , 74995  },
  {23730 , 74995  },
  {56944 , 75113  },
  {52785 , 75590  },
  {53817 , 76477  },
  {56943 , 76517  },
  {61680 , 76687  },
  {52659 , 77655  },
  {54511 , 78421  },
  {54591 , 79035  },
  {55920 , 79420  },
  {59496 , 79486  },
  {61181 , 79643  },
  {50691 , 79645  },
  {60805 , 79923  },
  {53878 , 80101  },
  {54715 , 80589  },
  {56067 , 80839  },
  {54432 , 80836  },
  {56432 , 81548  },
  {57801 , 83553  },
  {57883 , 83681  },
  {55092 , 83740  },
  {58217 , 84233  },
  {39130 , 84330  },
  {58395 , 84521  },
  {58414 , 84644  },
  {58468 , 84639  },
  {58506 , 84805  },
  {57884 , 84852  },
  {54590 , 84798  },
  {58569 , 84912  },
  {57411 , 85516  },
  {57885 , 85526  },
  {59131 , 85798  },
  {59104 , 85856  },
  {52374 , 86000  },
  {56009 , 86294  },
  {57735 , 86520  },
  {55519 , 86772  },
  {55211 , 88586  },
  {59103 , 89718  },
  {57297 , 89788  },
  {61898 , 90214  },
  {59101 , 90245  },
  {59102 , 90245  },
  {62404 , 90345  },
  {62354 , 91226  },
  {60609 , 91408  },
  {64723 , 92887  },
  {62218 , 97080  },
  {65121 , 97206  },
  {63674 , 97542  },
  {57485 , 97895  },
  {65516 , 97952  },
  {65535 , 98021  },
  {65590 , 98077  },
  {67512 , 101982 },
  {67476 , 102091 },
  {67477 , 102091 },
  {46666 , 102361 },
  {67683 , 102556 },
  {68067 , 103159 },
  {72883 , 103326 },
  {68383 , 103785 },
  {68392 , 103808 },
  {64536 , 103841 },
  {68523 , 104147 },
  {70400 , 105585 },
  {70401 , 105613 },
  {68729 , 106283 },
  {68291 , 107431 },
  {70193 , 107595 },
  {71828 , 111425 },
  {39490 , 111643 },
  {71945 , 112015 },
  {68860 , 112132 },
  {40003 , 112331 },
  {68393 , 112421 },
  {51599 , 112662 },
  {64328 , 113127 },
  {56949 , 113758 },
  {73706 , 115149 },
  {42362 , 62129  },
  {46047 , 62266  },
  {46003 , 62317  },
  {5905  , 63548  },
  {80951 , 143179 },
  {88061 , 143813 },
  {70290 , 153656 },
  {36605 , 62922  },
  {48085 , 70494  },
  {48086 , 70494  },
  {48856 , 71016  },
  {48667 , 71023  },
  {49845 , 72464  },
  {51326 , 72805  },
  {51740 , 73368  },
  {52971 , 74597  },
  {52279 , 74722  },
  {52398 , 75312  },
  {52732 , 75466  },
  {61138 , 75483  },
  {53505 , 76874  },
  {61171 , 77306  },
  {59897 , 77331  },
  {53946 , 77519  },
  {53971 , 77609  },
  {58719 , 77627  },
  {54975 , 77845  },
  {53612 , 78277  },
  {59094 , 79061  },
  {57951 , 79483  },
  {52413 , 79577  },
  {59724 , 79909  },
  {59725 , 79959  },
  {55544 , 80136  },
  {55545 , 80136  },
  {54957 , 80241  },
  {49097 , 80228  },
  {55679 , 80329  },
  {55710 , 80370  },
  {55413 , 80401  },
  {53327 , 80832  },
  {54406 , 82513  },
  {64589 , 85009  },
  {58744 , 85253  },
  {64621 , 85283  },
  {58540 , 85532  },
  {55975 , 85779  },
  {59579 , 85970  },
  {42430 , 85994  },
  {61588 , 86266  },
  {59540 , 86423  },
  {59536 , 86394  },
  {59668 , 86532  },
  {59885 , 86715  },
  {55819 , 86755  },
  {54440 , 86847  },
  {55093 , 88643  },
  {39403 , 89377  },
  {51263 , 118471 },
  {50962 , 125214 },
  {79632 , 127850 },
  {78606 , 128174 },
  {81426 , 130772 },
  {82119 , 131897 },
  {54636 , 132194 },
  {82292 , 132211 },
  {77474 , 132244 },
  {42280 , 132526 },
  {82989 , 133539 },
  {46242 , 133587 },
  {56210 , 133822 },
  {48169 , 135745 },
  {3186  , 136334 },
  {837   , 136400 },
  {84893 , 136690 },
  {64373 , 137140 },
  {39727 , 137181 },
  {81269 , 138286 },
  {86136 , 139073 },
  {86229 , 139252 },
  {82340 , 140464 },
  {82338 , 140464 },
  {40020 , 141313 },
  {82869 , 141832 },
  {89889 , 142935 },
  {87594 , 143032 },
  {6295  , 143032 },
  {87590 , 143033 },
  {88473 , 143035 },
  {88474 , 143035 },
  {88471 , 143035 },
  {12189 , 143416 },
  {87890 , 143515 },
  {87903 , 143563 },
  {87976 , 143738 },
  {78837 , 143957 },
  {89260 , 145946 },
  {26466 , 146396 },
  {89609 , 147221 },
  {77989 , 147585 },
  {91330 , 148454 },
  {90869 , 148454 },
  {91487 , 148454 },
  {90028 , 148520 },
  {90155 , 148781 },
  {66487 , 148976 },
  {92543 , 150373 },
  {92541 , 150376 },
  {92544 , 150467 },
  {90737 , 150569 },
  {70574 , 151096 },
  {91232 , 151673 },
  {81080 , 151994 },
  {91332 , 151993 },
  {77495 , 152035 },
  {76841 , 152114 },
  {90766 , 152359 },
  {90736 , 152379 },
  {90735 , 152798 },
  {90948 , 153026 },
  {42534 , 153096 },
  {47959 , 70257  },
  {48666 , 71018  },
  {48708 , 71201  },
  {46685 , 72807  },
  {60896 , 77140  },
  {59896 , 77328  },
  {52749 , 77431  },
  {53114 , 78278  },
  {54409 , 78274  },
  {54407 , 78274  },
  {54441 , 78576  },
  {59721 , 79705  },
  {55721 , 80242  },
  {61549 , 86716  },
  {60174 , 87088  },
  {60395 , 87343  },
  {59038 , 88300  },
  {60618 , 88422  },
  {60916 , 88473  },
  {55976 , 88578  },
  {58828 , 88677  },
  {61301 , 93002  },
  {65129 , 97236  },
  {68300 , 103625 },
  {62592 , 113201 },
  {34170 , 113417 },
  {67421 , 113694 },
  {73463 , 113827 },
  {73352 , 113984 },
  {73093 , 114063 },
  {19330 , 114835 },
  {17461 , 115097 },
  {73707 , 115150 },
  {70058 , 115663 },
  {70069 , 115786 },
  {76651 , 120589 },
  {76652 , 120589 },
  {75989 , 120830 },
  {76109 , 121112 },
  {76262 , 121317 },
  {76357 , 121540 },
  {77158 , 121564 },
  {77159 , 121564 },
  {62384 , 122015 },
  {76660 , 122114 },
  {76593 , 122560 },
  {86793 , 123093 },
  {64331 , 123316 },
  {77504 , 123655 },
  {77505 , 123655 },
  {75244 , 125081 },
  {78248 , 125299 },
  {79058 , 126708 },
  {81194 , 127010 },
  {79304 , 127176 },
  {79305 , 127176 },
  {78152 , 127553 },
  {52598 , 127874 },
  {65888 , 127952 },
  {24751 , 127853 },
  {79760 , 128159 },
  {80043 , 128616 },
  {78932 , 128616 },
  {641   , 128996 },
  {55820 , 130110 },
  {38261 , 130257 },
  {76658 , 130403 },
  {76655 , 131718 },
  {79477 , 137575 },
  {66640 , 138086 },
  {45092 , 139280 },
  {75594 , 140034 },
  {79232 , 142500 },
  {77652 , 143047 },
  {75592 , 148480 },
  {73602 , 153980 },
  {92156 , 154827 },
  {90993 , 154846 },
  {43225 , 156931 },
  {70178 , 157589 },
  {94714 , 161963 },
  {37580 , 162363 },
  {57041 , 79020  },
  {54848 , 79039  },
  {53776 , 79481  },
  {55376 , 79895  },
  {55463 , 80052  },
  {55763 , 80471  },
  {55833 , 80559  },
  {54443 , 81898  },
  {59727 , 82037  },
  {56124 , 82205  },
  {57822 , 83583  },
  {57962 , 83804  },
  {54412 , 83843  },
  {58834 , 84231  },
  {18117 , 84341  },
  {56803 , 84341  },
  {58295 , 84432  },
  {56068 , 84644  },
  {58611 , 85003  },
  {58745 , 85254  },
  {58833 , 85753  },
  {55765 , 85760  },
  {57880 , 85807  },
  {61646 , 86748  },
  {56848 , 86729  },
  {52834 , 107503 },
  {1192  , 123313 },
  {34068 , 123713 },
  {76312 , 124265 },
  {76311 , 124265 },
  {76302 , 124265 },
  {76301 , 124265 },
  {76479 , 126885 },
  {79156 , 126898 },
  {79635 , 127857 },
  {79636 , 127857 },
  {74423 , 127857 },
  {81994 , 135769 },
  {85225 , 136553 },
  {81084 , 142199 },
  {79015 , 143050 },
  {76844 , 143393 },
  {342   , 145337 },
  {83648 , 149147 },
  {75376 , 151354 },
  {75365 , 153462 },
  {88788 , 154771 },
  {60458 , 87705  },
  {20828 , 87796  },
  {60820 , 88225  },
  {60888 , 88413  },
  {65981 , 88542  },
  {61795 , 89741  },
  {61884 , 90200  },
  {61986 , 91823  },
  {67237 , 91936  },
  {31979 , 92117  },
  {15921 , 92298  },
  {63197 , 92627  },
  {64724 , 92876  },
  {63400 , 93010  },
  {63478 , 93124  },
  {63479 , 93124  },
  {62494 , 93952  },
  {69489 , 96404  },
  {65070 , 96649  },
  {66336 , 96878  },
  {65066 , 97018  },
  {65113 , 97174  },
  {1747  , 97248  },
  {65258 , 97345  },
  {51827 , 97449  },
  {65457 , 97840  },
  {65638 , 98132  },
  {65672 , 98185  },
  {65713 , 98236  },
  {66211 , 99527  },
  {66327 , 99760  },
  {62708 , 100846 },
  {64387 , 101077 },
  {6544  , 103624 },
  {65859 , 103786 },
  {69532 , 106232 },
  {70105 , 107477 },
  {70116 , 107487 },
  {70190 , 107617 },
  {70229 , 107677 },
  {41014 , 109324 },
  {64628 , 109702 },
  {70876 , 111463 },
  {51124 , 111633 },
  {46086 , 112334 },
  {63738 , 112910 },
  {45489 , 113125 },
  {71920 , 113755 },
  {73694 , 115145 },
  {73695 , 115145 },
  {73696 , 115145 },
  {73898 , 115479 },
  {24906 , 115553 },
  {70056 , 115666 },
  {71872 , 120386 },
  {86790 , 123095 },
  {86792 , 123095 },
  {77279 , 123310 },
  {47511 , 123502 },
  {64329 , 127636 },
  {78449 , 128164 },
  {80092 , 128667 },
  {81341 , 128799 },
  {37855 , 129516 },
  {320   , 129644 },
  {80093 , 130023 },
  {61927 , 131069 },
  {76653 , 133835 },
  {77491 , 133862 },
  {30210 , 137152 },
  {30213 , 137152 },
  {30211 , 139562 },
  {8013  , 140735 },
  {30212 , 141118 },
  {80414 , 143184 },
  {80264 , 143056 },
  {88468 , 143195 },
  {87999 , 143794 },
  {66292 , 144477 },
  {77493 , 148293 },
  {70448 , 149134 },
  {70266 , 153575 },
  {34670 , 153593 },
  {88873 , 154819 },
  {74800 , 154855 },
  {40169 , 156788 },
  {70154 , 157589 },
  {60863 , 88357  },
  {60922 , 88474  },
  {60973 , 88575  },
  {61016 , 88692  },
  {61148 , 88830  },
  {64854 , 89689  },
  {61889 , 90205  },
  {63394 , 92912  },
  {52808 , 92981  },
  {64097 , 94623  },
  {64256 , 94694  },
  {61825 , 96287  },
  {62217 , 97078  },
  {68294 , 103635 },
  {66850 , 103787 },
  {51815 , 105014 },
  {67273 , 105657 },
  {69274 , 106039 },
  {68666 , 106210 },
  {68859 , 106278 },
  {69724 , 106804 },
  {69740 , 106837 },
  {69896 , 107206 },
  {70194 , 107596 },
  {699   , 107846 },
  {41395 , 107846 },
  {70340 , 107914 },
  {55455 , 108535 },
  {68603 , 109351 },
  {32811 , 109934 },
  {71437 , 110043 },
  {71224 , 110741 },
  {71056 , 110826 },
  {2176  , 111158 },
  {71826 , 111421 },
  {32061 , 111887 },
  {69430 , 112636 },
  {70441 , 112691 },
  {72461 , 112945 },
  {72654 , 113122 },
  {62591 , 113198 },
  {73663 , 115136 },
  {73923 , 115677 },
  {75438 , 115795 },
  {73244 , 115918 },
  {61926 , 116921 },
  {74468 , 117180 },
  {74515 , 117343 },
  {74520 , 117371 },
  {74657 , 118060 },
  {74736 , 118244 },
  {75316 , 119499 },
  {75472 , 119968 },
  {75790 , 120477 },
  {76094 , 120477 },
  {76095 , 120477 },
  {77157 , 121564 },
  {76308 , 121564 },
  {76531 , 121623 },
  {76602 , 122023 },
  {76587 , 123508 },
  {76300 , 123527 },
  {38123 , 123636 },
  {37620 , 123813 },
  {74905 , 125003 },
  {74907 , 125003 },
  {75474 , 126445 },
  {77967 , 126702 },
  {85629 , 127333 },
  {79365 , 127776 },
  {79711 , 127954 },
  {79633 , 127850 },
  {78499 , 128167 },
  {78500 , 128167 },
  {83539 , 128699 },
  {67032 , 128710 },
  {80080 , 128658 },
  {80618 , 129476 },
  {68526 , 131262 },
  {82313 , 132987 },
  {82314 , 132987 },
  {80503 , 133997 },
  {76656 , 143898 },
  {70451 , 144839 },
  {76834 , 145457 },
  {62722 , 148296 },
  {78244 , 149707 },
  {77488 , 151998 },
  {70446 , 153660 },
  {32024 , 153593 },
  {25630 , 153726 },
  {1939  , 153818 },
  {41000 , 154506 },
  {75350 , 154789 },
  {64752 , 91916  },
  {58756 , 92429  },
  {63223 , 92694  },
  {45139 , 92707  },
  {64725 , 92875  },
  {1007  , 93318  },
  {64222 , 94927  },
  {66004 , 95268  },
  {64425 , 95572  },
  {64744 , 95951  },
  {70537 , 96021  },
  {38310 , 96123  },
  {69490 , 96403  },
  {65071 , 96622  },
  {62219 , 97076  },
  {65128 , 97229  },
  {65237 , 97511  },
  {30995 , 97531  },
  {65419 , 97789  },
  {63734 , 98230  },
  {65714 , 98238  },
  {60076 , 98273  },
  {65800 , 98428  },
  {37737 , 98890  },
  {66147 , 99389  },
  {74484 , 99425  },
  {66210 , 99513  },
  {66212 , 99526  },
  {66329 , 99760  },
  {66542 , 99779  },
  {66326 , 99760  },
  {48163 , 101062 },
  {67227 , 101575 },
  {68370 , 102918 },
  {29283 , 103563 },
  {30239 , 110066 },
  {64014 , 110502 },
  {61681 , 111784 },
  {44577 , 113123 },
  {47817 , 113759 },
  {73699 , 115147 },
  {73917 , 115671 },
  {86537 , 123653 },
  {78003 , 124303 },
  {78025 , 124486 },
  {78750 , 126142 },
  {78936 , 127294 },
  {52601 , 127874 },
  {77759 , 128162 },
  {80040 , 128616 },
  {30224 , 128551 },
  {19785 , 129833 },
  {81102 , 129950 },
  {42239 , 130160 },
  {42241 , 130160 },
  {42656 , 130160 },
  {55921 , 130575 },
  {81429 , 130817 },
  {76910 , 132653 },
  {707   , 137739 },
  {82010 , 137944 },
  {76650 , 138727 },
  {78853 , 138812 },
  {71540 , 139385 },
  {62863 , 141051 },
  {78855 , 141935 },
  {328   , 142699 },
  {4626  , 142699 },
  {17089 , 142717 },
  {75344 , 143034 },
  {75343 , 143034 },
  {87603 , 143044 },
  {80852 , 143200 },
  {88040 , 143807 },
  {88022 , 143798 },
  {88025 , 143798 },
  {83646 , 145110 },
  {75378 , 145337 },
  {62588 , 145736 },
  {89261 , 145948 },
  {89742 , 147587 },
  {88790 , 147671 },
  {89767 , 147692 },
  {31623 , 147838 },
  {86573 , 147884 },
  {77492 , 148293 },
  {90029 , 148524 },
  {81665 , 148825 },
  {90140 , 148843 },
  {90142 , 148846 },
  {80967 , 148985 },
  {90867 , 150375 },
  {68716 , 151133 },
  {8841  , 151634 },
  {77482 , 151998 },
  {63607 , 152092 },
  {68157 , 153585 },
  {75366 , 154697 },
  {75379 , 154702 },
  {78839 , 154781 },
  {65112 , 97179  },
  {72660 , 113440 },
  {73353 , 113527 },
  {23952 , 113739 },
  {73671 , 115138 },
  {77923 , 124278 },
  {80333 , 124397 },
  {304   , 125494 },
  {75473 , 126445 },
  {79709 , 127950 },
  {78464 , 128166 },
  {26774 , 132317 },
  {78131 , 139326 },
  {42781 , 143051 },
  {77464 , 148293 },
  {84038 , 149262 },
  {84039 , 149262 },
  {45491 , 152799 },
  {86465 , 154821 },
  {81214 , 154893 },
  {68289 , 103627 },
  {70228 , 107676 },
  {70383 , 108014 },
  {10662 , 108106 },
  {53311 , 108181 },
  {14315 , 108499 },
  {70937 , 109216 },
  {53782 , 111216 },
  {72656 , 111273 },
  {71849 , 111570 },
  {66835 , 112010 },
  {68845 , 112144 },
  {71980 , 112167 },
  {72239 , 112728 },
  {72085 , 112798 },
  {44552 , 112905 },
  {63621 , 112909 },
  {41485 , 113040 },
  {72719 , 113205 },
  {52896 , 113761 },
  {70663 , 113855 },
  {73351 , 113983 },
  {73308 , 114543 },
  {73697 , 115146 },
  {73913 , 115670 },
  {70068 , 115787 },
  {74472 , 117184 },
  {74473 , 117184 },
  {74514 , 117341 },
  {74700 , 118063 },
  {43497 , 118471 },
  {59026 , 119040 },
  {60459 , 119181 },
  {75132 , 119287 },
  {75315 , 119498 },
  {64466 , 119990 },
  {75766 , 120397 },
  {76366 , 121502 },
  {76408 , 121567 },
  {76530 , 121624 },
  {76600 , 122010 },
  {76794 , 122335 },
  {76795 , 122335 },
  {53767 , 123423 },
  {75470 , 123512 },
  {74906 , 124279 },
  {78022 , 124476 },
  {45906 , 125132 },
  {57486 , 126433 },
  {78989 , 126579 },
  {79547 , 126618 },
  {40269 , 126926 },
  {79267 , 126984 },
  {79776 , 128119 },
  {78451 , 128146 },
  {79876 , 128356 },
  {79890 , 128388 },
  {78159 , 128585 },
  {77473 , 128729 },
  {11908 , 129002 },
  {78473 , 128950 },
  {77506 , 131766 },
  {86799 , 132022 },
  {77475 , 133896 },
  {78021 , 134057 },
  {51128 , 134906 },
  {77477 , 135467 },
  {78247 , 135846 },
  {63016 , 136417 },
  {75599 , 136548 },
  {62862 , 137461 },
  {86802 , 140664 },
  {86800 , 140664 },
  {79059 , 142195 },
  {80457 , 143053 },
  {76837 , 149262 },
  {76836 , 149262 },
  {45490 , 152903 },
  {73603 , 152992 },
  {70449 , 153611 },
  {70450 , 153588 },
  {32546 , 153598 },
  {70440 , 153661 },
  {75358 , 154787 },
  {90878 , 154856 },
  {92162 , 154849 },
  {90523 , 154716 },
  {90516 , 154716 },
  {74864 , 154935 },
  {90522 , 154716 },
  {90518 , 154716 },
  {90524 , 154716 },
  {9758  , 155246 },
  {80254 , 155579 },
  {77899 , 157143 },
  {95171 , 161964 },
  {26740 , 115139 },
  {73916 , 115667 },
  {77980 , 124375 },
  {52600 , 124814 },
  {78396 , 125250 },
  {43647 , 125453 },
  {67022 , 126197 },
  {78926 , 126419 },
  {79019 , 126637 },
  {84333 , 127482 },
  {79518 , 127602 },
  {78179 , 127630 },
  {53282 , 127699 },
  {79594 , 127765 },
  {56156 , 127876 },
  {77485 , 129554 },
  {52602 , 132195 },
  {82000 , 134155 },
  {78650 , 136796 },
  {54845 , 142435 },
  {78835 , 143041 },
  {81058 , 143055 },
  {26524 , 143804 },
  {52656 , 148296 },
  {77483 , 152001 },
  {91870 , 153658 },
  {77494 , 153699 },
  {90874 , 154857 },
  {32814 , 162335 },
  {91811 , 163646 },
  {77557 , 123712 },
  {77204 , 126939 },
  {78958 , 126952 },
  {81492 , 126952 },
  {84061 , 127169 },
  {79361 , 127279 },
  {87918 , 127800 },
  {79766 , 128065 },
  {79798 , 128160 },
  {80265 , 128631 },
  {80266 , 128631 },
  {80500 , 129283 },
  {85339 , 142577 },
  {33088 , 143046 },
  {76624 , 143204 },
  {87862 , 143499 },
  {88001 , 143802 },
  {42659 , 152903 },
  {70442 , 153587 },
  {68749 , 153613 },
  {90512 , 154712 },
  {91110 , 154724 },
  {79481 , 127543 },
  {79777 , 128118 },
  {79700 , 136550 },
  {80460 , 143194 },
  {76761 , 143199 },
  {87895 , 143533 },
  {74038 , 143564 },
  {87945 , 143627 },
  {81972 , 143730 },
  {88003 , 143797 },
  {88290 , 143929 },
  {5187  , 148784 },
  {80966 , 148984 },
  {90230 , 149205 },
  {45274 , 150374 },
  {47859 , 150360 },
  {68898 , 151145 },
  {92542 , 152290 },
  {91933 , 152800 },
  {85664 , 153462 },
  {91027 , 154828 },
  {78151 , 154710 },
  {32060 , 154935 },
  {23057 , 155244 },
  {92502 , 155829 },
  {80511 , 155894 },
  {90764 , 156099 },
  {34007 , 156931 },
  {45149 , 156756 },
  {93312 , 157715 },
  {87763 , 158683 },
  {81387 , 159783 },
  {95152 , 160187 },
  {78253 , 160413 },
  {68899 , 160975 },
  {92906 , 161280 },
  {95146 , 162007 },
  {91810 , 162150 },
  {92905 , 163154 },
  {79638 , 127859 },
  {81495 , 130935 },
  {76294 , 130935 },
  {76790 , 131614 },
  {86020 , 138742 },
  {86088 , 138964 },
  {86231 , 139372 },
  {86482 , 139743 },
  {11089 , 140591 },
  {80617 , 141643 },
  {15464 , 141755 },
  {80456 , 141941 },
  {79014 , 143056 },
  {34417 , 143052 },
  {70445 , 149138 },
  {75372 , 154697 },
  {90945 , 154712 },
  {32056 , 154936 },
  {92580 , 155865 },
  {92581 , 155865 },
  {92582 , 155865 },
  {40153 , 156046 },
  {95174 , 161923 },
  {76483 , 130743 },
  {81085 , 131136 },
  {40721 , 131384 },
  {76565 , 131626 },
  {77584 , 133897 },
  {77630 , 133897 },
  {75339 , 134406 },
  {78854 , 135193 },
  {52696 , 135293 },
  {82159 , 135494 },
  {81083 , 136311 },
  {83844 , 136663 },
  {85199 , 137198 },
  {80031 , 137714 },
  {80829 , 139534 },
  {82339 , 140464 },
  {75597 , 140585 },
  {83197 , 141599 },
  {75383 , 142577 },
  {36595 , 143042 },
  {32791 , 143045 },
  {82003 , 150098 },
  {91113 , 154722 },
  {90991 , 154845 },
  {2305  , 157143 },
  {37604 , 161382 },
  {95176 , 161951 },
  {91809 , 163045 },
  {79002 , 131072 },
  {87604 , 143044 },
  {87605 , 143044 },
  {45190 , 143808 },
  {88024 , 143959 },
  {90027 , 148517 },
  {90031 , 148517 },
  {89749 , 148787 },
  {88023 , 148997 },
  {88028 , 148997 },
  {80954 , 149372 },
  {89244 , 149644 },
  {89243 , 149663 },
  {42520 , 150380 },
  {68852 , 153465 },
  {68853 , 153465 },
  {68854 , 153465 },
  {91029 , 153812 },
  {90412 , 154219 },
  {91025 , 154720 },
  {75368 , 154823 },
  {90876 , 154856 },
  {47241 , 131626 },
  {82210 , 131893 },
  {37547 , 131895 },
  {82391 , 132366 },
  {82491 , 132580 },
  {82593 , 132650 },
  {1006  , 132674 },
  {80412 , 133843 },
  {83821 , 134699 },
  {55918 , 134782 },
  {30221 , 135234 },
  {1535  , 135338 },
  {81323 , 135490 },
  {76667 , 135852 },
  {83881 , 136149 },
  {78251 , 136593 },
  {80962 , 137468 },
  {70260 , 137720 },
  {913   , 139278 },
  {86225 , 139335 },
  {80830 , 139534 },
  {86474 , 139703 },
  {86806 , 139782 },
  {75595 , 140034 },
  {11316 , 142338 },
  {21735 , 142342 },
  {61297 , 142437 },
  {74803 , 154796 },
  {90519 , 154836 },
  {2702  , 135304 },
  {76913 , 135450 },
  {76912 , 135450 },
  {76903 , 135450 },
  {76902 , 135450 },
  {75589 , 136548 },
  {37577 , 137211 },
  {82379 , 137450 },
  {85438 , 137681 },
  {86227 , 139356 },
  {78160 , 139488 },
  {86372 , 139534 },
  {86445 , 139622 },
  {86484 , 139744 },
  {86493 , 139793 },
  {75591 , 140034 },
  {81338 , 140433 },
  {56045 , 140594 },
  {75593 , 140585 },
  {34901 , 140591 },
  {2161  , 140735 },
  {29596 , 140830 },
  {29594 , 140830 },
  {76694 , 140830 },
  {55080 , 140938 },
  {82209 , 141029 },
  {86670 , 141755 },
  {11108 , 141755 },
  {822   , 141911 },
  {41326 , 143037 },
  {75353 , 143188 },
  {79567 , 143464 },
  {88002 , 143803 },
  {74319 , 145343 },
  {74313 , 145343 },
  {82974 , 152296 },
  {75377 , 153902 },
  {31460 , 154331 },
  {90946 , 154714 },
  {91021 , 154830 },
  {32021 , 154935 },
  {40156 , 153096 },
  {86366 , 153096 },
  {90732 , 153350 },
  {90731 , 153350 },
  {70336 , 153609 },
  {94165 , 154165 },
  {56043 , 154308 },
  {56047 , 154308 },
  {92265 , 154445 },
  {92073 , 154693 },
  {90520 , 154718 },
  {90526 , 154718 },
  {92160 , 154843 },
  {90875 , 154798 },
  {90517 , 154716 },
  {91631 , 155600 },
  {90944 , 154834 },
  {81215 , 154893 },
  {11104 , 162382 },
  {94886 , 162502 },
  {6735  , 3722   },
  {7836  , 4397   },
  {10902 , 4688   },
  {37143 , 4887   },
  {3006  , 5056   },
  {7549  , 5226   },
  {7671  , 5226   },
  {7672  , 5226   },
  {11094 , 5453   },
  {37778 , 5832   },
  {46055 , 5935   },
  {5289  , 6504   },
  {11087 , 6553   },
  {38005 , 7432   },
  {15384 , 11736  },
  {9560  , 12802  },
  {15434 , 15229  },
  {15355 , 15286  },
  {11410 , 16879  },
  {2850  , 20773  },
  {20522 , 21102  },
  {20294 , 21462  },
  {20425 , 21724  },
  {20571 , 21879  },
  {4877  , 22979  },
  {20738 , 23206  },
  {37572 , 23994  },
  {22629 , 24753  },
  {26296 , 25488  },
  {935   , 49251  },
  {20067 , 50370  },
  {3247  , 50873  },
  {70199 , 50926  },
  {1934  , 95908  },
  {5126  , 102515 },
  {9573  , 111784 },
  {13210 , 126726 },
  {1103  , 142334 },
  {1105  , 142337 },
  {76835 , 145457 },
  {2488  , 162364 },
  


}



